>NAME DDKUIP

>MENU /DDL
>GUIDANCE
Data Definition Language.
A multitude of examples can be found in the directory
%HB/ARTE-xx-yy (xx-yy stands for the latest Arte version).

>COMMAND Ddinit
>GUIDANCE
Must precede any other data definition command.
It IS a good idea to start the DD commands of every table with DDINIT.
Note that modifying the data definition has no effect for the present
job!
.
A job executing the DDINIT command cannot do normal
event processing: the RUN command starts doing all the
DD buisiness rather than to loop over events.
>ACTION KADINI

>COMMAND Dtable
>GUIDANCE
Start the definition of a table.
DTABLE should be the 2nd command in every data definition file (after
DDINIT).
.
Table name: Zebra restricts the length of table names to 4 characters
(limit in Mizzi: 16 characters
which is still too short; in Arte: 80 characters). In future
we shall adapt the naming conventions of the data base (description will
be written).

 Presently available divisions are:
 E  division EVENT: automatic fast dropping after event processing.
 C  division CONSTANT: dropping of those tables is under user control.

Menus group tables together and are used, e.g., for the help
mechanism and for manuals (see command DMENU).
Menus are totally independent
of the hierarchy of tables for I/O (see command DSUB_OF).
 Example:
 DDINIT
 DTABLE ABCD 20 E -own 'definition of my own table'
starts the definition of a table ABCD. In order to keep the
number of memory allocations small, the table is extended
in units of 20 rows, i.e.: booking one new row allocates
sufficient memory for booking the next 19 rows. The table
belongs to the division EVENT: it is automatically dropped
before a new event is read in. The menu has the name OWN
(see command DMENU).
.
Dont forget to write a description. If one line
(80 characters) is not sufficient you can continue the
description with the command DTEXT (q.v.).
>ACTION KADTAB
>PARAMETER
NAME 'table name' C
EXT  'extension when booking new space' I D=0
DIVISION 'division (see below)' C
+
TEXT 'table description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dmenu
>GUIDANCE
Describe a menu.
Two purposes:
 (i)  Organize the help text in menus and sub-menus (note that the help
      items are not necessarily sorted alphabetically);
 (ii) Make header files which simultaneously contain the declarations
      for all tables of a menu.
Menus are not at all related to the hierarchy of tables
(command DSUB_OF) which controls the I/O behaviour of a table.
.
Menus are established by the parameter -MENU in commands like Dtable,
DRELONE, DRELMANY, and other DMENU commands.
Thus the command DMENU, in principle, can be omitted but this leads to
a reduced readability of the HELP text.
The Dmenu command supplies a description of the menu
and, if desired, a superior menu (up to 4 levels of the menu
hierarchy are allowed). Example:
 DMENU MC -EV 'Monte Carlo'
 DTABLE MTRA 100 -MC 'description'
gives a description of the menu MC and declares it to be
a sub-menu of the menu EV. Table MTRA belongs to menu MC.
Example for HELP commands:
 HELP DDESCRIPTION
   gives a list of all menus. From there you may go to
   sub-menus, sub-sub-menus etc.
 HELP MTRA
   lists the data definition for table MTRA. In many cases
   you will get a message that this command is not unique.
   Make it unique by typing
 HELP MC/MTRA
 HELP EV/MC
>ACTION KADMEN
>PARAMETER
+
MNAME 'menu name' C D=' '
TEXT 'menu description' C D=' '
OPTION 'superior menu' C D=' '

>COMMAND Dend_out
>GUIDANCE
End output here.
The table is separated into to parts. The 1st part is
read/written from/to I/O files. The 2nd part (all attributes
declared after DEND_OUT) is not written to any output file.
On input, these attributes are set to 0. Note, however, that
inverse relations (described by the commands DINVONE and DINVMANY;
these commands must always be written after DEND_OUT)
are automatically established for tables on input files.
>ACTION KADEND

>COMMAND Dattrib
>GUIDANCE
Definition of an attribute of a table.
.
The attribute name now may contain up to 80 characters.
Attributes are scalars or one-dimensional
arrays; for scalars the dimension has explicitely be set to 0.
The type specification is adapted from Zebra. Hence, there is no
faintest trace of systematics in it but we cannot modify it because
of backward compatibility reasons.
 Type specification
.
 Dattrib Zebra     C/C++     Fortran  Gpack Mizzi          MEMA_TYPE
.
 I       integer   int       integer  I1    int            5
 B       bit       unsigned  integer  B1    unsigned       6
 F       floating  float     real     F     float          7
 H       Hollerith char[4]   integer  H1    char           8
 S       = I       integer   integer  I1    signed short   9
 U       = B       unsigned  integer  B1    unsigned short 10
 C       = H       char[4]   integer  H1    char           11
The only difference between S and C is that print-outs are formatted
differently (ASCII or hexadecimal). Short integers (signed/unsigned)
exist only on MIZZI and are translated to int/unsigned in the
DbArteBridge. Double is not forseen on any I/O file nor in Arte
Tables. Inside Arte, character strings are stored in units of
4 characters (32 bits). They have a fixed length (specified by
the parameter DIM). Unused bytes at the end are filled with blank
spaces (Fortran convention). There exist functions which translate
C/C++ character strings from and to Arte strings:
 void chhtot_ (char *Hstringin, int *Cstringout, int *Nwords)
 void chttoh_ (char *Cstringin, int *Hstringout, int *Nwords)
Nwords counts units of 4 characters; Cstring is a string terminated
by \0; Hstring is usable in Arte Tables.
.
The option -K or -KEY declares the attribute to be a Leda key.
There may be more than 1 Leda key for a table.
>ACTION KADATT
>PARAMETER
NAME 'attribute name' C
TYPE 'attribute type (I, F, ...)' C
DIM 'attribute dimension' I
TEXT 'attribute description' C D=' '
+
OPTION 'key' C D=' '

>COMMAND DIRANGE
>GUIDANCE
Declare the allowed range of values for an integer attribute.
.
Declaration for dimensioned attributes: as many different range
declarations as defined by the dimension can be given. If there are
less (e.g. 1) then the last one is taken for the rest.
>ACTION KADIRA
>PARAMETER
LOWER 'lower bound' I D=0
UPPER 'upper bound' I

>COMMAND DFRANGE
>GUIDANCE
Declare the allowed range of values for a float attribute.
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADFRA
>PARAMETER
LOWER 'lower bound' R D=0.0
UPPER 'upper bound' R
+
ACCU  'accuracy'    R D=0.0

>COMMAND DILOWER
>GUIDANCE
Declare lower bound for an integer attribute.
An upper bound is not declared.
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADILO
>PARAMETER
LOWER 'lower bound' I D=0

>COMMAND DIUPPER
>GUIDANCE
Declare upper bound for an integer attribute.
A lower bound is not declared.
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADIUP
>PARAMETER
UPPER 'upper bound' I

>COMMAND DFLOWER
>GUIDANCE
Declare lower bound for a float attribute.
An upper bound is not declared.
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADFLO
>PARAMETER
LOWER 'lower bound' R D=0.0
+
ACCU  'accuracy'    R D=0.0

>COMMAND DFUPPER
>GUIDANCE
Declare upper bound for a float attribute.
A lower bound is not declared.
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADFUP
>PARAMETER
UPPER 'upper bound' R
+
ACCU  'accuracy'    R D=0.0

>COMMAND DNBITS
>GUIDANCE
Declare maximum allowed number of bits.
Used for attributes of type B (unsigned).
Declaration for dimensioned attributes: see command DIRANGE
>ACTION KADNBI
>PARAMETER
BITS 'bits' I

>COMMAND Drelone
>GUIDANCE
Declare a one-to-one or one-to-many relation.
Relations in Arte consist of pointers
from a given row in table ABCD to one or many rows in table WXYZ
(ABCD and WXYZ may or may not be the same table).
.
A full declaration of a relation needs a corresponding DINVONE or
DINVMANY command in the table where the relation points to.
The correspondence between DREL and DINV is provided by
name of the relation given as parameter NAMREL. DINV establishes
pointers in the opposite direction (from WXYZ to ABCD).

 The following types of relation exist:
 DRELONE  <--> DINVONE
 DRELONE  <--> DINVMANY
 DRELMANY <--> DINVMANY (not recommended; using 2 one-many relations
                        with one intermediate table does the same
                        and is by far more convenient)
 not allowed: DRELMANY <--> DINVONE; use DRELONE  <--> DINVMANY instead.

Inside Arte jobs all relations are symmetric:
pointers exist in either direction, and declaring DRELONE/MANY without
corresponding DINVONE/MANY leads to a severe error. On I/O files,
however, only one direction is stored, given by DRELONE. The inverse
relation is automatically established when tables are read in.
In order to avoid unnecessary output of inverse relations
the DINVONE/MANY commands should be given after the command DEND_OUT.
.
The I/O behaviour of a relation follows the I/O behaviour of the
table in which the DRELONE/MANY command is given. If it is given
after the command DEND_OUT (i.e. in the local part of the table)
it is not written to any output file.
Note: In previous versions a command DFILE was requested after each
DRELONE/MANY. From Arte-02-01 on this DFILE command is NOT
ALLOWED ANY MORE.
.
The division must, and the -menu option should be the same as in the
corresponding DTABLE command. The HELP output looks ugly if
the -menu is omitted.
>ACTION KADRE1
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
DIVISION 'Zebra division' C
+
TEXT 'description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Drelmany
>GUIDANCE
Declare a many-to-many relation.
Description: see command DRELONE.
>ACTION KADREM
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
DIVISION 'Zebra division' C
+
TEXT 'description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dinvone
>GUIDANCE
Declare a one-to-one relation.
Description: see command DRELONE.
Note that DINVONE has to be given after the command DEND_OUT
>ACTION KADIN1
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
+
TEXT 'description' C D=' '

>COMMAND Dinvmany
>GUIDANCE
Declare a one-to-many or many-to-many relation.
Description: see command DRELONE.
Note that DINVMANY has to be given after the command DEND_OUT
>ACTION KADINM
>PARAMETER
NAME 'attribute name' C
NAMREL 'name of the relation' C
+
TEXT 'description' C D=' '

>COMMAND Dfile
>GUIDANCE
Declare default IO streams for tables.
These defaults can be modified by the command IOTABLE.
Syntax: see description of command IOTABLE.
>ACTION KADFIL
>PARAMETER
FILE 'stream names' C D=' '

>COMMAND Dtext
>GUIDANCE
Give any text to be printed with the DD help mechanism.
This text is considered as
the continuation of a comment given in the previous
command. Thus, DTEXT is not allowed at the very beginning.
>ACTION KADTEX
>PARAMETER
+
TEXT 'comment' C D=' '

>COMMAND Dsub_of
>GUIDANCE
Declare a table to be the subordinate of another (superior) table.
This influences the I/O behaviour: if output
of a superior table is disabled then the output of subordinate
tables is automatically disabled as well.
>ACTION KADSUB
>PARAMETER
SUPER 'name of the superior table' C D=' '
+
TEXT 'comment' C D=' '

>COMMAND Dpar_to
>GUIDANCE
Declare a table to be parallel to another (superior) table.
Booking parallel tables is not allowed; the number of rows
is automatically kept the same as in the superior table.
DPAR_TO was necessary in ARTE-01 and is hopefully obsolete
in ARTE-02.
>ACTION KADPAR
>PARAMETER
SUPER 'name of the superior table' C D=' '
+
TEXT 'comment' C D=' '

>MENU Dauto
>GUIDANCE
Automatically generated DD commands.

>COMMAND Drelati
>GUIDANCE
Automatically generated command. Keep you fingers away.
>ACTION KADREL
>PARAMETER
NAME 'relation name' C
DIVISION 'Zebra division' C
+
TEXT 'relation description' C D=' '
OPTION 'menu' C D=' '

>COMMAND Dnamseq
>GUIDANCE
Keep names in proper order.
Automatically generated command !! Never write it yourself !!!
>ACTION KADNAM
>PARAMETER
NAME 'attribute name' C
+
TEXT 'attribute description' C D=' '
