
// *********************************************************************
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/arte/include/arte.hh,v $
// $Revision: 1.5 $
// $Author: natasha $
// $Date: 1999/04/14 19:04:58 $
//
// Created: 03-97,   C. Borgmeier
//
// *********************************************************************

//
// This file is part of the C++ interface for Arte
// the HERA-B reconstruction and analysis tool
//

#ifndef __ARTE_HH__
#define __ARTE_HH__

#ifndef __CINT__
# ifdef USE_ROOT
#  include <TObject.h>
# else
#  ifndef _TOBJECT_
    class TObject {};
#   define _TOBJECT_
#  endif
# endif
#else
  /* CREATELINKS should _NOT_ be defined, it is just for tests */
//# define CREATELINKS 1
#endif


#ifdef NO_ARTE

#ifdef USE_GATE
class ArteLink
{
public:
};


template<class T>
class ArteVector: public ArteLink
{
public:
  ArteVector();
  ~ArteVector();
  void push_back( const T& );
  T& At( int idx );
  T& operator[]( int idx ) { return At( idx ); }
  unsigned int size() const;

  TClass *IsA() const { return 0; }
  void Streamer(TBuffer&) {}
  void ShowMembers(TMemberInspector &, char*) {}
private:
  void* vec;
};

template<class T>
class ArteRelVector//: public ArteVector<T>
{
public:
  ArteRelVector();
  ~ArteRelVector();
};
#endif /* USE_GATE */

#else               /*   ARTE   */


class ArteLink
{
public:
public:
  inline int& getRef() { return i; }
  inline int& getInt() { return i; }
  
protected:
  int i;
};


template<class T>
class ArteVector: public ArteLink
{
public:
  inline const int & operator()() { return getInt(); };

  inline void push_back( const T& );
  inline T& operator[]( int idx );
  inline unsigned int size() const;

public:
#ifdef USE_GATE
  TClass *IsA() const { return 0; }
  void Streamer(TBuffer&) {}
  void ShowMembers(TMemberInspector &, char*);
  Version_t Class_Version() { return 0; }
#endif
};

#ifndef STUPID_DEF3
#define STUPID_DEF3


template<class T>
class ArteRelVector: public ArteVector<T>
{
};


extern struct {
  int nzebra, gversn;
  float zversn;
  int ixstor, ixevnt, ixcons, fendq[16], lq[8], iq[1];
} gcbank_;


#include "arte/ArteProto.hh"

#endif /* STUPID_DEF3 */
#endif               /*    ARTE    */

#ifndef STUPID_DEF2
#define STUPID_DEF2


#ifdef USE_GATE
template <class T> class GClonesArray;

template <class T>
class GClonesArrayLink: public ArteVector<T>
{
public:
  GClonesArrayLink( GClonesArray<T*>* a )
    : array( a ) {}

  GClonesArray<T*>* array;
};
#endif

#include "arte/ArteTable.hh"

#endif /* STUPID_DEF2 */

//
// include the table definitions
//
#ifndef STUPID_DEF5
#define STUPID_DEF5

template <class T>
bool ArteTable<T>::isArteTable()
{
  return true;
}


#include <auto/auto.hh>

#endif /* STUPID_DEF5 */

#ifndef STUPID_DEF4
#define STUPID_DEF4
#include "arte/ArteTable.icc"

#endif /* STUPID_DEF4 */
#endif
