*-- Author :    Hartwig Albrecht   02/03/95

      SUBROUTINE UTKUGC (IDEF, IOUT, CUPP, LEN)

************************************************************************
*
* Description: Get character string or positive integer number from KUIP.
*              Character string is converted to upper case.
*
* Called from: KR routines
*
* External references: KUGETx
*
* Argument in/out description
*  IDEF    in     default value for IOUT if no number is given
*  IOUT    out    integer number from KUIP
*  CUPP    out    character string from KUIP; blank if number is given
*  LEN     out    length of CUPP
*
************************************************************************

      IMPLICIT NONE

      INTEGER I, IDEF, IOUT, J, LEN
      CHARACTER CUPP*(*), CDIG(10)
      DATA CDIG /'0','1','2','3','4','5','6','7','8','9'/

      CUPP = ' '
      CALL KUGETC (CUPP, LEN)

      IOUT = 0
      IF (LEN .EQ. 0 .OR. LEN .GE. 10)  GO TO 40

      DO 30 I = 1, LEN
        DO 10 J = 0, 9
 10     IF (CUPP(I:I) .EQ. CDIG(J+1))  GO TO 20
        IF (CUPP(I:I) .EQ. ' ')  GO TO 30
        GO TO 40
 20     IOUT = 10 * IOUT + J
 30   CONTINUE
      CUPP = ' '
      LEN = 0
      GO TO 90
 40   IOUT = IDEF
 90   END

************************************************************************
* End of UTKUGC
************************************************************************
