      SUBROUTINE UTSTAGE(LUN,ACS_NAME,STAGE_NAME)

* F.Ratnikov: disable everywhere except of SGI (hera-b) 

************************************************************************
*-- Author :    Fedor Ratnikov   08/05/96
************************************************************************
*
* UTSTAGE
* written by Fedor Ratnikov, 08/05/96 14.57.05
* modified by I.Belyaev      02/10/97 
* modified by N.Ratnikova    23/01/98 
* This routines action: Stage file from ACS system to /tmp/ directory
*----------------------------------------------------------------------*
* LUN          in    Logical I/O unit
* ACS_NAME     in    possible ACS filename (should start with /acs/)
* STAGE_NAME   out   staged file to be used for I/O
*
************************************************************************
c
c
      IMPLICIT NONE
c

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      CHARACTER*(*) ACS_NAME,STAGE_NAME
      INTEGER LUN
      INTEGER MaxFiles
      PARAMETER (MaxFiles=99)
      CHARACTER*256 TMP_NAME(MaxFiles)
      INTEGER LUNID(MaxFiles),nUsed,ifile,N_AVAI,N_REQU

      CHARACTER*256  CTMP, CUSER 
      CHARACTER*256 CCTMP,CCTMP1
      INTEGER SLATE,I1(10),I2(10),i,ii
      COMMON /SLATE/ SLATE(6)

      INTEGER   LENOCC  
      INTEGER   FREESPACE
      INTEGER   FILESIZE
   
      EXTERNAL  LENOCC
      EXTERNAL  FREESPACE
      EXTERNAL  FILESIZE
 
      LOGICAL   FIRST

      INTEGER   UNLINK 
      
      SAVE nUsed , TMP_NAME , LUNID , FIRST 
      DATA nUsed /0/    ! no files so far
      DATA FIRST /.TRUE./
      DATA LUNID / Maxfiles*0 / 

#include "arte/Arte.ff"

      CCTMP=HOSTNAME(1:LENOCC(HOSTNAME)) 
      CALL CLTOU(CCTMP(1:LENOCC(CCTMP))) 
      IF( CCTMP(1:LENOCC(CCTMP)) .NE. 'HERA-B' )THEN
         STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
         GO TO 500  
      ENDIF 
      
      IF( LUN .GE. 1 .AND. LUN .LE. 99 )   THEN
C     *     STAGE file 
         IF( LENOCC(ACS_NAME) .LE. LENOCC(STAGEDIR))THEN
C     *     No staging 
            STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
            GO TO 500  
         ENDIF
         
         IF( ACS_NAME(1:LENOCC(STAGEDIR))
     &        .NE. STAGEDIR(1:LENOCC(STAGEDIR)))THEN
C     * No staging 
            STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
            GO TO 500 
         ENDIF
         
         IF( FIRST ) THEN
            C78=' ' 
            DO i = 1 , 78
               C78(i:i)='*'
            ENDDO 
            CALL ME78SP( 'LP' )     
            C78=
     &           '*    SSSSSSSSSS   tttttttttttt   aaaaaaaaaa '//
     &           '   gggggggggg   eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSSSSSSSSSSS  tttttttttttt  aaaaaaaaaaaa'//    
     &           '  gggggggggggg  eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS        SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS                 tt       aa        aa'//
     &           '  gg            ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSS                tt       aa        aa'//
     &           '  gg            ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*    SSSSSSSSS         tt       aaaaaaaaaaaa'//
     &           '  gg            eeeeeeee         *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*     SSSSSSSSS        tt       aaaaaaaaaaaa'//
     *           '  gg     ggggg  eeeeeeee         *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*            SSS       tt       aa        aa'//
     &           '  gg     ggggg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*             SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS        SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSSSSSSSSSSS       tt       aa        aa'//
     &           '  gggggggggggg  eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*    SSSSSSSSSS        tt       aa        aa'//
     &           '   gggggggggg   eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78 = '*  utstage.F,  nice utility to STAGE tape f'//
     &           'iles                              *'
            CALL ME78SP('PL')
            C78 = '*   from tape to temporary disk            '//
     &           '                                  *'
            CALL ME78SP('PL')
            C78 = '*   originally written by F.Ratnikov       '//
     &           '                                  *'
            CALL ME78SP('PL')
            C78=' ' 
            DO i = 1 ,78
               C78(i:i)='*'
            ENDDO 
            CALL ME78SP( 'LP' ) 
            DO ifile = 1 , MaxFiles 
             TMP_NAME( iFile ) = ' ' 
            ENDDO 
          FIRST = .FALSE. 
       ENDIF 
       
         C78='utstage.F: File'
         CALL CH78BC( ACS_NAME(1:LENOCC(ACS_NAME)) )
         CALL CH78BC( 'has to be STAGED' ) 
         CALL ME78AP 
         
         DO ifile=1,nUsed
            IF( LUNID(ifile) .EQ. LUN )  THEN ! found
               C78='ustage.F: file with LUN='
               CALL CH78AI( LUN         )
               CALL CH78BC( 'is found!' )
               CALL CH78BC( '(ifile='   )
               CALL CH78AI( ifile       ) 
               CALL CH78AC( ')'         )
               CALL CH78BC( 'Remove it!')
               CALL ME78AP 
               C78 = 'Remove'
               CALL CH78BC( TMP_NAME(iFILE) ) 
               CALL ME78AP
               CALL SYSTEM(' rm '//TMP_NAME(ifile)) ! remove previous file if any
               GOTO 100         ! skip initialization
            ENDIF
         ENDDO
C     *     initiates temporary file
         IF(nUsed.GE.MaxFiles)  THEN
            C78='utstage.F ==> Cant stage more then'
            CALL CH78BI( MaxFiles ) 
            CALL CH78BC( 'units' ) 
            CALL ME78ER 
         ENDIF
         nUsed = nUsed+1
         ifile = nUsed
         LUNID(ifile) = LUN
         
 100     CONTINUE 
         
         ii=0
         DO i=1,LENOCC(ACS_NAME)
            IF( ACS_NAME(i:i) .NE. '/' )THEN 
               ii=ii+1
               CTMP(ii:ii)=ACS_NAME(i:i)
            ELSE 
               DO ii=1,LEN(CTMP)
                  CTMP(ii:ii)=' ' 
               ENDDO 
               ii=0
            ENDIF 
         ENDDO 
         
         IF( LENOCC(STAGETMP) .LE. 0)THEN
            CALL GETENV('USER',CUSER) 
            C78='utstage.F: directory /tmp/'
            CALL CH78AC( CUSER ) 
            CALL CH78BC( 'will be used for staging!' ) 
            CALL ME78PC( 9238147 , 1 )
            STAGETMP='/tmp/'//CUSER(1:LENOCC(CUSER))//'/'    
         ENDIF          
         
         N_AVAI = 0 
         N_AVAI = FREESPACE( STAGETMP(1:LENOCC(STAGETMP))) 
         
         IF( N_AVAI .LE. 0 )THEN
            C78='utstage.F: No space available on'
            CALL CH78BC( STAGETMP(1:LENOCC(STAGETMP)))
            CALL ME78WC( 92187  ) 
            STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
            GO TO 500           
         ENDIF 
         
         CCTMP=' '
         CCTMP=ACS_NAME(1:LENOCC(ACS_NAME))
         N_REQU = 0 
         N_REQU = FILESIZE( CCTMP(1:LENOCC(CCTMP)))
         
         IF( N_REQU .LE. 0 )THEN
            C78='utstage.F: File Info is not available:'
            CALL CH78BC( ACS_NAME(1:LENOCC(ACS_NAME)))
            CALL ME78WC( 92188  ) 
            STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
            GO TO 500           
         ENDIF 
         
         IF( N_REQU .GE. N_AVAI )THEN
            C78='utstage.F: Not enought space:Requested='
            CALL CH78AI( INT(FLOAT(N_REQU)/1024.0) )
            CALL CH78BC( 'MBytes' ) 
            CALL CH78CC( 'Available=' )
            CALL CH78AI( INT(FLOAT(N_AVAI)/1024.0) )
            CALL CH78BC( 'MBytes' ) 
            CALL ME78WC( 9123874  ) 
            STAGE_NAME=ACS_NAME(1:LENOCC(ACS_NAME))
            GO TO 500              
         ENDIF 

         C78='utstage.F: Available space is'
         CALL CH78BI( INT( FLOAT( N_AVAI ) / 1024.0 ) ) 
         CALL CH78BC( 'MBytes' ) 
         CALL CH78CC('Required space is')
         CALL CH78BI( INT( FLOAT( N_REQU ) / 1024.0 ) )
         CALL CH78BC( 'MBytes' )
         CALL ME78SP( 'PL' )   
                  
         C78='/'
         CALL CH78AC( CTMP(1:LENOCC(CTMP) ) ) 
         CCTMP = ' ' 
         CCTMP = STAGETMP(1:LENOCC(STAGETMP))//
     &           C78(1:LENOCC(C78))     
 
         C78='.'
         CALL CH78AI( PROCESSID ) 
         CALL CH78AC( '.' )
         CALL DATIME ( I1(1) , I2(1) )
         I2(1) = I2(1) * 100 + SLATE(6)
         CALL CH78AI ( I2(1) / 10000)
         CALL CH78AC ( 'h')
         CALL CH78AI ( MOD (I2(1) / 100, 100))
         CALL CH78AC ( 'm')
         CALL CH78AI ( MOD (I2(1), 100) )
         CALL CH78AC ( 's')
         
         CCTMP=CCTMP(1:LENOCC(CCTMP))//C78(1:LENOCC(C78))

         TMP_NAME(iFILE)=' '
         TMP_NAME(iFILE)=CCTMP(1:LENOCC(CCTMP))
         
         STAGE_NAME = TMP_NAME(ifile)(1:MIN(LEN(STAGE_NAME) , 
     &     LENOCC(TMP_NAME(ifile))))

         C78='utstage.F: Start STAGE  (it will take some time...)'
         CALL ME78AP
         C78='     from:' 
         CALL CH78BC( ACS_NAME(1:LENOCC(ACS_NAME))) 
         CALL ME78AP  
         C78='       to: ' 
         CALL CH78BC( STAGE_NAME(1:LENOCC(STAGE_NAME))) 
         CALL ME78AP  
         C78='       at: ' 
         CALL DATIME ( I1(1) , I2(1) )
         I2(1) = I2(1) * 100 + SLATE(6)
         CALL CH78BI (I1(1) / 10000)
         CALL CH78AC ('/')
         CALL CH78AI (MOD (I1(1) / 100, 100))
         CALL CH78AC ('/')
         CALL CH78AI (MOD (I1(1), 100))
         CALL CH78BI (I2(1) / 10000)
         CALL CH78AC ('h')
         CALL CH78AI (MOD (I2(1) / 100, 100))
         CALL CH78AC ('m')
         CALL CH78AI (MOD (I2(1), 100))
         CALL CH78AC ('s')
         CALL ME78AP 
         IF( LENOCC(STAGECOM) .LE. 0 )THEN
            C78='utstage.F: Command osmcp will be used for stageing!'
            CALL ME78PC(2937, 1 )      
            STAGECOM=' osmcp ' 
         ENDIF 

         CCTMP  = ACS_NAME  (1:LENOCC(ACS_NAME  ))
         CCTMP1 = STAGE_NAME(1:LENOCC(STAGE_NAME)) 

         CALL SYSTEM(STAGECOM(1:LENOCC(STAGECOM))//' '//
     &        CCTMP//' '//CCTMP1)

         C78='utstage.F: Complete STAGE from' 
         CALL CH78BC( ACS_NAME(1:LENOCC(ACS_NAME))) 
         CALL ME78AP  
         C78='       to:' 
         CALL CH78BC( STAGE_NAME(1:LENOCC(STAGE_NAME))) 
         CALL ME78AP  
         C78='       at:' 
         CALL DATIME ( I1(1) , I2(1) )
         I2(1) = I2(1) * 100 + SLATE(6)
         CALL CH78BI (I1(1) / 10000)
         CALL CH78AC ('/')
         CALL CH78AI (MOD (I1(1) / 100, 100))
         CALL CH78AC ('/')
         CALL CH78AI (MOD (I1(1), 100))
         CALL CH78BI (I2(1) / 10000)
         CALL CH78AC ('h')
         CALL CH78AI (MOD (I2(1) / 100, 100))
         CALL CH78AC ('m')
         CALL CH78AI (MOD (I2(1), 100))
         CALL CH78AC ('s')
         CALL ME78AP 
         
      ELSE      
C     *  Remove temporary files
         DO ifile = 1,nUsed
            C78='utstage.F: remove iFILE='
            CALL CH78AI( iFILE ) 
            CALL CH78BC( 'LUN=' ) 
            CALL CH78AI( LUNID(iFILE) )
            CALL ME78AP
            C78 = 'Remove'
            CALL CH78BC( TMP_NAME(iFILE) ) 
            CALL ME78AP        
            CALL SYSTEM('rm '//TMP_NAME(ifile))
         ENDDO
C     *  List TMP directory
         IF ( nUsed .NE. 0 )THEN
            C78='utstage.F: List of' 
            CALL CH78BC( STAGETMP(1:LENOCC(STAGETMP)))
            CALL CH78BC( 'directory' ) 
            CALL ME78AP 
            CALL SYSTEM( ' ls -alLF '//STAGETMP(1:LENOCC(STAGETMP)))
            N_AVAI = 0 
            N_AVAI = FREESPACE( STAGETMP(1:LENOCC(STAGETMP))) 
            C78='Available space in $STAGETMP='
            CALL CH78AC( STAGETMP(1:LENOCC(STAGETMP)))
            CALL CH78BC( 'directory is' ) 
            CALL CH78BI( INT( FLOAT(N_AVAI)/1024.0 ) )
            CALL CH78BC( 'Mbytes' ) 
            CALL ME78AP
C     *     Final message 
            C78=' ' 
            DO i = 1 , 78
               C78(i:i)='*'
            ENDDO 
            CALL ME78SP( 'LP' )     
            C78=
     &           '*    SSSSSSSSSS   tttttttttttt   aaaaaaaaaa '//
     &           '   gggggggggg   eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSSSSSSSSSSS  tttttttttttt  aaaaaaaaaaaa'//    
     &           '  gggggggggggg  eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS        SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS                 tt       aa        aa'//
     &           '  gg            ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSS                tt       aa        aa'//
     &           '  gg            ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*    SSSSSSSSS         tt       aaaaaaaaaaaa'//
     &           '  gg            eeeeeeee         *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*     SSSSSSSSS        tt       aaaaaaaaaaaa'//
     *           '  gg     ggggg  eeeeeeee         *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*            SSS       tt       aa        aa'//
     &           '  gg     ggggg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*             SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SS        SS       tt       aa        aa'//
     &           '  gg        gg  ee               *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*   SSSSSSSSSSSS       tt       aa        aa'//
     &           '  gggggggggggg  eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78=                     
     &           '*    SSSSSSSSSS        tt       aa        aa'//
     &           '   gggggggggg   eeeeeeeeeeee     *'
            CALL ME78SP( 'LP' ) 
            C78 = '*  utstage.F,  nice utility to STAGE tape f'//
     &           'iles                             *'
            CALL ME78SP('PL')
            C78 = '*   from tape to temporary disk            '//
     &           '                                 *'
            CALL ME78SP('PL')
            C78 = '*   originally written by F.Ratnikov       '//
     &           '                                 *'
            CALL ME78SP('PL')
            C78=' ' 
            DO i = 1 ,78
               C78(i:i)='*'
            ENDDO 
            CALL ME78SP( 'LP' ) 
         ENDIF 
      ENDIF
C     *    
 500  CONTINUE 
      
      RETURN
      END
      
