//                              -*- Mode: C++ -*-
//: CmdCareCalerr.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareCalerr.hh"
#include "arte/ArteMessage.hh"

/////////////// The function seen by kuip

extern "C" {
  void calerr_(){
    CmdCareCalerr prec;
    prec.readAndExe();
    prec.dump();
  }
}

extern "C" void granor_(float *y1,float *y2);

/////////////// Static data definition

float CmdCareCalerr::precision = 0.0;

/////////////// CmdCareCalerr class member function definition

CmdCareCalerr::CmdCareCalerr(){}
CmdCareCalerr::~CmdCareCalerr(){}

void CmdCareCalerr::defValues(){
  precision = 0.0;
}


//--
//   Execute stored command
void CmdCareCalerr::execute(){}

#ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareCalerr::read(){
  precision = readFloat();
  if( precision< 0.0 || precision >1.0){
    arteMsg<<" Care/PREC: input precision out of valid range [0,1[ :"
	   <<precision;
    arteMsg.warn();
    defValues();  
  }
}
#endif
float CmdCareCalerr::factor(){
  float f1 = 0.0 ,f2 = 0.0;
  if( precision>0.0){
    do{
      granor_(&f1,&f2);
      f1 = 1.0+precision*f1;
    } while( f1<0.01);
  } else 
    f1 = 1.0;
  return f1;
}

void CmdCareCalerr::dump(){
  arteMsg<<" Calibration precision :"<<precision;
  arteMsg.allp();
}
