//                              -*- Mode: C++ -*-
//: CmdCareMinims.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCAREMINIMS_HH_
#define CMDCAREMINIMS_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"
/*
CLASS
  CmdCareMinims
  Class to deal with the Minims kuip command
*/

class CmdCareMinims : public CmdBase {
public:
  //-- Constructors
  CmdCareMinims();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareMinims();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();
  //--
  //    Set internal data
  void setMinims(Energy_t  inn, Energy_t mid, Energy_t out);

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  Energy_t  inner,middle,outer;
};

#endif  //   CMDCAREMINIMS_HH_
