//                              -*- Mode: C++ -*-
//:EcalDB.hh
//
//
// Author: Vincenzo Vagnoni & Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
//

#ifndef __EcalDB_hh__
#define __EcalDB_hh__

extern "C" 
{
#include "mizzi/table.h"
}

#include <stdio.h>
#include <string.h>

class EcalDB {

private:
  Tables x;
  int xe[3];

  static char *tableName[3];

  static char *tableDesc[3];

  static int fieldNum[3];

  static int fieldDim[3][11];

  static int fieldType[3][11];

  static char *tableComment[3];


public:

  class TableMeth {
  private:
    int xeCur;
    EcalDB &EcalDBase;
    int tSize;
    int nrow;
    int major;
    int minor;

  public:
    TableMeth(int i, EcalDB &T);
    ~TableMeth();

    int Book();
    int Unbook();
    int Store(int nrow, void *ptr, int major, int minor, int access);
    int Nrow(int major, int minor, int access);
    int Fetch(void *ptr);
    int Match(int major, int minor, int access);
    int Major();
    int Minor();
  };

  friend class EcalDB::TableMeth;

  EcalDB();
  ~EcalDB();

  TableMeth ECBO;
  TableMeth ECHS;
  TableMeth ECHF;

  Tables Open(char *dbName, int access);
  int Close();

};

#endif
