//                              -*- Mode: C++ -*-
//:dgcalinit.hh
//
//
// Authors: Benedetto Giacobbe and Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it, villa@bo.infn.it
//
// Created 29/8/97
// Last Update ........
//
#ifndef DGCALINIT_HH_
#define DGCALINIT_HH_

#ifdef _OLD_NAMES_
#include <vector.h>
#else
#include <vector>
#endif


// struct containing the minimum of board description
struct BoardData {
  char type;
  float  pedChan;
  float  sigmaped;
  float  mipChan;
  int    trigflag;
  float  erconst;
  float  ersampl;
};

struct EcalDet {
  int ecaltype; // Type of ecal 1=outer, 2=middle, 3=inner
  int mstepx; // step in x in units of module
  int mstepy; // step in y in units of module
  int xmin;  // x starting corner in the global frame
  int ymin;  // y starting corner in the global frame
  int xmax;  // x ending corner in the global frame
  int ymax;  // y ending corner in the global frame
  char data[3000];
};

int ECALBoard(char* name, vector<BoardData> & boards,
	      vector<EcalDet> & calos);

extern "C" void dgcalinit_();

#endif // DGCALINIT_HH_
