#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define f2cFortran

#include <arte/Arte.h>
#include <arte/ArteUtil.h>

#include <auto/MTRA.h>
#include <auto/MIMP.h>
#include <auto/HITB.h>
#include <auto/GEDE.h>
#include <auto/GESL.h>
#include <auto/GTAR.h>
#include <auto/RTRA.h>
#include <auto/TOPP.h>

//#include "hbook.h"

#include "cfortran.h"
PROTOCCALLSFSUB6(SORTZV,sortzv,PFLOAT,PINT,INT,INT,INT,INT)
#define SORTZV(A1,A2,A3,A4,A5,A6)  CCALLSFSUB6(SORTZV,sortzv,PFLOAT,PINT,INT,INT,INT,INT,A1,A2,A3,A4,A5,A6)


#define NCHAMBERS 10
#define NPROJ      4
#define NTARGETS  10
#define MAXNUMBEROFHITS     10000
#define MAXNUMBEROFPOINTS   10000
#define MAXNUMBEROFSEGMENTS 100000
#define MAXNUMBEROFTRACKS   1000
#define maxcomb             2000

extern void fill_banks();
//extern void analyze_MC();
//extern void my_analyze_MC();

extern void ipl_(int* n, float* xpl, float* ypl);
extern void ipm_(int* n, float* xpl, float* ypl);
extern void isplci_(int* n);
extern void ispmci_(int* n);
extern void ismksc_(float* scale);
extern void iuwk_(int* m, int* n);
extern void ismk_(int* n);
extern void isfaci_(int* n);
extern void igbox_(float* a, float* b, float* c, float* d);
extern void iginit_(int* n);
extern void igsse_(int* ierrf, int* n);
extern void iscr_(int* wkid, int* n, float* r, float* g, float* b);
extern void iswn_(int* n, float* a, float* b, float* c, float* d);
extern void isvp_(int* n, float* a, float* b, float* c, float* d);
extern void iselnt_(int* n);
extern void isfaci_(int* n);
extern void isfais_(int* n);
extern void igend_();

 
//int NXPAW = 5000;
int ESC = 65307;

int DRAW  = 0;

int Black        =  1, 
    DarkGray     =  2, 
    Blue         =  3, 
    Green        =  4, 
    Cyan         =  5, 
    Red          =  6, 
    Magenta      =  7, 
    Brown        =  8, 
    LightBlue    =  9, 
    LightGreen   = 10, 
    LightCyan    = 11, 
    LightRed     = 12, 
    LightMagenta = 13, 
    Yellow       = 14, 
    LightGray    = 15, 
    White        =  0;

int Solid   = 1, 
    Dashed  = 2, 
    Dotted  = 3;


void run_cats();
void start_cats();
void stop_cats();
void Find_Space_Tracks();
void Sort_Hits();
void Reconstruct_Points();
void Automaton();
void Track_Finder();
void Find_Track_Chi_2(int n, int k);
void Draw_Event();
void graph_ini();
void graph_close();

void run_cats_mc();

                 /* distances in cm */

int   iTRUE=1; /* to simulate logical TRUE */

float ERROR      = 0.0030; /* error of measurements -> chi^2 */
int   MINLEVEL   = 2;

float TARGETCUT;    /* length of one side of the square-like target */
float MINDIST   ;    /* error for track searching */

int   n_at_least = 9;
int   n_at_least_target = 5;


int   nchambers, ichamber[NCHAMBERS+1]; /* real number of superlayers          */
                                        /* and their numbers in the GESL table */
int   nplanes;
int   ntargets,  itarget[NTARGETS+1];   /* numbers of targets wires */

float Z_TARGET;                         /* mean target z-position */

		       /* Z-positions of the chambers */
float Z_Layer[NCHAMBERS+1]={0.00,1.50,8.00,16.00,31.00,54.00,95.00,145.00};
                       /* inner and outer positions */
float ri_Layer[NCHAMBERS+1]={0.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00};
float ro_Layer[NCHAMBERS+1]={0.00,6.00,6.00,6.00,6.00,6.00,6.00,6.00};

int   N_Hits;           /* total number of hits */

float X_Hit[MAXNUMBEROFHITS];       /* coordinate ???                */
float Z_Hit[MAXNUMBEROFHITS];       /* coordinate ???                */
int   L_Hit[MAXNUMBEROFHITS];       /* layer                         */
int   M_Hit[MAXNUMBEROFHITS];       /* which part of a layer 1,2,3,4 */
int   T_Hit[MAXNUMBEROFHITS];       /* type of a plane 1,2,3,4       */
int   First_Hit[(1+4*(1+4))*NCHAMBERS+1];/* position of the first hit */
int   Last_Hit[(1+4*(1+4))*NCHAMBERS+1]; /* position of the last hit  */
/*    M_Hit:    1     ?     T_Hit: 1 -> xm -> -2.5^o ???      */
/*             4 2    ?            2 -> xp -> +2.5^o ???      */
/*              3     ?            3 -> ym -> -2.5^o ???      */
/*                                 4 -> xp -> +2.5^o ???      */
 

int   N_Points;           /* total number of points */

float X_Point[MAXNUMBEROFPOINTS];       /* x-coordinate               */
float Z_Point[MAXNUMBEROFPOINTS];       /* z-coordinate               */
int   L_Point[MAXNUMBEROFPOINTS];       /* layer                      */
int   M_Point[MAXNUMBEROFPOINTS];       /* detector number - see M_Hit*/

int    N_Segments, Total_N_Segments;

int   FirstSegment[MAXNUMBEROFPOINTS+1], LastSegment[MAXNUMBEROFPOINTS+1];
int   TrackPoint[MAXNUMBEROFPOINTS+1]; // free or on a track at the depth level


/*
The first and the last segments starting at a hit and ending at
another hit on the next plane. Index is the number of the hit.
*/

/* Arrays describing segments. Index is the number of the segment.  */


int   StartOfSegment[MAXNUMBEROFSEGMENTS+1], 
      EndOfSegment[MAXNUMBEROFSEGMENTS+1];


/* Starting and ending hits of a segment. */

int   First_Segment[MAXNUMBEROFSEGMENTS+1], 
      Last_Segment[MAXNUMBEROFSEGMENTS+1];

/*
The first and the last segments starting at the ending hit of a
segment and making a small [ < arccos(COSPHIMAX) ] angle with the segment.
I: I would prefer FirstNeighbor & LastNeighbor instead.
*/

int   HasNeighbour[MAXNUMBEROFSEGMENTS+1];
int   LevelOfSegment[MAXNUMBEROFSEGMENTS+1];
int   CorrectIndex[MAXNUMBEROFSEGMENTS+1];

int   StartOnPlane[NCHAMBERS+1], EndOnPlane[NCHAMBERS+1];
/*
The first and the last hit on a plane. Index is the number of the plane.
(!) StartOnPlane>=EndOnPlane.
*/

int   SetNo;
//int   PlaneSet[8][8]={{6,0,1,2,3,4,5},{5,0,2,3,4,5},{5,0,1,3,4,5}};
//int   CoPlaneSet[8][8]={{0},{1,1},{1,2}};

int   PlaneSet[8][8]={{5,1,2,3,4,5},{4,1,2,4,5},{4,1,3,4,5}};
int   CoPlaneSet[8][8]={{0},{1,3},{1,2}};

int   N_Vertices;

int   NumberOfTrackPoints;
int   NumberOfTracks, Level;
int   LengthOfTrack[MAXNUMBEROFTRACKS+1];
int   GoodTrack[MAXNUMBEROFTRACKS+1];
float Chi_2[MAXNUMBEROFTRACKS+1];
int   n_sector[MAXNUMBEROFTRACKS+1];

int   CurrentTrackStart[NCHAMBERS+1];
int   TrackStart[MAXNUMBEROFTRACKS+1][NCHAMBERS+1];

int   Call;

int   Event;

int   Ntr_mc_proper, Ntr_mc_reco, N_Events;
int   Ntr_mc_b_proper, Ntr_mc_b_reco, N_b_Events, N_g_Events;

float svd_efficiency, svd_b_efficiency, svd_ghost_rate;
float geometrical_acceptance;

float SHIFT      =  10.0;
float shift;
int   base_plane[5] = {0, 1, 11, 2, 7};
int   shift_coeff[5] = {0, 3, 1, -1, -3};
int   projection;

int   Ntk_prj[5];
float Yp_prj[5][MAXNUMBEROFTRACKS+1], Y0_prj[5][MAXNUMBEROFTRACKS+1];
int   N_Sector[5][MAXNUMBEROFTRACKS+1];

int   Ntk, nh_trk[MAXNUMBEROFTRACKS+1], NS_trk[MAXNUMBEROFTRACKS+1];
float Yp_trk[MAXNUMBEROFTRACKS+1], Y0_trk[MAXNUMBEROFTRACKS+1];
float Zp_trk[MAXNUMBEROFTRACKS+1], Z0_trk[MAXNUMBEROFTRACKS+1];
int   hits[MAXNUMBEROFHITS+MAXNUMBEROFTRACKS+10];


void run_cats(){
  int   nh, ih, ipr;
  int   nn, itr;
  float yy;

  TARGETCUT  = 0.3;    /* length of one side of the square-like target */
  MINDIST    = 0.0700; /* error for track searching */

  /* recall the target wires for each event */
  ntargets = 0;
  Z_TARGET = 0.0;
  for(ih=1; ih <= 10; ih++){
    if (GTAR(ih).wnr!=0){
      ntargets++;
      itarget[ntargets] = ih;
      Z_TARGET = Z_TARGET + GTAR(ih).z;
//     printf("Target %d wire %d (x_th %f - y_th %f), position (%f, %f, %f)\n",
//	       ntargets, GTAR(ih).wnr, GTAR(ih).dx, GTAR(ih).dy, 
//	       GTAR(ih).x, GTAR(ih).y, GTAR(ih).z);
    }
    if (GTAR(ih).wnr==0) goto no_more_targets;
  }
no_more_targets:;  
  if (ntargets!=0) Z_TARGET = Z_TARGET/ntargets;
  

  shift = SHIFT; /* for a case of simulated data - will be checked later*/
  
  if(DRAW){
    Draw_Event();
  }


// test data only in a projection corresponding to this plane slope

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  for(ipr=1; ipr <= 4; ipr++){ 

    projection = ipr;
    shift = shift_coeff[ipr]*SHIFT;

    N_Hits = 0;
    nh = NHITB(); 
  
    /*        x,y,z coodinates of the hit #ih */
    nn = 2;
    for(ih=1; ih <= nh; ih++){ 

      if (GEDE(HITB(ih).gede).cmp!=1) continue;
      if (
	  (fabs(GEDE(HITB(ih).gede).sin-GEDE(base_plane[ipr]).sin)<0.00001)&&
	  (fabs(GEDE(HITB(ih).gede).cos-GEDE(base_plane[ipr]).cos)<0.00001)
	  ) 
	{
	  N_Hits++;
	  X_Hit[N_Hits] = HITB(ih).x;
	  Z_Hit[N_Hits] = HITB(ih).z;
	  L_Hit[N_Hits] = GESL(GEDE(HITB(ih).gede).ogesl).nsl;
	  M_Hit[N_Hits] = GEDE(HITB(ih).gede).sec;// & 65535;
	  T_Hit[N_Hits] = GEDE(HITB(ih).gede).lay;// & 65535;

	}

      if (
	  (fabs(GEDE(HITB(ih).gede).sin+GEDE(base_plane[ipr]).sin)<0.00001)&&
	  (fabs(GEDE(HITB(ih).gede).cos+GEDE(base_plane[ipr]).cos)<0.00001)
	  ) 
	{
	  N_Hits++;
	  X_Hit[N_Hits] =-HITB(ih).x;
	  Z_Hit[N_Hits] = HITB(ih).z;
	  L_Hit[N_Hits] = GESL(GEDE(HITB(ih).gede).ogesl).nsl;
	  M_Hit[N_Hits] = GEDE(HITB(ih).gede).sec;// & 65535;
	  T_Hit[N_Hits] = GEDE(HITB(ih).gede).lay;// & 65535;

	}
    }

    Sort_Hits();

    Reconstruct_Points();

    Track_Finder();

    Ntk_prj[ipr] = 0;
    for (itr=1;itr<=NumberOfTracks;itr++){
      if (GoodTrack[itr]==1){ 
	Ntk_prj[ipr]++;
	Yp_prj[ipr][Ntk_prj[ipr]] = 
	  (X_Point[TrackStart[itr][LengthOfTrack[itr]]]-X_Point[TrackStart[itr][1]])/
	  (Z_Point[TrackStart[itr][LengthOfTrack[itr]]]-Z_Point[TrackStart[itr][1]]);
	Y0_prj[ipr][Ntk_prj[ipr]] = X_Point[TrackStart[itr][1]] - 
	  Yp_prj[ipr][Ntk_prj[ipr]]*Z_Point[TrackStart[itr][1]];

	N_Sector[ipr][Ntk_prj[ipr]] = n_sector[itr];

//	hfill(120+ipr, (float)LengthOfTrack[itr], 0.0, 1.0);


    	yy=Y0_prj[ipr][Ntk_prj[ipr]]+Yp_prj[ipr][Ntk_prj[ipr]]*Z_TARGET;

//	hfill(102+ipr, yy,  0.0, 1.0);

      }
    }
//    hfill(110+ipr, (float)Ntk_prj[ipr], 0.0, 1.0);

  }
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  
    Find_Space_Tracks();
  
    fill_banks();

  /*  for (itr=1; itr<= NRTRA();itr++){
    printf("track %d %f %f %f \n", itr, 
	   RTRA(itr).ZF, RTRA(itr).XF, RTRA(itr).YF); 
 }*/

  return;
  
}




void run_cats_mc(){
  int   nh, ih;
  int   nn, itr, ipr;

  TARGETCUT  = 0.3;    /* length of one side of the square-like target */
  MINDIST    = 0.0500; /* error for track searching */


  shift = SHIFT; /* for a case of simulated data - will be checked later*/

  /* recall the target wires for each event */
  ntargets = 0;
  Z_TARGET = 0.0;
  for(ih=1; ih <= 10; ih++){
    if (GTAR(ih).wnr!=0){
      ntargets++;
      itarget[ntargets] = ih;
      Z_TARGET = Z_TARGET + GTAR(ih).z;
//     printf("Target %d wire %d (x_th %f - y_th %f), position (%f, %f, %f)\n",
//	       ntargets, GTAR(ih).wnr, GTAR(ih).dx, GTAR(ih).dy, 
//	       GTAR(ih).x, GTAR(ih).y, GTAR(ih).z);
    }
    if (GTAR(ih).wnr==0) goto no_more_targets;
  }
no_more_targets:;  
  if (ntargets!=0) Z_TARGET = Z_TARGET/ntargets;
  


  
  if(DRAW){
    Draw_Event();
  }
  

  /* test data only in a projection corresponding to this plane slope */
  
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
  for(ipr=1; ipr <= 4; ipr++){ 
    
    projection = ipr;
    shift = shift_coeff[ipr]*SHIFT;
    
    N_Hits = 0;
    nh = NHITB(); 
    
    /*        x,y,z coodinates of the hit #ih */
    nn = 2;
    for(ih=1; ih <= nh; ih++){ 
      
      if (GEDE(HITB(ih).gede).cmp!=1) continue;
      if (
	  (fabs(GEDE(HITB(ih).gede).sin-GEDE(base_plane[ipr]).sin)<0.00001)&&
	  (fabs(GEDE(HITB(ih).gede).cos-GEDE(base_plane[ipr]).cos)<0.00001)
	  ) 
	{
	  N_Hits++;
	  X_Hit[N_Hits] = HITB(ih).x;
	  Z_Hit[N_Hits] = HITB(ih).z;
	  L_Hit[N_Hits] = GESL(GEDE(HITB(ih).gede).ogesl).nsl;
	  M_Hit[N_Hits] = GEDE(HITB(ih).gede).sec;// & 65535;
	  T_Hit[N_Hits] = GEDE(HITB(ih).gede).lay;// & 65535;
	  
	}
      
      if (
	  (fabs(GEDE(HITB(ih).gede).sin+GEDE(base_plane[ipr]).sin)<0.00001)&&
	  (fabs(GEDE(HITB(ih).gede).cos+GEDE(base_plane[ipr]).cos)<0.00001)
	  ) 
	{
	  N_Hits++;
	  X_Hit[N_Hits] =-HITB(ih).x;
	  Z_Hit[N_Hits] = HITB(ih).z;
	  L_Hit[N_Hits] = GESL(GEDE(HITB(ih).gede).ogesl).nsl;
	  M_Hit[N_Hits] = GEDE(HITB(ih).gede).sec;// & 65535;
	  T_Hit[N_Hits] = GEDE(HITB(ih).gede).lay;// & 65535;
	  
	}
    }
    
    Sort_Hits();
    Reconstruct_Points();
    Track_Finder();
    Ntk_prj[ipr] = 0;
    for (itr=1;itr<=NumberOfTracks;itr++){
      if (GoodTrack[itr]==1){ 
	Ntk_prj[ipr]++;
	Yp_prj[ipr][Ntk_prj[ipr]] = 
	  (X_Point[TrackStart[itr][LengthOfTrack[itr]]]-X_Point[TrackStart[itr][1]])/
	  (Z_Point[TrackStart[itr][LengthOfTrack[itr]]]-Z_Point[TrackStart[itr][1]]);
	Y0_prj[ipr][Ntk_prj[ipr]] = X_Point[TrackStart[itr][1]] - 
	  Yp_prj[ipr][Ntk_prj[ipr]]*Z_Point[TrackStart[itr][1]];
	
//	hfill(120+ipr, (float)LengthOfTrack[itr], 0.0, 1.0);
	
      }
    }
//    hfill(110+ipr, (float)Ntk_prj[ipr], 0.0, 1.0);
    
  }
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
  
  Find_Space_Tracks();
  fill_banks();
//  my_analyze_MC();
//  analyze_MC();
  /*  for (itr=1; itr<= NRTRA();itr++){
    printf("track %d %f %f %f \n", itr, 
	   RTRA(itr).ZF, RTRA(itr).XF, RTRA(itr).YF); 
 }*/

  return;
  
}



void Find_Space_Tracks()
{
  int   nh, ih, ih1,  ih2, ipr, ipl;
  int   i, itr, nt1, nt2;
  float MinDist; 
  float x;
  float c1, s1, c2, s2, det;
  float y1, yp1, y2, yp2;
  float y0, z0, yp, zp, yy, zz;
  int   nfound, nlost;
  float qual;
  int   fh[4*4*(NCHAMBERS+1)], lh[4*4*(NCHAMBERS+1)], fpl, npl; 
  float zpl[4*4*(NCHAMBERS+1)];
  int   ihit[MAXNUMBEROFHITS+1], ifl[MAXNUMBEROFHITS+1], n_hits;
  int   kl, kr, k0;
  float Ysl[maxcomb], Y0[maxcomb], Zsl[maxcomb], Z0[maxcomb], Nh[maxcomb];
  int   NS[maxcomb], ind[maxcomb], ncomb;
  int   ip1, ip2, it1, it2;
  int   m, nt, l;
  
  int   hh[4*4*(NCHAMBERS+1)];

  float xpl[1000], ypl[1000];
  int   nn;
  float z_target_tmp;
  int   target_found;

  int   il, im;
  int   n_3d[10];
  float z_3d[10];

  fpl = 1000;
  npl = 0;
  n_hits = 0;
  for(ih=1; ih <= NHITB(); ih++){ 
    if (n_hits+1>MAXNUMBEROFHITS) goto a;
    if (GEDE(HITB(ih).gede).cmp!=1) continue;
    n_hits++;
    ihit[n_hits] = ih;
    if (HITB(ih).gede > npl) npl = HITB(ih).gede;
  }
a:

  for(ih1=1; ih1 < n_hits; ih1++){ 
    for(ih2=ih1+1; ih2 <= n_hits; ih2++){ 
      if ((HITB(ihit[ih1]).gede > HITB(ihit[ih2]).gede)||
	  ((HITB(ihit[ih1]).gede == HITB(ihit[ih2]).gede)&&
	   (HITB(ihit[ih1]).x > HITB(ihit[ih2]).x))){
	ih        = ihit[ih1];
	ihit[ih1] = ihit[ih2];
	ihit[ih2] = ih;
      }
    }
  }

  for(ipl=1; ipl <= npl; ipl++){ 
    fh[ipl] = 0;
    lh[ipl] = 0;
  }


  
  for (ih=1;ih<=n_hits;ih++){
    ipl=HITB(ihit[ih]).gede;
    if (fh[ipl] == 0) fh[ipl] = ih;
    lh[ipl] = ih+1;
    zpl[ipl] = HITB(ihit[ih]).z;
    ifl[ih]  = 0;
  }

  ncomb = 0;
  for (ip1=1; ip1 < 4; ip1++){ /* loop over 1-st base proj.*/
    nt1=Ntk_prj[ip1];
    c1=GEDE(base_plane[ip1]).cos; s1=-GEDE(base_plane[ip1]).sin;
    
    for (ip2=ip1+1; ip2 <= 4; ip2++){ /* loop over 2-d base proj. */
      nt2=Ntk_prj[ip2];
      c2=GEDE(base_plane[ip2]).cos; s2=-GEDE(base_plane[ip2]).sin;
      det=c1*s2-c2*s1;

      for (it1=1; it1 <= nt1; it1++){ /* loop over tracks on 1-st base proj.*/
	y1 =Y0_prj[ip1][it1];
	yp1=Yp_prj[ip1][it1];
	
	for (it2=1; it2 <= nt2; it2++){ /* loop over tracks on 2-d base proj.*/
	  y2 =Y0_prj[ip2][it2];
	  yp2=Yp_prj[ip2][it2];
	  
	  if (N_Sector[ip1][it1]!=N_Sector[ip2][it2]) continue;/* require the same sector!!! */


	  /* space track candidate params*/
	  y0= (y1*s2-s1*y2)/det;
	  z0=-(y1*c2-c1*y2)/det;
	  yp= (yp1*s2-s1*yp2)/det;
	  zp=-(yp1*c2-c1*yp2)/det;
	  
//	  printf("  pr1 = %d  pr2 = %d y0= %f z0= %f yp= %f zp= %f\n", ip1, ip2, y0, z0, yp, zp);
	  
	  nfound=0;
	  nlost =0;
	  qual=0.0;
	  
          for(ipl=1; ipl <= npl; ipl++){ /* count hits on _all_ planes */
	    if(fh[ipl]==lh[ipl]) continue;
	    yy=y0+yp*zpl[ipl];
	    zz=z0+zp*zpl[ipl];

	    if ( yy > GEDE(ipl).sxmn &&
		 yy < GEDE(ipl).sxmx && 
		 zz > GEDE(ipl).symn &&
		 zz < GEDE(ipl).symx ) {
	    
	      x = yy*GEDE(ipl).cos - zz*GEDE(ipl).sin; /* rotate*/
	      
	      /* find hit, closest to track position "y"*/
	      kl=fh[ipl]; kr=lh[ipl]-1;
	      while((kr-kl) > 1){
		k0=(kl+kr)>>1;
		if(x <= HITB(ihit[k0]).x) kr=k0;
		else                      kl=k0;
	      }
	      if( (HITB(ihit[kr]).x-x) < (x-HITB(ihit[kl]).x) ) k0=kr;
	      else                                              k0=kl;
	      
	      if(fabs(x-HITB(ihit[k0]).x) < MINDIST) {
		nfound++;
		qual+=1.0-fabs(x-HITB(ihit[k0]).x)/MINDIST;
	      }
	      else{
		nlost++;
	      }
	    }
	  } /* end of loop over planes */


//	  hfill(131, (float)nfound, 0.0, 1.0);
//	  hfill(132, (float)nlost, 0.0, 1.0);
//	  if (nfound != 0)
//	    hfill(133, (float)nlost/(float)nfound, 0.0, 1.0);
	  

	  
	  /* crossing the target wires? */
	  target_found = 0;
	  for(ih=1; ih <= 10; ih++){
	    if (GTAR(ih).wnr!=0){

	      yy=y0+yp*GTAR(ih).z;
	      zz=z0+zp*GTAR(ih).z;
	      if (GTAR(ih).x*GTAR(ih).x+GTAR(ih).y*GTAR(ih).y<1.0)
		if ((fabs(yy-GTAR(ih).x)<2.0*TARGETCUT)&&
		    (fabs(zz-GTAR(ih).y)<2.0*TARGETCUT)) 
		  {
		    target_found = 1;
		  }
	    }
	    if (GTAR(ih).wnr==0) goto no_more_targets;
	  }
	no_more_targets:;  

	  if ((target_found==0)||
	      ((target_found==1)&&(nfound < n_at_least_target))) continue; // check next pair of proj. tracks
	  

	  /* Store combination*/
	  Ysl[ncomb] = yp;
	  Y0 [ncomb] = y0;
	  Zsl[ncomb] = zp;
	  Z0 [ncomb] = z0;
	  NS [ncomb] = N_Sector[ip1][it1];
	  Nh [ncomb] = nfound+qual/nfound; /* Number of hits + quality factor (less then 1)*/
	  ind[ncomb] = ncomb+1;
	  if( ++ncomb >= maxcomb) {
	    printf("*** Space tracks *** == > too many combinations %d\n", ncomb);
	    goto sorting;
	  }
	  
	}
      }
      
      
    }
  }
  

sorting:
  SORTZV(Nh[0],ind[0],ncomb,1,1,0);

  nt=0; 
  nh=0;
  
  for(l=0; l < ncomb; l++){ /* loop over combinations starting from Nhit max */
    m=ind[l]-1;

    nfound = 0;
    for(ipl=1; ipl <= npl; ipl++){ /* loop over _all_ planes */
      if(fh[ipl]==lh[ipl]) continue;
      yy=Y0[m]+Ysl[m]*zpl[ipl];
      zz=Z0[m]+Zsl[m]*zpl[ipl];

      if ( yy > GEDE(ipl).sxmn &&
	   yy < GEDE(ipl).sxmx && 
	   zz > GEDE(ipl).symn &&
	   zz < GEDE(ipl).symx ) {

	x = yy*GEDE(ipl).cos - zz*GEDE(ipl).sin; /* rotate */
	
	/* find hit, closest to track position "y" */
	MinDist = MINDIST;
	for (ih=fh[ipl]; ih < lh[ipl]; ih++){ 
	  if ((fabs(x-HITB(ihit[ih]).x)<MinDist)&&(ifl[ih]==0)) {
	    hh[nfound]=ih; /* store hit */
	    MinDist = fabs(x-HITB(ihit[ih]).x);
	  }
	}
	if (MinDist< MINDIST){
	  nfound++;
	}
      }
    } /* end of loop over planes */


//    hfill(134, (float)nfound, 0.0, 1.0);
//    hfill(135, (float)nlost, 0.0, 1.0);
//    if (nfound != 0)
//      hfill(136, (float)nlost/(float)nfound, 0.0, 1.0);

    
    /* crossing the target wires? */
    target_found = 0;
    for(ih=1; ih <= 10; ih++){
      if (GTAR(ih).wnr!=0){
	
	yy=Y0[m]+Ysl[m]*GTAR(ih).z;
	zz=Z0[m]+Zsl[m]*GTAR(ih).z;
	if (GTAR(ih).x*GTAR(ih).x+GTAR(ih).y*GTAR(ih).y<1.0)
	  if ((fabs(yy-GTAR(ih).x)<2.0*TARGETCUT)&&
	      (fabs(zz-GTAR(ih).y)<2.0*TARGETCUT)) 
	    {
	      target_found = 1;
	    }
      }
      if (GTAR(ih).wnr==0) goto no_more_targets_again;
    }
  no_more_targets_again:;  



    if ((target_found==0)||
	((nfound < n_at_least_target)&&(target_found==1)))
      goto next_comb; /* check next combination */

    /* store found hits */

    for(i=0; i < nfound; i++) {
      hits[nh++]=ihit[hh[i]];
      ifl[hh[i]]=1;  /* mark hit as used */
    }
    hits[nh++]=-1; /* end of hit list */

    //store found track parameters
    Y0_trk[nt]=Y0[m];
    Yp_trk[nt]=Ysl[m];
    Z0_trk[nt]=Z0[m];
    Zp_trk[nt]=Zsl[m];
    nh_trk[nt]=nfound;
    NS_trk[nt]=NS[m];

//    hfill(120, (float)nfound, 0.0, 1.0);

    for (ih=0; ih < nfound; ih++){ 

      yy=Y0[m]+Ysl[m]*HITB(ihit[hh[ih]]).z;
      zz=Z0[m]+Zsl[m]*HITB(ihit[hh[ih]]).z;

      x = yy*GEDE(HITB(ihit[hh[ih]]).gede).cos - 
	zz*GEDE(HITB(ihit[hh[ih]]).gede).sin; /* rotate */

//      hfill(130, fabs(x-HITB(ihit[hh[ih]]).x), 0.0, 1.0);
    }


    if(++nt >= MAXNUMBEROFTRACKS)  {
      printf("*** Space tracks *** == > too many tracks %d\n", nt); 
      return;
    }

  next_comb:;
  } /* end of loop over combinations*/

  if(DRAW){
    printf("Space tracks  N comb. = %5u N found tracks = %4u :\n", ncomb, nt);
  }

  Ntk = nt;  
   

  if(DRAW){

    isplci_(&Black);

    nn = 24;
    ismk_(&nn);
    {float mk_scal=1.5;
    ismksc_(&mk_scal);
    }
    
    for(ipr=1; ipr <= 4; ipr++){ 
      
      shift = shift_coeff[ipr]*SHIFT;

      for(ipl=1; ipl <= 10; ipl++){ 
	n_3d[ipl] = 0;
	z_3d[ipl] = 0.0;
      }

      nh = 0;//!
      
      for (itr=0;itr< Ntk;itr++){
	
	
	yy=Y0_trk[itr]+Yp_trk[itr]*Z_TARGET;
	zz=Z0_trk[itr]+Zp_trk[itr]*Z_TARGET;
	
	x = yy*GEDE(base_plane[ipr]).cos - zz*GEDE(base_plane[ipr]).sin; 
	
	xpl[0] = Z_TARGET;
	ypl[0] = x+shift+0.1;
	
	
	yy=Y0_trk[itr]+Yp_trk[itr]*zpl[npl];
	zz=Z0_trk[itr]+Zp_trk[itr]*zpl[npl];
	
	x = yy*GEDE(base_plane[ipr]).cos - zz*GEDE(base_plane[ipr]).sin; 
	
	xpl[1] = zpl[npl];
	ypl[1] = x+shift+0.1;
	nn = 2;
	ipl_(&nn,xpl,ypl);




      // find and draw 3D points

	for (ih=nh;ih<nh+nh_trk[itr];ih++){
	  il = GESL(GEDE(HITB(hits[ih]).gede).ogesl).nsl;
	  im = GEDE(HITB(hits[ih]).gede).sec;// & 65535;
	  if (im == NS_trk[itr]){
	    n_3d[il]++;
	    z_3d[il]=z_3d[il]+HITB(hits[ih]).z;
	  }
	}
	nh=nh+nh_trk[itr]+1; //skip (-1)


      for(ipl=1; ipl <= 10; ipl++){ 
	if (n_3d[ipl] != 0){
	  yy=Y0_trk[itr]+Yp_trk[itr]*z_3d[ipl]/n_3d[ipl];
	  zz=Z0_trk[itr]+Zp_trk[itr]*z_3d[ipl]/n_3d[ipl];
	  x = yy*GEDE(base_plane[ipr]).cos - zz*GEDE(base_plane[ipr]).sin; 
	
	  xpl[0] = z_3d[ipl]/n_3d[ipl];
	  ypl[0] = x+shift+0.1;
	  nn = 1;

	  ispmci_(&Black);
	  if (n_3d[ipl] == 1) ispmci_(&Black);
	  if (n_3d[ipl] == 2) ispmci_(&Blue);
	  if (n_3d[ipl] == 3) ispmci_(&Green);
	  if (n_3d[ipl] == 4) ispmci_(&Red);

	  ipm_(&nn,xpl,ypl);

	}
      }


	
      }
    }
    
    
    
    /* draw the target */
    
    ispmci_(&Green);
    nn = 3;
    ismk_(&nn);
    {float mk_scal=0.5;
    ismksc_(&mk_scal);
    }
    
    isplci_(&Black);
    
    for (i=1; i<=ntargets; i++){
      ih = itarget[i];
      
      xpl[0] = GTAR(ih).x;
      ypl[0] = GTAR(ih).y-0.5*GTAR(ih).dy;
      xpl[1] = GTAR(ih).x;
      ypl[1] = GTAR(ih).y+0.5*GTAR(ih).dy;
      nn = 2;
      ipl_(&nn,xpl,ypl);
      
      xpl[0] = GTAR(ih).x-0.5*GTAR(ih).dx;
      ypl[0] = GTAR(ih).y;
      xpl[1] = GTAR(ih).x+0.5*GTAR(ih).dx;
      ypl[1] = GTAR(ih).y;
      nn = 2;
      ipl_(&nn,xpl,ypl);
      
    }
    
    {float mk_scal=1.5;
    ismksc_(&mk_scal);
    }
    ispmci_(&Blue);
    nn = 24;
    ismk_(&nn);
    
  }/* draw */

//  hfill(110, (float)Ntk, 0.0, 1.0);

  for (itr=0;itr< Ntk;itr++){
    
    yy=Y0_trk[itr]+Yp_trk[itr]*Z_TARGET;
    zz=Z0_trk[itr]+Zp_trk[itr]*Z_TARGET;

//    hfill(100, yy,  zz, 1.0);
//    hfill(107, yy,  zz, 1.0);
//    hfill(101, yy, 0.0, 1.0);
//    hfill(102, zz, 0.0, 1.0);

    if(DRAW){
//      printf("track %d on the  target (%f, %f) \n", itr+1, yy, zz);
      
      xpl[0] = yy;
      ypl[0] = zz;
      
      nn = 1;
      ipm_(&nn,xpl,ypl);
    }
    
  }


  z_target_tmp = -0.7;
  for (itr=0;itr< Ntk;itr++){
    
    yy=Y0_trk[itr]+Yp_trk[itr]*z_target_tmp;
    zz=Z0_trk[itr]+Zp_trk[itr]*z_target_tmp;

//    hfill(150, yy,  zz, 1.0);
//    hfill(151, yy, 0.0, 1.0);
//    hfill(152, zz, 0.0, 1.0);

  }

  z_target_tmp = -1.0;
  for (itr=0;itr< Ntk;itr++){
    
    yy=Y0_trk[itr]+Yp_trk[itr]*z_target_tmp;
    zz=Z0_trk[itr]+Zp_trk[itr]*z_target_tmp;

//    hfill(160, yy,  zz, 1.0);
//    hfill(161, yy, 0.0, 1.0);
//    hfill(162, zz, 0.0, 1.0);

  }

  z_target_tmp = -4.7;
  for (itr=0;itr< Ntk;itr++){
    
    yy=Y0_trk[itr]+Yp_trk[itr]*z_target_tmp;
    zz=Z0_trk[itr]+Zp_trk[itr]*z_target_tmp;

//    hfill(170, yy,  zz, 1.0);
//    hfill(171, yy, 0.0, 1.0);
//    hfill(172, zz, 0.0, 1.0);

  }

  z_target_tmp = -5.0;
  for (itr=0;itr< Ntk;itr++){
    
    yy=Y0_trk[itr]+Yp_trk[itr]*z_target_tmp;
    zz=Z0_trk[itr]+Zp_trk[itr]*z_target_tmp;

//    hfill(180, yy,  zz, 1.0);
//    hfill(181, yy, 0.0, 1.0);
//    hfill(182, zz, 0.0, 1.0);

  }




  if(DRAW){
    nn = 1;
    iuwk_(&nn,&nn);
  }


  return;
}




void Sort_Hits(){
  
#define ALN2I 1.442695022
#define TINY  1.0e-5
  
  int   l_tmp, m_tmp, t_tmp;
  float x_tmp, z_tmp;

  int nn,m,j,i,lognb2;
  int n;
  
  n = N_Hits;   

  lognb2=(log((double) n)*ALN2I+TINY);
  
  /* make order only inside a superlayer */

  m=n;
  for (nn=1;nn<=lognb2;nn++) {
     m >>= 1;
     for (j=m+1;j<=n;j++) {
	i=j-m;
	l_tmp=L_Hit[j];
	m_tmp=M_Hit[j];
	t_tmp=T_Hit[j];
	x_tmp=X_Hit[j];
	z_tmp=Z_Hit[j];
	while (i >= 1 &&
	       ((L_Hit[i]   > l_tmp) ||
		((L_Hit[i] == l_tmp) && /* (M_Hit[i]  > m_tmp))||
		((L_Hit[i] == l_tmp) && (M_Hit[i] == m_tmp) &&
		 (T_Hit[i]  > t_tmp))||
		((L_Hit[i] == l_tmp) && (M_Hit[i] == m_tmp) &&
		 (T_Hit[i] == t_tmp) && */ (X_Hit[i]  > x_tmp)) )   ) {
	   L_Hit[i+m]=L_Hit[i];
	   M_Hit[i+m]=M_Hit[i];
	   T_Hit[i+m]=T_Hit[i];
	   X_Hit[i+m]=X_Hit[i];
	   Z_Hit[i+m]=Z_Hit[i];
	   i -= m;
	   }
	L_Hit[i+m]=l_tmp;
	M_Hit[i+m]=m_tmp;
	T_Hit[i+m]=t_tmp;
	X_Hit[i+m]=x_tmp;
	Z_Hit[i+m]=z_tmp;
	}
     }

  /*
    
  for (ih1=1; ih1<=N_Hits; ih1++)
    printf(" *** %d %d %d %d\n",ih1, L_Hit[ih1], M_Hit[ih1], T_Hit[ih1]);
    */

  /*

  for (i=1; i<=(1+4*(1+4))*nchambers; i++){
    First_Hit[i] = 0;
    Last_Hit[i]  =-1;
  }

  for (ih1=1; ih1<=N_Hits; ih1++){
    l_tmp = L_Hit[ih1];
    m_tmp = M_Hit[ih1];
    t_tmp = T_Hit[ih1];
    i = (l_tmp-1)*(1+4*(1+4))+1; // point to layer L 
    if (First_Hit[i]==0) 
      First_Hit[i] = ih1;
    Last_Hit[i] = ih1;
    i = (l_tmp-1)*(1+4*(1+4))+1+(m_tmp-1)*(1+4)+1; // point to part M 
    if (First_Hit[i]==0) 
      First_Hit[i] = ih1;
    Last_Hit[i] = ih1;
    i = (l_tmp-1)*(1+4*(1+4))+1+(m_tmp-1)*(1+4)+1+t_tmp;// point to plane T
    if (First_Hit[i]==0) 
      First_Hit[i] = ih1;
    Last_Hit[i] = ih1;
  }
  */
  /*     
    for (ih1=1; ih1<=nchambers; ih1++){
    i = (ih1-1)*(1+4*(1+4))+1; 
    printf("*** Layer %d at %d %d -- %d \n",ih1,i,First_Hit[i],Last_Hit[i]);
    for (ih2=1; ih2<=4; ih2++){
    i = (ih1-1)*(1+4*(1+4))+1+(ih2-1)*(1+4)+1; 
    printf(" ** Part  %d at %d %d -- %d \n",ih2,i,First_Hit[i],Last_Hit[i]);
    for (ih3=1; ih3<=4; ih3++){
    i = (ih1-1)*(1+4*(1+4))+1+(ih2-1)*(1+4)+1+ih3; 
    printf("  * Plane %d at %d %d -- %d \n",ih3,i,First_Hit[i],Last_Hit[i]);
    }
    }
    }
    */
  
}


void Reconstruct_Points(){
  
  int   i, il, ih1, nn, ip;
  float xpm[1000], ypm[1000];

  N_Points = 0;

  /*
  for (il=1; il<=nchambers; il++){
    for (im=1; im<=4; im++){
      for (ip1=1; ip1<=4;ip1++){
	i1 = (il-1)*(1+4*(1+4))+1+(im-1)*(1+4)+1+        ip1; 
	for (ih1=First_Hit[i1]; ih1<=Last_Hit[i1]; ih1++){
	    
	  N_Points++;
	  L_Point[N_Points] = L_Hit[ih1];
	  M_Point[N_Points] = M_Hit[ih1];
	  Z_Point[N_Points] = Z_Hit[ih1];
	  X_Point[N_Points] = X_Hit[ih1];
	      
	}
      }
    }
  }

  */


  for (ih1=1; ih1<=N_Hits; ih1++){
    N_Points++;
    L_Point[N_Points] = L_Hit[ih1];
    M_Point[N_Points] = M_Hit[ih1];
    Z_Point[N_Points] = Z_Hit[ih1];
    X_Point[N_Points] = X_Hit[ih1];
  }
  if(DRAW){
    /*  printf("Number of points = %d\n", N_Points);*/
  }

  for (i=0; i<=NCHAMBERS; i++) {
    StartOnPlane[i] = 0;
    EndOnPlane[i]   = N_Points+1;
  }
  
  for (i=N_Points;i>0;i--){
    TrackPoint[i] = 0;
    FirstSegment[i]=0;
    LastSegment[i]=-1;
    il=L_Point[i];
    if (StartOnPlane[il] == 0)
      StartOnPlane[il] = i;
    EndOnPlane[il] = i;
  }
  /*  
  for (i=0; i<=nchambers; i++) {
    printf("planes %d : %d - %d\n", i, StartOnPlane[i],EndOnPlane[i]); 
  }
  */


  if(DRAW){
    {float mk_scal=0.5;
    ismksc_(&mk_scal);
    }
    
    nn = 3;
    ismk_(&nn);
    
    for (ip=1; ip<=N_Points; ip++){
      
      ispmci_(&Red);
      
      xpm[0] = Z_Point[ip];
      ypm[0] = X_Point[ip]+shift;
      nn = 1;
      ipm_(&nn,xpm,ypm);
      
      /*
    printf("%d (%d) %f %f %f\n", ip, N_Point[ip], X_Point[ip], Y_Point[ip], Z_Point[ip]);
    */

 
    }
    
    nn = 1;
    iuwk_(&nn,&nn);
    
  }



}


void Automaton(){
  /*******************************************
    create and make relations between segments
    ******************************************/
  int   i, ii, j, ij, n, m, ih;
  int   index;
  int   start_on_plane, end_on_plane, iplane, eplane;
  float x_n, z_n, x_m, z_m;
  int   start, end, first, last;
  int   has_i, level_i, level_j;
  float k1, k2;
  float x, x_t;
  float A1, B1, A2, B2;
  int   from_a_target;

  /*
    Note: The hits forming segments are in descending order.
    So the first segment is segment connecting the last hit on the
    first before last plane and the last hit on the last plane,
    and the last segment is segment connecting the first hit on the
    first plane and the first hit on the second plane.
    */

  index = 0;

  /* create segments in upstream direction pointing from the target      */
  /* to have the last segment on each track connected with the target  */


  for (ii=PlaneSet[SetNo][0]; ii>1; ii--){
    eplane=PlaneSet[SetNo][ii];
    iplane=PlaneSet[SetNo][ii-1];
    start_on_plane = StartOnPlane[eplane];
    end_on_plane   = EndOnPlane[eplane];
    for (n=StartOnPlane[iplane]; n>=EndOnPlane[iplane]; n--){
      if (TrackPoint[n]==0){
	x_n = X_Point[n];
	z_n = Z_Point[n];
	FirstSegment[n] = index+1;
	for (m = start_on_plane; m>=end_on_plane; m--){
	  if (TrackPoint[m]==0){ /* free point */
	    x_m = X_Point[m];
	    z_m = Z_Point[m];

	    from_a_target = 0;
	    if (Call==0){
	      for (ih=1; ih<=10; ih++){
		if (GTAR(ih).wnr!=0){
		  if (GTAR(ih).x*GTAR(ih).x+GTAR(ih).y*GTAR(ih).y<1.0){

		    x_t = GTAR(ih).x*GEDE(base_plane[projection]).cos - 
		      GTAR(ih).y*GEDE(base_plane[projection]).sin; /* rotate*/
		    
		    A1 = (x_m-(x_t-TARGETCUT))/(z_m-GTAR(ih).z);
		    B1 = x_m-A1*z_m;
		    A2 = (x_m-(x_t+TARGETCUT))/(z_m-GTAR(ih).z);
		    B2 = x_m-A2*z_m;


		    if ((x_n>(A1*z_n+B1-MINDIST))&&
			(x_n<(A2*z_n+B2+MINDIST)) &&
			(M_Point[n]==M_Point[m])) /* require the same sector */
		      from_a_target = 1;
		  }
		}
		if (GTAR(ih).wnr==0) goto no_more_targets;
	      }
	    no_more_targets:;  
	      
	    }
	    
	    if (from_a_target)

//	    if (((Call==1)||(from_a_target))&&
//		(M_Point[n]==M_Point[m])) /* require the same sector!!! */
	      {

	      if (index==MAXNUMBEROFSEGMENTS){
		printf("<<< MAXIMUM NUMBER OF SEGEMENTS EXCEEDED >>>\n");
		goto a;
	      }
	      index++;

	      StartOfSegment[index] = n; /* from the target direction */ 
	      EndOfSegment[index] = m;

	      has_i = 0;
	      first =  0;
	      last  = -1;
	      start = FirstSegment[m];
	      end   = LastSegment[m];

	      for (j=start; j<=end; j++){
		k1=(Z_Point[EndOfSegment[j]]-Z_Point[m])/
		  (Z_Point[EndOfSegment[j]]-Z_Point[n]);
		k2=(Z_Point[m]-Z_Point[n])/
		  (Z_Point[EndOfSegment[j]]-Z_Point[n]);
		x=k1*x_n+k2*X_Point[EndOfSegment[j]];
		if (fabs(x-x_m)<MINDIST){
		  has_i = iTRUE;
		  HasNeighbour[j] = iTRUE;
		  if (first==0) first = j;
		  last = j;
		}
	      }
 
	      HasNeighbour[index]  = has_i;
	      First_Segment[index] = first;
	      Last_Segment[index]  = last;
	    }
	  }
	}
	LastSegment[n]  = index;
      }
    }
  }
  /*
    All the segments which have a neighbour are numerated in ascending order.
    First_Segment and Last_Segment are corrected in accordance with the new
    numbering. The old numbers of segments are stored in CorrectIndex:
    CorrectIndex[new#]=old#.
    */
a:

  Total_N_Segments = index;

  j=0;
  Level = 0;
  for (i=1; i<=index; i++){
    if (HasNeighbour[i]){
      j++;
      CorrectIndex[j] = i;
      HasNeighbour[i] = j;
      if (First_Segment[i]>0)
	First_Segment[i] = HasNeighbour[First_Segment[i]];
      if (Last_Segment[i]>0)
	Last_Segment[i]  = HasNeighbour[Last_Segment[i]];
      first = First_Segment[i];
      last  = Last_Segment[i];
      level_i = 0;
      for (ij=first;ij<=last;ij++){
	level_j = LevelOfSegment[CorrectIndex[ij]];
	if (level_j > level_i)
	  level_i = level_j;
      }
      LevelOfSegment[i] = ++level_i;
      if (level_i > Level)
	Level = level_i;
    }
  }
  N_Segments = j;

  
  /*
    LevelOfSegment is a number of continuos neighbours toward the last plane.
    Level is the maximum LevelOfSegment.
    */


}





void Track_Finder(){
  
  int   i, j, ii, jj, ic, jc, jjc, pi, cp, point;
  int   BestPoint;
  float k1,k2,x,Dist,MinDist;
  int   k, kc;
  int   first, last, start, end;
  int   level_i, level_j;
  int   first_track;
  int   ReCorrectIdx[MAXNUMBEROFSEGMENTS+1];
  int   idx_tr[MAXNUMBEROFTRACKS+1];
  int   it, itr, jtr, itrc, jtrc;
  
  int   MinLevel;
  
  int   first_track_configuration;

  float xpl[1000], ypl[1000];
  int   nn;
  float x_start;
  float s, sx, sy, sxx, sxy, delta, ax, bx;
  int   ipl, npl;

  BestPoint = 0;

  NumberOfTracks = 0;
  MinLevel = MINLEVEL;
  
  for (i=1;i<=N_Points;i++){
    TrackPoint[i] = 0;
    FirstSegment[i]=0;
    LastSegment[i]=-1;
  }
    
  Call=0;

  for (ii=0; ii<=2; ii++){ /*!!!! (0--3)*/
    
    first_track_configuration = NumberOfTracks+1;
    
    cp=CoPlaneSet[ii][0];
    /* Call == 0; */

    SetNo = ii;
    Automaton();

    while (Level>=MinLevel){
//    while ( (Level>=MinLevel) || (Call==0) ){
      
      first_track = NumberOfTracks+1;
      
      for (k=1;k<=N_Segments;k++){
	kc = CorrectIndex[k];

	if (LevelOfSegment[kc] == Level){
	  CurrentTrackStart[1] = StartOfSegment[kc];
	  
	  Find_Track_Chi_2(1, kc);
	}
      }
      


      for (itr=first_track;itr<=NumberOfTracks;itr++){
	idx_tr[itr] = itr;
	start=TrackStart[itr][1];
	end=TrackStart[itr][LengthOfTrack[itr]];
	/* determine a sector: */
	n_sector[itr] = M_Point[end];
	for (jj=1; jj<=cp; jj++){
	  pi=CoPlaneSet[ii][jj];
	  MinDist=MINDIST;
	  for (point=StartOnPlane[pi]; point>=EndOnPlane[pi]; point--){
	    if (TrackPoint[point]==0){
	      k1=(Z_Point[end]-Z_Point[point])
		/(Z_Point[end]-Z_Point[start]);
	      k2=(Z_Point[point]-Z_Point[start])
		/(Z_Point[end]-Z_Point[start]);
	      x=k1*X_Point[start]+k2*X_Point[end];

	      Dist=fabs(X_Point[point]-x);
	      if (Dist < MinDist) {
		MinDist=Dist;
		BestPoint=point;
	      }
	    }
	  }

	  if (MinDist<MINDIST) {
	    it=LengthOfTrack[itr];
	    while (Z_Point[TrackStart[itr][it]]>Z_Point[BestPoint]){
	      TrackStart[itr][it+1]=TrackStart[itr][it];
	      it--;
	    }
	    TrackStart[itr][it+1]=BestPoint;
	    LengthOfTrack[itr]++;
	    Chi_2[itr] = Chi_2[itr] + MinDist*MinDist;
	  }
	  
	}
	Chi_2[itr] = Chi_2[itr]/((ERROR*ERROR)*(LengthOfTrack[itr]-2));

      }



      for (itrc=first_track;itrc<=NumberOfTracks;itrc++){
	itr = idx_tr[itrc];
	/* sort tracks */
	if (GoodTrack[itr]==1){
	  jjc=itrc;
	  jj =itr ;
	  for (jtrc=(itrc+1);jtrc<=NumberOfTracks;jtrc++){
	    jtr = idx_tr[jtrc];
	    if (GoodTrack[jtr]==1){
	      if ( (LengthOfTrack[jtr]>LengthOfTrack[jj])||
		   ( (LengthOfTrack[jtr] == LengthOfTrack[jj])&&
		     (Chi_2[jtr] < Chi_2[jj]) ) ){
		jjc=jtrc;
		jj =jtr ;
	      }
	    }
	  }
	  
	  idx_tr[itrc]=jj;
	  idx_tr[jjc ]=itr;
	  
	  /* mark used points */
	  
	  for (i=1;i<=LengthOfTrack[jj];i++) {
	    TrackPoint[TrackStart[jj][i]] = 1;
	  }
	  
	  for (jtrc=(itrc+1);jtrc<=NumberOfTracks;jtrc++){
	    jtr = idx_tr[jtrc];
	    if (GoodTrack[jtr]==1){
	      for (j=1;j<=LengthOfTrack[jtr];j++){
		if (TrackPoint[TrackStart[jtr][j]]==1){
		  GoodTrack[jtr] = 0;
		  goto continue_break;
		}
	      }
	    }
	  continue_break:;
	  }
	}
      }
      
      while ((NumberOfTracks>0)&&(GoodTrack[NumberOfTracks]==0))
	NumberOfTracks--;
      


//	if (Call!=0){
	  j=0;
	  for (i=1; i<=N_Segments; i++){
	    ic = CorrectIndex[i];
	    ReCorrectIdx[i] = 0;
	    if ((TrackPoint[StartOfSegment[ic]] == 0)&&
		(TrackPoint[EndOfSegment[ic]] == 0)){
	      j++;
	      ReCorrectIdx[i] = j;
	      CorrectIndex[j] = ic;
	      first=First_Segment[ic];
	      last=Last_Segment[ic];
	      First_Segment[ic]=0;
	      Last_Segment[ic]=-1;
	      level_i=0;
	      for (jj=first; jj<=last; jj++) {
		jc=ReCorrectIdx[jj];
		if (jc>0) {
		  if (First_Segment[ic]==0) First_Segment[ic]=jc;
		  Last_Segment[ic]=jc;
		  level_i=1;
		  LevelOfSegment[CorrectIndex[jc]]=1;
		}
	      }
	      LevelOfSegment[ic]=level_i;
	    }
	  }
	  N_Segments = j;
	  
	  Level = 0;
	  for (i=1; i<=N_Segments; i++){
	    ic = CorrectIndex[i];
	    if (LevelOfSegment[ic]){
	      first = First_Segment[ic];
	      last  = Last_Segment[ic];
	      level_i = 0;
	      for (j=first;j<=last;j++){
		level_j = LevelOfSegment[CorrectIndex[j]];
		if (level_j > level_i)
		  level_i = level_j;
	      }
	      LevelOfSegment[ic] = ++level_i;
	      if (level_i > Level)
		Level = level_i;
	    }
	  }
//	}
//	else{
//	  Call = 1;
//	  Automaton();
//	}

    }/* while (Level> MinLevel); */

  } /* ii */
  

  Call = 0;
  SetNo = 0;
  Automaton();
  
  // add single segments pointed to the target as track candidates 

  for (i=1; i<=Total_N_Segments; i++){
    npl=0;
    for (ipl=1; ipl<=nplanes;ipl++){
      if (M_Point[StartOfSegment[i]]==(GEDE(ipl).sec)){//!!!! 65535 !!!
	
	if (
	    ((fabs(GEDE(ipl).sin-GEDE(base_plane[projection]).sin)<0.00001)&&
	     (fabs(GEDE(ipl).cos-GEDE(base_plane[projection]).cos)<0.00001))
	    ){
	  
	  k1 = (X_Point[EndOfSegment[i]]-X_Point[StartOfSegment[i]])/
	    (Z_Point[EndOfSegment[i]]-Z_Point[StartOfSegment[i]]);
	  k2 = X_Point[StartOfSegment[i]] - k1*Z_Point[StartOfSegment[i]];
	  
	  x=k1*GEDE(ipl).zmin+k2;
	  
	  if ((x > GEDE(ipl).xfw[0])&& 
	      (x <(GEDE(ipl).xfw[0]+GEDE(ipl).nwi[0]*GEDE(ipl).pit))) {
	    npl++;
	  }
	}
	
	if (
	    ((fabs(GEDE(ipl).sin+GEDE(base_plane[projection]).sin)<0.00001)&&
	     (fabs(GEDE(ipl).cos+GEDE(base_plane[projection]).cos)<0.00001))
	    ){
	  
	  k1 = (X_Point[EndOfSegment[i]]-X_Point[StartOfSegment[i]])/
	    (Z_Point[EndOfSegment[i]]-Z_Point[StartOfSegment[i]]);
	  k2 = X_Point[StartOfSegment[i]] - k1*Z_Point[StartOfSegment[i]];
	  
	  x=-(k1*GEDE(ipl).zmin+k2);
	  
	  if ((x > GEDE(ipl).xfw[0])&& 
	      (x <(GEDE(ipl).xfw[0]+GEDE(ipl).nwi[0]*GEDE(ipl).pit))) {
	    npl++;
	  }
	}
	
      }
    }
    
//    if (npl==2){
      NumberOfTracks++;
      TrackStart[NumberOfTracks][1] = StartOfSegment[i];
      TrackStart[NumberOfTracks][2] = EndOfSegment[i];
      LengthOfTrack[NumberOfTracks] = 2;
      Chi_2[NumberOfTracks] = 0.0;
      GoodTrack[NumberOfTracks]=1;
      //		TrackPoint[StartOfSegment[i]] = 1;
      //		TrackPoint[EndOfSegment[i]] = 1;
//    }
  }

  
  if(DRAW){
    
    itr = 0;
    isplci_(&Blue);
    ispmci_(&Blue);
    {float mk_scal=0.5;
    ismksc_(&mk_scal);
    }
    nn = 3;
    ismk_(&nn);
    for (i=1;i<=NumberOfTracks;i++){
      if (GoodTrack[i]==1){ 
	s   = 0.0;
	sx  = 0.0;
	sy  = 0.0;
	sxx = 0.0;
	sxy = 0.0;
	
	if (L_Point[TrackStart[i][1]] != 0)
	  it = 1;
	else
	  it = 2;
	
	for (j=it;j<=LengthOfTrack[i];j++){
	  s = s + 1.0;
	  sx = sx + Z_Point[TrackStart[i][j]];
	  sy = sy + X_Point[TrackStart[i][j]];
	  sxx = sxx + Z_Point[TrackStart[i][j]]*Z_Point[TrackStart[i][j]];
	  sxy = sxy + Z_Point[TrackStart[i][j]]*X_Point[TrackStart[i][j]];
	}
	delta = s*sxx-sx*sx;
	ax = (s*sxy-sx*sy)/delta;
	bx = (sxx*sy-sx*sxy)/delta;
	x_start = ax*0.0+bx;
	
	itr++;
	
	xpl[0] = Z_Point[TrackStart[i][1]];
	ypl[0] = X_Point[TrackStart[i][1]]+shift;
	xpl[1] = Z_Point[TrackStart[i][LengthOfTrack[i]]];
	ypl[1] = X_Point[TrackStart[i][LengthOfTrack[i]]]+shift;
	nn = 2;
//	ipl_(&nn,xpl,ypl);
	
      }
    }
    
    /*
      printf(" *** ---> %d\n",itr);
      */
    nn = 1;
    iuwk_(&nn,&nn);

  }


  
}






void Find_Track_Chi_2(int n, int k){
  
  int   i;
  int   l, lc, lvl;
  int   first, last;
  float chi_2;
  int   start, end, point;
  float k1, k2, x;
  /*
    n is the number of segments in track processed (CurrentTrack).
    Level is the largest possible length of the track.
    */
  
  /*
    A track is treated processed if the number of the last segment (n) is
    equal to Level. If the first segment of the track is the same as that of
    the previously processed track than the best track is chosen.
    Otherwise a new track is formed.
    */
  
  
  lvl=Level-n; n++;
  if (lvl == 0){
    start = CurrentTrackStart[1];
    end   = EndOfSegment[k];
    chi_2 = 0.0;
    for (i=2;i<n;i++){
      point=CurrentTrackStart[i];
      k1=(Z_Point[end]-Z_Point[point])/(Z_Point[end]-Z_Point[start]);
      k2=(Z_Point[point]-Z_Point[start])/(Z_Point[end]-Z_Point[start]);
      x=k1*X_Point[start]+k2*X_Point[end];
      
      chi_2 = chi_2 + 
	(X_Point[point]-x)*(X_Point[point]-x);
    }

    if (TrackStart[NumberOfTracks][1] != CurrentTrackStart[1]){
      NumberOfTracks++;
      GoodTrack[NumberOfTracks] = 1;
      LengthOfTrack[NumberOfTracks] = n;
    }
    else
      if (chi_2 > Chi_2[NumberOfTracks])
	goto a;
    
    Chi_2[NumberOfTracks] = chi_2;
    for (i=1;i<n;i++)
      TrackStart[NumberOfTracks][i] = CurrentTrackStart[i];
    TrackStart[NumberOfTracks][n]=EndOfSegment[k];
  a:;
  }
  else {
    first = First_Segment[k];
    last  = Last_Segment[k];
    for (l=first;l<=last;l++){
      lc = CorrectIndex[l];
      if (LevelOfSegment[lc] == lvl){
	CurrentTrackStart[n] = StartOfSegment[lc];
	
	Find_Track_Chi_2(n, lc);
      }
    }
  }
  return;
}










void start_cats(){
  
  int ih;
  
  ntargets = 0;
  Z_TARGET = 0.0;
  for(ih=1; ih <= 10; ih++){
    if (GTAR(ih).wnr!=0){
      ntargets++;
      itarget[ntargets] = ih;
      Z_TARGET = Z_TARGET + GTAR(ih).z;
//      if(DRAW){
	printf("Target %d wire %d (x_th %f - y_th %f), position (%f, %f, %f)\n",
	       ntargets, GTAR(ih).wnr, GTAR(ih).dx, GTAR(ih).dy, 
	       GTAR(ih).x, GTAR(ih).y, GTAR(ih).z);
//      }
    }
    if (GTAR(ih).wnr==0) goto no_more_targets;
  }
no_more_targets:;  
  if (ntargets!=0) Z_TARGET = Z_TARGET/ntargets;
  
  nchambers = 0;
  for(ih=1; ih <= 100; ih++){
    if (GESL(ih).cmp==1){
      nchambers++;     
      ichamber[nchambers] = ih;
      if(DRAW){
	printf("%d (%d) cmp= %d, nsl= %d, lay= %d, npl= %d, fpl= %d z= %f\n", 
	       nchambers, ih,
	       GESL(ih).cmp, GESL(ih).nsl, GESL(ih).lay, GESL(ih).npl, GESL(ih).fpl,
	       GESL(ih).z1);
      }
      nplanes= GESL(ih).fpl+GESL(ih).npl-1;
    }
    if (GESL(ih).cmp==0) goto no_more_chambers;
  }
no_more_chambers:;

  N_Events   = 0;
  N_b_Events = 0;
  svd_efficiency = 0.0;
  svd_b_efficiency = 0.0;
  svd_ghost_rate = 0.0;
  geometrical_acceptance = 0.0;


  if(DRAW){
    graph_ini();
    printf("--> Start drawing? Yes... <ENTER>");
    if (getchar() == ESC){
      graph_close();
    }
  }

  /*  
  // booking of histograms
  hbook2(100,"Target",50,0.0, 1.0, 50, -0.5, 0.5);
  hbook1(101,"Target x-position",50,0.0, 1.0);
  hbook1(102,"Target y-position",50,-0.5, 0.5);
  hbook1(103,"Target proj. 1",50,-1.0, 1.0);
  hbook1(104,"Target proj. 2",50,-1.0, 1.0);
  hbook1(105,"Target proj. 3",50,-1.0, 1.0);
  hbook1(106,"Target proj. 4",50,-1.0, 1.0);
  hbook2(107,"Around the target",50,-10.0, 10.0, 50, -10.0, 10.0);

  hbook1(110,"Number of space tracks",50,0.0, 20.0);
  hbook1(111,"Number of tracks in proj. 1",50,0.0, 20.0);
  hbook1(112,"Number of tracks in proj. 2",50,0.0, 20.0);
  hbook1(113,"Number of tracks in proj. 3",50,0.0, 20.0);
  hbook1(114,"Number of tracks in proj. 4",50,0.0, 20.0);

  hbook1(120,"Number of hits on space tracks",50,0.0, 20.0);
  hbook1(121,"Number of hits on tracks in proj. 1",50,0.0, 20.0);
  hbook1(122,"Number of hits on tracks in proj. 2",50,0.0, 20.0);
  hbook1(123,"Number of hits on tracks in proj. 3",50,0.0, 20.0);
  hbook1(124,"Number of hits on tracks in proj. 4",50,0.0, 20.0);

  hbook1(130,"Residuals for space tracks",50,0.0, 0.05);

  hbook1(131,"Found hits",20,0.0, 10.0);
  hbook1(132,"Lost hits",20,0.0, 10.0);
  hbook1(133,"Lost/found hits",10,0.0, 1.0);

  hbook1(134,"Final found hits",20,0.0, 10.0);
  hbook1(135,"Final lost hits",20,0.0, 10.0);
  hbook1(136,"Final lost/found hits",10,0.0, 1.0);


  hbook2(140,"Noise vs signal hits",150,0.0, 150.0, 150, 0.0, 150.0);
  hbook2(141,"Signal vs total hits",150,0.0, 150.0, 150, 0.0, 150.0);
  hbook2(142,"Noise vs total hits", 150,0.0, 150.0, 150, 0.0, 150.0);
  hbook2(143,"Noise per MC proper track", 10,0.0, 10.0, 50, 0.0, 50.0);

  hbook1(144,"Hits per MC track", 20,0.0, 20.0);
  hbook1(145,"Layers crossed by MC track", 10,0.0, 5.0);
  hbook1(146,"Projections with m.or.eq 3 layers per MC track", 10,0.0, 5.0);

  hbook2(150,"Target at -0.7",20,-10.0, 10.0, 20, -10.0, 10.0);
  hbook1(151,"Target at -0.7 x-position",20,-3.0, 3.0);
  hbook1(152,"Target at -0.7 y-position",20,-3.0, 3.0);

  hbook2(160,"Target at -1.0",20,-10.0, 10.0, 20, -10.0, 10.0);
  hbook1(161,"Target at -1.0 x-position",20,-3.0, 3.0);
  hbook1(162,"Target at -1.0 y-position",20,-3.0, 3.0);

  hbook2(170,"Target at -4.7",20,-10.0, 10.0, 20, -10.0, 10.0);
  hbook1(171,"Target at -4.7 x-position",20,-3.0, 3.0);
  hbook1(172,"Target at -4.7 y-position",20,-3.0, 3.0);

  hbook2(180,"Target at -5.0",20,-10.0, 10.0, 20, -10.0, 10.0);
  hbook1(181,"Target at -5.0 x-position",20,-3.0, 3.0);
  hbook1(182,"Target at -5.0 y-position",20,-3.0, 3.0);
  
  hbook2(211,"rc_set/all_mtra on all_mtra", 26, 0.0, 26.0, 10, 0.0, 1.0);
  hbook2(212,"rc_set/all_mtra on ref_set",  26, 0.0, 26.0, 10, 0.0, 1.0);

  hbook2(213,"rc_in_set/ref_set on all_mtra",26,0.0, 26.0, 10, 0.0, 1.0);
  hbook2(214,"rc_in_set/ref_set on ref_set",26,0.0, 26.0, 10, 0.0, 1.0);

  hbook2(215,"(rc_set-rc_in_refset)/no_ref_set on all_mtra",26,0.0, 26.0, 10, 0.0, 1.0);
  hbook2(216,"(rc_set-rc_in_refset)/no_ref_set on ref_set",26,0.0, 26.0, 10, 0.0, 1.0);

  hbook2(207,"ghost/(rc_set+ghost+clones) on all_mtra",26,0.0, 26.0, 10, 0.0, 1.0);
  hbook2(208,"ghost/(rc_set+ghost+clones) on ref_set",26,0.0, 26.0, 10, 0.0, 1.0);

  hbook2(209,"clones/(rc_set+ghost+clones) on all_mtra",26,0.0, 26.0, 10, 0.0, 1.0);
  hbook2(210,"clones/(rc_set+ghost+clones) on ref_set",26,0.0, 26.0, 10, 0.0, 1.0);

  hbook2(203,"Clones/(Rc_set+Ghost+Clones) on all_mtra",26,0.0, 26.0, 10, 0.0, 1.0);
  hbook2(204,"Clones/(Rc_set+Ghost+Clones) on ref_set",26,0.0, 26.0, 10, 0.0, 1.0);

  */

}


void stop_cats(){

  if (N_Events != 0) {
    svd_efficiency = svd_efficiency/(float)N_Events;
    printf("Svd track reconstruction efficiency %f\n", svd_efficiency);
  }
  if (N_b_Events != 0) {
    svd_b_efficiency = svd_b_efficiency/(float)N_b_Events;
    printf("Svd  -B-  reconstruction efficiency %f\n", svd_b_efficiency);
  }
  if (N_Events != 0) {
    svd_ghost_rate = svd_ghost_rate/(float)N_Events;
    printf("Svd ghost tracks rate %f\n", svd_ghost_rate);
  }


  if(DRAW){
    graph_close();
  }
}


void Draw_Event(){
  
  float xpl[1000], ypl[1000];
  int   nn, iproj;
  float aa, bb, cc, dd;
  int   i, j, ih;
  
  
  /* test data only in a projection corresponding to this plane slope */
  
  
  for(iproj=1; iproj <= 4; iproj++){ 
    
    shift = shift_coeff[iproj]*SHIFT;
       
    isfaci_(&White);
    isplci_(&Red);
    aa= -15.00;bb=220.00;cc=-10.00+shift;dd=10.00+shift;
    igbox_(&aa,&bb,&cc,&dd);
       
       
       
       /* draw the targets - only their centers - how to project them?.. */

    ispmci_(&Red);
    nn = 3;
    ismk_(&nn);
    {float mk_scal=0.5;
    ismksc_(&mk_scal);
    }
    
    for (i=1; i<=ntargets; i++){
      xpl[0] = GTAR(itarget[i]).z;
      ypl[0] = GTAR(itarget[i]).x+shift;
      nn = 1;
      ipm_(&nn,xpl,ypl);
    }
    
    /* draw layers */
    
    ispmci_(&Black);
    nn = 3;
    ismk_(&nn);
    {float mk_scal=0.5;
    ismksc_(&mk_scal);
    }
    
    isplci_(&Black);
    for (i=1; i<=nchambers; i++){
      ih = ichamber[i];
      for (j=GESL(ih).fpl; j<GESL(ih).fpl+GESL(ih).npl; j++){

	if (GEDE(j).ogesl!=0){
	  
	  if (
	      (fabs(GEDE(j).sin-GEDE(base_plane[iproj]).sin)<0.00001)&&
	      (fabs(GEDE(j).cos-GEDE(base_plane[iproj]).cos)<0.00001)
	      ) 
	    {
	      xpl[0] = GEDE(j).zmin;
	      ypl[0] = GEDE(j).xfw[0]+shift;
	      xpl[1] = GEDE(j).zmin;
	      ypl[1] = GEDE(j).xfw[0]+GEDE(j).nwi[0]*GEDE(j).pit+shift;
	      nn = 2;
	      ipl_(&nn,xpl,ypl);
	    }

	  if (
	      (fabs(GEDE(j).sin+GEDE(base_plane[iproj]).sin)<0.00001)&&
	      (fabs(GEDE(j).cos+GEDE(base_plane[iproj]).cos)<0.00001)
	      ) 
	    {
	      xpl[0] = GEDE(j).zmin;
	      ypl[0] = -GEDE(j).xfw[0]+shift;
	      xpl[1] = GEDE(j).zmin;
	      ypl[1] = -(GEDE(j).xfw[0]+GEDE(j).nwi[0]*GEDE(j).pit)+shift;
	      nn = 2;
	      ipl_(&nn,xpl,ypl);
	    }
	  
	}
      }
    }    
    
  }
  nn = 1;
  iuwk_(&nn,&nn); 
  
  
}



/***************** Graphics ******************/



/******************************************/
/************ graph_ini() ******************/
/******************************************/



void graph_ini(){
//  int nxpaw=NXPAW;
  
  float aa,bb,cc,dd;
  int nn=0, ierrf=0;
  int wkid;
  float r,g,b;
  
//  hlimit_(&nxpaw); 
  
  iginit_(&nn);
  nn=8;
  igsse_(&ierrf, &nn);
  
  
  wkid=1;
  
  r=0.0000; g=0.0000; b=0.0000; iscr_(&wkid, &Black       ,&r,&g,&b);
  r=0.5000; g=0.5400; b=0.5300; iscr_(&wkid, &DarkGray    ,&r,&g,&b);
  r=0.0000; g=0.0000; b=1.0000; iscr_(&wkid, &Blue        ,&r,&g,&b);
  r=0.1333; g=0.5451; b=0.1333; iscr_(&wkid, &Green       ,&r,&g,&b);
  r=0.0000; g=0.8078; b=0.8196; iscr_(&wkid, &Cyan        ,&r,&g,&b);
  r=1.0000; g=0.0000; b=0.0000; iscr_(&wkid, &Red         ,&r,&g,&b);
  r=1.0000; g=0.0000; b=1.0000; iscr_(&wkid, &Magenta     ,&r,&g,&b);
  r=0.5000; g=0.1647; b=0.1647; iscr_(&wkid, &Brown       ,&r,&g,&b);
  r=0.6784; g=0.8471; b=0.9020; iscr_(&wkid, &LightBlue   ,&r,&g,&b);
  r=0.5961; g=0.9843; b=0.5961; iscr_(&wkid, &LightGreen  ,&r,&g,&b);
  r=0.4980; g=1.0000; b=0.8314; iscr_(&wkid, &LightCyan   ,&r,&g,&b);
  r=0.9804; g=0.5020; b=0.4471; iscr_(&wkid, &LightRed    ,&r,&g,&b);
  r=0.8549; g=0.4392; b=0.8392; iscr_(&wkid, &LightMagenta,&r,&g,&b);
  r=1.0000; g=1.0000; b=0.0000; iscr_(&wkid, &Yellow      ,&r,&g,&b);
  r=0.8275; g=0.8275; b=0.8275; iscr_(&wkid, &LightGray   ,&r,&g,&b);
  r=1.0000; g=1.0000; b=1.0000; iscr_(&wkid, &White       ,&r,&g,&b);
  
  
  
  nn=2;
  aa=-15.00;bb=220.00;cc=-40.00;dd=40.00;
  iswn_(&nn,&aa,&bb,&cc,&dd);
  aa=0.0;bb=1.0;cc=0.0;dd=1.0;
  isvp_(&nn,&aa,&bb,&cc,&dd);
  iselnt_(&nn);
  
  nn=1;
  isfais_(&nn);
  
  isfaci_(&LightGray);
  isplci_(&Red);

  aa= -15.00;
  bb= 220.00;
  cc=-40.00;
  dd= 40.00;
  igbox_(&aa,&bb,&cc,&dd);
  
  nn = 1;
 iuwk_(&nn,&nn);
  
}


/**************************************************/
/************** graph_close() *********************/
/**************************************************/

void graph_close(){
  igend_();
}





