#include <vector>

#include <iostream.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <arte/arte.hh>

#define MAXNUMBEROFHITS     10000
#define MAXNUMBEROFTRACKS   1000

extern int   base_plane[5];
extern int   Ntk, nh_trk[MAXNUMBEROFTRACKS+1];
extern float Yp_trk[MAXNUMBEROFTRACKS+1], Y0_trk[MAXNUMBEROFTRACKS+1];
extern float Zp_trk[MAXNUMBEROFTRACKS+1], Z0_trk[MAXNUMBEROFTRACKS+1];
extern int   hits[MAXNUMBEROFHITS+MAXNUMBEROFTRACKS+10];

extern void makeRhits(ArtePointer<RSEG> rseg);

extern "C" {
  void fill_banks(){
    
    int nh, itk;
    float x, y, z;
    

    /*fill the RSEG table*/
    
    nh = 0;
    for (itk=0;itk<Ntk;itk++){ // loop over 3D tracks

      RSEG rseg_newrow;


      // a track is parametrized as a line y(or x)=A*z+B in projections
      // for x proj. A = Yp_trk[itk]; B = Y0_trk[itk];   
      // for y proj. A = Zp_trk[itk]; B = Z0_trk[itk];
      
      z = ArtePointer<HITB>(hits[nh])->z;
      x = Yp_trk[itk]*z + Y0_trk[itk];
      y = Zp_trk[itk]*z + Z0_trk[itk];
      
      rseg_newrow.zf = z;
      rseg_newrow.xf = x;
      rseg_newrow.yf = y;

      z = ArtePointer<HITB>(hits[nh+nh_trk[itk]-1])->z;
      x = Yp_trk[itk]*z + Y0_trk[itk];
      y = Zp_trk[itk]*z + Z0_trk[itk];

      rseg_newrow.ze = z;
      rseg_newrow.xe = x;
      rseg_newrow.ye = y;


      rseg_newrow.txf = 
	(rseg_newrow.xe-rseg_newrow.xf)/(rseg_newrow.ze-rseg_newrow.zf);
      rseg_newrow.tyf = 
	(rseg_newrow.ye-rseg_newrow.yf)/(rseg_newrow.ze-rseg_newrow.zf);
      rseg_newrow.pf = 1.0; 

      rseg_newrow.txe = rseg_newrow.txf;
      rseg_newrow.tye = rseg_newrow.tyf;
      rseg_newrow.pe = 1.0; 
      rseg_newrow.chi = 0.0; 
      rseg_newrow.cmp = 1; 


      ArteTable<RSEG>::push_back( rseg_newrow );
      ArtePointer<RSEG> rseg( ArteTable<RSEG>::size() );

      // some relations are missing!

      vector<ArtePointer<HITB> > hitt;
      int ih;
      for (ih=nh;ih<nh+nh_trk[itk];ih++){
	hitt.push_back( ArtePointer<HITB> (hits[ih]) );
      }

     for( vector<ArtePointer<HITB> >::iterator hitb = hitt.begin();
	   hitb != hitt.end(); ++hitb ) {
	createRelation( *hitb, rseg, &RSEG::hitb );
      }
 
      makeRhits(rseg);
       
      nh=nh+nh_trk[itk]+1; //skip (-1): hits of diff. tracks are
                           //separated by (-1)
			   
			     
  }


  return;
}
}





