
#include <vector>

#include <arte/arte.hh>

//
// Create RHITs for a segment, which has only HITBs
//

void makeRhits( ArtePointer<RSEG> rseg )
{
  vector<ArtePointer<RHIT> > rhits;
  for( ArteRelationIterator<HITB> hitb = rseg->hitb.begin();
       hitb != rseg->hitb.end(); ++hitb ) {
    
    RHIT rh;
    rh.x = rseg->xf+((*hitb)->z-rseg->zf)*rseg->txf;
    rh.y = rseg->yf+((*hitb)->z-rseg->zf)*rseg->tyf;
    rh.tx = rseg->txf;
    rh.ty = rseg->tyf;
    rh.p = 0;
    rh.q = 0;
    ArteTable<RHIT>::push_back( rh );
    ArtePointer<RHIT> rhit( ArteTable<RHIT>::nrow() );
    
    //createRelation( rseg,  rhit, &RSEG::rhit );
    rhits.push_back( rhit );
    createRelation( *hitb, rhit, &HITB::rhit );
  }
  for( vector<ArtePointer<RHIT> >::reverse_iterator rhit
	 = rhits.rbegin(); rhit!=rhits.rend(); ++rhit ) {
    createRelation( rseg, *rhit, &RSEG::rhit );
  }
}

