#ifndef _AUTO_HH_
#define _AUTO_HH_

struct BEAM;
struct CDIM;
struct CEFF;
struct CLEN;
struct CPDW;
struct CPMD;
struct CPMI;
struct CPMT;
struct CPOI;
struct CSMI;
struct CSPM;
struct CSSM;
struct CSUP;
struct CVES;
struct DCAL;
struct DDAQ;
struct DDEF;
struct DEVT;
struct DFCS;
struct DFLT;
struct DIGB;
struct HITB;
struct HIDI;
struct MIMP;
struct MIDI;
struct DIHD;
struct DITR;
struct DMUP;
struct DMUT;
struct DMUX;
struct DOTR;
struct DPTC;
struct DRIC;
struct DSLT;
struct DSVD;
struct DTAR;
struct DTLT;
struct DTRD;
struct DTST;
struct ECBO;
struct ECHF;
struct ECHS;
struct ERRC;
struct EVFN;
struct EVHD;
struct FELD;
struct GCAL;
struct GESL;
struct GSGC;
struct GMAT;
struct GMGC;
struct GCCE;
struct GCGD;
struct GEDE;
struct GSGD;
struct GMGD;
struct GEHD;
struct GWAL;
struct GSGW;
struct GMGW;
struct NEDE;
struct GMND;
struct NCAL;
struct GMNC;
struct NWAL;
struct GMNW;
struct GMIX;
struct GNEI;
struct GSSL;
struct GTAR;
struct RTRA;
struct RTHI;
struct MIHI;
struct RHIT;
struct HIRH;
struct RSEG;
struct RSHI;
struct HITC;
struct RTHC;
struct MCAL;
struct MCHC;
struct RCCL;
struct HCRC;
struct MARK;
struct MTRA;
struct MTMC;
struct MCIN;
struct MCME;
struct MVER;
struct MVME;
struct MEIO;
struct MEMA;
struct MEMO;
struct MEMS;
struct MF01;
struct MF02;
struct MF03;
struct MF04;
struct MF05;
struct MF06;
struct MF07;
struct MF08;
struct MF09;
struct MF10;
struct MF11;
struct MF12;
struct MF13;
struct MF14;
struct MF15;
struct MF16;
struct MF17;
struct MF18;
struct MF19;
struct MF20;
struct MF21;
struct MFHD;
struct MFLD;
struct MTMI;
struct MTCP;
struct MTMP;
struct TOPP;
struct MTTO;
struct BVER;
struct MVMT;
struct BTRA;
struct MTMT;
struct ETRA;
struct EVER;
struct MTMV;
struct RTMT;
struct RSMT;
struct MTRC;
struct NBEA;
struct NESL;
struct NSNC;
struct NSND;
struct NSNW;
struct NFLD;
struct NGHD;
struct NMAT;
struct NMIX;
struct NTAR;
struct PTAD;
struct PTFD;
struct PXAF;
struct PTCH;
struct PXCA;
struct PTAL;
struct PTMD;
struct PXGM;
struct PTGE;
struct PXGA;
struct PTCE;
struct PXGC;
struct PXCC;
struct PTCR;
struct PXCM;
struct PXFC;
struct RTRC;
struct RSRC;
struct RSRH;
struct RPNT;
struct RTRP;
struct RSRP;
struct RREL;
struct RRRT;
struct RVER;
struct RRRV;
struct RTRS;
struct RBEG;
struct RSRS;
struct REND;
struct RTTO;
struct RVRT;
struct SHCA;
struct SHPR;
struct STPR;
struct SPSH;
struct SHRC;
struct STRC;
struct SRSH;
struct SNAB;
struct SNAV;
struct SBSN;
struct SNAX;
struct SNSN;
struct SPAR;
struct SPAS;
struct SSEE;
struct SPSS;
struct SSTA;
struct STCA;
struct SUSI;
struct TDEC;
struct TEMP;
struct TMP0;
struct TMP1;
struct TMP2;
struct TMP3;
struct TMP4;
struct TMP5;
struct TMP6;
struct TMP7;
struct TMP8;
struct TMP9;
struct XTRA;
struct XTRI;
struct YTRA;
struct YTRI;
struct NMNC;
struct NMND;
struct NMNW;

/** beam geometry */
struct BEAM
{
/** x-position of beam center */
  float x;
/** y-position of beam center */
  float y;
/** z-position of beam center */
  float z;
/** beam width along the axis x-prime */
  float dx;
/** beam width along the axis y-prime */
  float dy;
/** beam time width */
  float dt;
/** mean time value for generation */
  float time;
/** MC time smearing switch: on -> .ne. 0 */
  int tsw;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror
CDIM: riCh DIelectric Material

A dielectric material is defined by refering to
a definition of a refractive index in the table
CPOI. The definition starts in this table CPOI
in the row iref and consists out of nref
points. Similar in the table CPOI the absorption
loss is defined with nabs points starting in
row iabs. For the simulation of rayleigh scat-
tering the particle densisity has to be defined.
Setting it to -1 switches the simulation of
Rayleigh scattering of. A quick simulation of
the reflexion loss occuring, when the photon
crosses the material can be switched on, by set-
ting rlos to a value greater zero. To allow
book keeping a name of the material have to be
defined.
 */
struct CDIM
{
/** name of the material */
  char name[80];
/** reflexion loss */
  float rlos;
/** particle density (Rayleigh Scattering) */
  float dens;
/** absorption loss: number of defined points */
  int nabs;
/** absorption loss: index in table CPOI */
  int iabs;
  //###ArtePointer<CPOI> iabs;
/** refractive index: number of defined points */
  int nref;
/** refractive index: index in table CPOI */
  int iref;
  //###ArtePointer<CPOI> iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: table with efficiencies
CEFF: riCh EFFiciency

pm-channel dependent efficiency scaling factors */
struct CEFF
{
/** only a value for the efficiency */
  float eff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh LENse system
CLEN: riCh LENse system

A dielectric material is defined by refering to
The absorption properties of the lens system is
 */
struct CLEN
{
/** identifier */
  int id;
/** wavelength-loss: number of defined points */
  int nwav;
/** wavelength-loss: index in table CPOI */
  //###ArtePointer<CPOI> iwav;
  int iwav;
/** angular-loss: number of defined points */
  int nang;
/** angular-loss: index in table CPOI */
  //###ArtePointer<CPOI> iang;
  int iang;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror
CPDW: riCh Photon Detector Window

The Photon Detector Window has a rectangular box
with horizontal dimension (along the x-axis)
hdim and with a vertical dimension (along the
y-axis) vdim. The orientation in space is
describe by the assigned coordinate system.
The origin is positioned on the surface, which
is in contact with the radiator gas. imat
points to the row in the table CDIM, where the
properties of the dielectric material are
stored.
 */
struct CPDW
{
/** lower left corner */
  float orig[3];
/** horizontal dimension * x-direction */
  float xvec[3];
/** vertical   dimension * y-direction */
  float yvec[3];
/** thickness of the window */
  float t;
/** material: row in table CDIM */
  ArtePointer<CDIM> imat;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: properties of a certain Photomultiplier

riCh PhotoMultiplier Definiton

A PM with serial number "seno" is described
by setting the type-name, like its defined in
the table CPMT and the channel to channel
efficiency variation.
 */
struct CPMD
{
/** serial number */
  char seno[16];
/** type specification */
  char type[16];
/** supermodule id */
  int isup;
/** supermodule row */
  int irow;
/** supermodule col */
  int icol;
/** 1st row in table CEFF */
  //ArtePointer<CEFF> efv0;
  int efv0;
/** lens system identifier */
  int lens;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Planar MIrror

CPMI: riCh Planar MIrror
 */
struct CPMI
{
/** radius of hole for electron beam */
  float rec;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
  //###ArtePointer<CPOI> iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: definition of the properties of a pm type
CPMT: riCh PhotoMultiplier Type

A PM type has to have a certain name, which
is stored as type. The number of channels
in x and in y direction nx and ny has
to be specified, as well as the dimensions
xdiv and ydiv of the at the moment square
area, which one channel covers. The wavelength
dependent efficiency off a certain type is
stored beginning in the row ieff in table CPOI
and is defined using neff values. It is
assumed, that the efficiency of a certain pm
is good enough describe, by multiplying this
shape with a certain correction factor.
 */
struct CPMT
{
/** name of the PM type */
  char type[16];
/** number of channels in x-direction */
  int nx;
/** cell size in x-direction */
  float xdiv;
/** number of channels in y-direction */
  int ny;
/** cell size in y-direction */
  float ydiv;
/** number of bins */
  int neff;
/** starting row in table CPOI */
  //###ArtePointer<CPOI> ieff;
  int ieff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
///
struct CPOI
{
/** any pair of floats */
  float x[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Spherical MIrror

CSMI: riCh Spherical MIrror

The spherical mirror consists out of many single
spherical mirrors, that are stored in the CSSM
table. Here only some general information is
stored. */
struct CSMI
{
/** horizontal tiling */
  float ah;
/** horizontal tiling: start angle */
  float ah0;
/** vertical tiling */
  float av;
/** vertical tiling: start angle */
  float av0;
/** radius of curvature */
  float r;
/** radius of hole around proton beam */
  float rpc;
/** radius of hole around electron beam */
  float rec;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
  //###ArtePointer<CPOI> iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror

CSPM: riCh Single Planar MIrror
A Single Planar MIrror has a rectangular surface
with horizontal dimension (along the x-axis) and
with a vertical dimension (along the y-axis).
The orientation in space is describe by the
assigned coordinate system. "iref" points to the
row in the table CPOI, where the reflectivity is
stored.
 */
struct CSPM
{
/** lower left corner */
  float orig[3];
/** horizontal dimension * x-direction */
  float xvec[3];
/** vertical   dimension * y-direction */
  float yvec[3];
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
  //###ArtePointer<CPOI> iref;
/** row */
  int row;
/** column */
  int col;
/** mirror type name (HEX,FIVE,FOUR,...) */
  char type[8];
/** name */
  char name[20];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Spherical Mirror
CSSM: riCh Single Spherical Mirror
        -  -      -         -

A Single Spherical MIrror is a cut out of a
sphere with radius ||norm||. The general
boundary is a regular hexagon. The smaller
horizontal (along the x-direction) extension
is 2*||xvec||.The normal direction points to
the center of  curvature. The origin of the
coordinate system is the center of the hexagon
and has to be placed on the mirror surface! The
hexagon fits into a circle with radius hdia.
The mirrors exist is various versions, which all
are some cuts of the general hexagonal boundary.
The coordinate system defined above is stored in
the row icor in the table CCOR. Similar iref
points to the row in the table CPOI, where the
reflectivity is stored. */
struct CSSM
{
/** origin */
  float orig[3];
/** radius * normal direction */
  float norm[3];
/** horizontal dimension/2 * horizontal direction */
  float xvec[3];
/** mirror type name (HEX,FIVE,FOUR,...) */
  char type[8];
/** half of the diameter the mirror */
  float hdia;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
  //###ArtePointer<CPOI> iref;
/** row */
  int row;
/** column */
  int col;
/** name */
  char name[20];
/** number of corners */
  int ncor;
/** max. 6 corners */
  float corn[18];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: definition of a supermodule
CSUP: riCh SUPermodule

CSUP describe the rectangular front surface of a
supermodule. The orientation in space is defined
by the three vectors x0,ex=xvec/||xvec||,
ey=yvec/||yvec||. The norm ||xvec|| and ||yvec||
defining the outer dimensions of the rectangle.
The supermodule is devide in matrice like cells.
This is done by setting nx=12, ny=36,
xdiv=ydiv=36 mm. */
struct CSUP
{
/** origin */
  float x0[3];
/** x-direction * xdim */
  float xvec[3];
/** y-direction * ydim */
  float yvec[3];
/** number of pms/cells in x-direction (rows) */
  int nx;
/** cell size in x-direction */
  float xdiv;
/** number of pms/cells in y-direction (columns) */
  int ny;
/** cell size in y-direction */
  float ydiv;
/** supermodule identifier */
  int id;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: VESsel
CVES: riCh VESsel

The information needed to trace the photons in
the RICH Vessel is stored. This is the dimen-
sions of the proton beam shroud and the electron
beam shroud (they are tubes) as well as the pro-
perties of the radiator. The radiator is descri-
bed as a general dielectric material. The infor-
mation you can find in the row irad of the
table CDIM */
struct CVES
{
/** center proton shroud */
  float pori[3];
/** axis   proton shroud */
  float pez[3];
/** radius proton shroud */
  float prad;
/** length proton shroud */
  float plen;
/** center electron shroud */
  float eori[3];
/** axis   electron shroud */
  float eez[3];
/** radius electron shroud */
  float erad;
/** length electron shroud */
  float elen;
/** radiator: row in table CDIM */
  ArtePointer<CDIM> irad;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** calorimeter digits */
struct DCAL
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data acquisition digits */
struct DDAQ
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data definition */
struct DDEF
{
/** flag: see sequence ZDDEFP */
  int flag;
/** attribute, relation, etc: column */
  int col;
/** table: extension; attribute: dimension; */
  int dim;
/** table,relation: flag: 0: table;
-1: subord.table; -2 parallel table
range: lower boundary for integer */
  int rflg;
/** Zebra division: 1=const; 2=event;
range: upper boundary for integer */
  int div;
/** lower boundary for float */
  float flo;
/** upper boundary for float */
  float fup;
/** accuracy for float */
  float fac;
/** name */
  char name[80];
/** menu name / format */
  char nam2[80];
/** relation name */
  char nam3[80];
/** comment */
  char text[80];
/** 1: attribute is a Leda key; 0: no Leda key */
  int key;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event digits */
struct DEVT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** fast control system digits */
struct DFCS
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 1st level trigger digits */
struct DFLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC digitization for all detectors except ECAL */
struct DIGB
{
/** strip / wire / pad identifier */
  int id;
/** Quantity: amplitude for SVD, MSGC
drift time for outer tracker
0 for RICH, TRD, MUON */
  float q;
/** many digits to one hit */
  ArtePointer<HITB> hitb;
/** many digits to many mimps */
  ArteManRelationPointer<MIDI,MIMP> mimp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for measured digits */
struct DIHD
{
/** Bunch crossing number
from 1st FED output */
  int bx;
/** First Level Trigger number
from SLB output */
  int flt;
/** Second Level Trigger number
from DAQ event output */
  int slt;
/** Second Level Buffer number
from SLB output */
  int slb;
/** Component mask
from DAQ event output */
  int cmsk;
/** Event mask
from DAQ event output */
  int emsk;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Inner Tracker digits */
struct DITR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Pad Chamber digits */
struct DMUP
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Tube Chamber digits */
struct DMUT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Pixel Chamber digits */
struct DMUX
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Outer Tracker digits */
struct DOTR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-pt chamber digits */
struct DPTC
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH digits */
struct DRIC
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 2nd level trigger digits */
struct DSLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Vertex Detector digits */
struct DSVD
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Target digits */
struct DTAR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 3rd level trigger digits
(whatever this means - H.A.) */
struct DTLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Transition Radiation Detector digits */
struct DTRD
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** any digits for test purposes */
struct DTST
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout BOard data */
struct ECBO
{
/** FED IDentification */
  int fdid;
/** Board status */
  int stat;
/** Board number [0,200] */
  int numb;
/** Shark link index */
  int link;
/** Index of connected cell
For each channed of the board there is
an integer number that point out a
single connected cell.
value -1 means no connection */
  int chan[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout CHannel Calibration table (Fast)
 Fast update rate */
struct ECHF
{
/** status of the channel: bit field
1 = ON for good working conditions
2 = NOISY for ch present but unusable
3 = OFF  for ch not present */
  int stat;
/** PEDestal Fast */
  float pedf;
/** Pedestal width */
  float wid;
/** Energy scale: factor for E calibration */
  float q;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout CHannel Calibration table (Slow)
 Slow update rate */
struct ECHS
{
/** PEDestal Slow */
  float peds;
/** 6 calibration constants */
  float pcal[6];
/** 6 calibration const for error */
  float ecal[6];
/** First threshold (channels) */
  float thr1;
/** Second threshold (energy) */
  float thr2;
/** Minimum Ionizing Particle signal */
  float mip;
/** MIP variance */
  float vmip;
/** Channel at which saturation starts */
  float chst;
/** Readout board FED ID */
  int fdid;
/** Readout channel identifier [0,31] */
  int chan;
/** Index pointing to an ECBO bank entry */
  ArtePointer<ECBO> ecbo;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** error count */
struct ERRC
{
/** Text of the error message as appearing in the
1st CALL with the given error identifier. */
  char text[80];
/** Error identifier =
pointer to 1st argument in MEERRC (563415,...) */
  int id;
/** Message counter */
  int cnt;
/** Maximum number of print-outs */
  int prnt;
/** Fatal error condition when error count expires
this number */
  int ftl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** DST etc. file names */
struct EVFN
{
/** file name */
  char name[80];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event header bank */
struct EVHD
{
/** event number */
  int evt;
/** run number */
  int run;
/** experiment number
exp > 0: real data
exp < 0: Monte Carlo; specifies the lab:
     -1: DESY HH
     -2: DESY Zeuthen
    ...: not yet specified */
  int exp;
/** measurement/creation date (format: yymmdd) */
  int date;
/** measurement/creation time (format: hhmmss) */
  int time;
/** version of the mag field MC and reco */
  float vfld;
/** event classification flag from/to DST */
  int flagdst;
/** event classification flag from/to EDIR
if no EDIR: same as flagdst */
  int flag;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** bank of magnetic field (temporary - const field) */
struct FELD
{
/** x-position of field center */
  float x;
/** y-position of field center */
  float y;
/** z-position of field center */
  float z;
/** radius of field region */
  float r;
/** strength of field (in kG) */
  float h;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
///
struct GCAL
{
/** number of subsectors per block
1: outer  calorimeter - block division 1*1
2: middle calorimeter - block division 2*2
5: inner  calorimeter - block division 5*5 */
  int ncl;
/** block number within the superlayer (packed) */
  int sec;
/** x of the left edge of the block */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** light efficiency */
  float eff;
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** detector component (see table GESL) */
  int cmp;
/** one super-layer <-> many detector planes */
  ArtePointer<GESL> gesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** Geant volume name */
  char gvol[4];
/** first cell of given module in GCCE */
  int fcl;
/** first MIMP */
  ArteTableIterator<MIMP> mim1;
/** last MIMP */
  ArteTableIterator<MIMP> miml;
/** first DIGB */
  ArteTableIterator<DIGB> dig1;
/** last DIGB */
  ArteTableIterator<DIGB> digl;
/** first HITB */
  ArteTableIterator<HITB> hit1;
/** last HITB */
  ArteTableIterator<HITB> hitl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** ECAL Cell Informations */
struct GCCE
{
/** Cell Identification in GCAL numbering */
  int ceid;
/** Number of neibourings in the GNEI table */
  int neib;
/** Neibourings position in the table GNEI */
  int adrs;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal Cell Grid */
struct GCGD
{
/** index of the first cell contained in the module */
  int cidx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** detector geometry: planes */
struct GEDE
{
/** detector component (see table GESL) */
  int cmp;
/** layer number within the superlayer */
  int lay;
/** sector number */
  int sec;
/** detector shape */
  int shp;
/** x of the left edge of the detector */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** outer tracker: x of the left edge
of the sensitive area
muon: the size of sensitive area near pad */
  float sxmn;
/** outer tracker: y of the right edge
muon: efficiency in the gap between pads */
  float sxmx;
/** outer tracker: y of the lower edge
muon: y-distance from chamber edge to pad */
  float symn;
/** outer tracker: y of the upper edge
muon: y-gap between pads */
  float symx;
/** cosine of the wire angle with respect to y-axis */
  float cos;
/** sine of the wire angle with respect to y axis */
  float sin;
/** 3 by 3 rotation matrix */
  float rot[9];
/** measurement accuracy (for MC digitization) */
  float acc;
/** hit efficiency (for MC digitization) */
  float eff;
/** max drift distance or double hit resolution */
  float dod;
/** pitch */
  float pit;
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** SVD   1   d_min: distance of first wire to z axis
 */
  float xfw[4];
/** outer tracker: z of first wire in sublayer 1...4
muon: 1 - z of wires
muon: 2 - z of pads
muon: 3 - y-size of first (small) pad or pixel
muon: 4 - y-size of large pads */
  float zfw[4];
/** outer tracker: number of wires in sublayer 1...4
muon: 1 - number of wires or pixels in x-dir
muon: 2 - number of pixels in y-direction
muon: 3 - number of connected pixels in x-dir
muon: 4 - number of connected pixels in y-dir */
  int nwi[4];
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many detector planes */
  ArtePointer<GESL> gesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** number of walls connected to this detector */
  int nwl;
/** first wall connected to this detector */
  int fwl;
/** additional word for comp. geometrical shapes */
  float xmad;
/** additional word for comp. geometrical shapes */
  float ymad;
/** additional word for comp. geometrical shapes */
  float zmad;
/** lower boundary in y for wires in sublayer 1...4 */
  float y1w[4];
/** upper boundary in y for wires in sublayer 1...4 */
  float y2w[4];
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** Hardware code for the given detector */
  char hwc[12];
/** energy loss of a mip in the given detector */
  float dedx;
/** Geant copy number - so called user number */
  int gcop;
/** first MIMP */
  ArteTableIterator<MIMP> mim1;
/** last MIMP */
  ArteTableIterator<MIMP> miml;
/** first DIGB */
  ArteTableIterator<DIGB> dig1;
/** last DIGB */
  ArteTableIterator<DIGB> digl;
/** first HITB */
  ArteTableIterator<HITB> hit1;
/** last HITB */
  ArteTableIterator<HITB> hitl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for the detector geometry */
struct GEHD
{
/** version number for the geometry constants */
  float geom;
/** version number of the hbgean program producing
the constants */
  float gean;
/** date */
  int date;
/** time */
  int time;
/** version number for the geometry constants
the vector is given by gehd.geom(LGESL_... ,I)
LGESL_MOTH = 30 = overall geometry = datt geom
LGESL_RPOT = 29 = Roman Pot
LGESL_TAR  = 11 = target
LGESL_SIL  = 1  = SVD
LGESL_MAG  = 28 = Magnet elements
LGESL_FLD  = 12 = magnetic field
LGESL_PPIP = 27 = Proton beam pipe
LGESL_EPIP = 26 = Electron beam pipe
LGESL_WCH  = 2  = OTR
LGESL_MSG  = 3  = ITR
LGESL_PTC  = 4  = PTL
LGESL_RIC  = 5  = RICH
LGESL_TRSL = 24 = TRD
LGESL_ECA  = 7  = ECA
LGESL_MUON = 25 = MUON System
LGESL_HOD1 = 13 = new trigger hodoscope
LGESL_HOD2 = 14 = trigger hodoscope
LGESL_HOD3 = 15 = last (in z) hodoscope */
  float gevs[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** detector geometry: superlayers */
struct GESL
{
/** superlayer name (up to 4 characters) */
  char name[4];
/** detector component:
 1 SIL silicon vertex detector
 2 WCH wire chambers
 3 MSG microstrip chambers
 4 PTC chambers (pi-pi trigger)
 5 RIC Cerenkov counter
 6 TRD forward TRD
 7 CAL electromagnetic calorimeter
 8 MUO muon outer chambers
 9 MUX muon central chambers
11 TAR target
12 FLD field
13 HOD1 hodoscope 1
14 HOD2 hodoscope 2
15 HOD3 hodoscope 3
25 MUON system
26 Electron pipe
27 Proton pipe
28 Magnet
29 Roman Pot */
  int cmp;
/** shape of the superlayer
 1 box
 3 trapezoid (ie. x and y varying along z)
 5 tube
 9 spherical shell */
  int shp;
/** nth superlayer of this component */
  int nsl;
/** magnet flag (0 = no mag. field) */
  int mfl;
/** number of layers */
  int lay;
/** box:  left  boundary in x
trap: left boundary in x at smaller z
tube and sphere: inner radius */
  float x1;
/** box:  right boundary in x
trap: right boundary in x at smaller z
tube and sphere: x-pos. of tube/sphere center */
  float x2;
/** box:  lower boundary in y
trap: lower boundary in y at smaller z
tube and sphere : outer radius */
  float y1;
/** box:  upper boundary in y
trap: upper boundary in y at smaller z
tube and sphere: y-pos. of tube/sphere center */
  float y2;
/** z of begin of superlayer */
  float z1;
/** z of end of superlayer */
  float z2;
/** trap: difference in x to x1 at bigger z */
  float dx;
/** trap: difference in y to y1 at bigger z */
  float dy;
/** number of detector planes (nlayers*nsectors) */
  int npl;
/** first det. plane belonging to this superlayer */
  int fpl;
/** number of walls in this superlayer */
  int nwl;
/** first wall belonging to this superlayer */
  int fwl;
/** layer types/sequences */
  int ltyp;
/** relation to detector planes */
  ArteInvOneRelationPointer<GSGD,GEDE> gede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<GSGC,GCAL> gcal;
/** relation to walls */
  ArteInvOneRelationPointer<GSGW,GWAL> gwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Materials */
struct GMAT
{
/** material name */
  char name[12];
/** average A */
  float a;
/** Z */
  float z;
/** density */
  float dens;
/** radiation length */
  float radl;
/** absortion length */
  float absl;
/** number of components in mixtures
=0 = w only one component
>0 = w is the proportional weight in mixt
<0 = w is the number of atoms in a molecule */
  ArtePointer<NMIX> nmix;
/** flag
1 = nonsensitive nonmagnetic medium
2 = nonsensitive magnetic medium
4 = sensitive nonmagnetic medium
8 = sensitive magnetic medium */
  int flag;
/** number of row for first component in table gmix */
  ArtePointer<GMIX> gmix;
/** energy loss for MIPS */
  float loss;
/** relation to detector planes */
  ArteInvOneRelationPointer<GMGD,GEDE> gede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<GMGC,GCAL> gcal;
/** relation to walls */
  ArteInvOneRelationPointer<GMGW,GWAL> gwal;
/** relation to detector planes for nominal geometry */
  ArteInvOneRelationPointer<GMND,NEDE> nede;
///
  ArteInvOneRelationPointer<GMNC,NCAL> ncal;
/** relation to walls for nominal geometry */
  ArteInvOneRelationPointer<GMNW,NWAL> nwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of components of material mixtures */
struct GMIX
{
/** component name */
  char name[12];
/** A */
  float a;
/** Z */
  float z;
/** weights of this component */
  float w;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Adjacent ECAL cells references */
struct GNEI
{
/** code information about neighbors */
  int ncod;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Selection flags for superlayers */
struct GSSL
{
/** flag */
  int flag;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target geometry */
struct GTAR
{
/** wire material */
  int cmp;
/** wire number */
  int wnr;
/** wire thickness along the axis x */
  float dx;
/** wire thickness along the axis y */
  float dy;
/** wire thickness along the axis z */
  float dz;
/** x-position of wire center */
  float x;
/** y-position of wire center */
  float y;
/** z-position of wire center */
  float z;
/** 3*3 rotation matrix wire system to lab system */
  float rot[9];
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** maximum of vertex distribution in x direction */
  float x0bm;
/** maximum of vertex distribution in y direction */
  float y0bm;
/** width of vertex distribution in x direction */
  float sxbm;
/** width of vertex distribution in y direction */
  float sybm;
/** shape integer (same as in GEDE) */
  int shap;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** walls */
struct GWAL
{
/** detector shape */
  int shp;
/** x of the left edge */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** 3 by 3 rotation matrix */
  float rot[9];
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many walls */
  ArtePointer<GESL> gesl;
/** one material <-> many walls */
  ArtePointer<GMAT> gmat;
/** detector connected to this wall */
  ArtePointer<GEDE> gede;
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** energy loss of a mip in the given wall */
  float dedx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** hits in all detectors except ECAL */
struct HITB
{
/** z coordinate */
  float z;
/** x coordinate */
  float x;
/** y coordinate (for pad chambers only) */
  float y;
/** Quantity: amplitude for SVD, MSGC
drift time for outer tracker
0 for RICH, TRD, MUON */
  float q;
/** Resolution of quantity Q */
  float r;
/** detector plane */
  ArtePointer<GEDE> gede;
/** many hits to many tracks */
  ArteManRelationPointer<RTHI,RTRA> rtra;
/** many hits to many MC impact points */
  ArteManRelationPointer<MIHI,MIMP> mimp;
/** many digits to one hit */
  ArteInvOneRelationPointer<HIDI,DIGB> digb;
/** one fitted hit to many reconstructed hits */
  ArteInvOneRelationPointer<HIRH,RHIT> rhit;
/** many hits to one track segment */
  ArteManRelationPointer<RSHI,RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** hits in ECAL */
struct HITC
{
/** x coordinate */
  float x;
/** y coordinate (for pad chambers only) */
  float y;
/** energy */
  float q;
/** energy resolution */
  float r;
/** detector cell */
  ArtePointer<GCCE> gcce;
/** ADC value read (-pedestal) */
  float adc;
/** many hits to many tracks */
  ArteManRelationPointer<RTHC,RTRA> rtra;
/** many ECAL impact points to many hits */
  ArteManRelationPointer<MCHC,MCAL> mcal;
/** many ECAL hitc to many clusters */
  ArteInvManRelationPointer<HCRC,RCCL> rccl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi hit Mark Table */
struct MARK
{
/** Hit is used for SUSi Reconstruction */
  int used;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC calorimeter energy deposition */
struct MCAL
{
/** energy release of particle in the given block */
  float de;
/** block plane in table GCAL */
 int gcal;
/** one MTRA to many MCAL */
  ArtePointer<MTRA> mtra;
/** many hits to many MC impact points */
  ArteInvManRelationPointer<MCHC,HITC> hitc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC general information */
struct MCIN
{
/** mixing information: iijjkkll = ii interactions
from file evin1 + jj from file evin2 + ...
 ... file evin4 */
  char mix[4];
/** version of the geometry constants */
  float vgeo;
/** GEANT version */
  float vgea;
/** random seed for GEANT */
  int rgea[2];
/** random seed for digitisation */
  int rdig[2];
/** number of tracks from particle generator */
  int nmtr;
/** number of vertices from particle generator */
  int nmve;
/** random seed for L1SIMU */
  int rl1s[2];
/** long MC: bit flags */
  char fmcl[4];
/** short MC: bit flags */
  char fmcs[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC data for event mixing */
struct MCME
{
/** event number */
  int evt;
/** run number */
  int run;
/** experiment number. For unmixed events: the same
as the corresponding number in table EVHD */
  int exp;
/** flag for the generated physics process.
   0 ...  999 light quarks u,d,s
1000 ... 1999 c cbar or J/psi not from b-decay
2000 ... 2999 b bbar with J/psi
         2000: J/psi K0s
3000 ... 3999 b bbar with bs or b-baryon
4000 ... 4999 b bbar with semileptonic b-decay
Further specification necessary ! */
  int phy;
/** random seed for particle generator */
  int rlun[2];
/** primary vertex */
  ArtePointer<MVER> mver;
/** version of the particle generator (LUND) */
  float vlun;
/** generation time of the subevent (sec) */
  float time;
/** weight */
  float wgth;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** input/output files */
struct MEIO
{
/** file name */
  char name[120];
/** stream name */
  char stream[80];
/** Zebra options for FZFILE */
  char zoption[8];
/** logical unit associated to bit N (=1...32) */
  char bit[4];
/** 0: no io package; 1: Zebra IO
2: gpack */
  int pack;
/** IO status (from INQUIRE, OPEN, CLOSE, REWIND) */
  int iostat;
/** -1: unused; 0 reserved; 1: file name specified;
2: open at begin of file; 3: open;
4: end-of-file/closed (?); 5: closed. */
  int flag;
/** 0: sequential data set; >0: record length */
  int rleng;
/** 1: formatted IO; 0: unformatted; -1: unknown */
  int format;
/** pointer to concatenated data set */
  int concat;
/** pointer to to the file currently being open */
  int current;
/** number of records */
  int nrec;
/** next table on input file */
  int table;
/** flag: skip */
  int fskip;
/** number of events to be skipped */
  int nskip;
/** pointer from cfopen */
  int cfopen;
/** maximum number of bytes for output files */
  float maxout;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** DD: attribute description */
struct MEMA
{
/** attribute name */
  char name[80];
/** attribute type:
 */
  int type;
/** relation: pointer to relation */
  int rela;
/** relation: pointer the other the table */
  int relt;
/** relation: position inside table */
  int relp;
/** 1: attribute is a Leda key; 0: no Leda key */
  int key;
/** lower boundary for type integer */
  int ilow;
/** upper boundary for type integer
number of bits for type bit */
  int iupp;
/** lower boundary for type real */
  float flow;
/** upper boundary for type real */
  float fupp;
/** accuracy for type real */
  float accu;
/** minimum value */
  int imin;
/** maximum value */
  int imax;
/** minimum value
fmax must be the last attribute !!! */
  float fmin;
/** maximum value */
  float fmax;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data description: tables */
struct MEMO
{
/** table name */
  char name[80];
/** Zebra format */
  int fmt;
/** bits for default I/O units */
  char iod[4];
/** bits for active I/O units */
  char ioa[4];
/** Zebra division; IXCONS or IXEVNT */
  int div;
/** number of columns/row */
  int col;
/** number of output columns */
  int ocol;
/** extend table by this value */
  int ext;
/** -2: parallel table; -1: subord.; 0: other table
1: one-one; 2: one-many; 4: many-many */
  int flag;
/** positions for storing relations; */
  int pos[2];
/** superior tables */
  int sup[2];
/** pointer to SUBT (subordinate tables) */
  int sub1;
/** pointer to SUBT (subordinate tables)
ISUBT_SUB(IMEMO_SUB1(irow)...
 ... ISUBT_SUB(IMEMO_SUB2(irow) */
  int sub2;
/** pointer to attribute description MEMA */
  ArtePointer<MEMA> mema;
/** # bookings */
  int book;
/** # droppings */
  int drop;
/** # extensions */
  int extn;
/** maximum number of rows */
  int maxr;
/** accumulated number of rows */
  int accrow;
/** 2nd moment */
  int mom2;
/** # read from input files */
  int nin;
/** # written to output files
!!!! NOUT must be the last word !!!! */
  int nout;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** subordinate tables */
struct MEMS
{
/** Link number of a subordinate bank */
  int sub;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 01 */
struct MF01
{
/** coefficient of polinomial */
  float para[3];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 02 */
struct MF02
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 03 */
struct MF03
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 04 */
struct MF04
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 05 */
struct MF05
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 06 */
struct MF06
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 07 */
struct MF07
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 08 */
struct MF08
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 09 */
struct MF09
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 10 */
struct MF10
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 11 */
struct MF11
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 12 */
struct MF12
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 13 */
struct MF13
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 14 */
struct MF14
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 15 */
struct MF15
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 16 */
struct MF16
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 17 */
struct MF17
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 18 */
struct MF18
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 19 */
struct MF19
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 20 */
struct MF20
{
/** coefficient of polinomial */
  float para[60];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 21 */
struct MF21
{
/** coefficient of polinomial */
  float para[30];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for magnetic field constants */
struct MFHD
{
/** version number */
  float vers;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** regions for the magnetic field */
struct MFLD
{
/** method of field evaluation */
  int meth;
/** number of region subdivision on x */
  int nr_x;
/** number of region subdivision on y */
  int nr_y;
/** number or region subdivision on z */
  int nr_z;
/** size of region subdivision on x */
  float dr_x;
/** size of region subdivision on y */
  float dr_y;
/** size of region subdivision on z */
  float dr_z;
/** lower bound of region on x */
  float xmin;
/** upper bound of region on x */
  float xmax;
/** lower bound of region on y */
  float ymin;
/** upper bound of region on y */
  float ymax;
/** lower bound of region on z */
  float zmin;
/** upper bound of region on z */
  float zmax;
/** scale factor for coordinates */
  float scal;
/** nonzero if region include e-pipe */
  int pipe;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC detector impact points */
struct MIMP
{
/** z coordinate; note the order: z x y ! */
  float z;
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** tan(px/pz) */
  float tx;
/** tan(py/pz) */
  float ty;
/** momentum multiplied by the sign of pz */
  float p;
/** Time of flight */
  float time;
/** detector plane in table GEDE */
  ArtePointer<GEDE> gede;
/** relation one track to many impact points */
  ArtePointer<MTRA> mtra;
/** many digits to many mimps */
  ArteInvManRelationPointer<MIDI,DIGB> digb;
/** many hits to many MC impact points */
  ArteInvManRelationPointer<MIHI,HITB> hitb;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC-Track-Entry-Point in calorimeter */
struct MTCP
{
/** z coordinate; note the order: z x y ! */
  float z;
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** tan(px/pz) */
  float tx;
/** tan(py/pz) */
  float ty;
/** momentum multiplied by the sign of pz */
  float p;
/** Pointer to track entering into the calorimeter */
  ArtePointer<MTRA> mtra;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC particles / tracks */
struct MTRA
{
/** Px */
  float px;
/** Py */
  float py;
/** Pz */
  float pz;
/** Particle mass for resonances;
track length for stable particles */
  float ml;
/** whereabout of the track:
0: just created; not yet processed
1: expected to decay according to QMTRX_LENG
2: decayed resonance or electromagnetic decay
   (production vertex = decay vertex)
3: decay with non-zero track length
4: track ends in a electromagnetic or
   hadronic interaction
5: track leaves the detector volume
6: track stops inside detector volume
7: track curls up inside detector volume */
  int flag;
/** particle code */
  ArtePointer<TOPP> topp;
/** data for MTRX_BVER, MTRX_BTRA */
  int orig;
/** mass */
  float mass;
/** track length */
  float leng;
/** one vertex to many outgoing tracks */
  ArtePointer<MVER> bver;
/** one track to many outgoing tracks */
  ArtePointer<MTRA> btra;
/** many outgoing tracks to one track */
  ArteInvOneRelationPointer<MTMT,MTRA> etra;
/** many end vertices to one track */
  ArteInvOneRelationPointer<MTMV,MVER> ever;
/** many impact points to one track */
  ArteInvOneRelationPointer<MTMI,MIMP> mimp;
/** many ECALs to one track */
  ArteInvOneRelationPointer<MTMC,MCAL> mcal;
/** many reconstructed tracks to many MC tracks */
  ArteManRelationPointer<RTMT,RTRA> rtra;
/** many track segments to many MC tracks */
  ArteManRelationPointer<RSMT,RSEG> rseg;
/** many clusters to many MC tracks */
  ArteInvManRelationPointer<MTRC,RCCL> rccl;
/** to calorimeter entry point in bank MTCP */
  ArteInvOneRelationPointer<MTMP,MTCP> mtcp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC vertices */
struct MVER
{
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** z coordinate */
  float z;
/** 0: primary vertex; x=y=z=0;
1: primary vertex at target;
2: decay vertex; 3: kink;
4: 2ndary,3rtiary, ... interaction */
  int flag;
/** one mother track to many vertices */
  ArtePointer<MTRA> btra;
/** many outgoing tracks to one origin vertex */
  ArteInvOneRelationPointer<MVMT,MTRA> etra;
/** primary interaction in MCME */
  ArteInvOneRelationPointer<MVME,MCME> mcme;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** beam geometry */
struct NBEA
{
/** x-position of beam center */
  float x;
/** y-position of beam center */
  float y;
/** z-position of beam center */
  float z;
/** beam width along the axis x-prime */
  float dx;
/** beam width along the axis y-prime */
  float dy;
/** beam time width */
  float dt;
/** mean time value for generation */
  float time;
/** MC time smearing switch: on -> .ne. 0 */
  int tsw;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: calorimeter/scintill. */
struct NCAL
{
/** number of subsectors per block
1: outer  calorimeter - block division 1*1
2: middle calorimeter - block division 2*2
5: inner  calorimeter - block division 5*5 */
  int ncl;
/** block number within the superlayer (packed) */
  int sec;
/** x of the left edge of the block */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** light efficiency */
  float eff;
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** detector component (see table NESL) */
  int cmp;
/** one super-layer <-> many detector planes */
  ArtePointer<NESL> nesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** Geant volume name */
  char gvol[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: planes */
struct NEDE
{
/** detector component (see table NESL) */
  int cmp;
/** layer number within the superlayer */
  int lay;
/** sector number */
  int sec;
/** detector shape */
  int shp;
/** x of the left edge of the detector */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** outer tracker: x of the left edge
of the sensitive area
muon: the size of sensitive area near pad */
  float sxmn;
/** outer tracker: y of the right edge
muon: efficiency in the gap between pads */
  float sxmx;
/** outer tracker: y of the lower edge
muon: y-distance from chamber edge to pad */
  float symn;
/** outer tracker: y of the upper edge
muon: y-gap between pads */
  float symx;
/** cosine of the wire angle with respect to y-axis */
  float cos;
/** sine of the wire angle with respect to y axis */
  float sin;
/** 3 by 3 rotation matrix */
  float rot[9];
/** measurement accuracy (for MC digitization) */
  float acc;
/** hit efficiency (for MC digitization) */
  float eff;
/** max drift distance or double hit resolution */
  float dod;
/** pitch */
  float pit;
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** outer tracker: x of first wire in sublayer 1...4
muon: 1 - x of first wire
muon: 2 - x-size of pad or pixel cell
muon: 3 - x-distance from chamber edge to pad
muon: 4 - x-gap between pads */
  float xfw[4];
/** outer tracker: z of first wire in sublayer 1...4
muon: 1 - z of wires
muon: 2 - z of pads
muon: 3 - y-size of first (small) pad or pixel
muon: 4 - y-size of large pads */
  float zfw[4];
/** outer tracker: number of wires in sublayer 1...4
muon: 1 - number of wires or pixels in x-dir
muon: 2 - number of pixels in y-direction
muon: 3 - number of connected pixels in x-dir
muon: 4 - number of connected pixels in y-dir */
  int nwi[4];
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many detector planes */
  ArtePointer<NESL> nesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** number of walls connected to this detector */
  int nwl;
/** first wall connected to this detector */
  int fwl;
/** additional word for comp. geometrical shapes */
  float xmad;
/** additional word for comp. geometrical shapes */
  float ymad;
/** additional word for comp. geometrical shapes */
  float zmad;
/** lower boundary in y for wires in sublayer 1...4 */
  float y1w[4];
/** upper boundary in y for wires in sublayer 1...4 */
  float y2w[4];
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** Hardware code for the given detector */
  char hwc[12];
/** energy loss of a mip in the given detector */
  float dedx;
/** Geant copy number - so called user number */
  int gcop;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: superlayers */
struct NESL
{
/** superlayer name (up to 4 characters) */
  char name[4];
/** detector component:
 1 SIL silicon vertex detector
 2 WCH wire chambers
 3 MSG microstrip chambers
 4 PTC chambers (pi-pi trigger)
 5 RIC Cerenkov counter
 6 TRD forward TRD
 7 CAL electromagnetic calorimeter
 8 MUO muon outer chambers
 9 MUX muon central chambers
11 TAR target
12 FLD field
13 HOD1 hodoscope 1
14 HOD2 hodoscope 2
15 HOD3 hodoscope 3
25 MUON system
26 Electron pipe
27 Proton pipe
28 Magnet
29 Roman Pot */
  int cmp;
/** shape of the superlayer
 1 box
 3 trapezoid (ie. x and y varying along z)
 5 tube
 9 spherical shell */
  int shp;
/** nth superlayer of this component */
  int nsl;
/** magnet flag (0 = no mag. field) */
  int mfl;
/** number of layers */
  int lay;
/** box:  left  boundary in x
trap: left boundary in x at smaller z
tube and sphere: inner radius */
  float x1;
/** box:  right boundary in x
trap: right boundary in x at smaller z
tube and sphere: x-pos. of tube/sphere center */
  float x2;
/** box:  lower boundary in y
trap: lower boundary in y at smaller z
tube and sphere : outer radius */
  float y1;
/** box:  upper boundary in y
trap: upper boundary in y at smaller z
tube and sphere: y-pos. of tube/sphere center */
  float y2;
/** z of begin of superlayer */
  float z1;
/** z of end of superlayer */
  float z2;
/** trap: difference in x to x1 at bigger z */
  float dx;
/** trap: difference in y to y1 at bigger z */
  float dy;
/** number of detector planes (nlayers*nsectors) */
  int npl;
/** first det. plane belonging to this superlayer */
  int fpl;
/** number of walls in this superlayer */
  int nwl;
/** first wall belonging to this superlayer */
  int fwl;
/** layer types/sequences */
  int ltyp;
/** relation to detector planes */
  ArteInvOneRelationPointer<NSND,NEDE> nede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<NSNC,NCAL> ncal;
/** relation to walls */
  ArteInvOneRelationPointer<NSNW,NWAL> nwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** bank of magnetic field (temporary - const field) */
struct NFLD
{
/** x-position of field center */
  float x;
/** y-position of field center */
  float y;
/** z-position of field center */
  float z;
/** radius of field region */
  float r;
/** strength of field (in kG) */
  float h;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for the nominal detector geometry */
struct NGHD
{
/** version number for the geometry constants */
  float geom;
/** version number of the hbgean program producing
the constants */
  float gean;
/** date */
  int date;
/** time */
  int time;
/** version number for the geometry constants
the vector is given by gehd.geom(LGESL_... ,I)
LGESL_MOTH = 30 = overall geometry = datt geom
LGESL_RPOT = 29 = Roman Pot
LGESL_TAR  = 11 = target
LGESL_SIL  = 1  = SVD
LGESL_SML  = 16 = Silicon in magnet
LGESL_MAG  = 28 = Magnet elements
LGESL_FLD  = 12 = magnetic field
LGESL_PPIP = 27 = Proton beam pipe
LGESL_EPIP = 26 = Electron beam pipe
LGESL_WCH  = 2  = OTR
LGESL_MSG  = 3  = ITR
LGESL_PTC  = 4  = PTL
LGESL_RIC  = 5  = RICH
LGESL_TRSL = 24 = TRD
LGESL_ECA  = 7  = ECA
LGESL_MUON = 25 = MUON System
LGESL_HOD1 = 13 = new trigger hodoscope
LGESL_HOD2 = 14 = trigger hodoscope
LGESL_HOD3 = 15 = last (in z) hodoscope */
  float gevs[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Materials */
struct NMAT
{
/** material name */
  char name[12];
/** average A */
  float a;
/** Z */
  float z;
/** density */
  float dens;
/** radiation length */
  float radl;
/** absortion length */
  float absl;
/** number of components in mixtures
=0 = w only one component
>0 = w is the proportional weight in mixt
<0 = w is the number of atoms in a molecule */
  int nmx;
/** flag
1 = nonsensitive nonmagnetic medium
2 = nonsensitive magnetic medium
4 = sensitive nonmagnetic medium
8 = sensitive magnetic medium */
  int flag;
/** number of row for first component in table gmix */
  ArtePointer<NMIX> nmix;
/** energy loss for MIPS */
  float loss;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of components of material mixtures */
struct NMIX
{
/** component name */
  char name[12];
/** A */
  float a;
/** Z */
  float z;
/** weights of this component */
  float w;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target geometry */
struct NTAR
{
/** wire material */
  int cmp;
/** wire number */
  int wnr;
/** wire thickness along the axis x */
  float dx;
/** wire thickness along the axis y */
  float dy;
/** wire thickness along the axis z */
  float dz;
/** x-position of wire center */
  float x;
/** y-position of wire center */
  float y;
/** z-position of wire center */
  float z;
/** 3*3 rotation matrix wire system to lab system */
  float rot[9];
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** maximum of vertex distribution in x direction */
  float x0bm;
/** maximum of vertex distribution in y direction */
  float y0bm;
/** width of vertex distribution in x direction */
  float sxbm;
/** width of vertex distribution in y direction */
  float sybm;
/** shape integer (same as in GEDE) */
  int shap;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal walls */
struct NWAL
{
/** detector shape */
  int shp;
/** x of the left edge */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** 3 by 3 rotation matrix */
  float rot[9];
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many walls */
  ArtePointer<NESL> nesl;
/** one material <-> many walls */
  ArtePointer<GMAT> gmat;
/** detector connected to this wall */
  ArtePointer<NEDE> nede;
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** energy loss of a mip in the given wall */
  float dedx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt ASD-8 board
Each ASD-8 board reads 16 channels
for gas pixel chambers */
struct PTAD
{
/** ASD-8/Cable unique mark (8 symbols)
for example for run98:  PT1M0011 */
  char name[8];
/** ASD-8/Cable position */
  int pos;
/** First channel in table PTCH */
  int fstc;
/** Last  channel in table PTCH */
  int lstc;
/** one FED board to many ASD-8 boards */
  ArtePointer<PTFD> ptfd;
/** one ASD-8 board to many channels */
  ArteInvOneRelationPointer<PXCA,PTCH> ptch;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Alignment information */
struct PTAL
{
/** flag */
  int flag;
/** x offset */
  float xoff;
/** y offset */
  float yoff;
/** z offset */
  float zoff;
/** rotation matrix */
  float rotm[9];
/** one module to one geom info */
  ArtePointer<PTMD> ptmd;
/** one PTGE to many geom info */
  ArtePointer<PTGE> ptge;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Cells of PT chambers */
struct PTCE
{
/** Cell Flag */
  int flag;
/** Cell ID */
  int id;
/** one PTGE to many PT Cells */
  ArtePointer<PTGE> ptge;
/** one PT Channel to one PT Cell */
  ArtePointer<PTCH> ptch;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-pt Channel */
struct PTCH
{
/** Channel number */
  int id;
/** one ASD-8 to many channels */
  ArtePointer<PTAD> ptad;
/** one PT Cell to one PT Channel */
  ArteInvOneRelationPointer<PXCC,PTCE> ptce;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt FED Mother Board/Crate
High-Pt FED description */
struct PTCR
{
/** Mother board/Crate number */
  int id;
/** Mother Board/Crate name (8 symbols) */
  char name[8];
/** Short Description     (128 symbols) */
  char text[128];
/** one module to many crates */
  ArtePointer<PTMD> ptmd;
/** one crate to many boards */
  ArteInvOneRelationPointer<PXFC,PTFD> ptfd;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Daugther Board
High-Pt Readout board description
Board houses up to 18 ASD-8 chips */
struct PTFD
{
/** Daugther Board number */
  int id;
/** Daugther Board name  (8 symbols) */
  char name[8];
/** Comment/short description (128 symbols) */
  char text[128];
/** one crate to many boards */
  ArtePointer<PTCR> ptcr;
/** one board to many ASD-8 */
  ArteInvOneRelationPointer<PXAF,PTAD> ptad;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** PT detector geometry: planes and walls */
struct PTGE
{
/** Flag:    =  1 Detector
         = -1 Wall
 else    =  dummy row */
  int flag;
/** Arte Element: >0    (GEDE row)
              =0 dummy row
              <0 -1*(GWAL row) */
  int arte;
/** DataBase Flag */
  int db;
/** Detector/Wall name   (   4 symbols ) */
  char name[4];
/** Superlayer name      (   4 symbols ) */
  char supl[4];
/** GEANT Mother name    (   4 symbols ) */
  char moth[4];
/** Shape of the volume  (   4 symbols ) */
  char shap[4];
/** Matherial name       (<=12 symbols ) */
  char mate[12];
/** MANY/ONLY flag for GEANT */
  char maon[4];
/** Rotation matrix flag/index */
  int irot;
/** 3x3 Rotation Matrix
For following 8 attributes see also
definitions in gean/PTGEA.fi,PTGEA.ff */
  float rotm[9];
/** minimal X          ( for BOX  shape )
Outer Radius       ( for TUBE shape )
X-length           ( for TRD2 shape ) */
  float xmin;
/** maximal X          ( for BOX  shape )
Thickness          ( for TUBE shape )
Y-length           ( for TRD2 shape ) */
  float xmax;
/** minimal Y          ( for BOX  shape )
Length             ( for TUBE shape )
Z-length           ( for TRD2 shape ) */
  float ymin;
/** maximal Y          ( for BOX  shape )
X-position         ( for TUBE shape )
X-position         ( for TUBE shape ) */
  float ymax;
/** minimal Z          ( for BOX  shape )
Y-position         ( for TUBE shape )
Y-position         ( for TUBE shape ) */
  float zmin;
/** maximal Z          ( for BOX  shape )
Z-position         ( for TUBE shape )
Z-position         ( for TUBE shape ) */
  float zmax;
/** DX                 ( for TRD2 shape ) */
  float dx;
/** DY                 ( for TRD2 shape ) */
  float dy;
/** NX - chamber division in X-direction */
  int nx;
/** NY - chamber division in Y-direction */
  int ny;
/** Direction of hardware addressing
 MOD(DIR,10000)<=1 - from Xmin to Xmax
  suitable for X>0 chambers
 MOD(DIR,10000)>=2 - from Xmax to Xmin
  suitable for X<0 chambers
 DIR/10000     <=1 - from Ymin to Ymax
  suitable for Y>0 chambers
 DIR/10000     >=2 - from Ymax to Ymin
  suitable for Y<0 chambers
 DIR =   0,1 - normal    ordering
 DIR =     2 - inverse X-ordering
 DIR = 20000 - inverse Y-ordering
 DIR = 20002 - inverse X and Y-ordering */
  int dir;
/** COLOR attribute for GEANT */
  int colo;
/** FILL  attribute for GEANT */
  int fill;
/** SEEN  attribute for GEANT */
  int seen;
/** Comment,short description (128 symbols) */
  char comm[128];
/** First Cell in table PTCE */
  int fstc;
/** Last  Cell in table PTCE */
  int lstc;
/** one PTGE to many cells */
  ArteInvOneRelationPointer<PXGC,PTCE> ptce;
/** one PTGE to many geom info */
  ArteInvOneRelationPointer<PXGA,PTAL> ptal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Module
High-Pt Module description */
struct PTMD
{
/** Module number */
  int id;
/** Module name  (8 symbols) */
  char name[8];
/** Short Description (128 symbols) */
  char text[128];
/** one module to many crates */
  ArteInvOneRelationPointer<PXCM,PTCR> ptcr;
/** one module to many geom info */
  ArteInvOneRelationPointer<PXGM,PTAL> ptal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** cluster table */
struct RCCL
{
/** z of the cluster */
  float z;
/** x of the corrected cog for electrons */
  float x;
/** y of the corrected cog for electrons */
  float y;
/** px/pz of the cluster axis */
  float tx;
/** py/pz of the cluster axis */
  float ty;
/** Total energy of cluster */
  float esum;
/** matrix of the errors (5x5) */
  float cve[15];
/** width of the cluster */
  float wid;
/** asymmetry of the cluster */
  float asym;
/** flag */
  int flag;
/** likelyhood of electromagnetic shower */
  float lemp;
/** likelyhood of MIP */
  float lmip;
/** likelyhood of hadron shower */
  float lhad;
/** x of the cog */
  float xcog;
/** y of the cog */
  float ycog;
/** Covariances (2x2) of COG */
  float vcog[3];
/**  many hitc to many clusters */
  ArteManRelationPointer<HCRC,HITC> hitc;
/**  many tracks to many clusters */
  ArteManRelationPointer<RTRC,RTRA> rtra;
/**  many MC tracks to many clusters */
  ArteManRelationPointer<MTRC,MTRA> mtra;
/**  many segments to many clusters */
  ArteManRelationPointer<RSRC,RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** fitted hits in all detectors except ECAL */
struct RHIT
{
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** px / pz */
  float tx;
/** py / pz */
  float ty;
/** 1 / p signed according to charge */
  float p;
/** quantity (detector dependent) */
  float q;
/** track number */
  ArtePointer<RTRA> rtra;
/** one fitted hit to one measured hit */
  ArtePointer<HITB> hitb;
/** one track segment to many reconstr. hits */
  ArtePointer<RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** point on a track (e.g. impact point into muon) */
struct RPNT
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** 1/p (signed according to charge) */
  float pf;
/** covariance matric of parameters at first point */
  float cvf[15];
/** many track to many points on it */
  ArteManRelationPointer<RTRP,RTRA> rtra;
/** one track segment to many points on it */
  ArtePointer<RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** relation between tracks and  vertices */
struct RREL
{
/** 0/1: not used / used for the vertex fit */
  int flag;
/** used particle hypothesis; 0: no hyp. */
  ArtePointer<TOPP> topp;
/** contribution to chi */
  float chi;
/** one track to many track-vertex relations */
  ArtePointer<RTRA> rtra;
/** one vertex to many track-vertex relations */
  ArtePointer<RVER> rver;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed track segments */
struct RSEG
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** 1/p (signed according to charge) */
  float pf;
/** covariance matrix of parameters at first point */
  float cvf[15];
/** time in ns */
  float time;
/** error on time */
  float dtim;
/** z coordinate at end of track
z=0: end of track is not determined */
  float ze;
/** x coordinate */
  float xe;
/** y coordinate */
  float ye;
/** px / pz */
  float txe;
/** py / pz */
  float tye;
/** 1/p (signed according to charge) */
  float pe;
/** covariance matrix of parameters at end point */
  float cve[15];
/** chi**2 of fit */
  float chi;
/** fit flag */
  int fit;
/** detector component (bit flags ?) */
  int cmp;
/** many hits to one track segment */
  ArteInvManRelationPointer<RSHI,HITB> hitb;
/** many track segments to one track */
  ArteManRelationPointer<RTRS,RTRA> rtra;
/** many track segment to many reconstructed points */
  ArteInvOneRelationPointer<RSRP,RPNT> rpnt;
/** many track segments to many MC tracks */
  ArteInvManRelationPointer<RSMT,MTRA> mtra;
/** one track segment to many reconstr. hits */
  ArteInvOneRelationPointer<RSRH,RHIT> rhit;
/** many track segments to many ECAL clusters */
  ArteInvManRelationPointer<RSRC,RCCL> rccl;
/** many track segments at the begin of
this segment to many segments */
  ArteManRelationPointer<RSRS,RSEG> rbeg;
/** many track segments at the end of
this segment to many segments */
  ArteInvManRelationPointer<RSRS,RSEG> rend;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed tracks */
struct RTRA
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** charged tracks: Q/p
neutral decays: 1/p */
  float pf;
/** covariance matrix of parameters at first point
****************************************
* the following is only a proposal
* and needs lots of future discussion! *
**************************************** */
  float cvf[15];
/** bit map of hit layers in the SVD */
  int hsi;
/** number of hits in the inner tracker */
  int hin;
/** number of hits in the outer tracker */
  int hou;
/** number of hits in the RICH */
  int hri;
/** number of hits in the calorimeter */
  int hca;
/** number of hits in the TRD */
  int htr;
/** number of hits in the muon chambers */
  int hmu;
/** fit flag: D + 10 * E with ...
D = 0: reconstructed charged track
    1: reconstructed momentum to main vertex
    2: reconstructed short decay
    3: reconstructed long decay
    4: conversion
E: error flag from track or vertex fit */
  int fit;
/** chi of track or vertex fit */
  float chi;
/** Rich: likelihood of electron hypothesis */
  float lre;
/** Rich: likelihood of muon hypothesis */
  float lrmu;
/** Rich: likelihood of pion hypothesis */
  float lrpi;
/** Rich: likelihood of kaon hypothesis */
  float lrk;
/** Rich: likelihood of proton hypothesis */
  float lrp;
/** Rich: particle identification flag */
  int flr;
/** particle code
for charged tracks: hypothesis used for the
track fit; BY NO MEANS: the only hypothesis
for decays with mass constraint: hypothesis
for decays without mass constraint: 0 */
  ArtePointer<TOPP> topp;
/** TRD: likelihood of electron hypothesis */
  float lte;
/** TRD: likelihood of hadron hypothesis */
  float lth;
/** TRD: particle identification flag */
  int flt;
/** ECAL: likelihood of electron hypothesis */
  float lee;
/** ECAL: likelihood of MIP hypothesis */
  float lemi;
/** ECAL: likelihood of hadron hypothesis */
  float leh;
/** ECAL: particle identification flag */
  int fle;
/** MUON: likelihood of muon hypothesis */
  float lmmu;
/** MUON: likelihood of hadron hypothesis */
  float lmh;
/** MUON: particle identification flag */
  int flm;
/** one incoming track to one vertex */
  ArteInvOneRelationPointer<RVRT,RVER> ever;
/** one track to many track-vertex relations */
  ArteInvOneRelationPointer<RRRT,RREL> rrel;
/** many hits to many reconstructed tracks */
  ArteInvManRelationPointer<RTHI,HITB> hitb;
/** many ECAL hits to many reconstructed track */
  ArteInvManRelationPointer<RTHC,HITC> hitc;
/** one track to many points on it */
  ArteInvManRelationPointer<RTRP,RPNT> rpnt;
/** many reconstructed tracks to many MC tracks */
  ArteInvManRelationPointer<RTMT,MTRA> mtra;
/** many track segments to one track */
  ArteInvManRelationPointer<RTRS,RSEG> rseg;
/** many clusters to many tracks */
  ArteInvManRelationPointer<RTRC,RCCL> rccl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed vertices */
struct RVER
{
/** x coordinate */
  float xv;
/** y coordinate */
  float yv;
/** z coordinate */
  float zv;
/** covariance matrix */
  float cv[6];
/** reconstructed mass */
  float mass;
/** error on reconstructed mass
The particle hypothesis used for
a mass constraint fit is stored in RTRA */
  float merr;
/** number of tracks used for the fit */
  int nt;
/** one vertex to one incoming track */
  ArtePointer<RTRA> btra;
/** e */
  ArteInvOneRelationPointer<RRRV,RREL> rrel;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for SUSi Candidates */
struct SHCA
{
/** HITB row number */
  ArtePointer<HITB> hitb;
/** Plane number */
  int plan;
/** The measured value */
  float meas;
/** Delta Chi2 for a hit */
  float dchi;
/** (4)   SUSi Parameters */
  float p[4];
/** (4x4) Covariance Error Matrix */
  float c[16];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for SUSi Proper Tracks */
struct SHPR
{
/** HITB row number */
  ArtePointer<HITB> hitb;
/** one reconctructed   track to many hits */
  ArtePointer<STPR> stpr;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for Reconstructed Tracks */
struct SHRC
{
/** Row in HITB table */
  ArtePointer<HITB> hitb;
/** SUSi Plane of measurement */
  int plan;
/** Parameters */
  float p[4];
/** Covariance Matrix */
  float c[10];
/** Measurement for Kalman Smoothing */
  float meas;
/** Residial for Kalman Smoothing */
  float res;
/** one reconctructed   track to many hits */
  ArtePointer<STRC> strc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SNAB
{
/** NEXT plane to be searched for */
  int next;
/** one PLANE to many PLANES */
  ArtePointer<SNAV> snav;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (from) */
struct SNAV
{
/** GEDE plane Number */
  ArtePointer<GEDE> gede;
/** Number of SNAX to be connected */
  int npla;
/** Number of SNAB to be connected */
  int nbac;
/** C */
  ArteInvOneRelationPointer<SNSN,SNAX> snax;
/** C */
  ArteInvOneRelationPointer<SBSN,SNAB> snab;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SNAX
{
/** NEXT plane to be searched for */
  int next;
/** one PLANE to many PLANES */
  ArtePointer<SNAV> snav;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Parameters Table
This table consiists of almost all
vital SUSi parameters. Be careful
to modify them! In the case of
errors table automatically reset
to default values. */
struct SPAR
{
/** Number of Modification(normally=1) */
  int nmod;
/** Default Flag:
 >0 Default Parameters
 <0 Not default Parametrs
 =0 Not Yet Defined! Dangerous!!!! */
  int dfla;
/** Dimension of the SEEDing algorithm
 = 4 Standard documented 4-plane
     seeds  for SUSi, robust and
     well tested. Disadvantage -
     execution time proportional
     to n_hit**4, very low track
     reconstruction efficiency for
     large occupancy.
 = 2 Very Simple 2-plane seeding
     algorithm. Advantages:
     5-10 times faster and much
     larger efficiency for high
     occupancy. It is DEFAULT!! */
  int seed;
/**  = 0 Minimal Z approach in 2-plane
     seeding algorithm(default)
 = 1 Minimal Angular difference
     approach */
  int angu;
/** =   0 No PROPER TRACK business */
  int prop;
/** =   0 No refit business
=   1 Kalman  Smother refit
=   2 Reverse Kalman  refit */
  int algo;
/** =   0 No Reconstructed Point */
  ArtePointer<RPNT> rpnt;
/** Number of Hitted SL */
  int mhsl;
/** Minimal Track Quality Cut */
  float qual;
/** Minimal Correct hits contents */
  float perc;
/** Weight for missing hits */
  float wmis;
/** Weight for chi2 */
  float wch2;
/** Minimal Tolerance Parameter */
  float mnto;
/** Maximal Tolerance Parameter */
  float mxto;
/** Angle Tolerance Parameter */
  float anto;
/** CRITICAL Parameter */
  float crit;
/** TARGET_WINDOW Parameter */
  float twin;
/** Minimal Momenta for a Particle
Used twice:
a) for a Proper Track Definition
b) for MS estimation in s_klmpre.F */
  float pmin;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi PASS Table */
struct SPAS
{
/** C */
  ArteInvOneRelationPointer<SPSS,SSEE> ssee;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi SEEDing Table */
struct SSEE
{
/** First Plane Number in Combination */
  int pln1;
/** First Plane Number in Combination */
  int pln2;
/** First Plane Number in Combination */
  int pln3;
/** First Plane Number in Combination */
  int pln4;
/** one PASS to many SEEDs */
  ArtePointer<SPAS> spas;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Statistics Table */
struct SSTA
{
/** Start NEVENT  for Statistics */
  int frst;
/** Last  NEVENT  for Statistics */
  int last;
/** Print Flag: 0 - no print
  N - print stat for N events
 -N - print stat every N events */
  int prn;
/** Minimal number of Prop. Tracks */
  int mnpf;
/** Maximal number of Prop. Tracks */
  int mxpf;
/** Minimal number of Pre.Rec.Tracks */
  int mnpr;
/** Maximal number of Pre.Rec.Tracks */
  int mxpr;
/** Minimal number of Rec.Tracks */
  int mnre;
/** Maximal number of Rec.Tracks */
  int mxre;
/** Minimal number of Prop.Rec.Tracks */
  int mnpt;
/** Maximal number of Prop.Rec.Tracks */
  int mxpt;
/** Minimal number of Ext.Rec.Tracks */
  int mnex;
/** Maximal number of Ext.Rec.Tracks */
  int mxex;
/** Minimal number of Ghost Rec.Tracks */
  int mngh;
/** Maximal number of Ghost Rec.Tracks */
  int mxgh;
/** Minimal number of RSEGs */
  int mnse;
/** Maximal number of RSEGs */
  int mxse;
/** Minimal number of RPNTs */
  int mnrp;
/** Maximal number of RPNTs */
  int mxrp;
/** Minimal calls of s_propseed.F */
  int mncp;
/** Maximal calls of s_propseed.F */
  int mxcp;
/** Total number of Proper Tracks */
  int nstp;
/** AUXinfo  for error in NSTP */
  float ystp;
/** Total number of Prelim.Rec.Tracks */
  int npre;
/** AUXinfo  for error in NPRE */
  float ypre;
/** Total number of Reconctruc.Tracks */
  int nrec;
/** AUXinfo  for error in NREC */
  float yrec;
/** Total number of Rec.Segments */
  int nseg;
/** AUXinfo  for error in NSEG */
  float yseg;
/** Total number of GHOSTS */
  int ngho;
/** AUXinfo  for error in NGHO */
  float ygho;
/** Total number of RPNTs */
  int npnt;
/** AUXinfo  for error in NPNT */
  float ypnt;
/** Total calls of s_propseed.F */
  int nncp;
/** AUXinfo  for error in NNCP */
  float yncp;
/** Eff. for Prop.Rec.Tracks */
  float epro;
/** AUXinfo  for error in EPRO */
  float apro;
/** Eff. for Extra Rec.Tracks */
  float eext;
/** AUXinfo  for error in EEXT */
  float aext;
/** Eff. for Ghost Rec.Tracks */
  float egho;
/** AUXinfo  for error in EGHO */
  float agho;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Track Candidates */
struct STCA
{
/** Number of Silicon HITS for a candidate */
  int nhit;
/** Number of Missing HITS */
  int nmis;
/** Number of dbl foults */
  int n2mi;
/** hit seeding pl for a cand */
  int hspl;
/** lpl_x parameter for a candidat */
  int lplx;
/** lpl_y parameter for a candidat */
  int lply;
/** Ac_bit 1=tracking,2=finished,0=dead */
  int ac;
/** Chi2 for a candidate */
  float chi2;
/** AUXinfo - Plane */
  int plan;
/** AUXinfo - Parameters for a candidate */
  float p[4];
/** AUXinfo - Covariant matrix for a candidate */
  float c[16];
/** List of SHCA for this STCA */
  int hili[40];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Reconstructable Tracks */
struct STPR
{
/** MTRA Row Number for the Proper Track */
  ArtePointer<MTRA> mtra;
/** Number of Silicon HITS for the track */
  int nhit;
/** Many Silicon HITS to One Proper Track */
  ArteInvOneRelationPointer<SPSH,SHPR> shpr;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Reconstructed Tracks */
struct STRC
{
/** Number of Silicon HITS for a track */
  int nhit;
/** Number of Missing HITS */
  int nmis;
/** last Plane of measurement */
  int plan;
/** MTRA row number for a track */
  ArtePointer<MTRA> mtra;
/** responsible SEED for a track */
  int seed;
/** percentage of correctly associated hits */
  int perc;
/** chi2 for a track */
  float chi2;
/** Track Quality */
  float qual;
/** Z of last plane of measurement */
  float z;
/** (4)  Track Parameters  at Z */
  float p[4];
/** (4x4)Covariance Matrix at Z */
  float c[10];
/** Activation bit */
  int ac;
/** Many SI hits to one Reconstructed SUSi Track */
  ArteInvOneRelationPointer<SRSH,SHRC> shrc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SUSI
{
/** SUSi Version */
  float vers;
/** Navigation Table Version */
  float nver;
/** SEEDing Table Version */
  float sver;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Particle decays */
struct TDEC
{
/** Arte code for mother particle */
  int moth;
/** Arte code for daughter particles */
  int daug[5];
/** Lund MDME array */
  int mdme[2];
/** branching ratio */
  float brat;
/** next decay channel for same mother */
  int next;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TEMP
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP0
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP1
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP2
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP3
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP4
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP5
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP6
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP7
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP8
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP9
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Particle Properties */
struct TOPP
{
/** particle name */
  char name[12];
/** mass */
  float mass;
/** width */
  float wid;
/** truncate Breit-Wigner at mass - trbw */
  float trbw;
/** life time */
  float life;
/** 3 * charge */
  int chrg;
/** colour information: 0 = colour singlet;
2 = gluon; 1 = quark or anti-diquark;
-1 = anti-quark or diquark */
  int colo;
/** Lund decay flag (0 = no decay) */
  int deca;
/** LUND code */
  int lund;
/** GEANT code */
  int gean;
/** anti-particle row number */
  int anti;
/** 1st entry in table TDEC */
  ArtePointer<TDEC> tdec;
/** relation to many MC tracks */
  ArteInvOneRelationPointer<MTTO,MTRA> mtra;
/** relation to many reconstructed tracks */
  ArteInvOneRelationPointer<RTTO,RTRA> rtra;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L2Simu track output */
struct XTRA
{
/** Absolute track number (= FLT track number) */
  int itra;
/** Flag for track accepts (= 1 if ACC) */
  int flag;
/** Total number of layers used in L2SIMU run */
  int nlay;
/** FLT RoI on TC2 (x2,y2,z2,x2_err,y2_err) */
  float flt2[5];
/** FLT RoI on PC1 (x1,y1,z1,x1_err,y1_err) */
  float flt1[5];
/** Number of hits used in refit-xz */
  int nhix;
/** Number of holes in refit-xz */
  int nhox;
/** Track slope after refit-xz */
  float slox;
/** Track intercept after refit-xz */
  float intx;
/** Covariance matrix after refit-xz */
  float covx[3];
/** Chisquare sum after refit-xz */
  float chix;
/** Number of hits used in refit-yz */
  int nhiy;
/** Number of holes in refit-yz */
  int nhoy;
/** Track slope after refit-yz */
  float sloy;
/** Track intercept after refit-yz */
  float inty;
/** Covariance matrix after refit-yz */
  float covy[3];
/** Chisquare sum after refit-yz */
  float chiy;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L2Simu trigger output */
struct XTRI
{
/** BX number for this trigger */
  int bx;
/** Absolute trigger number */
  int itri;
/** Pretrigger type */
  int type;
/** Flag for trigger accepts (= 1 if ACC) */
  int flag;
/** Last stage before trigger was rejected */
  int step;
/** Number of tracks for this trigger */
  int ntra;
/** Index to XTRA bank */
  int tra[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L1 output track candidate */
struct YTRA
{
/** BunchCrossing for this message */
  int bx;
/** Pretrigger name */
  char id[4];
/** Total energy reconstructed */
  float e;
/** Px/Pz reconstructed */
  float pxpz;
/** Py/Pz reconstructed */
  float pypz;
/** charge reconstructed */
  int chrg;
/** X position of the center of the hit in TC2 SL */
  float xtc2;
/** Hit width in TC2 SL (+/- 0.5sx) */
  float sx2;
/** Y position of the center of the hit in TC2 SL */
  float ytc2;
/** Z position of the hit in TC2 SL */
  float ztc2;
/** X position of the center of the hit in PC1 SL */
  float xpc1;
/** Hit width in PC1 SL (+/- 0.5sx) */
  float sx1;
/** Z position of the hit in PC1 SL */
  float zpc1;
/** Hardware message (80 bits) */
  int msg[3];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L1 trigger message */
struct YTRI
{
/** BX for the trigger */
  int bx;
/** trigger pair names */
  char id[8];
/** First message of the pair in table L1TRA */
  int tra1;
/** Second message of the pair in table L1TRA */
  int tra2;
/** Pair invariant mass */
  float mass;
/** Hardware trigger descriptor (48 bit) */
  int msg[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 

#ifdef __CINT__
class ArteRelationPointer<HIDI,DIGB>;
class ArteRelationPointer<MIDI,DIGB>;
class ArteRelationPointer<GSGC,GCAL>;
class ArteRelationPointer<GMGC,GCAL>;
class ArteRelationPointer<GSGD,GEDE>;
class ArteRelationPointer<GMGD,GEDE>;
class ArteRelationPointer<GSGW,GWAL>;
class ArteRelationPointer<GMGW,GWAL>;
class ArteRelationPointer<RTHI,HITB>;
class ArteRelationPointer<MIHI,HITB>;
class ArteRelationPointer<HIRH,RHIT>;
class ArteRelationPointer<RSHI,HITB>;
class ArteRelationPointer<RTHC,HITC>;
class ArteRelationPointer<MCHC,HITC>;
class ArteRelationPointer<HCRC,RCCL>;
class ArteRelationPointer<MTMC,MCAL>;
class ArteRelationPointer<MVME,MCME>;
class ArteRelationPointer<MTMI,MIMP>;
class ArteRelationPointer<MTMP,MTCP>;
class ArteRelationPointer<MTTO,MTRA>;
class ArteRelationPointer<MVMT,MTRA>;
class ArteRelationPointer<MTMT,MTRA>;
class ArteRelationPointer<MTMV,MVER>;
class ArteRelationPointer<RTMT,MTRA>;
class ArteRelationPointer<RSMT,MTRA>;
class ArteRelationPointer<MTRC,RCCL>;
class ArteRelationPointer<NSNC,NCAL>;
class ArteRelationPointer<NMNC,BEAM>;
class ArteRelationPointer<NSND,NEDE>;
class ArteRelationPointer<NMND,BEAM>;
class ArteRelationPointer<NSNW,NWAL>;
class ArteRelationPointer<NMNW,BEAM>;
class ArteRelationPointer<PXAF,PTAD>;
class ArteRelationPointer<PXCA,PTCH>;
class ArteRelationPointer<PXGM,PTAL>;
class ArteRelationPointer<PXGA,PTAL>;
class ArteRelationPointer<PXGC,PTCE>;
class ArteRelationPointer<PXCC,PTCE>;
class ArteRelationPointer<PXCM,PTCR>;
class ArteRelationPointer<PXFC,PTFD>;
class ArteRelationPointer<RTRC,RCCL>;
class ArteRelationPointer<RSRC,RCCL>;
class ArteRelationPointer<RSRH,RHIT>;
class ArteRelationPointer<RTRP,RPNT>;
class ArteRelationPointer<RSRP,RPNT>;
class ArteRelationPointer<RRRT,RREL>;
class ArteRelationPointer<RRRV,RREL>;
class ArteRelationPointer<RTRS,RSEG>;
class ArteRelationPointer<RSRS,RSEG>;
class ArteRelationPointer<RTTO,RTRA>;
class ArteRelationPointer<RVRT,RVER>;
class ArteRelationPointer<SPSH,SHPR>;
class ArteRelationPointer<SRSH,SHRC>;
class ArteRelationPointer<SBSN,SNAB>;
class ArteRelationPointer<SNSN,SNAX>;
class ArteRelationPointer<SPSS,SSEE>;
class ArteRelationPointer<GMND,NEDE>;
class ArteRelationPointer<GMNC,NCAL>;
class ArteRelationPointer<GMNW,NWAL>;
#endif /* defined(__CINT__) */

#ifndef CREATELINKS
extern
#endif
struct ArteLinkStruct
{
#ifndef NO_ARTE
ArteVector<MEMO> larln1,larlnl,narlnk,jlink;
#endif
ArteVector<BEAM> jbeam;
ArteVector<CDIM> jcdim;
ArteVector<CEFF> jceff;
ArteVector<CLEN> jclen;
ArteVector<CPDW> jcpdw;
ArteVector<CPMD> jcpmd;
ArteVector<CPMI> jcpmi;
ArteVector<CPMT> jcpmt;
ArteVector<CPOI> jcpoi;
ArteVector<CSMI> jcsmi;
ArteVector<CSPM> jcspm;
ArteVector<CSSM> jcssm;
ArteVector<CSUP> jcsup;
ArteVector<CVES> jcves;
ArteVector<DCAL> jdcal;
ArteVector<DDAQ> jddaq;
ArteVector<DDEF> jddef;
ArteVector<DFCS> jdfcs;
ArteVector<DFLT> jdflt;
ArteVector<DIGB> jdigb;
ArteVector<DIHD> jdihd;
ArteVector<DITR> jditr;
ArteVector<DMUP> jdmup;
ArteVector<DMUT> jdmut;
ArteVector<DMUX> jdmux;
ArteVector<DOTR> jdotr;
ArteVector<DPTC> jdptc;
ArteVector<DRIC> jdric;
ArteVector<DSLT> jdslt;
ArteVector<DSVD> jdsvd;
ArteVector<DTAR> jdtar;
ArteVector<DTLT> jdtlt;
ArteVector<DTRD> jdtrd;
ArteVector<DTST> jdtst;
ArteVector<ECBO> jecbo;
ArteVector<ECHF> jechf;
ArteVector<ECHS> jechs;
ArteVector<ERRC> jerrc;
ArteVector<EVFN> jevfn;
ArteVector<EVHD> jevhd;
ArteVector<FELD> jfeld;
ArteVector<GCAL> jgcal;
ArteVector<GCCE> jgcce;
ArteVector<GCGD> jgcgd;
ArteVector<GEDE> jgede;
ArteVector<GEHD> jgehd;
ArteVector<GESL> jgesl;
ArteVector<GMAT> jgmat;
ArteVector<GMIX> jgmix;
ArteVector<GNEI> jgnei;
ArteVector<GSSL> jgssl;
ArteVector<GTAR> jgtar;
ArteVector<GWAL> jgwal;
ArteVector<HITB> jhitb;
ArteVector<HITC> jhitc;
ArteVector<MARK> jmark;
ArteVector<MCAL> jmcal;
ArteVector<MCIN> jmcin;
ArteVector<MCME> jmcme;
ArteVector<MEIO> jmeio;
ArteVector<MEMA> jmema;
ArteVector<MEMO> jmemo;
ArteVector<MEMS> jmems;
ArteVector<MF01> jmf01;
ArteVector<MF02> jmf02;
ArteVector<MF03> jmf03;
ArteVector<MF04> jmf04;
ArteVector<MF05> jmf05;
ArteVector<MF06> jmf06;
ArteVector<MF07> jmf07;
ArteVector<MF08> jmf08;
ArteVector<MF09> jmf09;
ArteVector<MF10> jmf10;
ArteVector<MF11> jmf11;
ArteVector<MF12> jmf12;
ArteVector<MF13> jmf13;
ArteVector<MF14> jmf14;
ArteVector<MF15> jmf15;
ArteVector<MF16> jmf16;
ArteVector<MF17> jmf17;
ArteVector<MF18> jmf18;
ArteVector<MF19> jmf19;
ArteVector<MF20> jmf20;
ArteVector<MF21> jmf21;
ArteVector<MFHD> jmfhd;
ArteVector<MFLD> jmfld;
ArteVector<MIMP> jmimp;
ArteVector<MTCP> jmtcp;
ArteVector<MTRA> jmtra;
ArteVector<MVER> jmver;
ArteVector<NBEA> jnbea;
ArteVector<NCAL> jncal;
ArteVector<NEDE> jnede;
ArteVector<NESL> jnesl;
ArteVector<NFLD> jnfld;
ArteVector<NGHD> jnghd;
ArteVector<NMAT> jnmat;
ArteVector<NMIX> jnmix;
ArteVector<NTAR> jntar;
ArteVector<NWAL> jnwal;
ArteVector<PTAD> jptad;
ArteVector<PTAL> jptal;
ArteVector<PTCE> jptce;
ArteVector<PTCH> jptch;
ArteVector<PTCR> jptcr;
ArteVector<PTFD> jptfd;
ArteVector<PTGE> jptge;
ArteVector<PTMD> jptmd;
ArteVector<RCCL> jrccl;
ArteVector<RHIT> jrhit;
ArteVector<RPNT> jrpnt;
ArteVector<RREL> jrrel;
ArteVector<RSEG> jrseg;
ArteVector<RTRA> jrtra;
ArteVector<RVER> jrver;
ArteVector<SHCA> jshca;
ArteVector<SHPR> jshpr;
ArteVector<SHRC> jshrc;
ArteVector<SNAB> jsnab;
ArteVector<SNAV> jsnav;
ArteVector<SNAX> jsnax;
ArteVector<SPAR> jspar;
ArteVector<SPAS> jspas;
ArteVector<SSEE> jssee;
ArteVector<SSTA> jssta;
ArteVector<STCA> jstca;
ArteVector<STPR> jstpr;
ArteVector<STRC> jstrc;
ArteVector<SUSI> jsusi;
ArteVector<TDEC> jtdec;
ArteVector<TEMP> jtemp;
ArteVector<TMP0> jtmp0;
ArteVector<TMP1> jtmp1;
ArteVector<TMP2> jtmp2;
ArteVector<TMP3> jtmp3;
ArteVector<TMP4> jtmp4;
ArteVector<TMP5> jtmp5;
ArteVector<TMP6> jtmp6;
ArteVector<TMP7> jtmp7;
ArteVector<TMP8> jtmp8;
ArteVector<TMP9> jtmp9;
ArteVector<TOPP> jtopp;
ArteVector<XTRA> jxtra;
ArteVector<XTRI> jxtri;
ArteVector<YTRA> jytra;
ArteVector<YTRI> jytri;
ArteRelVector<HIDI> jhidi;
ArteRelVector<MIDI> jmidi;
ArteRelVector<GSGC> jgsgc;
ArteRelVector<GMGC> jgmgc;
ArteRelVector<GSGD> jgsgd;
ArteRelVector<GMGD> jgmgd;
ArteRelVector<GSGW> jgsgw;
ArteRelVector<GMGW> jgmgw;
ArteRelVector<RTHI> jrthi;
ArteRelVector<MIHI> jmihi;
ArteRelVector<HIRH> jhirh;
ArteRelVector<RSHI> jrshi;
ArteRelVector<RTHC> jrthc;
ArteRelVector<MCHC> jmchc;
ArteRelVector<HCRC> jhcrc;
ArteRelVector<MTMC> jmtmc;
ArteRelVector<MVME> jmvme;
ArteRelVector<MTMI> jmtmi;
ArteRelVector<MTMP> jmtmp;
ArteRelVector<MTTO> jmtto;
ArteRelVector<MVMT> jmvmt;
ArteRelVector<MTMT> jmtmt;
ArteRelVector<MTMV> jmtmv;
ArteRelVector<RTMT> jrtmt;
ArteRelVector<RSMT> jrsmt;
ArteRelVector<MTRC> jmtrc;
ArteRelVector<NSNC> jnsnc;
ArteRelVector<NMNC> jnmnc;
ArteRelVector<NSND> jnsnd;
ArteRelVector<NMND> jnmnd;
ArteRelVector<NSNW> jnsnw;
ArteRelVector<NMNW> jnmnw;
ArteRelVector<PXAF> jpxaf;
ArteRelVector<PXCA> jpxca;
ArteRelVector<PXGM> jpxgm;
ArteRelVector<PXGA> jpxga;
ArteRelVector<PXGC> jpxgc;
ArteRelVector<PXCC> jpxcc;
ArteRelVector<PXCM> jpxcm;
ArteRelVector<PXFC> jpxfc;
ArteRelVector<RTRC> jrtrc;
ArteRelVector<RSRC> jrsrc;
ArteRelVector<RSRH> jrsrh;
ArteRelVector<RTRP> jrtrp;
ArteRelVector<RSRP> jrsrp;
ArteRelVector<RRRT> jrrrt;
ArteRelVector<RRRV> jrrrv;
ArteRelVector<RTRS> jrtrs;
ArteRelVector<RSRS> jrsrs;
ArteRelVector<RTTO> jrtto;
ArteRelVector<RVRT> jrvrt;
ArteRelVector<SPSH> jspsh;
ArteRelVector<SRSH> jsrsh;
ArteRelVector<SBSN> jsbsn;
ArteRelVector<SNSN> jsnsn;
ArteRelVector<SPSS> jspss;
ArteVector<DEVT> jdevt;
ArteRelVector<GMND> jgmnd;
ArteRelVector<GMNC> jgmnc;
ArteRelVector<GMNW> jgmnw;
ArteVector<MEMO> jlast;
} artelink_;
template <> inline ArteVector<BEAM>& ArteTable<BEAM>::getLink()
{ return artelink_.jbeam; }

template <> inline ArteVector<CDIM>& ArteTable<CDIM>::getLink()
{ return artelink_.jcdim; }

template <> inline ArteVector<CEFF>& ArteTable<CEFF>::getLink()
{ return artelink_.jceff; }

template <> inline ArteVector<CLEN>& ArteTable<CLEN>::getLink()
{ return artelink_.jclen; }

template <> inline ArteVector<CPDW>& ArteTable<CPDW>::getLink()
{ return artelink_.jcpdw; }

template <> inline ArteVector<CPMD>& ArteTable<CPMD>::getLink()
{ return artelink_.jcpmd; }

template <> inline ArteVector<CPMI>& ArteTable<CPMI>::getLink()
{ return artelink_.jcpmi; }

template <> inline ArteVector<CPMT>& ArteTable<CPMT>::getLink()
{ return artelink_.jcpmt; }

template <> inline ArteVector<CPOI>& ArteTable<CPOI>::getLink()
{ return artelink_.jcpoi; }

template <> inline ArteVector<CSMI>& ArteTable<CSMI>::getLink()
{ return artelink_.jcsmi; }

template <> inline ArteVector<CSPM>& ArteTable<CSPM>::getLink()
{ return artelink_.jcspm; }

template <> inline ArteVector<CSSM>& ArteTable<CSSM>::getLink()
{ return artelink_.jcssm; }

template <> inline ArteVector<CSUP>& ArteTable<CSUP>::getLink()
{ return artelink_.jcsup; }

template <> inline ArteVector<CVES>& ArteTable<CVES>::getLink()
{ return artelink_.jcves; }

template <> inline ArteVector<DCAL>& ArteTable<DCAL>::getLink()
{ return artelink_.jdcal; }

template <> inline ArteVector<DDAQ>& ArteTable<DDAQ>::getLink()
{ return artelink_.jddaq; }

template <> inline ArteVector<DDEF>& ArteTable<DDEF>::getLink()
{ return artelink_.jddef; }

template <> inline ArteVector<DFCS>& ArteTable<DFCS>::getLink()
{ return artelink_.jdfcs; }

template <> inline ArteVector<DFLT>& ArteTable<DFLT>::getLink()
{ return artelink_.jdflt; }

template <> inline ArteVector<DIGB>& ArteTable<DIGB>::getLink()
{ return artelink_.jdigb; }

template <> inline ArteVector<DIHD>& ArteTable<DIHD>::getLink()
{ return artelink_.jdihd; }

template <> inline ArteVector<DITR>& ArteTable<DITR>::getLink()
{ return artelink_.jditr; }

template <> inline ArteVector<DMUP>& ArteTable<DMUP>::getLink()
{ return artelink_.jdmup; }

template <> inline ArteVector<DMUT>& ArteTable<DMUT>::getLink()
{ return artelink_.jdmut; }

template <> inline ArteVector<DMUX>& ArteTable<DMUX>::getLink()
{ return artelink_.jdmux; }

template <> inline ArteVector<DOTR>& ArteTable<DOTR>::getLink()
{ return artelink_.jdotr; }

template <> inline ArteVector<DPTC>& ArteTable<DPTC>::getLink()
{ return artelink_.jdptc; }

template <> inline ArteVector<DRIC>& ArteTable<DRIC>::getLink()
{ return artelink_.jdric; }

template <> inline ArteVector<DSLT>& ArteTable<DSLT>::getLink()
{ return artelink_.jdslt; }

template <> inline ArteVector<DSVD>& ArteTable<DSVD>::getLink()
{ return artelink_.jdsvd; }

template <> inline ArteVector<DTAR>& ArteTable<DTAR>::getLink()
{ return artelink_.jdtar; }

template <> inline ArteVector<DTLT>& ArteTable<DTLT>::getLink()
{ return artelink_.jdtlt; }

template <> inline ArteVector<DTRD>& ArteTable<DTRD>::getLink()
{ return artelink_.jdtrd; }

template <> inline ArteVector<DTST>& ArteTable<DTST>::getLink()
{ return artelink_.jdtst; }

template <> inline ArteVector<ECBO>& ArteTable<ECBO>::getLink()
{ return artelink_.jecbo; }

template <> inline ArteVector<ECHF>& ArteTable<ECHF>::getLink()
{ return artelink_.jechf; }

template <> inline ArteVector<ECHS>& ArteTable<ECHS>::getLink()
{ return artelink_.jechs; }

template <> inline ArteVector<ERRC>& ArteTable<ERRC>::getLink()
{ return artelink_.jerrc; }

template <> inline ArteVector<EVFN>& ArteTable<EVFN>::getLink()
{ return artelink_.jevfn; }

template <> inline ArteVector<EVHD>& ArteTable<EVHD>::getLink()
{ return artelink_.jevhd; }

template <> inline ArteVector<FELD>& ArteTable<FELD>::getLink()
{ return artelink_.jfeld; }

template <> inline ArteVector<GCAL>& ArteTable<GCAL>::getLink()
{ return artelink_.jgcal; }

template <> inline ArteVector<GCCE>& ArteTable<GCCE>::getLink()
{ return artelink_.jgcce; }

template <> inline ArteVector<GCGD>& ArteTable<GCGD>::getLink()
{ return artelink_.jgcgd; }

template <> inline ArteVector<GEDE>& ArteTable<GEDE>::getLink()
{ return artelink_.jgede; }

template <> inline ArteVector<GEHD>& ArteTable<GEHD>::getLink()
{ return artelink_.jgehd; }

template <> inline ArteVector<GESL>& ArteTable<GESL>::getLink()
{ return artelink_.jgesl; }

template <> inline ArteVector<GMAT>& ArteTable<GMAT>::getLink()
{ return artelink_.jgmat; }

template <> inline ArteVector<GMIX>& ArteTable<GMIX>::getLink()
{ return artelink_.jgmix; }

template <> inline ArteVector<GNEI>& ArteTable<GNEI>::getLink()
{ return artelink_.jgnei; }

template <> inline ArteVector<GSSL>& ArteTable<GSSL>::getLink()
{ return artelink_.jgssl; }

template <> inline ArteVector<GTAR>& ArteTable<GTAR>::getLink()
{ return artelink_.jgtar; }

template <> inline ArteVector<GWAL>& ArteTable<GWAL>::getLink()
{ return artelink_.jgwal; }

template <> inline ArteVector<HITB>& ArteTable<HITB>::getLink()
{ return artelink_.jhitb; }

template <> inline ArteVector<HITC>& ArteTable<HITC>::getLink()
{ return artelink_.jhitc; }

template <> inline ArteVector<MARK>& ArteTable<MARK>::getLink()
{ return artelink_.jmark; }

template <> inline ArteVector<MCAL>& ArteTable<MCAL>::getLink()
{ return artelink_.jmcal; }

template <> inline ArteVector<MCIN>& ArteTable<MCIN>::getLink()
{ return artelink_.jmcin; }

template <> inline ArteVector<MCME>& ArteTable<MCME>::getLink()
{ return artelink_.jmcme; }

template <> inline ArteVector<MEIO>& ArteTable<MEIO>::getLink()
{ return artelink_.jmeio; }

template <> inline ArteVector<MEMA>& ArteTable<MEMA>::getLink()
{ return artelink_.jmema; }

template <> inline ArteVector<MEMO>& ArteTable<MEMO>::getLink()
{ return artelink_.jmemo; }

template <> inline ArteVector<MEMS>& ArteTable<MEMS>::getLink()
{ return artelink_.jmems; }

template <> inline ArteVector<MF01>& ArteTable<MF01>::getLink()
{ return artelink_.jmf01; }

template <> inline ArteVector<MF02>& ArteTable<MF02>::getLink()
{ return artelink_.jmf02; }

template <> inline ArteVector<MF03>& ArteTable<MF03>::getLink()
{ return artelink_.jmf03; }

template <> inline ArteVector<MF04>& ArteTable<MF04>::getLink()
{ return artelink_.jmf04; }

template <> inline ArteVector<MF05>& ArteTable<MF05>::getLink()
{ return artelink_.jmf05; }

template <> inline ArteVector<MF06>& ArteTable<MF06>::getLink()
{ return artelink_.jmf06; }

template <> inline ArteVector<MF07>& ArteTable<MF07>::getLink()
{ return artelink_.jmf07; }

template <> inline ArteVector<MF08>& ArteTable<MF08>::getLink()
{ return artelink_.jmf08; }

template <> inline ArteVector<MF09>& ArteTable<MF09>::getLink()
{ return artelink_.jmf09; }

template <> inline ArteVector<MF10>& ArteTable<MF10>::getLink()
{ return artelink_.jmf10; }

template <> inline ArteVector<MF11>& ArteTable<MF11>::getLink()
{ return artelink_.jmf11; }

template <> inline ArteVector<MF12>& ArteTable<MF12>::getLink()
{ return artelink_.jmf12; }

template <> inline ArteVector<MF13>& ArteTable<MF13>::getLink()
{ return artelink_.jmf13; }

template <> inline ArteVector<MF14>& ArteTable<MF14>::getLink()
{ return artelink_.jmf14; }

template <> inline ArteVector<MF15>& ArteTable<MF15>::getLink()
{ return artelink_.jmf15; }

template <> inline ArteVector<MF16>& ArteTable<MF16>::getLink()
{ return artelink_.jmf16; }

template <> inline ArteVector<MF17>& ArteTable<MF17>::getLink()
{ return artelink_.jmf17; }

template <> inline ArteVector<MF18>& ArteTable<MF18>::getLink()
{ return artelink_.jmf18; }

template <> inline ArteVector<MF19>& ArteTable<MF19>::getLink()
{ return artelink_.jmf19; }

template <> inline ArteVector<MF20>& ArteTable<MF20>::getLink()
{ return artelink_.jmf20; }

template <> inline ArteVector<MF21>& ArteTable<MF21>::getLink()
{ return artelink_.jmf21; }

template <> inline ArteVector<MFHD>& ArteTable<MFHD>::getLink()
{ return artelink_.jmfhd; }

template <> inline ArteVector<MFLD>& ArteTable<MFLD>::getLink()
{ return artelink_.jmfld; }

template <> inline ArteVector<MIMP>& ArteTable<MIMP>::getLink()
{ return artelink_.jmimp; }

template <> inline ArteVector<MTCP>& ArteTable<MTCP>::getLink()
{ return artelink_.jmtcp; }

template <> inline ArteVector<MTRA>& ArteTable<MTRA>::getLink()
{ return artelink_.jmtra; }

template <> inline ArteVector<MVER>& ArteTable<MVER>::getLink()
{ return artelink_.jmver; }

template <> inline ArteVector<NBEA>& ArteTable<NBEA>::getLink()
{ return artelink_.jnbea; }

template <> inline ArteVector<NCAL>& ArteTable<NCAL>::getLink()
{ return artelink_.jncal; }

template <> inline ArteVector<NEDE>& ArteTable<NEDE>::getLink()
{ return artelink_.jnede; }

template <> inline ArteVector<NESL>& ArteTable<NESL>::getLink()
{ return artelink_.jnesl; }

template <> inline ArteVector<NFLD>& ArteTable<NFLD>::getLink()
{ return artelink_.jnfld; }

template <> inline ArteVector<NGHD>& ArteTable<NGHD>::getLink()
{ return artelink_.jnghd; }

template <> inline ArteVector<NMAT>& ArteTable<NMAT>::getLink()
{ return artelink_.jnmat; }

template <> inline ArteVector<NMIX>& ArteTable<NMIX>::getLink()
{ return artelink_.jnmix; }

template <> inline ArteVector<NTAR>& ArteTable<NTAR>::getLink()
{ return artelink_.jntar; }

template <> inline ArteVector<NWAL>& ArteTable<NWAL>::getLink()
{ return artelink_.jnwal; }

template <> inline ArteVector<PTAD>& ArteTable<PTAD>::getLink()
{ return artelink_.jptad; }

template <> inline ArteVector<PTAL>& ArteTable<PTAL>::getLink()
{ return artelink_.jptal; }

template <> inline ArteVector<PTCE>& ArteTable<PTCE>::getLink()
{ return artelink_.jptce; }

template <> inline ArteVector<PTCH>& ArteTable<PTCH>::getLink()
{ return artelink_.jptch; }

template <> inline ArteVector<PTCR>& ArteTable<PTCR>::getLink()
{ return artelink_.jptcr; }

template <> inline ArteVector<PTFD>& ArteTable<PTFD>::getLink()
{ return artelink_.jptfd; }

template <> inline ArteVector<PTGE>& ArteTable<PTGE>::getLink()
{ return artelink_.jptge; }

template <> inline ArteVector<PTMD>& ArteTable<PTMD>::getLink()
{ return artelink_.jptmd; }

template <> inline ArteVector<RCCL>& ArteTable<RCCL>::getLink()
{ return artelink_.jrccl; }

template <> inline ArteVector<RHIT>& ArteTable<RHIT>::getLink()
{ return artelink_.jrhit; }

template <> inline ArteVector<RPNT>& ArteTable<RPNT>::getLink()
{ return artelink_.jrpnt; }

template <> inline ArteVector<RREL>& ArteTable<RREL>::getLink()
{ return artelink_.jrrel; }

template <> inline ArteVector<RSEG>& ArteTable<RSEG>::getLink()
{ return artelink_.jrseg; }

template <> inline ArteVector<RTRA>& ArteTable<RTRA>::getLink()
{ return artelink_.jrtra; }

template <> inline ArteVector<RVER>& ArteTable<RVER>::getLink()
{ return artelink_.jrver; }

template <> inline ArteVector<SHCA>& ArteTable<SHCA>::getLink()
{ return artelink_.jshca; }

template <> inline ArteVector<SHPR>& ArteTable<SHPR>::getLink()
{ return artelink_.jshpr; }

template <> inline ArteVector<SHRC>& ArteTable<SHRC>::getLink()
{ return artelink_.jshrc; }

template <> inline ArteVector<SNAB>& ArteTable<SNAB>::getLink()
{ return artelink_.jsnab; }

template <> inline ArteVector<SNAV>& ArteTable<SNAV>::getLink()
{ return artelink_.jsnav; }

template <> inline ArteVector<SNAX>& ArteTable<SNAX>::getLink()
{ return artelink_.jsnax; }

template <> inline ArteVector<SPAR>& ArteTable<SPAR>::getLink()
{ return artelink_.jspar; }

template <> inline ArteVector<SPAS>& ArteTable<SPAS>::getLink()
{ return artelink_.jspas; }

template <> inline ArteVector<SSEE>& ArteTable<SSEE>::getLink()
{ return artelink_.jssee; }

template <> inline ArteVector<SSTA>& ArteTable<SSTA>::getLink()
{ return artelink_.jssta; }

template <> inline ArteVector<STCA>& ArteTable<STCA>::getLink()
{ return artelink_.jstca; }

template <> inline ArteVector<STPR>& ArteTable<STPR>::getLink()
{ return artelink_.jstpr; }

template <> inline ArteVector<STRC>& ArteTable<STRC>::getLink()
{ return artelink_.jstrc; }

template <> inline ArteVector<SUSI>& ArteTable<SUSI>::getLink()
{ return artelink_.jsusi; }

template <> inline ArteVector<TDEC>& ArteTable<TDEC>::getLink()
{ return artelink_.jtdec; }

template <> inline ArteVector<TEMP>& ArteTable<TEMP>::getLink()
{ return artelink_.jtemp; }

template <> inline ArteVector<TMP0>& ArteTable<TMP0>::getLink()
{ return artelink_.jtmp0; }

template <> inline ArteVector<TMP1>& ArteTable<TMP1>::getLink()
{ return artelink_.jtmp1; }

template <> inline ArteVector<TMP2>& ArteTable<TMP2>::getLink()
{ return artelink_.jtmp2; }

template <> inline ArteVector<TMP3>& ArteTable<TMP3>::getLink()
{ return artelink_.jtmp3; }

template <> inline ArteVector<TMP4>& ArteTable<TMP4>::getLink()
{ return artelink_.jtmp4; }

template <> inline ArteVector<TMP5>& ArteTable<TMP5>::getLink()
{ return artelink_.jtmp5; }

template <> inline ArteVector<TMP6>& ArteTable<TMP6>::getLink()
{ return artelink_.jtmp6; }

template <> inline ArteVector<TMP7>& ArteTable<TMP7>::getLink()
{ return artelink_.jtmp7; }

template <> inline ArteVector<TMP8>& ArteTable<TMP8>::getLink()
{ return artelink_.jtmp8; }

template <> inline ArteVector<TMP9>& ArteTable<TMP9>::getLink()
{ return artelink_.jtmp9; }

template <> inline ArteVector<TOPP>& ArteTable<TOPP>::getLink()
{ return artelink_.jtopp; }

template <> inline ArteVector<XTRA>& ArteTable<XTRA>::getLink()
{ return artelink_.jxtra; }

template <> inline ArteVector<XTRI>& ArteTable<XTRI>::getLink()
{ return artelink_.jxtri; }

template <> inline ArteVector<YTRA>& ArteTable<YTRA>::getLink()
{ return artelink_.jytra; }

template <> inline ArteVector<YTRI>& ArteTable<YTRI>::getLink()
{ return artelink_.jytri; }

template <> inline ArteRelVector<HIDI>& ArteInvOneRelationPointer<HIDI,DIGB>::getLink()
{ return artelink_.jhidi; }

template <> inline ArteRelVector<MIDI>& ArteManRelationPointer<MIDI,MIMP>::getLink()
{ return artelink_.jmidi; }

template <> inline ArteRelVector<MIDI>& ArteInvManRelationPointer<MIDI,DIGB>::getLink()
{ return artelink_.jmidi; }

template <> inline ArteRelVector<GSGC>& ArteInvOneRelationPointer<GSGC,GCAL>::getLink()
{ return artelink_.jgsgc; }

template <> inline ArteRelVector<GMGC>& ArteInvOneRelationPointer<GMGC,GCAL>::getLink()
{ return artelink_.jgmgc; }

template <> inline ArteRelVector<GSGD>& ArteInvOneRelationPointer<GSGD,GEDE>::getLink()
{ return artelink_.jgsgd; }

template <> inline ArteRelVector<GMGD>& ArteInvOneRelationPointer<GMGD,GEDE>::getLink()
{ return artelink_.jgmgd; }

template <> inline ArteRelVector<GSGW>& ArteInvOneRelationPointer<GSGW,GWAL>::getLink()
{ return artelink_.jgsgw; }

template <> inline ArteRelVector<GMGW>& ArteInvOneRelationPointer<GMGW,GWAL>::getLink()
{ return artelink_.jgmgw; }

template <> inline ArteRelVector<RTHI>& ArteManRelationPointer<RTHI,RTRA>::getLink()
{ return artelink_.jrthi; }

template <> inline ArteRelVector<RTHI>& ArteInvManRelationPointer<RTHI,HITB>::getLink()
{ return artelink_.jrthi; }

template <> inline ArteRelVector<MIHI>& ArteManRelationPointer<MIHI,MIMP>::getLink()
{ return artelink_.jmihi; }

template <> inline ArteRelVector<MIHI>& ArteInvManRelationPointer<MIHI,HITB>::getLink()
{ return artelink_.jmihi; }

template <> inline ArteRelVector<HIRH>& ArteInvOneRelationPointer<HIRH,RHIT>::getLink()
{ return artelink_.jhirh; }

template <> inline ArteRelVector<RSHI>& ArteManRelationPointer<RSHI,RSEG>::getLink()
{ return artelink_.jrshi; }

template <> inline ArteRelVector<RSHI>& ArteInvManRelationPointer<RSHI,HITB>::getLink()
{ return artelink_.jrshi; }

template <> inline ArteRelVector<RTHC>& ArteManRelationPointer<RTHC,RTRA>::getLink()
{ return artelink_.jrthc; }

template <> inline ArteRelVector<RTHC>& ArteInvManRelationPointer<RTHC,HITC>::getLink()
{ return artelink_.jrthc; }

template <> inline ArteRelVector<MCHC>& ArteManRelationPointer<MCHC,MCAL>::getLink()
{ return artelink_.jmchc; }

template <> inline ArteRelVector<MCHC>& ArteInvManRelationPointer<MCHC,HITC>::getLink()
{ return artelink_.jmchc; }

template <> inline ArteRelVector<HCRC>& ArteManRelationPointer<HCRC,HITC>::getLink()
{ return artelink_.jhcrc; }

template <> inline ArteRelVector<HCRC>& ArteInvManRelationPointer<HCRC,RCCL>::getLink()
{ return artelink_.jhcrc; }

template <> inline ArteRelVector<MTMC>& ArteInvOneRelationPointer<MTMC,MCAL>::getLink()
{ return artelink_.jmtmc; }

template <> inline ArteRelVector<MVME>& ArteInvOneRelationPointer<MVME,MCME>::getLink()
{ return artelink_.jmvme; }

template <> inline ArteRelVector<MTMI>& ArteInvOneRelationPointer<MTMI,MIMP>::getLink()
{ return artelink_.jmtmi; }

template <> inline ArteRelVector<MTMP>& ArteInvOneRelationPointer<MTMP,MTCP>::getLink()
{ return artelink_.jmtmp; }

template <> inline ArteRelVector<MTTO>& ArteInvOneRelationPointer<MTTO,MTRA>::getLink()
{ return artelink_.jmtto; }

template <> inline ArteRelVector<MVMT>& ArteInvOneRelationPointer<MVMT,MTRA>::getLink()
{ return artelink_.jmvmt; }

template <> inline ArteRelVector<MTMT>& ArteInvOneRelationPointer<MTMT,MTRA>::getLink()
{ return artelink_.jmtmt; }

template <> inline ArteRelVector<MTMV>& ArteInvOneRelationPointer<MTMV,MVER>::getLink()
{ return artelink_.jmtmv; }

template <> inline ArteRelVector<RTMT>& ArteManRelationPointer<RTMT,RTRA>::getLink()
{ return artelink_.jrtmt; }

template <> inline ArteRelVector<RTMT>& ArteInvManRelationPointer<RTMT,MTRA>::getLink()
{ return artelink_.jrtmt; }

template <> inline ArteRelVector<RSMT>& ArteManRelationPointer<RSMT,RSEG>::getLink()
{ return artelink_.jrsmt; }

template <> inline ArteRelVector<RSMT>& ArteInvManRelationPointer<RSMT,MTRA>::getLink()
{ return artelink_.jrsmt; }

template <> inline ArteRelVector<MTRC>& ArteManRelationPointer<MTRC,MTRA>::getLink()
{ return artelink_.jmtrc; }

template <> inline ArteRelVector<MTRC>& ArteInvManRelationPointer<MTRC,RCCL>::getLink()
{ return artelink_.jmtrc; }

template <> inline ArteRelVector<NSNC>& ArteInvOneRelationPointer<NSNC,NCAL>::getLink()
{ return artelink_.jnsnc; }

template <> inline ArteRelVector<NMNC>& ArteManRelationPointer<NMNC,BEAM>::getLink()
{ return artelink_.jnmnc; }

template <> inline ArteRelVector<NMNC>& ArteInvManRelationPointer<NMNC,BEAM>::getLink()
{ return artelink_.jnmnc; }

template <> inline ArteRelVector<NSND>& ArteInvOneRelationPointer<NSND,NEDE>::getLink()
{ return artelink_.jnsnd; }

template <> inline ArteRelVector<NMND>& ArteManRelationPointer<NMND,BEAM>::getLink()
{ return artelink_.jnmnd; }

template <> inline ArteRelVector<NMND>& ArteInvManRelationPointer<NMND,BEAM>::getLink()
{ return artelink_.jnmnd; }

template <> inline ArteRelVector<NSNW>& ArteInvOneRelationPointer<NSNW,NWAL>::getLink()
{ return artelink_.jnsnw; }

template <> inline ArteRelVector<NMNW>& ArteManRelationPointer<NMNW,BEAM>::getLink()
{ return artelink_.jnmnw; }

template <> inline ArteRelVector<NMNW>& ArteInvManRelationPointer<NMNW,BEAM>::getLink()
{ return artelink_.jnmnw; }

template <> inline ArteRelVector<PXAF>& ArteInvOneRelationPointer<PXAF,PTAD>::getLink()
{ return artelink_.jpxaf; }

template <> inline ArteRelVector<PXCA>& ArteInvOneRelationPointer<PXCA,PTCH>::getLink()
{ return artelink_.jpxca; }

template <> inline ArteRelVector<PXGM>& ArteInvOneRelationPointer<PXGM,PTAL>::getLink()
{ return artelink_.jpxgm; }

template <> inline ArteRelVector<PXGA>& ArteInvOneRelationPointer<PXGA,PTAL>::getLink()
{ return artelink_.jpxga; }

template <> inline ArteRelVector<PXGC>& ArteInvOneRelationPointer<PXGC,PTCE>::getLink()
{ return artelink_.jpxgc; }

template <> inline ArteRelVector<PXCC>& ArteInvOneRelationPointer<PXCC,PTCE>::getLink()
{ return artelink_.jpxcc; }

template <> inline ArteRelVector<PXCM>& ArteInvOneRelationPointer<PXCM,PTCR>::getLink()
{ return artelink_.jpxcm; }

template <> inline ArteRelVector<PXFC>& ArteInvOneRelationPointer<PXFC,PTFD>::getLink()
{ return artelink_.jpxfc; }

template <> inline ArteRelVector<RTRC>& ArteManRelationPointer<RTRC,RTRA>::getLink()
{ return artelink_.jrtrc; }

template <> inline ArteRelVector<RTRC>& ArteInvManRelationPointer<RTRC,RCCL>::getLink()
{ return artelink_.jrtrc; }

template <> inline ArteRelVector<RSRC>& ArteManRelationPointer<RSRC,RSEG>::getLink()
{ return artelink_.jrsrc; }

template <> inline ArteRelVector<RSRC>& ArteInvManRelationPointer<RSRC,RCCL>::getLink()
{ return artelink_.jrsrc; }

template <> inline ArteRelVector<RSRH>& ArteInvOneRelationPointer<RSRH,RHIT>::getLink()
{ return artelink_.jrsrh; }

template <> inline ArteRelVector<RTRP>& ArteManRelationPointer<RTRP,RTRA>::getLink()
{ return artelink_.jrtrp; }

template <> inline ArteRelVector<RTRP>& ArteInvManRelationPointer<RTRP,RPNT>::getLink()
{ return artelink_.jrtrp; }

template <> inline ArteRelVector<RSRP>& ArteInvOneRelationPointer<RSRP,RPNT>::getLink()
{ return artelink_.jrsrp; }

template <> inline ArteRelVector<RRRT>& ArteInvOneRelationPointer<RRRT,RREL>::getLink()
{ return artelink_.jrrrt; }

template <> inline ArteRelVector<RRRV>& ArteInvOneRelationPointer<RRRV,RREL>::getLink()
{ return artelink_.jrrrv; }

template <> inline ArteRelVector<RTRS>& ArteManRelationPointer<RTRS,RTRA>::getLink()
{ return artelink_.jrtrs; }

template <> inline ArteRelVector<RTRS>& ArteInvManRelationPointer<RTRS,RSEG>::getLink()
{ return artelink_.jrtrs; }

template <> inline ArteRelVector<RSRS>& ArteManRelationPointer<RSRS,RSEG>::getLink()
{ return artelink_.jrsrs; }

template <> inline ArteRelVector<RSRS>& ArteInvManRelationPointer<RSRS,RSEG>::getLink()
{ return artelink_.jrsrs; }

template <> inline ArteRelVector<RTTO>& ArteInvOneRelationPointer<RTTO,RTRA>::getLink()
{ return artelink_.jrtto; }

template <> inline ArteRelVector<RVRT>& ArteInvOneRelationPointer<RVRT,RVER>::getLink()
{ return artelink_.jrvrt; }

template <> inline ArteRelVector<SPSH>& ArteInvOneRelationPointer<SPSH,SHPR>::getLink()
{ return artelink_.jspsh; }

template <> inline ArteRelVector<SRSH>& ArteInvOneRelationPointer<SRSH,SHRC>::getLink()
{ return artelink_.jsrsh; }

template <> inline ArteRelVector<SBSN>& ArteInvOneRelationPointer<SBSN,SNAB>::getLink()
{ return artelink_.jsbsn; }

template <> inline ArteRelVector<SNSN>& ArteInvOneRelationPointer<SNSN,SNAX>::getLink()
{ return artelink_.jsnsn; }

template <> inline ArteRelVector<SPSS>& ArteInvOneRelationPointer<SPSS,SSEE>::getLink()
{ return artelink_.jspss; }

template <> inline ArteVector<DEVT>& ArteTable<DEVT>::getLink()
{ return artelink_.jdevt; }

template <> inline ArteRelVector<GMND>& ArteInvOneRelationPointer<GMND,NEDE>::getLink()
{ return artelink_.jgmnd; }

template <> inline ArteRelVector<GMNC>& ArteInvOneRelationPointer<GMNC,NCAL>::getLink()
{ return artelink_.jgmnc; }

template <> inline ArteRelVector<GMNW>& ArteInvOneRelationPointer<GMNW,NWAL>::getLink()
{ return artelink_.jgmnw; }

#endif  /* defined(_AUTO_HH_) */
