
// *****************************************************************************
//
// source:    faCycle.C
//
// type:      source code
//
// created:   12 Feb 99
// updated:   11 Mar 99  Andreas Gellrich
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    faCycle()
//
// input:     void
// return:    void
//
// called by: faRead()
//
// purporse:  handling cycling by means of a stop file
//
// changes:   includes (AG: 23 Feb 99)
//            polishing (AG: 1 Mar 99)
//            polishing (AG: 11 Mar 99)
//
// *****************************************************************************

// includes
#include "farm/fa.hh"

// externals
extern int FADEB; // debug flag
extern int CYCLE; // cycling flag
extern int WAIT;  // delay

//
// program code
//
void
faCycle()
{
  // sleep
  sleep( WAIT );

  // cycling ?
  if ( !CYCLE ){
    return;
  }

  // cycle
  FILE *in = 0;
  if( ( in = fopen( "cycle.stop", "r" ) ) ){
#ifdef _DEB_
    if( FADEB ){
      cout << "faCycle(): Found file cycle.stop" << endl;
    }
#endif
    arteflag_.neventl = 0;
    if( in ){
      fclose( in );
    }
  }
}
