
#ifndef _FARM_HH_
#define _FARM_HH_

// *****************************************************************************
//
// source:    farm.hh
//
// type:      header file
//
// created:   23 Feb 99
// updated:   26 Mar  99 Andreas Gellrich
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:   Fortran/C callable functions (AG: 8 Mar 99)
//            polishing (AG: 11 Mar 99)
//            change return values of utility functions (AG: 26 Mar 99)
//
// *****************************************************************************

// includes
#include "etb.h"

// C prototypes
extern "C" int ARTE_get_recid_DSVD( int *recid );
extern "C" int ARTE_get_recid_DITR( int *recid );
extern "C" int ARTE_get_recid_DPTC( int *recid );
extern "C" int ARTE_get_recid_DOTR( int *recid );
extern "C" int ARTE_get_recid_DRIC( int *recid );
extern "C" int ARTE_get_recid_DTRD( int *recid );
extern "C" int ARTE_get_recid_DCAL( int *recid );
extern "C" int ARTE_get_recid_DMUT( int *recid );
extern "C" int ARTE_get_recid_DMUX( int *recid );
extern "C" int ARTE_get_recid_DMUP( int *recid );

extern "C" int ARTE_get_recid_DTAR( int *recid );

extern "C" int ARTE_get_feds_DSVD( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DITR( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DPTC( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DOTR( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DRIC( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DTRD( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DCAL( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DMUT( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DMUX( int max, ETB_fed *feds, int *n );
extern "C" int ARTE_get_feds_DMUP( int max, ETB_fed *feds, int *n );

// C++ prototypes
int faPrintNrow();

int faPrintEVHD();
int faPrintDIHD();
int faPrintDDAQ();
int faPrintDTAR();

int faEVHDrun();
int faEVHDevent();
int faEVHDdate();
int faEVHDtime();

int   faDDAQrun_number();   // Run number
int   faDDAQevent_time();   // Time event was built
int   faDDAQevent_status(); // event status/error code
int   faDDAQflt_status();   // FLT trigger number
int   faDDAQslp_node();     // SLP processing node
int   faDDAQslt_status();   // SLT trigger number/status
int   faDDAQexp_number();   // Experiment Number
int   faDDAQfarm_node();    // Farm node
int   faDDAQBX_long();      // bits 0 to 31 of the BX tag (at time trigger issued)
short faDDAQBX_upper();     // bits 32 to 47 of the BX tag (at time trigger issued)
short faDDAQFCS_tcode();    // FCS trigger code for event
short faDDAQphysBX();       // physical BX == hera bucket ID of event
short faDDAQFLT_BX();       // pipeline cell triggered on by FLT for this event
short faDDAQfltevt();       // flt event number as delivered by FCS

float faDTARia();
float faDTARbg();

// C prototype
extern "C" float faDTARia_();
extern "C" float faDTARbg_();

int faDaqLog();

#endif
