

      SUBROUTINE CAFMLC

************************************************************************
* Author :    Olga Igonkina   10/09/96
*
* Description: line-circle crossing (ECAl miniMC package)
*
* Called from:  CAFMLO
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

      REAL M

#include "arte/Arte.fi"
#include "gean/cafmcl.fi"
#include "gean/cafmcc.fi"

#include "arte/Arte.ff"

C         circle and line
C         x*a1 + y*b1 - c1 = 0
C         x*x + y*y = R*R

      IF( abs(A1).GT.0.1E-8 )THEN
        m = a1*a1 + b1*b1
        dis = c1*c1*b1*b1 - m*(C1*C1 - a1*A1*RC*RC)
        if(dis.GE.0.) then
           S(1,2) = ( b1*c1 - sqrt(dis) )/ m
           S(2,2) = ( b1*c1 + sqrt(dis) )/ m
           S(1,1) = ( c1 - b1 * S(1,2) ) / a1
           S(2,1) = ( c1 - b1 * S(2,2) ) / a1
        ELSE
           DIS = -100.
        endif
      ELSE
        m = (a1*a1 + b1*b1)
        dis = c1*c1*a1*a1 - m*(c1*C1 - b1*B1*RC*RC)
        if(dis.GE.0.) then
           S(1,1) = ( A1*c1 - sqrt(dis) )/ m
           S(2,1) = ( A1*c1 + sqrt(dis) )/ m
           S(1,2) = ( c1 - A1 * S(1,1) ) / B1
           S(2,2) = ( c1 - A1 * S(2,1) ) / B1
        ELSE
           DIS = -100.
        endif
      ENDIF

C************************************************************
      RETURN
      END

************************************************************************
* End of CAFMLC
************************************************************************
