
      SUBROUTINE CAFMLO

************************************************************************
* Author :    Olga Igonkina   13/03/96
*
* Description: for integration of shower parametrization function
*              ( ECAl miniMC package )
*
* Called from: CAFMFI, CAFMFM, CAFMFO
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

       REAL  ALPHA, SUM1
       INTEGER  J
       INTEGER NCL1, NCL2, NCL3, NCL4, ILC1, ILC2, ILC3, ILC4
       REAL X1, X2, Y1, Y2

#include "arte/Arte.fi"
#include "gean/cafmcl.fi"
#include "gean/cafmco.fi"
#include "gean/cafmcc.fi"
#include "arte/Arte.ff"


      DO J=1,MAXLC
         LC(J,1) = 0.
         LC(J,2) = 0.
      ENDDO
      INUM = 0
      SUM = 0.
      ILC1 = 0
      ILC2 = 0
      ILC3 = 0.
      ILC4 = 0.
      SUM1 = 0.

C line - circle interseption

      A1 = AL(1)
      B1 = BL(1)
      C1 = CL(1)
      CALL CAFMLC
      IF(  DIS.GT.0. )THEN
        CALL CAFMBD( 4, ILC1)
        NCL1 = INUM
      ENDIF

 20      CONTINUE

      A1 = AL(2)
      B1 = BL(2)
      C1 = CL(2)
      CALL CAFMLC
      IF(  DIS.GT.0. )THEN
        CALL CAFMBD( 1, ILC2)
        NCL2 = INUM
      ENDIF

 30      CONTINUE

      A1 = AL(3)
      B1 = BL(3)
      C1 = CL(3)
      CALL CAFMLC
      IF(  DIS.GT.0. )THEN
        CALL CAFMBD( 2, ILC3)
        NCL3 = INUM
      ENDIF

 40      CONTINUE

      A1 = AL(4)
      B1 = BL(4)
      C1 = CL(4)
      CALL CAFMLC

      IF(  DIS.GT.0. )THEN
        CALL CAFMBD( 3, ILC4)
        NCL4 = INUM
      ENDIF

 50      CONTINUE

      LC(INUM+1,1) = LC(1,1)
      LC(INUM+1,2) = LC(1,2)

C.. square

      IF( INUM.LT.0.5.AND.(CL(1)*CL(3)).LT.0.
     +               .AND.(CL(2)*CL(4)).LT.0. )THEN
        IF( RC.LE.R2 )THEN
          SUM = SUM + 1.57079635 * RC * RC
        ELSE
          ALPHA = ACOS ( R2/RC )
          SUM = SUM + RC * RC *
     +               ( 1.57079635 - ALPHA + SIN(2*ALPHA)/2 )
        ENDIF
        IF( RC.LE.ABS(R1) )THEN
          SUM = SUM + 1.57079635 * RC * RC
        ELSE
          ALPHA = ACOS ( ABS(R1)/RC )
          SUM = SUM + RC * RC *
     +               ( 1.57079635 - ALPHA + SIN(2*ALPHA)/2 )
        ENDIF
        GOTO 999
      ENDIF

C... manyangles square

      IF( INUM.GT.0.5 )THEN

       DO J = 1, INUM

        X1 = LC(J,1)
        Y1 = LC(J,2)
        X2 = LC(J+1,1)
        Y2 = LC(J+1,2)

        SUM1 = -0.5 * ( X1*Y2 - X2*Y1 )
        IF( ABS(SUM1).LT.0.1E-8 )GOTO 70
        SUM = SUM + SUM1

        IF( X1.GT.R2 )THEN
         IF( X2.GT.R2 )THEN
            SUM = SUM - SUM1  - 0.5 * R2*R2 * ( Y2/X2-Y1/X1 )
         ELSE
           SUM = SUM - SUM1 * (X1-R2 )**2 / X1 / (X1 - X2)
         ENDIF
        ELSE
         IF( X2.GT.R2 )THEN
          SUM = SUM - SUM1 * (X2-R2 )**2/ X2 / (X2 - X1)
         ENDIF
        ENDIF
C...
        IF( X1.LT.R1 )THEN
         IF( X2.LT.R1 )THEN
            SUM = SUM - SUM1  - 0.5 * R1*R1 *( Y2/X2-Y1/X1 )
        ELSE
           SUM = SUM + SUM1 * (X1-R1 )**2 / X1 / (X2 - X1)
         ENDIF
        ELSE
         IF( X2.LT.R1 )THEN
          SUM = SUM + SUM1 * (X2-R1 )**2 / X2 / (X1 - X2)
         ENDIF
        ENDIF

 70          CONTINUE
       ENDDO

      ENDIF

      SUM = ABS( SUM)

 100     CONTINUE


C.. first arc

      IF( ILC1.GT.0.5 )THEN
       CALL CAFMLI(NCL1)
      ENDIF

C.. 2 arc

      IF( ILC2.GT.0.5 )THEN
       CALL CAFMLI(NCL2)
      ENDIF

C.. 3 arc
      IF( ILC3.GT.0.5 )THEN
       CALL CAFMLI(NCL3)
      ENDIF

C.. 4 arc

      IF( ILC4.GT.0.5 )THEN
       CALL CAFMLI(NCL4)
      ENDIF

 999  RETURN
      END

C************************************************************************
C* End of CAFMLO
C************************************************************************
