/*************************************************************************
*
* CR_ARTE_USER
* written by Siegmund Nowak
*
* This routines gives the user the possibility to change data in the 
* last NEDE bank produced by cr_arte.C
*
*       called from G..MAIN
*
*************************************************************************/

#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/ZGMOTH.h"
#include "gean/ZGESL.h"

  extern "C" {
    void cr_arte_user_(int,int,char*,int*,int);
}
    void itr_arte(int,int,char*,int*,int);
    void sil_arte(int,int,char*,int*,int);
    void ric_arte(int,int,char*,int*,int);
    void szh3_arte(int,int,char*,int*,int);

void cr_arte_user_(int nede,int nwal,char *lvols,int lcopy[],int nlev) {

    ArtePointer<NESL> sl(zgmoth_.CURRSL);

    if(sl->cmp == LGESL_SIL) 
       sil_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_MSG) 
       itr_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_RIC) 
       ric_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_HOD3)
       szh3_arte(nede,nwal,lvols,lcopy,nlev);
  }
      
/* cr_arte_user */








