
      SUBROUTINE CRMIXTC(CINP,L,MEDFLG,INMIX,NAM_MIX,LL,VOL_MIX)

************************************************************************
* Author :    Siegmund Nowak   15/07/96
*
* Description: adds a mixture to GMAT and GEANT/JMATE and calculates the
*              medium parameters ( mainly for calls from c++
*
* Called from: <user>
*
* External references:
*
* Argument in/out description
* CNAME  (A12) foresseen name of the mixture                    INPUT
* Medflag = IGMAT_FLAG (see description of table GMAT)          INPUT
* INMIX  number of components in the mixture                    INPUT
* NAM_MIX(I) vector of component names                          INPUT
* VOL_MIX(I) vector of volume % of components (not normalized)  INPUT
************************************************************************

      IMPLICIT NONE

      INTEGER MEDFLG,INMIX,IFIRST,I,IX,ILAST,L,LL
      REAL VOL_MIX(INMIX),A_MIX(10),Z_MIX(10),D_MIX(10),W_MIX(10)
      REAL VOL,WEIGHT,DENS,AEFF,ZEFF,REFF,ALEFF
      CHARACTER CNAME*12,MNAME*12,CNU*12,CC*12,CNAM*20
      CHARACTER*12 CINP,NAM_MIX(INMIX)

#include "arte/Arte.fi"
#include "auto/GMAT.fi"
#include "auto/GMIX.fi"

#include "arte/Arte.ff"
#include "auto/GMAT.ff"
#include "auto/GMIX.ff"

      IF(IFIRST.EQ.0) THEN
         IF(JGMAT.EQ.0) CALL MMBOOK(JGMAT,0)
         IF(JGMIX.EQ.0) CALL MMBOOK(JGMIX,0)
         IFIRST = 1
      ENDIF

C     look whether the mixture has been already booked
      CNAME(1:L) = CINP(1:L)
      IF(L.LT.12) CNAME(L+1:12) = ' '
      CNU = CNAME
      CALL CLTOU (CNU)
      DO 10 IX = 1, NGMAT()
        CALL UHTOC (IQ(HQGMAT_NAME(1,IX)),4, CC,12)
        CALL CLTOU (CC)
        IF(CNU .EQ. CC)  THEN
           C78 = CNAME(1:L)
           CALL CH78BC('has been already booked - see entry')
           CALL CH78BI(IX)
           CALL ME78WA
           GO TO 20
        ENDIF
 10   CONTINUE

C     Check that it is a mixture and it is given with volume %
 20   IF(INMIX.LE.1) THEN
         C78='CRMIXT is valid only for mixtures with input of volume %'
         CALL ME78WA
         GO TO 99
      ENDIF

C     get the mixture parameters
      WEIGHT = 0.
      VOL = 0.
      DO I = 1,INMIX
       MNAME(1:LL) = NAM_MIX(I)(1:LL)
       IF(LL.LT.12) MNAME(LL+1:12) = ' '
       CNU = MNAME
       CALL CLTOU(CNU)
       DO IX =1,NGMAT()
        CALL UHTOC (IQ(HQGMAT_NAME(1,IX)),4,CC,12)
        CALL CLTOU (CC)
        IF(CNU .EQ. CC)  THEN
           A_MIX(I) = FGMAT_A(IX)
           Z_MIX(I) = FGMAT_Z(IX)
           D_MIX(I) = FGMAT_DENS(IX)
           GO TO 30
        ENDIF
       ENDDO
       C78 = 'Mixture component'
       CALL CH78BC(NAM_MIX(I))
       CALL CH78BC('with volume weights must be defined before')
       CALL ME78ER
       GO TO 99

 30    VOL    = VOL_MIX(I) + VOL
       W_MIX(I) = VOL_MIX(I)* D_MIX(I)
       WEIGHT = W_MIX(I) + WEIGHT
      ENDDO
      DO I=1,INMIX
       W_MIX(I) = W_MIX(I)/WEIGHT
      ENDDO
      DENS = WEIGHT/VOL

c     book JGMAT,JGMIX and relations
      CALL MMBOOK (JGMAT, 1)
      IX = NGMAT()
      CALL UCTOH (CNAME, IQ(HQGMAT_NAME(1,IX)), 4,12)
      ILAST = NGMIX()

      CALL MEDMIX(A_MIX,Z_MIX,W_MIX,DENS,INMIX,AEFF,ZEFF,REFF,ALEFF)
      IQ(IQGMAT_GMIX(IX)) = ILAST + 1
      CALL MMBOOK(JGMIX,INMIX)
      DO I = 1, INMIX
       MNAME(1:LL) = NAM_MIX(I)(1:LL)
       IF(LL.LT.12) MNAME(LL+1:12) = ' '
       CNU = MNAME
       CALL CLTOU(CNU)
       CALL UCTOH (CNU, IQ(HQGMIX_NAME(1,ILAST+I)), 4,12)
       Q(QGMIX_A(ILAST+I)) = A_MIX(I)
       Q(QGMIX_Z(ILAST+I)) = Z_MIX(I)
       Q(QGMIX_W(ILAST+I)) = W_MIX(I)
      ENDDO

      Q( QGMAT_A   (IX)) = AEFF
      Q( QGMAT_Z   (IX)) = ZEFF
      Q( QGMAT_DENS(IX)) = DENS
      Q( QGMAT_RADL(IX)) = REFF
      Q( QGMAT_ABSL(IX)) = ALEFF
      IQ(IQGMAT_FLAG(IX)) = MEDFLG
      IQ(IQGMAT_NMIX(IX)) = INMIX

      CNAM(1:L) = CNAME(1:L)
      CNAM(L+1:L+1) = '$'
      CNAM(L+2:20) = ' '
      CALL GSMIXT(IX,CNAM,A_MIX,Z_MIX,DENS,INMIX,W_MIX)

      IF(MEDFLG.NE.0) CALL CRTMED(IX) 


 99   RETURN
      END

************************************************************************
* End of CRMIXT
************************************************************************
