      
      SUBROUTINE CRVOLU(CNAME,CSHAP,SDGR,MEDFLG,CMAT,COLOR,SEEN)

************************************************************************
* written by Siegmund Nowak 1997/Jun/17
*
* This routine is a combined call to GSVOLU with NPAR=0 (GEANT-GEOM100-1)
* and GSDET (GEANT-HITS100-1) 
* called from all geometry routines
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* CNAME     in            Name of the volume to be defined (A4)
* CSHAPE    in            Name of the shape for the given volume
* SDGRP     in            LGESL_...for this subdetector 
* MEDFLG    in            a bit flag for giving the magnetic field and the
*                         sensitivity (possibility to store hits):
*                         =1  no magnetic field, nonsensitive medium;
*                         =2  magnetic field, nonsensitive medium; 
*                         =4  no magnetic field, sensitive medium;
*                         =8  magnetic field, sensitive medium.
* CMAT      in            Material name (A12)
* COLOR     in            Colour number according to GEANT rules (GSATT)
* SEEN      in            Seen flag according to GEANT rules  (GSATT)
************************************************************************
      IMPLICIT NONE
      INTEGER SDGR,MEDFLG,IVOL,MEDNUM,COLOR,SEEN,ISET,IDET
      REAL PAR(10)
      CHARACTER CNAME*4,CSHAP*4,CMAT*(*)
      CALL GSVOLU(CNAME,CSHAP,MEDNUM(MEDFLG,CMAT),PAR,0,IVOL)
      CALL GSATT(CNAME,'COLO',COLOR)
      CALL GSATT(CNAME,'SEEN',SEEN)      
      IF(MEDFLG.GE.3) CALL GSDET
     +       (CNAME(1:2)//'SD',CNAME,1,CNAME,16,SDGR,20,20,ISET,IDET)
      RETURN
      END
