/************************************************************************
*
* FLDGEO
* written by Siegmund Nowak
*
* This routines fills the Artebank FIELD
*
*       called from G..MAIN
*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgeom.h"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"

  void fldgeo() {
    struct FELD fld;  

    ArtePointer<NESL> gs(zgmoth_.FELDSL);
    gs->mfl =1; 
    if(zgdetv_.DETV[LGESL_FLD-1] == 'L') {
       gs->y2 = -8.;  arteMsg << "MAGNETIC FIELD FROM FIELD MAP IS USED"; 
    }
    else if(zgdetv_.DETV[LGESL_FLD-1] == 'S') {
       gs->y2 = 0.;                    gs->mfl =0;
       arteMsg << "THE MAGNET IS SWITCHED OFF !!!!";  
    }
    else {
       arteMsg << "Neither short nor long version given for the field";
       arteMsg.error();
    }
    arteMsg.warn();              
    fld.x = gs->x1;
    fld.y = gs->y1;
    fld.z = gs->z1; 
    fld.r = gs->x2;
    fld.h = gs->y2;
    ArtePointer<FELD>::append(fld); 
  }
  
/* fldgeo_ */



