#ifndef _ZGVOL_HH_
#define _ZGVOL_HH_

  typedef struct {
    int   type;
    int   sens_flag;
    int   color;
    int   seen;
    int   npar; 
    int   ncomp, index_hgpos;
    int   index_hgdet;
    float dimension[11];
    float rel_px,rel_py,rel_pz;
    char  name  [40];
    char  object  [4];
    char  shape [4];
    char  material[12];
    char  user[80];           
  } hgvol;

class zgvol{
public:

  friend class zgdet;
  friend class zgpos;
  friend class zgrot;
  friend class zguser;
 
  zgvol() {}
  ~zgvol() {} 
  
  static void ini(int n);
  static void fin();
  static void increase();
  static void Set_ind_pt(int); 
  unsigned int size() { return nrvol[ind_pt] +1; }
  hgvol *volpointer(unsigned int i);  
  void  Read_vol(char*,int&);
  void  Read_shape(char*);
  void  Read_dimension(char*);
  void  Read_type(char*);  
  void  Read_sens_fl(char*);
  void  Read_material(char*);
  void  Read_rel_point(char*);
  void  Read_color(char*);

  void  Set_default();
  void  Copy_previous();
  int   RotateBox(int &);

  char* Get_volname(int &);
  int   Get_volnr(char *, int);
  char* Get_shape(int &) ;
  int   Get_dimension(int &,float *) ;
  int   Get_par(int &,float *) ;
  int   Get_type(int &) ;  
  int   Get_sens_flag(int &) ;
  char* Get_material(int &, int &) ;
  void  Get_rel_point(int &, float*, float*, float*) ;
  int   Get_color(int &) ;
  int   Get_ncomp(int &);

  void  Create_Gvol(int); 
  int   Check_Gvol(char*);  

private:
  static  hgvol        *ptvol[33];
  static  int           nrvol[33];
  static  int           maxvol[33];
  static  int           ind_pt;
};


#endif
