        subroutine  otrage(isl)
******************************************************************
*
* Defines aging boxes geometry (BigBox, KaBox) installed in run 98-99.
* Geant volumes are defined and the corresponding Arte tables.
*
* Called from: otrgeo.F
*
* External references:
*
* Arguments  in/out       Description
*
* isl        in           superlayer number (index for NESL table)
*
* Alexander Lanyov     Feb 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "gean/otrgeo.fi"

        integer isl,mf
        real par(8),xp,yp,zp,xpp,ypp,zpp,zp0,xwid,zwid,thick,xwall
        character*4 csl,iron(2),alum(2)
        data iron/'WTIR','WTIM'/
        data alum/'WTAL','WTAM'/

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c-- install the superlayer volume
      currsl = isl
      call uhtoc(hnesl_name(isl),4,csl,4)
      mf = inesl_mfl(isl) + 1
      if (mf.eq.1) then
         call cggesl(csl,'MOTH',0)
      else
         call cggesl(csl,'MAGN',0)
      end if

c      c78 = 'OTRAGE is called with isl ='
c      call ch78bi(isl)
c      call me78sp('T')

c--------------------------------------------------------- BigBox
      xwid = 44.
      zwid = 8.
      thick = 0.4
      xwall = 4.
      par(1) = 0.5 * xwid
      par(2) = 0.5 * 136.
      par(3) = 0.5 * 0.1
      xp = 35.
      yp = 0.
      zp = -1.5 - 2
      call crpos(alum(mf),csl,0,0,xp,yp,zp-par(3),0,'ONLY',par) ! exit cover
      zp0 = zp - 2.*par(3)
      zp =  zp + zwid
      call crpos(alum(mf),csl,0,0,xp,yp,zp+par(3),0,'ONLY',par) ! entry cover
      zp =  zp - 0.5*zwid

c right C-shaped profile
      par(1) = 0.5 * thick
      par(3) = 0.5 * zwid
      xpp = xp + (0.5*xwid - xwall + thick)
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zp,0,'ONLY',par)

      par(1) = 0.5 * (xwall-thick)
      par(3) = 0.5 * thick
      zpp = zp + 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zpp-par(3),0,'ONLY',par)
      zpp = zp - 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zpp+par(3),0,'ONLY',par)

c left C-shaped profile
      par(1) = 0.5 * thick
      par(3) = 0.5 * zwid
      xpp = xp - (0.5*xwid - xwall + thick)
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zp,0,'ONLY',par)

      par(1) = 0.5 * (xwall-thick)
      par(3) = 0.5 * thick
      zpp = zp + 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zpp-par(3),0,'ONLY',par)
      zpp = zp - 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zpp+par(3),0,'ONLY',par)

      zp =  zp - 0.5*zwid - 0.1

c--------------------------------------------------------- KaBox
      xwid = 35.
      zwid = 4.
      thick = 0.4
      xwall = 2.

      par(1) = 0.5 * xwid
      par(2) = 0.5 * 90.
      par(3) = 0.5 * 0.5
      call crpos(alum(mf),csl,0,0,xp,yp,zp-par(3),0,'ONLY',par) ! 5mm
      zp =  zp - 2.*par(3)

      par(1) = 0.5 * xwid
      par(2) = 0.5 * 60.
      par(3) = 0.5 * 0.1
      zp = zp - 2.*par(3)
      call crpos(alum(mf),csl,0,0,xp,yp,zp+par(3),0,'ONLY',par) ! exit cover
      zp =  zp - zwid
      call crpos(alum(mf),csl,0,0,xp,yp,zp-par(3),0,'ONLY',par) ! entry cover
      zp =  zp + 0.5*zwid

c right C-shaped profile
      par(1) = 0.5 * thick
      par(3) = 0.5 * zwid
      xpp = xp + (0.5*xwid - xwall + thick)
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zp,0,'ONLY',par)

      par(1) = 0.5 * (xwall-thick)
      par(3) = 0.5 * thick
      zpp = zp + 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zpp-par(3),0,'ONLY',par)
      zpp = zp - 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zpp+par(3),0,'ONLY',par)

c left C-shaped profile
      par(1) = 0.5 * thick
      par(3) = 0.5 * zwid
      xpp = xp - (0.5*xwid - xwall + thick)
      call crpos(alum(mf),csl,0,0,xpp+par(1),yp,zp,0,'ONLY',par)

      par(1) = 0.5 * (xwall-thick)
      par(3) = 0.5 * thick
      zpp = zp + 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zpp-par(3),0,'ONLY',par)
      zpp = zp - 0.5*zwid
      call crpos(alum(mf),csl,0,0,xpp-par(1),yp,zpp+par(3),0,'ONLY',par)

c--------------------------------------------------------- Outer frames
      thick = 0.4

c XY plane
      par(1) = 0.5 * 30.
      par(2) = 0.5 * 180.
      par(3) = 0.5 * thick
      xp = xp - 88
      yp = 0.
      zp = zp0
      call crpos(iron(mf),csl,0,0,xp+par(1),yp,zp-par(3),0,'ONLY',par)
      xpp = xp + 2.*par(1)

      par(1) = 0.5 * 80.
      par(2) = 0.5 * 30.
      par(3) = 0.5 * thick
      ypp = yp + (0.5 * 180. - par(2))
      call crpos(iron(mf),csl,0,0,xpp+par(1),ypp,zp-par(3),0,'ONLY',par)

      ypp = yp - (0.5 * 180. - par(2))
      call crpos(iron(mf),csl,0,0,xpp+par(1),ypp,zp-par(3),0,'ONLY',par)

c XY plane
      par(1) = 0.5 * thick
      par(2) = 0.5 * 180.
      par(3) = 0.5 * 10.
      call crpos(iron(mf),csl,0,0,xp+par(1),yp,zp+par(3),0,'ONLY',par)

      par(1) = 0.5 * 110.
      par(2) = 0.5 * thick
      par(3) = 0.5 * 10.
      ypp = yp + 0.5 * 180.
      call crpos(iron(mf),csl,0,0,xp+par(1),ypp,zp+par(3),0,'ONLY',par)
      ypp = yp - 0.5 * 180.
      call crpos(iron(mf),csl,0,0,xp+par(1),ypp,zp+par(3),0,'ONLY',par)

      return
      end
