
      SUBROUTINE  SMLGEO()
************************************************************************
*
* SMLGEO
* written by Siegmund Nowak 12/92
*
* This routines defines silicon detector in magnet for HERA-B detector
*
*       called from G00MAIN
*
* Arguments  kind         description
*
*-----------------------------------------------------------------------
*   ISL      in           silicon superlayer
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGSMLD.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

      INTEGER NSL,IFIRST,IVOL,ISEC,IRS,NPL,NSEC,MEDNUM,IROTM(4)
      INTEGER IUCOMP,ILAY,MG,NN
      REAL XPL, YPL, PXMOD, PYMOD, PZMOD, PZPLAN, XP(3)
      REAL PARSI(3), PARCA(3), PARAD(3), PARHY(3)
      REAL POSSI(3), POSCA(3), POSAD(3), POSHY(3)
      REAL ANG,COSX,SINX, XMINEF,XMAXEF, YMINEF,YMAXEF
      CHARACTER*4 CNAM
      DATA IFIRST /0/
      SAVE IFIRST

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--   initialisation (volume definition,rad-length,angles etc)

      IF(IFIRST.EQ.0) THEN
         IROTM(1) = 0
         CALL CRROTM(IROTM(2), 90., 270.,  90.,   0.,  0.,  0.)
         CALL CRROTM(IROTM(3), 90., 180.,  90., 270.,  0.,  0.)
         CALL CRROTM(IROTM(4), 90.,  90.,  90., 180.,  0.,  0.)
         IF(INT(GEOMVERS).EQ.98 .OR.INT(GEOMVERS).EQ. 99 ) THEN
            CALL SMLDAT('SVD/sml98.dat')
         ELSEIF(INT(GEOMVERS).EQ.00) THEN
            CALL SMLDAT('SVD/sml.dat')
         ENDIF
         CALL GSVOLU('SMLZ','BOX ',MEDNUM(4,'SILICON'),PARSI,0,IVOL)
         CALL GSVOLU('SMCA','BOX ',MEDNUM(2,'CARBONFIBRE'),PARSI,0,IVOL)
         CALL GSVOLU('SMAD','BOX ',MEDNUM(2,'AL2O3'),PARSI,0,IVOL)
         CALL GSVOLU('SMHY','BOX ',MEDNUM(2,'AL2O3'),PARSI,0,IVOL)

         ANG = ANGSM/180.*PI
         COSX = COS(ANG)
         SINX = SIN(ANG)
         IFIRST = 1
      ENDIF

      IF(INESL_LAY(CURRSL).EQ.0) GO TO 90
 
      CALL UHTOC(HNESL_NAME(CURRSL),4,CNAM,4)

      NSL = IUCOMP(CNAM,DESM,NSLSM)
      IF(NSL.EQ.0) CALL MEERRO('SMLGEO: '//CNAM//' not found in DESM')
      NPL  = INESL_LAY(CURRSL)
      NSEC = 4
      CALL CGGESL(CNAM,'MAGN',0)
      CALL GSATT(CNAM,'COLO',-5)

C--   loop over the four sectors
      XPL = XRSM(NSL) + OVSM(NSL) - .5*DXSMSI    
      YPL = XRSM(NSL)

      DO ISEC = 1,4
      IRS = IROTM(ISEC)  

       IF(ISEC.EQ.1) THEN
          PZPLAN = -PZLYSM(NSL)
       ELSEIF(ISEC.EQ.2) THEN
          PZPLAN = PZLYSM(NSL)
       ELSEIF(ISEC.EQ.3) THEN
          PZPLAN = -PZLYSM(NSL)
       ELSEIF(ISEC.EQ.4) THEN
          PZPLAN = PZLYSM(NSL)
       ENDIF

       PXMOD = -XPL 
       PYMOD =  YPL

C--    DIMENSIONS AND x/y POSITIONS


       DO ILAY =1,3,2

       IF(ILAY.EQ.1) PZMOD = PZPLAN - PZC1SM(NSL)
       IF(ILAY.EQ.3) PZMOD = PZPLAN + PZC1SM(NSL) 


C--    silicon:
       PYSMSI(NSL) = .5*DYSMSI
       PARSI(1) = .5 * DXSMSI
       PARSI(2) = .5 * DYSMSI
       PARSI(3) = .5 * DZSMSI
       POSSI(1) = PXMOD
       POSSI(2) = PYSMSI(NSL) + PYMOD
       POSSI(3) = PZMOD -.5*(DZC1SM+DZSMSI)
       CALL GUROT(IRS,POSSI,XP)       
       CALL CRPOS('SILZ',CNAM,ILAY,ISEC,
     +                            XP(1),XP(2),XP(3),IRS,'ONLY',PARSI)

       NN = NNEDE()
       XMINEF = FNEDE_XMIN(NN) + RANDSM
       XMAXEF = FNEDE_XMAX(NN) - RANDSM
       YMINEF = FNEDE_YMIN(NN) + RANDSM
       YMAXEF = FNEDE_YMAX(NN) - RANDSM
       Q (QNEDE_SXMN_L()) = XMINEF
       Q (QNEDE_SXMX_L()) = XMAXEF
       Q (QNEDE_SYMN_L()) = YMINEF
       Q (QNEDE_SYMX_L()) = YMAXEF
       Q (QNEDE_ACC_L()) = SIGSM
       Q (QNEDE_EFF_L()) = EFFSM
       Q (QNEDE_PIT_L()) = PITSM
       Q (QNEDE_DOD_L()) = DMSM
       IQ(IQNEDE_NSL_L())  = 1

       IF(ILAY .EQ. 1) THEN
          Q (QNEDE_COS_L()) = COSX
          Q (QNEDE_SIN_L()) = -SINX
       ELSE IF(ILAY.eq.3) THEN
          Q (QNEDE_COS_L()) = COSX
          Q (QNEDE_SIN_L()) = SINX
       ENDIF

       Q (QNEDE_XFW_L(1)) = XMINEF*FNEDE_COS(NN) + 
     +                      YMINEF*FNEDE_SIN(NN) + 0.5*PITSM
       Q (QNEDE_ZFW_L(1)) = FNEDE_ZMIN(NN)
       IQ(IQNEDE_NWI_L(1)) = ((XMAXEF-XMINEF)*FNEDE_COS(NN) 
     +                      + (YMAXEF-YMINEF)*FNEDE_SIN(NN))/PITSM

       CALL MMBOOK(JNEDE,1)
       NN = NNEDE()
       CALL UCOPY(Q(JNEDE+(NN-2)*NCNEDE()+3),
     +            Q(JNEDE+(NN-1)*NCNEDE()+3),NCNEDE())
       IQ(JNEDE+(NN-1)*NCNEDE()+2 + JNEDE_NESL) = 0
       CALL MMBREL(JNSND,CURRSL,NN)
       MG = ONEDE_GMAT(NN-1) 
       IQ(JNEDE+(NN-1)*NCNEDE()+2 + JNEDE_GMAT) = 0
       CALL MMBREL(JGMND,MG,NN)
       IQ(IQNESL_NPL(CURRSL)) = IQ(IQNESL_NPL(CURRSL)) + 1

       IF(ILAY .EQ. 1) THEN
          Q (QNEDE_COS_L()) = -SINX
          Q (QNEDE_SIN_L()) = -COSX
       ELSE IF(ILAY.eq.3) THEN
          Q (QNEDE_COS_L()) = SINX
          Q (QNEDE_SIN_L()) = -COSX
       ENDIF
       IQ(IQNEDE_LAY_L()) = ILAY + 1 
       Q (QNEDE_XFW_L(1)) = -XMINEF*FNEDE_COS(NN) - 
     +                       YMINEF*FNEDE_SIN(NN) + 0.5*PITSM
       Q (QNEDE_ZFW_L(1)) = FNEDE_ZMAX(NN)
       IQ(IQNEDE_NWI_L(1)) =-((XMAXEF-XMINEF)*FNEDE_COS(NN) 
     +                      + (YMAXEF-YMINEF)*FNEDE_SIN(NN))/PITSM

C--   adapter -front side
       PARAD(1) = .5 * DXA1SM
       PARAD(2) = .5 * DYA1SM
       PARAD(3) = .5 * DZA1SM
       POSAD(1) = PXMOD
       POSAD(2) = PYA1SM(NSL) + PYMOD
       POSAD(3) = PZMOD - .5*(DZC1SM+DZA1SM)
       CALL GUROT(IRS,POSAD,XP)              
       CALL CRPOS('SMAD',CNAM,ILAY,ISEC,
     +                   XP(1),XP(2),XP(3),IRS,'ONLY',PARAD)

c--   hybrid - front side  
       PARHY(1) = .5 * DXHYSM
       PARHY(2) = .5 * DYHYSM
       PARHY(3) = .5 * DZHYSM
       POSHY(1) = -PXH1SM(NSL) + PXMOD
       POSHY(2) =  PYH1SM(NSL) + PYMOD
       POSHY(3) = PZMOD - .5*(DZC1SM+DZHYSM)
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       POSHY(1) = PXH1SM(NSL) + PXMOD
       POSHY(2) = PYH1SM(NSL) + PYMOD
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)

C--    Carrier (beam-side)
       PARCA(1) = .5 * DXC1SM
       PARCA(2) = .5 * DYC1SM
       PARCA(3) = .5 * DZC1SM
       POSCA(1) = PXMOD
       POSCA(2) = PYC1SM(NSL) + PYMOD
       POSCA(3) = PZMOD
       CALL GUROT(IRS,POSCA,XP)
       CALL CRPOS('SMCA',CNAM,ILAY,ISEC,
     +                         XP(1),XP(2),XP(3),IRS,'ONLY',PARCA)

C--    Carrier (beam off-side)
       PARCA(1) = .5 * DXC2SM
       PARCA(2) = .5 * DYC2SM
       PARCA(3) = .5 * DZC2SM
       POSCA(1) = PXMOD
       POSCA(2) = PYC2SM(NSL) + PYMOD
       POSCA(3) = PZMOD
       CALL GUROT(IRS,POSCA,XP)
       CALL CRPOS('SMCA',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARCA)

C--    Adapter (back side)
       PARAD(1) = .5 * DXA2SM
       PARAD(2) = .5 * DYA2SM
       PARAD(3) = .5 * DZA2SM
       POSAD(1) = PXMOD
       POSAD(2) = PYA2SM(NSL) + PYMOD
       POSAD(3) = PZMOD + .5*(DZC1SM+DZA1SM)
       CALL GUROT(IRS,POSAD,XP)
       CALL CRPOS('SMAD',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARAD)

C--     hybrid (back side)
       POSHY(1) = -PXH2SM(NSL) + PXMOD
       POSHY(2) =  PYH2SM(NSL) + PYMOD
       POSHY(3) = PZMOD + .5*(DZC1SM+DZHYSM)
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       POSHY(1) = PXH2SM(NSL) + PXMOD
       POSHY(2) = PYH2SM(NSL) + PYMOD
       CALL GUROT(IRS,POSHY,XP)
       CALL CRPOS('SMHY',CNAM,ILAY,ISEC,
     +                        XP(1),XP(2),XP(3),IRS,'ONLY',PARHY)
       enddo             ! end loop over layers


      ENDDO               ! end loop over sectors ISEC

 90   RETURN
      END

