/*
************************************************************************
*
* TARGEO
* written by Siegmund Nowak
*
* This routines defines geometry of the beam pipe outside the si-region
* and up to the muon system
*
*       called from G..MAIN
*
************************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteUtil.h"
#include "gean/gclink.h"
#include "gean/ZGMOTH.h"
#include "gean/ZGTAR.hh"


  struct NTAR gt; 
 
  extern "C" {
    void targeo_();
    void gsvolu_(char*,char*,int*,float[],int*,int*);
    void gsatt_(char*,char*,int*);
    void crpos_(char*,char*,int*,int*,float*,float*,float*,int*,char*,float[]);
    void crrotm_(int*,float*,float*,float*,float*,float*,float*);    
    int  mednum_(int &, char *, int);
    int  matnum_(char *,int);
    int  tardat_();
    extern ZGTAR tarbuf_;
  }

void targeo_() {
//  targ buf;

    ZGTAR&  targ=tarbuf_;
    int ivol, imed, imat, irot, len; 
    int zero=0, one=1; 
    char shap[4], colo[4],  only[4], mot[4],  vol[5],  mat[13];
    float fzero =0., fninety=90.;
    float par[3], xp, yp, zp;

// standard definitions 
    strncpy(shap,"BOX ",4); 
    strncpy(colo,"COLO",4);
    strncpy(only,"ONLY",4);
    crrotm_(&irot , &fzero, &fzero, &fninety,&fzero, &fninety, &fninety);

//  posit volumes within mother 
    int wnr=0; 

    for (;;)   {
    int fi = tardat_();
    if (fi == 0) continue;
    if (fi != 0) {
      union  { int ii; char bla[4];};
      int i=0, k=0;
      int nvol=*(gcbank_.iq + gclink_.jvolum -2); 
      while( i<nvol) {
        ii = *(gcbank_.iq+gclink_.jvolum+i);
        if(!strncmp(bla,targ.object,4)) {
           k=i+1; 
           break; }
        i++; }

      wnr = wnr + 1;
      strncpy(mot,targ.mother,4);
      strncpy(vol,targ.object, 4);
      strncpy(shap,targ.shape, 4);
      len = strlen(targ.material);
      if(len >12) len=12;
      strncpy(mat,targ.material, len);
      imat = matnum_(targ.material,len);
      if (k == 0)  { 
         imed = mednum_(one,targ.material, len);
	 gsvolu_(vol,shap, &imed, par, &zero, &ivol);
         gsatt_(vol, colo, &one); }
         
      par[0] = 0.5 * targ.dx;
      par[1] = 0.5 * targ.dy;
      par[2] = 0.5 * targ.dz;
      xp = targ.xpos;
      yp = targ.ypos;
      zp = targ.zpos + zgmoth_.ZZERO;
      if(targ.rotation == 0)
         crpos_(vol,mot,&wnr,&zero,&xp,&yp,&zp,&zero,only,par);
      else
         crpos_(vol,mot,&wnr,&zero,&xp,&yp,&zp,&irot,only,par);

      gt.cmp  = imat;   
      gt.wnr  = wnr;
      gt.dx   = targ.dx;
      gt.dy   = targ.dy;
      gt.dz   = targ.dz;
      gt.x    = xp;
      gt.y    = yp;
      gt.z    = targ.zpos; 
      gt.rot[0] = 1.;
      gt.rot[4] = 1.;
      gt.rot[8] = 1.;
      gt.x0bm   = targ.xb;
      gt.y0bm   = targ.yb;
      gt.sxbm   = targ.sxb;
      gt.sybm   = targ.syb;
      ArtePointer<NTAR>::append(gt); 
      if ( fi <= 0 ) break;
}}}  
 /* targeo_ */






