*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE LIUNIT (LUN, CTPL)

************************************************************************
*
* Description: Print information on logical unit number LUN.
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   LUN    in     Logical unit number. If LUN = 0: all units
*   CTPL   in     Print destination (combination of 'TPL')
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      CHARACTER CTPL*(*), CSTREAM*80, CHS(7)*1, CHF(3)*1, C3*3,
     +   CHZ(0:2)*1, CHO*8, CN*120
      INTEGER ILINE, LUN, L, L0, L1, L2, LENOCC
      DATA CHS /' ','r','n','w','o','e','c'/, CHF /' ','b','f'/,
     +   CHZ /' ', 'Z', 'G'/

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      L1 = 1
      L2 = 99
      IF (LUN .LT. 0 .OR. LUN .GE. 100)  THEN
        C78 = 'LIUNIT: logical unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('is not in the range 1 ... 99')
        CALL ME78WC (7456745)
        L2 = 0
      ELSE IF (LUN .NE. 0)  THEN
        L1 = LUN
        L2 = LUN
        IF (IMEIO_FLAG(LUN) .LT. 0)  THEN
          C78 = 'LIUNIT: logical unit'
          CALL CH78BI (LUN)
          CALL CH78BC ('is unknown to Arte')
          CALL ME78SP (CTPL)
          GO TO 90
        END IF
      END IF

      CALL MESELP
     +  ('Lun  IOS Flags   Recl  Nrec   Stream    Name', CTPL)
      ILINE = 0

      DO 30 L0 = L1, L2
        IF (IMEIO_FLAG(L0) .LT. 0)  GO TO 30
        L = L0
        WRITE (C3,'(I3)')  L0

 10     CALL CHHTOC (IQ(HQMEIO_STREAM(1,L0)), CSTREAM)
        CALL CHHTOC (IQ(HQMEIO_ZOPTION(1,L)), CHO)
        WRITE (C78, 1001)  C3, IMEIO_IOSTAT(L), CHS(IMEIO_FLAG(L)+2),
     +    CHF(IMEIO_FORMAT(L)+2), CHZ(IMEIO_PACK(L)), CHO
        CALL CHAPBI (C78(17:), IMEIO_RLENG(L))
        CALL CHAPBI (C78(23:), IMEIO_NREC(L))
        CALL CHAPBC (C78(30:), CSTREAM)
        CALL CHHTOC (IQ(HQMEIO_NAME(1,L)), CN)
        IF (LENOCC(CN) + LENOCC (C78) .LE. 100)  THEN
          CALL CHAPBC (C78(40:), CN)
        ELSE
          ILINE = ILINE + 1
          CALL ME78SP (CTPL)
          C78 = CN
          CALL CHRIGH (C78)
          CALL CHLEFT (C78(33:))
        END IF
        ILINE = ILINE + 1
        CALL ME78SP (CTPL)
        L = IMEIO_CONCAT(L)
        C3(1:1) = '+'
        IF (L .NE. 0)  GO TO 10
        IF (ILINE .GE. 5)  THEN
          ILINE = 0
          CALL MESELP (' ', CTPL)
        END IF
 30   CONTINUE

 1001 FORMAT (A,I5,1X,4A)

 90   END

************************************************************************
* End of LIUNIT
************************************************************************
