*-- Author :    Rainer Mankel   08/05/95

      subroutine prhfit()

*     **** print information for reconstructed hits in table rhit
*     **** Parameters:
*     ****   hfit1, hfit2  - range of rows in table hfit
*     ****   rc          - associated reconstructed track
*     ****   rs          - associated reconstructed segment
*     ****   hit         - associated hit (hitb)
*     ****   pl          - associated plane
*     ****   sl          - associated superlayer

*     **** called by KUIP

      implicit none
#include "arte/Arte.fi"

      integer hfit, hfit1, hfit2, nt, hit, rc, sl, ipl, pl, nch, rs, 
     +     hit_ass
      character*1 cresp
      character*80 chopts
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"

*     **** parameters
      call kugeti(hfit1)
      call kugeti(hfit2)
      call kugeti(rc  )
      call kugeti(rs  )
      call kugeti(hit)
      call kugeti(pl  )
      call kugeti(sl  )
      call kugetc(chopts,nch)

*     **** fixup
      if (jrhit.le.0) then
         call mewarn('prhfit: table RHIT is not booked')
         go to 999
      endif

      if (hfit2.eq.0) hfit2 = hfit1
      if (hfit1.eq.0) then
       hfit1 = 1
       hfit2 = iq(jrhit+2)
      endif
      hfit1 = max(1,hfit1)
      hfit2 = min(hfit2,iq(jrhit+2))

*     **** header
      write(* ,'(a6,5a8,a10,2a8,4a6,a8)')
     +      'ihf','z','x','y','tx','ty','1/p','q','ipl','rt','rs','ih',
     +     'q(hitb)'
      nt = 0

*     **** print as stored in hfit bank
      do 10 hfit=hfit1,hfit2
       if (rc.gt.0.and.irhit_rtra(hfit).ne.rc) go to 10
       if (rs.gt.0.and.orhit_rseg(hfit).ne.rs) go to 10
       ipl = ihitb_gede(orhit_hitb(hfit))
       if (pl.gt.0.and.ipl.ne.hfit) go to 10
       if (sl.gt.0) then
        if (ipl.ge.1.and.ipl.le.iq(jgede+2)) then
         if (ogede_gesl(ipl).ne.sl) go to 10
        endif
       endif
       if (hit.ne.0.and.orhit_hitb(hfit).ne.hit) go to 10

       nt = nt + 1
       if (orhit_hitb(hfit).gt.0.and.orhit_hitb(hfit).lt.iq(jhitb+2))
     +      then
          hit_ass = orhit_hitb(hfit)
       else
          hit_ass = 0
       endif

       write(* ,'(i6,5f8.2,e10.2,f8.4,4i6,f8.4)')
     +      hfit,fhitb_z(orhit_hitb(hfit)),frhit_x(hfit),frhit_y(hfit),
     +      frhit_tx(hfit),frhit_ty(hfit),frhit_p(hfit),frhit_q(hfit),
     +      ihitb_gede(orhit_hitb(hfit)),irhit_rtra(hfit),
     +      orhit_rseg(hfit),orhit_hitb(hfit),fhitb_q(hit_ass)
       if (mod(nt,100).eq.0) then
        print *,' <any key to continue>'
        read(*,'(a1)') cresp
        if (cresp.eq.'q'.or.cresp.eq.'Q') go to 999
       endif
 10   continue ! hfit loop

 999  end

