//**********************************************************************/
// Created: 23.08.97,   Olya Igonkina   for   MARPLE package
//
// implementation of RcHitBPoint class
//
//**********************************************************************/
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"

#include "marple/marple.hh"
#include "marple/RcHitBPoint.hh"

// returns relation with MTRA 
vector<ArtePointer<MTRA> > RcHitBPoint::mtraList() const
{
  vector<ArtePointer<MTRA> > mList;
  for( ArteRelationIterator<MIMP>   rsMimp = link()->mimp.begin();
       rsMimp != link()->mimp.end();
       ++rsMimp )
    {
      mList.push_back((*rsMimp)->mtra);
    }
  return mList;
}

// returns relation with HITB 
vector<ArtePointer<HITB> > RcHitBPoint::hitbList() const
{
  vector<ArtePointer<HITB> > hList;
  hList.push_back( link() );
  return hList;
}

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitAll()
{ return 0; }

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitForward()
{ return 0; }

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitBack()
{ return 0; }

ostream & operator << (ostream & os, const RcHitBPoint &rp)
{
  const RcPoint * ptPoint = &rp;
  os << *ptPoint;
  os << "            HITB link: " << rp.link() << endl ;
  return os ;
}
