//**********************************************************************/
// Created: 1.10.97  by   Olya Igonkina  for MARPLE package
//
// MARPLE kuip commands
//
//**********************************************************************/

//#ifdef USEKUIP

#include "marple/marple.hh"

NameRcMatchConst Eparameter;

extern "C"
{
  //************************************************************/
  // set all constants
  void FORTRAN_ROUTINE(maall_read )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	  Eparameter = Eall;
	  ptRcConst->read( Eparameter );
	  return;
    }
  //************************************************************/
  // show all constants
  void FORTRAN_ROUTINE(maall_show )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
      cout << *ptRcConst << endl;

    }
  //************************************************************/
  // set chi2 value
  void FORTRAN_ROUTINE(machi2 )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Echi2;
	(*ptRcConst).read( Eparameter );
    }
  //************************************************************/
  //set constants for DELTAS cut 
  void FORTRAN_ROUTINE(madeltas )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Edelta_x;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_y;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_tx;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_ty;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Edelta_pe;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Echi2;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Euse_delta_cut ;
	(*ptRcConst).read( Eparameter  );
    }

  //************************************************************/
  //set constants for PAIR_cut
  void FORTRAN_ROUTINE(mapair_cut )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Euse_pair_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter =En_pair_left;
	(*ptRcConst).read( Eparameter  );
	Eparameter =En_pair_right;
	(*ptRcConst).read( Eparameter  );
    }

  //************************************************************/
  //set which cuts should be used
  void FORTRAN_ROUTINE(macuts )()
    {
      int iType;
      RcMatchConst* ptRcConst = &rcSvdMtConst;
	FORTRAN_ROUTINE(kugeti)(&iType);
	switch (iType)
	  {
	  case 2 :
	    ptRcConst = &rcSvdOtConst ; 
	    break;
	  case 1 :
	  default :
	    ptRcConst = &rcSvdMtConst ; 
	    break;
	  }
	Eparameter = Euse_pair_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Euse_delta_cut;
	(*ptRcConst).read( Eparameter  );
	Eparameter = Eflag;
	(*ptRcConst).read( Eparameter  );
    }
}

//#elseif

//#endif


