*-- Author :       Olya Igonkina   21.03.97
c--------------------------------------------------------------

      subroutine RCMESM ( iGESL, allms) 
************************************************************************
*
* Description: return the average MS-angle from RXE point to the ZMEPLANE
*
* Called from: RCMESW
*
* Arguments:  iGESL - row in the table GESl 
*             allms - average multiple scattering for iGESL
************************************************************************

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "auto/GEO.fi"
C#include "gean/ZGESL.fi"
C#include "pris/zmpack.fi"

      INTEGER iGESL

      DOUBLE PRECISION ALLMS
      DOUBLE PRECISION A, B, A1, B1, VOL, VOL1
      INTEGER          IPL, IERR, INDX

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      ALLMS = 0.D0
      IF(IGESL_SHP(iGESL).EQ.1) THEN ! BOX
         VOL = dble (ABS( (FGESL_X2(iGESL)-FGESL_X1(iGESL))*
     +        (FGESL_Y2(iGESL)-FGESL_Y1(iGESL))*
     +        (FGESL_Z2(iGESL)-FGESL_Z1(iGESL)) ))
      ELSEIF(IGESL_SHP(iGESL).EQ.3 ) THEN ! TRAPESOID
         A1 = dble( ABS(FGESL_X2(iGESL)-FGESL_X1(iGESL)))
         B1 = dble( ABS(FGESL_Y2(iGESL)-FGESL_Y1(iGESL)))
         A  = A1 + 2*dble( ABS(FGESL_DX(iGESL)))
         B  = B1 + 2*dble( ABS(FGESL_DY(iGESL)))
         VOL = dble(ABS((FGESL_Z2(iGESL)-FGESL_Z1(iGESL)) *
     +        (A*B+(A+A1)*(B+B1)+A1*B1)))/6.D0
      ELSEIF(IGESL_SHP(iGESL).EQ.5.or.IGESL_SHP(iGESL).EQ.9) THEN ! TUBE,SPHERE
         VOL = dble(ABS( (FGESL_Z2(iGESL)-FGESL_Z1(iGESL))*
     +        3.1415927*(FGESL_Y1(iGESL)**2-FGESL_X1(iGESL)**2)))
      ELSE
         VOL = dble (ABS( (FGESL_X2(iGESL)-FGESL_X1(iGESL))*
     +        (FGESL_Y2(iGESL)-FGESL_Y1(iGESL))*
     +        (FGESL_Z2(iGESL)-FGESL_Z1(iGESL)) ))
         C78 = 'RCMESM: ISHAP = '
         CALL CH78AI(IGESL_SHP(IPL))
         CALL CH78BC('is not foreseen ')
         ierr = 1111100 + IGESL_SHP(IPL)
         CALL MEMESC(ierr, 1,ILARGEST,C78)
      ENDIF
      
      IF( VOL.LT.0.1E-8 )GO TO 800
      
*     add all GEDE coresponding to this GESL
      INDX = PGESL_GEDE(iGESL)
      DO WHILE( INDX.NE.0)
         IPL = MGESL_GEDE(INDX)
         IF( FGEDE_MS(IPL).LT. -0.1e-5 .OR.FGEDE_MS(IPL).GT.100. )THEN
            C78 = 'RCMESM: GEDE = '
            CALL CH78BI(IPL)
            CALL CH78BC(' has unphysical MS angle ')
            CALL CH78BF(FGEDE_MS(IPL), 8)
            ierr = 45453300 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            GO TO 300
         ELSEIF(IGEDE_SHP(IPL).EQ.1.OR.IGEDE_SHP(IPL).EQ.10)THEN
            VOL1 = dble(abs( (FGEDE_XMAX(IPL)-FGEDE_XMIN(IPL)) *
     +           (FGEDE_YMAX(IPL)-FGEDE_YMIN(IPL)) *
     +           (FGEDE_ZMAX(IPL)-FGEDE_ZMIN(IPL)))) 
         ELSEIF( IGEDE_SHP(IPL).EQ.3)THEN
            A1 = dble(2 * FGEDE_XMIN(IPL) )
            B1 = dble(2 * FGEDE_YMIN(IPL) )
            A  = dble(2 * FGEDE_XMAX(IPL) )
            B  = dble(2 * FGEDE_YMAX(IPL) )
            VOL1 = dble(ABS( (FGEDE_ZMAX(IPL)-FGEDE_ZMIN(IPL)) *
     +           2/3 * (A*B+(A+A1)*(B+B1)+A1*B1)))
         ELSEIF( IGEDE_SHP(IPL).EQ.5)THEN
            VOL1 = dble( ABS( (FGEDE_ZMAX(IPL)-FGEDE_ZMIN(IPL))*
     +           3.1415927*(FGEDE_YMIN(IPL)**2-FGEDE_XMIN(IPL)**2)))
         ELSE
            C78 = 'RCMESM: ISHAP = '
            CALL CH78AI(IGEDE_SHP(IPL))
            CALL CH78BC('is not foreseen ')
            ierr = 3333300 + IGEDE_SHP(IPL)
            CALL MEMESC(ierr, 1,ILARGEST,C78)
         ENDIF
         IF( VOL1 .GT. VOL )THEN
            C78 = 'RCMESM: GEDE '
            CALL CH78BI(IPL)
            CALL CH78BC(' biger that superlayer !!!') 
            ierr = 343000 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            ALLMS = ALLMS + FGEDE_MS(IPL)
         ELSEIF( VOL1 .GT. 0.1e-5 )THEN 
            ALLMS = ALLMS + FGEDE_MS(IPL)*VOL1/VOL
         ELSE
            C78 = 'RCMESM: GEDE '
            CALL CH78BI(IPL)
            CALL CH78BC(' has zero volume !!!') 
            ierr = 44344000 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
         ENDIF
 300     CONTINUE
         INDX = XGESL_GEDE(INDX)
      ENDDO

*     add all GCAL coresponding to this GESL
      INDX = PGESL_GCAL(iGESL)
      DO WHILE( INDX.NE.0)
         IPL = MGESL_GCAL(INDX)
         IF( FGCAL_MS(IPL).LT. -0.1e-5 .OR.FGCAL_MS(IPL).GT.100. )THEN
            C78 = 'RCMESM: GCAL = '
            CALL CH78BI(IPL)
            CALL CH78BC(' has unphysical MS angle ')
            CALL CH78BF(FGCAL_MS(IPL), 8)
            ierr = 45453300 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            GO TO 400
         ELSE
            VOL1 = dble(abs( (FGCAL_XMAX(IPL)-FGCAL_XMIN(IPL)) *
     +           (FGCAL_YMAX(IPL)-FGCAL_YMIN(IPL)) *
     +           (FGCAL_ZMAX(IPL)-FGCAL_ZMIN(IPL)))) 
         ENDIF
         IF( VOL1 .GT. VOL )THEN
            C78 = 'RCMESM: GCAL '
            CALL CH78BI(IPL)
            CALL CH78BC(' biger that superlayer !!!') 
            ierr = 443413200 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            ALLMS = ALLMS + FGCAL_MS(IPL)
         ELSEIF( VOL1 .GT. 0.1e-5 )THEN 
            ALLMS = ALLMS + FGCAL_MS(IPL)*VOL1/VOL
         ELSE
            C78 = 'RCMESM: GCAL '
            CALL CH78BI(IPL)
            CALL CH78BC(' has zero volume !!!') 
            ierr = 42144000 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
         ENDIF
         INDX = XGESL_GCAL(INDX)
 400     continue
      ENDDO
*     add all GWAL coresponding to this GESL
      INDX = PGESL_GWAL(iGESL)
      DO WHILE( INDX.NE.0)
         IPL = MGESL_GWAL(INDX)
         IF( FGWAL_MS(IPL).LT. -0.1e-5 .OR.FGWAL_MS(IPL).GT.1. )THEN
            C78 = 'RCMESM: GWAL = '
            CALL CH78BI(IPL)
            CALL CH78BC(' has unphysical MS angle ')
            CALL CH78BF(FGWAL_MS(IPL), 8)
            ierr = 4565500 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            GO TO 500
         ELSEIF(IGWAL_SHP(IPL).EQ.1.OR.IGWAL_SHP(IPL).EQ.10)THEN
            VOL1 = dble(abs( (FGWAL_XMAX(IPL)-FGWAL_XMIN(IPL)) *
     +           (FGWAL_YMAX(IPL)-FGWAL_YMIN(IPL)) *
     +           (FGWAL_ZMAX(IPL)-FGWAL_ZMIN(IPL)) ))
         ELSEIF( IGWAL_SHP(IPL).EQ.3)THEN
            A1 = dble(2 * FGWAL_XMIN(IPL))
            B1 = dble(2 * FGWAL_YMIN(IPL))
            A  = dble(2 * FGWAL_XMAX(IPL))
            B  = dble(2 * FGWAL_YMAX(IPL))
            VOL1 = dble(ABS( (FGWAL_ZMAX(IPL)-FGWAL_ZMIN(IPL)) * 
     +           2/3 * (A*B+(A+A1)*(B+B1)+A1*B1)))
         ELSEIF( IGWAL_SHP(IPL).EQ.5)THEN
            VOL1 = dble(ABS( (FGWAL_ZMAX(IPL)-FGWAL_ZMIN(IPL))*
     +           3.1415927*(FGWAL_YMIN(IPL)**2-FGWAL_XMIN(IPL)**2)))
         ELSEIF( IGWAL_SHP(IPL).EQ.7)THEN
            VOL1 = dble(ABS( (FGWAL_ZMAX(IPL)-FGWAL_ZMIN(IPL))*
     +           3.1415927*(FGWAL_YMIN(IPL)**2-FGWAL_XMIN(IPL)**2)))
         ELSE
            C78 = 'RCMESM: ISHAP = '
            CALL CH78AI(IGWAL_SHP(IPL))
            CALL CH78BC('is not foreseen ')
            ierr = 445552400 + IGWAL_SHP(IPL)
            CALL MEMESC(ierr, 1,ILARGEST,C78)
         ENDIF
         IF( VOL1 .GT. VOL )THEN
            C78 = 'RCMESM: GWAL '
            CALL CH78BI(IPL)
            CALL CH78BC(' biger that superlayer !!!') 
            ierr = 4531500 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
            ALLMS = ALLMS + dble(FGWAL_MS(IPL))
         ELSEIF( VOL1 .GT. 0.1e-5 )THEN 
            ALLMS = ALLMS + dble(FGWAL_MS(IPL))*VOL1/VOL
         ELSE
            C78 = 'RCMESM: GWAL '
            CALL CH78BI(IPL)
            CALL CH78BC('has zero volume !!!') 
            ierr = 446500 + IPL
            CALL MEMESC(ierr, 1,ILARGEST,C78)
         ENDIF
         INDX = XGESL_GWAL(INDX)
 500     CONTINUE
      ENDDO
 800   continue
      
 999   return
       end
**********************************************************************
* END OF RCMESM
*********************************************************************

