* B.Fominykh  28.05.98
* one step of kalman fit
* input:  ITRP   =0 - nomal operation
*                =1 - only transport the parameters
*                =2 - no hit rejection
* output: IOUT=0    - O.K., hit accepted
*             =1    - hit rejected
*         DDOUT     - residual
*         EXTOUT    - error of extrapolation
*         CHIOUT    - chi**2 
*
      SUBROUTINE MURKALF(ITRP,IOUT,DDOUT,EXTOUT,CHIOUT)
C-    =====================================================
      IMPLICIT NONE
#include "murec/MUCKALF.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCPAR.fi"
#include "arte/Arte.fi"
      INTEGER I,J,K,L,ITRP,IOUT
      REAL DDOUT,CHIOUT,EXTOUT,WW
      DOUBLE PRECISION H(4),AK(4),WWD,QNS(4),TR(4,4)
      DOUBLE PRECISION PARN(4),COVN(4,4)
      DOUBLE PRECISION DT,DD,SIGE,SIGT,SIGF,CHI
      DOUBLE PRECISION SIGADD
#include "arte/Arte.ff"
*     ------------------
      SIGADD=15.
      IOUT=1
      DDOUT=0.
      CHIOUT=0.
      IF(ITMEAS.LT.1.OR.ITMEAS.GT.3) RETURN
*
      IF(IPRSC.GE.5)
     + PRINT 1003, ITMEAS,ZMEAS,SINROT,COSROT,DMEAS
      IF(IPRLG.GE.5)
     + WRITE(LLOGF,1003) ITMEAS,ZMEAS,SINROT,COSROT,DMEAS
 1003 FORMAT(1X,'MURKALF: IT',I2,' z,sin,cos',F8.1,2F8.3,' d',F8.3)
*
* transport matrix
      DO I=1,4
        DO J=1,4
          TR(I,J)=0.
          COVN(I,J)=0.
        ENDDO
          TR(I,I)=1.
      ENDDO
      TR(1,3)=ZMEAS-PARAM(1)
      TR(2,4)=TR(1,3)
* transport parameters
      DO I=1,4
        PARN(I)=0.
        DO J=1,4
          PARN(I)=PARN(I)+PARAM(J+1)*TR(I,J)
        ENDDO      
      ENDDO      
* transport covariance
      DO I=1,4
        DO J=1,4
          DO K=1,4
          DO L=1,4
            COVN(I,J)=COVN(I,J)+TR(I,L)*COV(L,K)*TR(J,K)
          ENDDO
          ENDDO
        ENDDO
      ENDDO

      IF(ITRP.EQ.1) GOTO 77

* projection matrix
      IF(ITMEAS.EQ.1) THEN
        H(1)=1.
        H(2)=0.
        H(3)=0.
        H(4)=0.
      ENDIF
      IF(ITMEAS.EQ.2) THEN
        H(1)=0.
        H(2)=1.
        H(3)=0.
        H(4)=0.
      ENDIF
      IF(ITMEAS.EQ.3) THEN
        H(1)=COSROT
        H(2)=-SINROT
        H(3)=0.
        H(4)=0.
      ENDIF
* process-noise
      IF(SIGMS1.GT.0.) THEN
        QNS(1)=SIGMS1**2
        QNS(2)=SIGMS1**2
        QNS(3)=0.33*THTMSC
        QNS(4)=0.33*THTMSC
* correct covariance
        DO I=1,4
          COVN(I,I)=COVN(I,I)+QNS(I)
        ENDDO
      ENDIF
      COVN(1,3)=COVN(1,3)+0.87*SQRT(QNS(1)*QNS(3))
      COVN(3,1)=COVN(1,3)
      COVN(2,4)=COVN(2,4)+0.87*SQRT(QNS(2)*QNS(4))
      COVN(4,2)=COVN(2,4)
* prediction step
*
* extrapolation of track to z-position of hit
      DT=0.
      DO I=1,4
        DT=DT+H(I)*PARN(I)
      ENDDO
* residual
      DD=DMEAS-DT
      IF(DABS(DD).GT.1.E+4) GOTO 200
* error of extrapolation
      SIGE=0.
      DO I=1,4
      DO J=1,4
        SIGE=SIGE+H(I)*COVN(I,J)*H(J)
      ENDDO
      ENDDO
* errors
      SIGT=SIGE+SMEAS**2+SIGMS1**2
      IF(ITRP.NE.2) SIGT=SIGT+SIGADD
*      SIGF=SIGE+SMEAS**2+SIGMS2**2
* chi**2 contribution
      CHI=DD*DD/SIGT
***      CHI=DD*DD/SIGF
      IF(IPRSC.GE.4)
***     +   PRINT 1002, SIGE,SMEAS**2,SIGT,SIGF,
     +   PRINT 1002, SIGE,SMEAS**2,SIGT,
     +                    DMEAS,DT,DD,CHI
      IF(IPRLG.GE.4)
***     +   WRITE(LLOGF,1002) SIGE,SMEAS**2,SIGT,SIGF,
     +   WRITE(LLOGF,1002) SIGE,SMEAS**2,SIGT,
     +                    DMEAS,DT,DD,CHI
*** 1002 FORMAT(1X,'er2(extr,meas,SIGt.f):',4E10.3,
 1002 FORMAT(1X,'er2(extr,meas,SIGT):',3E10.3,
     +      /,5X,'dm,dt,dd',3F9.3,' chi',E12.4)
*
* filter step
*
      IF(ITRP.NE.2.AND.CHI.GT.CHICUT) THEN
        IF(IPRSC.GE.4)
     +  PRINT*, '*** MURKALF: hit rejected',CHI,CHICUT
        IF(IPRLG.GE.4)
     +  WRITE(LLOGF,*) '*** MURKALF: hit rejected',CHI,CHICUT
        GOTO 200
      ENDIF
      IF(ITRP.EQ.2.AND.CHI.GT.CHICUT) SIGT=SIGT+100.
*
* gain matrix
      DO I=1,4
      AK(I)=0.
      DO J=1,4
        AK(I)=AK(I)+COVN(I,J)*H(J)/SIGT
***        AK(I)=AK(I)+COVN(I,J)*H(J)/SIGF
      ENDDO
      ENDDO
* update track parameters
      DO I=1,4
        PARN(I)= PARN(I)+AK(I)*DD
      ENDDO
* update covariance
      DO I=1,4
        DO J=1,4
          DO K=1,4
            COVN(I,J)=COVN(I,J)-AK(I)*H(K)*COVN(K,J)
          ENDDO
        ENDDO
      ENDDO
* save parameter and covariance
 77    CONTINUE
       PARAM(1)=ZMEAS 
       DO I=1,4
         PARAM(I+1)=PARN(I)
         DO J=1,4
           COV(I,J)=COVN(I,J)
         ENDDO
       ENDDO
      IOUT=0
      DDOUT=DD
      CHIOUT=CHI
      EXTOUT= SIGE
  200 CONTINUE
      RETURN
      END
