*-- Author :    Rainer Mankel   21/12/93

      subroutine diiso(iihit)

*     **** display drift time circles around hit
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
      integer iihit, ipl, isl, isltyp, imc, mimp, nhmimp
      real xx, yy, rr, sna, ey, dx
      real sn, cs, zwire, dd, sr, rota, sntot, cstot
      real tg, xredwire, zhitmc, a, r, beta, x0, y0, z0, mx,xmin,xmax,
     +     ymin,ymax
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"

*     **** works only in xz- and yz-views, except for backup sol,
*     **** where it works only in xy

      if (fscalzg(1).ne.1..or.fscalzg(2).ne.1.
     +     .or.fscalzg(3).ne.1.) then
         print *,' () diiso: scale factors active, fscalzg=',fscalzg
      endif

*     **** check plane
      ipl = ihitb_gede(iihit)
      isl = ogede_gesl(ipl)
      isltyp = igesl_cmp(isl)

      if (iviewzg.ne.1.and.iviewzg.ne.2.and.iviewzg.lt.7) then
         go to 999
      endif

      xmin = 1.5 * xminzg - 0.5 * xmaxzg ! prepare SW clipping
      xmax = 1.5 * xmaxzg - 0.5 * xminzg
      ymin = 1.5 * yminzg - 0.5 * ymaxzg
      ymax = 1.5 * ymaxzg - 0.5 * yminzg

      sntot  = fgede_sin(ipl) * fgede_rot(1,ipl) ! total rotation angle
     +     + fgede_cos(ipl) * fgede_rot(2,ipl)
      cstot = fgede_cos(ipl) * fgede_rot(1,ipl)
     +     - fgede_sin(ipl) * fgede_rot(2,ipl)

      if (isltyp.eq.2) then     ! straw type
         sn = fgede_sin(ipl)    ! 0-deg ?
         cs = fgede_cos(ipl)
         sna = abs(fgede_sin(ipl))
         rota = abs(fgede_rot(2,ipl))
         sna = max(sna,rota)

         call igset('PLCI',cocirzg) ! colour index

         if (abs(sntot).lt.0.001.and.iviewzg.eq.1) then
            xx = fhitb_z(iihit) ! coordinates of hit
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif
            rr = abs( fhitb_q(iihit) ) ! radius
            call igarc(xx,yy,rr,rr,0.,0.) ! draw circle
         elseif (abs(sntot).gt.0.001.and.iviewzg.eq.2) then
            call tuhmimp(iihit,imc,mimp,nhmimp) ! y coordinate of center
            if (nhmimp.gt.0.and.mimp.gt.0) then
               sn = sntot
               cs = cstot
               tg = sn / cs
               zwire = fhitb_z(iihit)
               xredwire = fhitb_x(iihit) / cstot
               dd = abs( fhitb_q(iihit) )

               zhitmc = fmimp_z(mimp) ! get parameters of xz constraint
               mx = fmimp_tx(mimp)
               x0 = fmimp_x(mimp) + (zwire - zhitmc) * mx
               z0 = zwire
               y0 = (x0 - xredwire) / tg
               if (lsclipzg) then ! SW clipping
                  if (z0.lt.xmin) go to 999
                  if (z0.gt.xmax) go to 999
                  if (y0.lt.ymin) go to 999
                  if (y0.gt.ymax) go to 999
               endif
               a = dd / abs(sntot) ! half-axes for mx=0
               r = dd
               beta = mx / tg

               call dielsh(z0, y0, r, a, beta) ! draw sheared ellipse
            endif
         elseif (sntot.gt.0.001.and.iviewzg.eq.7) then
            xx = fhitb_z(iihit)
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif

            rr = abs( fhitb_q(iihit) ) ! radius
            call igarc(xx,yy,rr,rr,0.,0.) ! draw circle
         elseif (sntot.lt.-0.001.and.iviewzg.eq.8) then
            xx = fhitb_z(iihit)
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif
            rr = abs( fhitb_q(iihit) ) ! radius
            call igarc(xx,yy,rr,rr,0.,0.) ! draw circle
         endif

      elseif (isltyp.eq.1.or.isltyp.eq.3) then ! strip device hits

         sn  = fgede_sin(ipl)   ! 0-deg ?
         cs = fgede_cos(ipl)
         sr = fgede_rot(2,ipl)
         sna = abs(fgede_sin(ipl))
         rota = abs(fgede_rot(2,ipl))
         sna = max(sna,rota)

         call igset('PLCI',cocirzg) ! color index
         call igset('BORD',1.)
         call igset('FACI',5.)

         if (sna.lt.0.001.and.iviewzg.eq.1) then
            xx = fhitb_z(iihit) ! coordinates of hit
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif
            ey = fhitb_r(iihit) * 1.73
            dx = 0.2
            call igbox(xx-dx,xx,yy-ey,yy+ey) ! draw rectangle
         elseif (sna.gt.0.001.and.iviewzg.eq.2) then
            call tuhmimp(iihit,imc,mimp,nhmimp) ! y coordinate of center
            if (nhmimp.gt.0.and.mimp.gt.0) then
               sn = fgede_sin(ipl)
               cs = fgede_cos(ipl)
               tg = sn / cs
               zwire = fhitb_z(iihit)
               xredwire = fhitb_x(iihit) / fgede_cos(ipl)

               xx = fhitb_z(iihit) ! get parameters of xz constraint
               yy = (fmimp_x(mimp) - xredwire) / tg
               if (lsclipzg) then ! SW clipping
                  if (xx.lt.xmin) go to 999
                  if (xx.gt.xmax) go to 999
                  if (yy.lt.ymin) go to 999
                  if (yy.gt.ymax) go to 999
               endif
               ey = fhitb_r(iihit) * 1.73 / sna
               dx = 0.2
               call igbox(xx-dx,xx,yy-ey,yy+ey) ! draw rectangle
            endif

         elseif (sr.gt.0.001.and.iviewzg.eq.7) then
            xx = fhitb_z(iihit)
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif
            ey = fhitb_r(iihit) * 1.73
            dx = 0.2
            call igbox(xx-dx,xx,yy-ey,yy+ey) ! draw rectangle
         elseif (sr.lt.-0.001.and.iviewzg.eq.8) then
            xx = fhitb_z(iihit)
            yy = fhitb_x(iihit)
            if (lsclipzg) then  ! SW clipping
               if (xx.lt.xmin) go to 999
               if (xx.gt.xmax) go to 999
               if (yy.lt.ymin) go to 999
               if (yy.gt.ymax) go to 999
            endif
            ey = fhitb_r(iihit) * 1.73
            dx = 0.2
            call igbox(xx-dx,xx,yy-ey,yy+ey) ! draw rectangle
         endif

      else                      ! invalid type
      endif

 999  end







