
>Name DIKUIP

>Menu DISPLAY
>Guidance
Commands related to the event visualisation tool prism.

>Command DETECTOR
>Parameters
+
ISLFIRST 'Id of first superlayer to be displayed' I D=0
ISLLAST  'Id of last  superlayer to be displayed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Display detector within scope defined by the display/scope command.
Optionally restrict to a given superlayer range. 
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -V : show vertices
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DIDET

>Command SUPERLAYER
>Parameters
+
ISLFIRST 'Id of first superlayer to be displayed' I D=0
ISLLAST  'Id of last  superlayer to be displayed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Display range of superlayers.
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -V : show vertices
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DISUPL

>Command PLANE
>Parameters
IPL 'Id of plane' I D=28
+
CHOPT 'Options' C D=' '
>Guidance
Display plane IPL.
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DISPL

>Command DRAW

>Guidance
(Re)draw the detector using the latest (or default) set of redraw
parameters.

>Action DIDRAW

>Command STYLE
>Parameters
+
MTMIMP 'use mimps to draw MC tracks (y/n) ?' C D=' '
RTRHIT 'use rhits to draw RC tracks (y/n) ?' C D=' '
CR*OSS  'draw crosses at rhit position (y/n) ?' C D=' '
O*PAQUE 'draw opaque detector planes (y/n) ?' C D=' '
H*EADER 'draw header (y/n) ?' C D=' '
F*RAME  'draw frame (y/n) ?' C D=' '
AX*IS   'draw axes (y/n) ?' C D=' '
T*YPE   'draw particle type string (y/n) ?' C D=' '
ST*EREO 'show stereo plane (y/n) ?' C D=' '
BA*CKGROUND 'use background colour (y/n) ?' C D=' '
MT*RA   'show MC tracks (y/n) ?' C D=' '
B0      'restrict to golden B0 daughters (y/n) ?' C D=' '
RT*RA   'show RC tracks (y/n) ?' C D=' '
MI*MPS  'show MIMPS (y/n) ?' C D=' '
QU*ANT  'show QUANTITY (y/n) ?' C D=' '
HI*T    'show wires/hits (y/n) ?' C D=' '
AS*PECT 'force conserved aspect ratio (y/n) ?' C D=' '
GW*AL   'draw walls (y/n) ?' C D=' '
SE*NS   'use sensitive areas for drawing planes (y/n) ?' C D=' '
MV*ER   'draw MC vertices (y/n) ?' C D=' '
GE*DE   'draw planes (y/n) ?' C D=' '
SC*LIP  'apply software clipping (y/n) ?' C D=' '
NE*UT   'show neutral MC particles (MTRA must be active) (y/n) ?' C D=' '
CH*AIN  'show whole decay chain (y/n) ?' C D=' '
EV*ER   'show end vertices (y/n) ?' C D=' '
MAG*NET 'show magnet (y/n) ?' C D=' '
RV*ER   'show reconstructed vertices (y/n) ?' C D=' '
SPL*INE 'use spline to display tracks in magnet (y/n) ?' C D=' '
RS*EG   'show reconstructed segments (y/n) ?' C D=' '
CE*LL   'show detector cells (y/n) ?' C D=' '
TA*RGET 'show target (y/n) ?' C D=' '
WIDMT   'width factor of MC lines' R D=0.
WIDRT   'width factor of RC lines' R D=0.
CHOPT   'Options' C D=' '
>Guidance
Set parameters which influence the drawing style.
Option L displays the current values.

Options:
  -L : display current option values

>Action DISTYLE

>Command SCOPE
>Parameters
+
SCOPE1  'Scope descriptor' C D=' '
SCOPE2  'Scope descriptor' C D=' '
SCOPE3  'Scope descriptor' C D=' '
SCOPE4  'Scope descriptor' C D=' '
SCOPE5  'Scope descriptor' C D=' '
SCOPE6  'Scope descriptor' C D=' '
SCOPE7  'Scope descriptor' C D=' '
SCOPE8  'Scope descriptor' C D=' '
SCOPE9  'Scope descriptor' C D=' '
SCOPE10 'Scope descriptor' C D=' '
SCOPE11 'Scope descriptor' C D=' '
SCOPE12 'Scope descriptor' C D=' '
SCOPE13 'Scope descriptor' C D=' '
SCOPE14 'Scope descriptor' C D=' '
SCOPE15 'Scope descriptor' C D=' '
CHOPT   'Options' C D=' '
>Guidance
Define the display scope through descriptors for superlayer names.
Option 'L' just lists the current scope, ignoring all other arguments.

The scope arguments may be superlayer names - including a trailing
asterisk as placeholder - or a predefined group name. Examples:

  display/scope TC*        - display OT trigger chambers only
  display/scope SI08 SI09  - display some magnet silicons only
  display/scope MX*        - display muon pixel chabmers only

Valid group names:

  SIVD  - all silicons with z<200cm
  MAIN  - all silicon, MSGC and HDC trackers with z>200cm
  FULL  - all silicon, MSGC and HDC trackers
  IMAIN - all inner main trackers
  OMAIN - all outer main trackers
  MAG   - all magnet trackers
  IMAG  - all inner magnet trackers
  OMAG  - all outer magnet trackers
  PAT   - all pattern trackers
  IPAT  - all inner pattern trackers
  OPAT  - all outer pattern trackers
  TRIG  - all trigger trackers
  ITRIG - all inner trigger trackers
  OTRIG - all outer trigger trackers
  ECAL  - calorimeter
  MUON  - all muon chambers
  PT    - all high-pt trigger chambers

Example:

  display/scope SIVD IMAG     - display vertex detector and inner 
                                magnet tracker

Options:
  -I  : add items to present scope
  -O  : remove items from present scope
  -L  : list present scope

Example:

  display/scope MS03 -O       - remove MS03 from present scope

>Action DIKSCOPE


>Command PARAMETERS
>Parameters
+
MT*RA   'Restrict to MC track ' I D=-1
RT*RA   'Restrict to RC track ' I D=-1
CMP     'Restrict to component ' I D=-1
LAYER   'Restrict to layer' I D=-1
SECTOR  'Restrict to sector' I D=-1
TOPP    'Restrict to particle type' I D=0
CTOPP   'Restrict no particle name' C D=' '
CHOPT   'Options' C D=' '
>Guidance
Define parameters for subsequent display/draw commands.
Option -R resets all parameters
>Action DIKPARAM

>Command FRAME
>Parameters
+
XLEFT  'Left   x bound of frame ' R D=0.0
XRIGHT 'Right  x bound of frame ' R D=0.0
YLOW   'Lower  y bound of frame ' R D=0.0
YHIGH  'Higher y bound of frame ' R D=0.0
CHOPT 'Options' C D=' '
>Guidance
Define new frame via explicit world coordinates, or via rubberband.
Option 'R' resets to original frame.

Options:
  -R : reset to standard frame. The standard frame is determined from
       the detector dimensions in x,y,z projected into the current
       view

  -B : go back to the previous frame. prism remembers the five last 
       frames.

  -I : Zoom in (2x)

  -O : Zoom out (2x)

  -N : No automatic redraw

>Action DIFRAM

>Command ANGLES
>Parameters
THETA 'Polar angle of observers view' R D=70. R=-180.:180.
PHI   'Azimuth angle of observers view' R D=0. R=-360.:360.
+
CHOPT 'Options' C D=' '
>Guidance
Define the 3D viewing angles used for view 3.

Options:

  -N : No automatic redraw

>Action DIANGL

>Command SCALE
>Parameters
+
FSCALX 'x axis scale factor' R D=1.
FSCALY 'y axis scale factor' R D=1.
FSCALZ 'z axis scale factor' R D=1.
>Guidance
Define additional scaling factors for each axis.

>Action DISCAL

>Command VIEW
>Parameters
+
IVIEW 'Identifier of view selection' I D=-1
CHOPT 'Options' C D=' '

>Guidance
Select the VIEW identifier, which determines the detector projection
into the twodimensional plane.
Possible values:

    IVIEW = 0      xy projection
            1      xz     
            2      yz     
            3      free 3D   (see ANGLES command)
            4      isometric projection
            5      dimetric     
            6      trimetric
            7      u
            8      v
            9      cone-corrected
           10      cone-corrected, pseudo-logarithmic x-scale

Any other integer keeps the view unchanged.

Options:
  -F : view is directed forward in z (relevant for hidden lines removal)
  -B : view is directed backward in z (standard)
  -N : No automatic redraw


>Action DIVIEW

>Command HEADER
>Guidance
Draw prism header & edge on top of current picture.
>Action DIKHEAD

>Command CLIP
>Parameters
ICLIP 'Clipping mode' I D=1 R=0,1

>Guidance
See HIGZ manual under ISCLIP

>Action DICLIP

>Command SELNT
>Parameters
NT 'Normalization transform id' I D=1

>Guidance
See HIGZ manual under ISELNT

>Action DISELNT

>Command COLOR
>Parameters

CR  'Red volume' R D=1.0
CG  'Green volume' R D=1.0
CB  'Blue volume' R D=1.0

>Guidance
Test a color mixture in rgb space.

>Action DICOLR

>Command SETCOL
>Parameters
+
IC  'Color index'  I D=15
CR  'Red volume'   R D=1.0
CG  'Green volume' R D=1.0
CB  'Blue volume'  R D=1.0
CHOPT 'Options' C D=' '

>Guidance
Add/change colour mixture. Option -L displays colors defined.

Note:
Use the ASSIGNCOL command without parameters to see which colour
indices are already used.


>Action DISETC

>Command ASSIGNCOL
>Parameters

OBJECT 'Object to be assigned' C D=' '
COLOR  'Color index'  I D=-1

>Guidance
Assign color index to object name.
If the color index is not predefined it must have been generated
from rgb code by the SETCOL command.

If no OBJECT argument is given, the current assignments will be listed.

>Action DIASSC


>Command PICK
>Parameters
PICKITEM  'Kind of item to be picked' C D=' '

>Guidance
Pick graphical objects in display window. Possible pick items are:

      MTRA  - pick Monte Carlo track
      RTRA  - pick reconstructed track 
      MImp  - pick Monte Carlo impact point
      Hit   - pick detector hit
      Gede  - pick detector plane
      MV    - pick Monte Carlo vertex   (planned)
      RV    - pick reconstructed vertex (planned)
      Gwal  - pick wall                 (planned)

>Action PKPICK


>Command DQUERY

>Guidance
Query status of graphical workstations

>Action DIQUERY


>Command SAVE
>Parameters

KUNAME  'Name of KUMAC file where parameters should be saved ' C D='dummy.kumac'
+
KUDIR   'Directory in which to store KUMAC file' C D=' '

>Guidance
Store graphics constants (frame etc) to a KUIP macro

>Action DISAVE

