*-- Author :    Rainer Mankel   19/03/96

      subroutine dirinit()

*     **** core initialization for prism, subset of diinit

*     **** dirinit assumes:
      !      - iginit has already been called
      !      - igsse         "
      !      - metafile has already been opened
      !      - igmeta(...,-112) has already been called
      !      - igrng for A4L          "

      implicit none
      integer ierfil, kwktyp, lun_ps, lun_iz, istat
      real rval(12)
      character*80 cfile
      parameter (ierfil=6,lun_ps=49,lun_iz=54)
#include "pris/zgraf.fi"
#include "arte/Arte.fi"

*     **** defaults in common /zgraf/
      mdrfzg = 1

*     **** view direction in z
      idirzg = -1

*     **** view angles
      thetzg = +70.
      phizg  =   0.

      call diudef()             ! view angle for view 7/8

*     **** axes scale factors
      fscalzg(1) = 1.
      fscalzg(2) = 1.
      fscalzg(3) = 1.


*     **** set initial parameters for redraw
      modezg = 1
      sl1zg = 1
      sl2zg = 39
      plzg = 0
      mczg = 0
      rczg = 0
      mvzg = 0
      rvzg = 0
      layerzg = 0
      sectorzg = 0
      cmpzg = 0
      toppzg = 0
      choptzg = ' '

*     **** initialize the display scope
      call discope('   ',0.,9999.,0)
      call discope('SI*',0.,9999.,1)
      call discope('MS*',0.,9999.,1)
      call discope('MC*',0.,9999.,1)
      call discope('PC*',0.,9999.,1)
      call discope('TC*',0.,9999.,1)
      call discope('RICH',0.,9999.,1)

*     **** define colours for detector
      ncolzg = 0
*     **** square fill in LOGO (default: light green)
      call dicozg(11,.5,1.,.5)
      coloqzg = 11
      coltvzg = 5        ! logo triangle volume (plain yellow)
      colcvzg = 2        ! logo circle volume (plain red)
*     **** backgound color (default: light red)
      call dicozg(0 ,1.,.9,.9)
*     **** display box fill (default: light blue)
      call dicozg(13,.9,.9,1.)
      codiszg = 13
*     **** light magenta
      call dicozg(14,1.,.9,1.)
*     **** text and axes (default: plain blue)
      call dicozg(15,0.,0.,1.)
      cotxtzg = 15
*     **** MC particles (default: plain red)
      call dicozg(16,1.,0.,0.)
      comczg = 16
*     **** MIMPs
      comimzg = 1
*     **** RC particles (default: plain blue)
      call dicozg(17,0.,0.,1.)
      corczg = 17
*     **** circles etc (default: plain green)
      call dicozg(18,0.,1.,0.)
      cocirzg = 4
*     **** magnetic field volume (default: light pink)
      call dicozg(19,1.,.8,1.)
      comavzg = 19
*     **** magnetic field border (default: pink)
      call dicozg(20,1.,0.,1.)
      comabzg = 20
      call dicozg(21,1.,1.,.8)
      corivzg = 21              ! magnetic field volume
      call dicozg(22,1.,1.,0.)
      coribzg = 22              ! magnetic field border

      call dicozg(23,1.,0.855,0.725) ! PeachPuff

      coplvzg = 23.             ! plane volume

      call dicozg(24,0.,0.8,0.) ! darker green
      cowirzg = 24.             ! wires

      coplbzg = 1.              ! plane border
      cowavzg = 5.              ! wall volume
      cowabzg = 3.              ! wall border

      call dicozg(25,0.9,1.0,0.9) ! light green/grey
      call dicozg(26,0.7,0.8,0.7) ! medium green/grey
      coca1zg = 25.             ! ECAL colours
      coca2zg = 26.
      coca3zg = 3.
      coca4zg = 5.
      coca5zg = 2.
      widmczg = 6.
      widrczg = 6.
      cobaczg = 27.
      call dicozg(27,1.,.9,.9)  ! backgound color (default: light red)

      call dicozg(28,0.,.7,0.)  ! dark green
      corszg = 28               ! reconstructed segments

      call dicozg(29,.7,1.,.7)  ! very light green
      cocevzg = 29              ! cell volume
      cocebzg = 1               ! cell border
      cotarzg = 4.              ! target

*     **** check number of colours on workstation
      call igqwk(1,'HWCO',rval)
      if (rval(1).lt.2.1) then
*        **** fixup for cheap monochrome Xterms
         print *,' This workstation supports ', rval(1), ' colours'
         coloqzg = 11           ! square fill in LOGO
         call dicozg(12,1.,1.,1.) ! triangle fill in LOGO
         call dicozg(0 ,1.,1.,1.) ! backgound color
         codiszg = 0            ! display box fill
         cotxtzg = 1            ! text and axes
         cowirzg = 1            ! wires
         comczg = 1             ! MC particles
         comimzg = 1            ! mimps
         corczg = 1             ! RC particles
         corszg = 1             ! RSEGs
         cocirzg = 1            ! circles etc
         comavzg = 0            ! magnetic field volume
         comabzg = 1            ! magnetic field border
         corivzg = 0            ! RICH volume
         coribzg = 1            ! RICH border
         coplvzg = 0.           ! plane volume
         coplbzg = 1.           ! plane border
         cowavzg = 0.           ! wall volume
         cowabzg = 1.           ! wall border
         cobaczg = 0.           ! background
         cotarzg = 1.           ! target
      endif


*     **** set default options
      lmcmimpzg = .true.  ! if .true., use mimps to draw MC tracks
      lrcrhitzg = .true.  ! if .true., use rhits to draw RC tracks
      lcrosszg  = .false. ! if .true., draw crosses at rhit position
      lopaquezg = .false. ! if .true., draw opaque planes
      lheaderzg = .true.  ! if .true., draw header
      lframezg  = .true.  ! if .true., draw frame
      laxiszg   = .true.  ! if .true., draw axes
      ltypezg   = .false. ! if .true., draw particle name string
      lstereozg = .false. ! if .true., show stereo plane borders
      lbackzg   = .true.  ! if .false. omit background
      lmczg     = .true.  ! if .true., draw MC tracks
      lb0zg     = .false. ! if .true., restrict to golden B0
      lrczg     = .false. ! if .true., draw RC tracks
      lmimpzg   = .false. ! if .true., draw mimps
      lwirezg   = .false. ! if .true., draw wires/hits
      lquantzg  = .false. ! if .true., draw quantity
      laspectzg = .true.  ! if .true., force conserved aspect ratio
      lwallzg   = .false. ! if .true., draw walls
      lsenszg   = .false. ! if .true., draw borders of sensitive areas
      lmverzg   = .true.  ! if .true., draw MC vertices
      lplanzg   = .true.  ! if .true., draw planes
      lsclipzg  = .true.  ! if .true., do software clipping
      lneutzg   = .false. ! if .true., show neutrals
      lchainzg  = .false. ! if .true., show whole decay chain
      leverzg   = .true.  ! if .true., show end vertices
      lmagnetzg = .true.  ! if .true., show magnet
      lrverzg   = .false. ! if .true., show reconstructed vertices
      lsplinezg = .false. ! if .true., use spline for magnet tracks
      lcellzg   = .false. ! if .true., draw detector cells
      ltargzg   = .false. ! if .true., show target 

      iviewzg = 1
      iframzg = 1
      call difrno()
      vpxzg = 0
      vpyzg = 0
      call divpset()

*     **** clipping
      call isclip(1)

**      call iscr(8,.7,.9,1.)

*     **** print logo
      call isclip(0)
      call iscr(1,0,0.,0.,0.)   ! black background
      call iclrwk(0,1)
**      call dititl(70.*uxzg,0.,70.*uxzg,70.*uyzg)
**      call dititl(70.*uxzg,0.,35.*uxzg,35.*uyzg)
      call iselnt(nt_pictzg)
      call dititl(50.,50.,35.,35.)
      call iuwk(0,1)
      call iscr(1,0,1.,1.,1.)   ! normal background
      call iselnt(nt_framzg)
      call isclip(1)

      end


