// Author V.Balagura (balagura@mail.desy.de)   (28.10.98).

/* This is the comparator class for comparing doubles. It defines the
   equality with the accuracy given as the argument to the constructor.
   
   Usage: LessDouble ld(1.e-5); // default is 1.e-6
          map<double, string, LessDouble> m(ld);
          ...
   */

#ifndef LessDouble_hh
#define LessDouble_hh 1

class LessDouble {
  double epsilon;
public:
  LessDouble(double accuracy = 1e-6) : epsilon(accuracy) {}
  bool operator()(double x1, double x2) const { return x1 < x2 - epsilon; }
};

#endif
