// Functions for HPT dptc-->hitb translation.  05.04.99
// Author:  V.Popov

#include <stdlib.h>
#include <stdio.h>
#include "arte/Arte.h"
#include "auto/GEDE.h"
#include "auto/GESL.h"

extern "C" {
  //void fillh_(int &, float*);
void ptfillh_(int*, float*);
}
extern unsigned int ptSwapBytes(unsigned int );

enum { HOT_LMAX = 33 };

static int mxyz[3][1024], ptfpl[3],ptnpl[3];
static unsigned int hot[HOT_LMAX];
static float x0[3]= { 0.,-17.0,-18.0};
static float y0[3]= { 0., 0., 0. };
static float zz[3]= { 468.75, 558.25, 604.75 };
static float csiz[3]= { 8., 9.5, 10.4 };

int get_ix(int ih) { return(mxyz[0][ih]);}
int get_iy(int ih) { return(mxyz[1][ih]);}
int get_iz(int ih) { return(mxyz[2][ih]);}

enum { PTC_ID = 4};

void GetNpl()
{
int i;
  printf("nsl=%d\n",NGESL());
  for(i=0; i<NGESL(); ++i) {
    GESL& ges = GESL(i);
    if(ges.cmp==PTC_ID) {
      ptfpl[ges.nsl-1]=ges.fpl;
      ptnpl[ges.nsl-1]=ges.npl;
      printf("cmp=%d nsl=%d npl=%d fpl=%d\n",ges.cmp,ges.nsl,ges.npl,ges.fpl);
      printf("lay=%d name=%s z1=%f z2=%f\n",ges.lay,ges.name,ges.z1,ges.z2);
      }
  }
  printf("ptfpl="); for(i=0;i<3;++i) printf(" %d",ptfpl[i]);  printf("\n");
  /*
  printf("nsl=%d\n",NGEDE());
  printf("cmp  lay  sec  shp  nsl  xmin  xmax  ymin  ymax  zmin zmax \n");
  for(i=0; i<NGEDE(); ++i) {
    GEDE& ged = GEDE(i);
    if(ged.cmp==PTC_ID) {
      printf(" %d %4d %4d %4d %4d",ged.cmp,ged.lay,ged.sec,ged.shp,ged.nsl);
      printf(" %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n",ged.xmin,ged.xmax,ged.ymin,ged.ymax,ged.zmin,ged.zmax);
      }
  }
  */
  return;
}

int ptGetSector(int iz, float x, float y) {
int i;
 for(i=ptfpl[iz]; i<ptfpl[iz]+ptnpl[iz]; ++i) {
   GEDE& ged = GEDE(i);
   if(ged.cmp==PTC_ID) {
     if((ged.xmin<x)&&(x<ged.xmax)&&(ged.ymin<y)&&(y<ged.ymax))
       return(ged.sec+ptfpl[iz]-1); }
 }
   printf("could not find sector for: x=%4.1f y=%4.1f\n",x,y);
   return(0);
}

int ptGetHitTable(int lmax) {

const char *file_cnf = getenv("HPT_FEDS_PACK");

char line[150];
FILE *cnf;
int n_line;
int ix, iy,iz,nx,hn,nc,i;

enum { NC_MAX = 64 };

  cnf = fopen(file_cnf, "r");
  if (!cnf) {
    printf("FED config: Can not open %s\n", file_cnf);
    return(1);
    }
  hn=0;
  n_line=0;
  while (fscanf(cnf,"%[^\n] ",line) != EOF) {
    switch(line[0]) {
    case 'g': {
      fscanf(cnf,"%[^\n] ",line);
   sscanf(line," %f %f %f %f %f %f",&x0[0],&y0[0],&x0[1],&y0[1],&x0[2],&y0[2]);
      break; }

    default: {
      if (line[0] != '*') {
	if ( n_line < NC_MAX ) {
	  sscanf(line,"%d %d %d %d %d", &nc,&ix,&iy,&nx,&iz);
	if(nx<=0||nx>16) printf("HitPack> ERROR in string reading:nc=%d\n",nc);
	for (i=0; i<nx; i++) {
	  if(nx<15) { mxyz[0][hn+8]=ix; mxyz[1][hn+8]=iy-1; mxyz[2][hn+8]=iz; }

	  mxyz[0][hn]=ix;
	  mxyz[1][hn]=iy;
	  mxyz[2][hn]=iz;
	    if(ix >= 0) ix++;
	    else ix--;
	  hn++; if(hn > lmax) {
	    printf("Sorry, xy buffer is full\n");
	    fclose(cnf);
	    return(hn); }
	}
       if(nx<15) hn=hn+16-nx;
       n_line++;
	}
      else {
        printf("FED config: Sorry, the config file %s is too long.\n"
                " Only %d lines (without comments) can be accepted.\n"
                "Extra lines will be ignored\n", file_cnf, NC_MAX);
        break; }
      }
      break;
    }
    }
  }
  fclose(cnf);
  //   printf("\n ch.  1: ");
  //    for ( i=0; i<1024; i++) { printf("%4d  %3d %2d", mxyz[0][i], mxyz[1][i], mxyz[2][i]);
  //  if ((i+1)%8 == 0) printf("\n ch. %3d: ",i+1);}
   return(hn);
}

// ******************

int ptGetHotCh() {

//const char file_read[] = "/afs/desy.de/user/p/popovvp/public/dbase/hot.dat";
const char *file_read = getenv("HPT_HOT_CHANNELS");

char line[150];
FILE *cnf;
int n_line,i,j;
unsigned int b[8],a;
enum { NC_MAX = 16 };

  cnf = fopen(file_read, "r");
  if (!cnf) {
    printf("unpack> Can not open data file\n");
    return (-1);
    }
  n_line=0;
  i = 0;
  while (fscanf(cnf,"%[^\n] ",line) != EOF) {
    if (line[0] !='*') {
      if ( n_line < NC_MAX ) {
	n_line++;
        sscanf(line,"%0x %0x %0x %0x %0x %0x %0x %0x",&b[0],&b[1],&b[2],&b[3],&b[4],&b[5],&b[6],&b[7]);
	a = 0;
	for(j=3; j>=0; j--) a = (a<<8)|(b[j]&0xff);
	hot[i++]=a;
	a = 0;
	for(j=7; j>=4; j--) a = (a<<8)|(b[j]&0xff);
	hot[i++]=a;
	}
      else {
        printf("Hots table: Sorry, the file %s is too long.\n"
                " Only %d lines (without comments) can be accepted.\n"
                "Extra lines will be ignored\n", file_read, NC_MAX);
        break; }
      if(i > HOT_LMAX) {
	printf("unpack> Sorry, buffer is full\n");
	fclose(cnf);
	return(i); }
     }
  }
  fclose(cnf);
  /*    printf("\n hot  1: ");
    for ( i=0; i<32; i++) { printf(" %0x",hot[i]);
    if ((i+1)%2 == 0) printf("\n hot%3d: ",i+1); }
   */
  return(i);
}

int pth2xyz(int ih, float xyz[]) {

float cf,x;
int ix,iy,iz,ixp,iyp;
int ipl;
enum {nsec=7};

//int ixmn[6]= { 1, 13, 1, 25, 1, 33 };
//int ixmx[6]= { 24,24,24, 32,28, 48 };
//int iymn[6]= { 7,  1, 13, 1,19,  1 };
//int iymx[6]= { 12, 6, 18,12,26, 18 };

//  ix = abs(mx[ih]);  iy = abs(my[ih]); iz = mz[ih]-1;

  ixp = get_ix(ih); iyp = get_iy(ih); iz = get_iz(ih) -1;
  if(iz<0) return(iz);
  ix = abs(get_ix(ih)); iy = abs(get_iy(ih));
  cf=csiz[iz]/csiz[0];
  /*
  ipl=7;
  for(i=0;i<nsec-1; ++i) {
    if((ixmn[i]<=ix)&&(ix<=ixmx[i])&&(iymn[i]<=iy)&&(iy<=iymx[i])) ipl=i; }
  i=0; if(iyp>0) i+=2;
  if(ixp>0) i++;
  //  printf("ix=%d iy=%d iz=%d i=%d ipl= %d",ixp,iyp,iz,i,ipl);
  ipl = ipl + i*nsec + ptfpl[iz];
  //  printf(" %d\n",ipl);
  */ 
  switch(iz) {
  case 0: {
    if(0<iy && iy<13) {
      if(ix<25) x= -0.2 + ix*0.4;
      if(24<ix && ix<33) x=9.3 + (ix-24)*0.6;
      if(32<ix && ix<49) x=14.0+ (ix-32)*0.8;
    }
    if(12<iy && iy<19) {
      if(ix<25) x=-0.3 + ix*0.6;
      if(24<ix && ix<49) x=14.0+ (ix-24)*0.8;
    }
    if(18<iy && iy<27)  x=-0.4 + ix*0.8;

    xyz[0]=x*cf;
 //   xyz[1]=(iy*0.8 -0.4)*cf;
 //   xyz[2]=zz[iz];
    break;}

  case 1:
  case 2: {
    xyz[0]=(-0.4 + ix*0.8)*cf;
    //    printf("z=%d x=%d y=%d\n",iz,ixp,iyp);
    break;}
  default: ;
  }

  xyz[1]=(iy*0.8 -0.4)*cf;

  if(ixp<0)  xyz[0]=-xyz[0];
  if(iyp<0)  xyz[1]=-xyz[1];

  xyz[0]=x0[iz]+xyz[0];
  xyz[1]=y0[iz]+xyz[1];
  xyz[2]=zz[iz];
  //  printf("xyz= %f %f %f\n",xyz[0],xyz[1],xyz[2]);
  ipl=ptGetSector(iz, xyz[0], xyz[1]);
  //  printf("isector=%d\n",ipl);
  return(ipl);
}

void ptFillHITB (int iw, unsigned int* p) {
int j, ih,ipt[2];
unsigned int vp;
float xyz[3];

  ih=iw*32;
  vp=ptSwapBytes(*p)&hot[iw];
  for (j=0; j<32; j++) {
    if(vp&1) {
      ipt[0]=pth2xyz(ih,xyz);
      ipt[1]=ih;
      //      printf("z=%5.1f y=%5.2f x=%5.2f \n",xyz[2],xyz[1],xyz[0]);
      //      if(xyz[2]>0) ptfillh_(ipt, xyz);
      if(ipt[0]>0) ptfillh_(ipt, xyz);
    }
    vp = (vp >> 1); ih++;
  }
}

unsigned int ptSwapBytes(unsigned int n) {
unsigned int i;
 i= ((n<<24)&0xff000000)|((n<< 8)&0xff0000)|
    ((n>>24)&0xff)      |((n>> 8)&0xff00);
 // printf("SwapBytes>in=%0x out=%0x\n",n,i);
 return(i);
}

