// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerHitPad
// node class for 2D (pad or pixel) measurements 

#ifndef rangerHitPad_HH
#define rangerHitPad_HH

#include "CLHEP/Matrix/Matrix.h"
#include "CLHEP/Matrix/Vector.h"
#include "rang/Hit.hh"
#include "rang/FitMode.hh"

class rangerHitPad : public rangerHit {

public:

  rangerHitPad();
  rangerHitPad(ArtePointer<RHIT> rhit,rangerFitMode fm);
  rangerHitPad(ArtePointer<HITB>   hb,rangerFitMode fm);
  ~rangerHitPad();

  void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);
//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStateP* s);
//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStatePI* s);
  inline int dim() const {return 2;};         // dimension of measurement

private:

};

#endif
