*-- Author :    A. Spiridonov   27/11/98

      subroutine tfbuild()
*
*  Control routine to invoke ranger++ fit and build track
*      (book RTRA table) from segments reconstucted 
*         in VDS,magnet+pattern and tc area    
*             
*     Combinations of segments to be stored as track :
*
*             VDS    patt+magn  tc area
*
*       1      +         +        +
*       2      +         +        
*       3      +
*       4                +        +        
*       5                +
*
*
      implicit none
*
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
*
* 
      integer rgseg2t,rgsv2t
      integer rs,rt,iirs,ind_rs,ii,jj,kk
      integer if_seg,segVec(20)
      integer n_end,seg_end(20),n_end1,seg_end1(20),n_beg,seg_beg(20)      

      integer rgfitsv
        
      logical rang_fit
      data rang_fit/.false./
      save rang_fit

#include "arte/Arte.ff"
#include "auto/RSEG.ff"

*--------------------------------------------------

      if(rlevel_fit.ge.2) then
        if(rlevel_zfpar.ge.2) then
          rang_fit = .true.
        else if(rlevel_zfpar.eq.0) then
          rang_fit = .true.
        else
          rang_fit = .false.
        end if
      else
        rang_fit = .false.
      end if
    
      if(jrseg.le.0)   go to 999        ! skip empty event
      if(NRSEG().le.0) go to 999 

      do rs=1,NRSEG()                             ! loop on segments
        if (iand(irseg_cmp(rs),rsegc_bitsign).eq.0) then !  alive segment
          call tfunbeg(rs,n_beg,seg_beg)
          if((n_beg.eq.0)
     +    .and.((iand(irseg_cmp(rs),rsegc_vxd ).ne.0)
     +    .or.  (iand(irseg_cmp(rs),rsegc_magt).ne.0)) ) then

          call tfunend(rs,n_end,seg_end)
            if(n_end.gt.0) then         !   treat pair of segments
              do ii=1,n_end
                segVec(1) = rs          
                segVec(2) = seg_end(ii)
                call tfunend(segVec(2),n_end1,seg_end1)
                if(iand(irseg_cmp(rs),rsegc_vxd ).ne.0) then
*               **** covariance of momentum for SVD segment
                  do kk=11,14
                    q(qrseg_cvf(kk,rs))=0.
                    q(qrseg_cve(kk,rs))=0.
                  end do
                  q(qrseg_cvf(15,rs))= frseg_cvf(15,segVec(2))
                  q(qrseg_cve(15,rs))= frseg_cvf(15,segVec(2))
                end if
                if(n_end1.gt.0) then       !   triplet of segments
                  do jj=1,n_end1
                    segVec(3) = seg_end1(jj)
                    if(rang_fit) then
                      rt = rgfitsv(segVec,3,0)
                    end if
                    rt = rgsv2t(segVec,3) ! store triplet of segment as track  
                  end do
                else                    ! pair of segments
                  if(rang_fit) then
                    rt = rgfitsv(segVec,2,0)
                  end if
                  rt = rgsv2t(segVec,2) ! store pair of segment as track
                end if                ! end if of triplet
              end do                  ! 1,n_end
            else                    ! treat one segments
              if(rang_fit) call rgfit(rs,0)      
              rt = rgseg2t(rs)       ! store one segment as track 
            end if                   ! end treat of segment
          end if                  ! end of VDS or magnet with n_beg=0
        end if                    ! endif of alive segment
      end do                      ! end of loop on segments
 
 999  end
