*-- Author :    Rainer Mankel   11/07/96

      subroutine tffhist(imc,t1,t2,hitff_min,hitfm_min,z_min,z_max)

*     **** track fit histograms
      implicit none
#include "pris/zmh.fi"
#include "arte/Arte.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "auto/TOPP.fi"

      integer nmx
      parameter (nmx=20)
      integer imc, cmp, hits_cmp(3), hits_all, mimp,
     +     iih, iso, ih, nhits, it, iprob, hitff_min, hitfm_min,
     +     hits_mag, istat, ii, ippabs, gcode, t1, t2, n_df,
     +     hit_array(nmx), nhit
      real ptot, prob, chi2, chi2prob, pa(5), pamc(5),
     +     dpa(5), dpanorm(5), ch2mc, dpabs, dpabsnorm, ppabs,
     +     z_min, z_max, probmc
      logical momentum,electron,muon,pion,kaon,proton,other

      logical init
      data init /.false./

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"
#include "auto/TOPP.ff"

      if (.not.init) then
         call hbook1( 1,' chi**2  muon/pion ',50,0.,50.,0.)
         call hbook1( 2,' prob    muon/pion ', 50,0.,1.,0.)
         call hbook1( 3,' chi**2/Nhit  muon/pion ',50,0.,5.,0.)
         call hbook1( 4,' chi**2/(Nhit-Npar)  muon/pion ',50,0.,5.,0.)
         call hbook1( 5,' prob(nhit)    muon/pion ', 50,0.,1.,0.)
*        **** to be filled by rangerFit
         call hbook1( 6,' rad thickness',50,0.,1.,0.)
         call hbook1(11,' chi**2 Si',50,0.,50.,0.)
         call hbook1(12,' prob   Si', 50,0.,1.,0.)
         call hbook1(21,' chi**2 HDC',50,0.,50.,0.)
         call hbook1(22,' prob   HDC', 50,0.,1.,0.)
         call hbook1(31,' chi**2 MSGC',50,0.,50.,0.)
         call hbook1(32,' prob   MSGC', 50,0.,1.,0.)
         call hbook2(51,' p/prob ',50,0.,50.,50,0.,1.,0.)
         call hbook1(61,' chi**2 (e+-)   ',50,0.,50.,0.)
         call hbook1(62,' prob   (e+-)   ', 50,0.,1.,0.)
         call hbook1(71,' chi**2 (mip)   ',50,0.,50.,0.)
         call hbook1(72,' prob   (mip)   ', 50,0.,1.,0.)
         call hbook1(81,' chi**2 (mip) HDC ',50,0.,50.,0.)
         call hbook1(82,' prob   (mip) HDC ', 50,0.,1.,0.)
         call hbook1(91,' chi**2 (mip) MSGC',50,0.,50.,0.)
         call hbook1(92,' prob   (mip) MSGC', 50,0.,1.,0.)

         call hbook1(101,' delta(xf) electron',50,-0.004,0.004,0.)
         call hbook1(102,' delta(yf) electron',50,-0.004,0.004,0.)
*         call hbook1(103,' delta(txf) electron',50,-0.004,0.004,0.)
*         call hbook1(104,' delta(tyf) electron',50,-0.02,0.02,0.)
*         call hbook1(105,' delta(Q/p) electron',50,-0.04,0.04,0.)
*         call hbook1(106,' delta(1/p) electron',50,-0.04,0.04,0.)
         call hbook1(103,' delta(txf) electron',100,-0.001,0.001,0.)
         call hbook1(104,' delta(tyf) electron',100,-0.02,0.02,0.)
         call hbook1(105,' delta(Q/p) electron',100,-0.04,0.04,0.)
         call hbook1(106,' delta(1/p) electron',100,-0.04,0.04,0.)
         call hbook1(107,' delta(1/p)*p electron',200,-0.4,0.4,0.)
         call hbook1(108,' ((Q/p)RC-(Q/p)MC) / (Q/p)MC electron',
     +        200,-0.04,0.04,0.)
         call hbook1(109,' delta(1/p)*p electron',200,-1.,1.,0.)

         call hbook1(710,' zf electron',100,-100.,700.,0.)



         call hbook1(111,' delta(xf)/sigma(xf)  electron',50,-5.,5.,0.)
         call hbook1(112,' delta(yf)/sigma(yf)  electron',50,-5.,5.,0.)
         call hbook1(113,' delta(txf)/sigma(txf) electron',50,-5.,5.,0.)
         call hbook1(114,' delta(tyf)/sigma(tyf) electron',50,-5.,5.,0.)
         call hbook1(115,' delta(Q/p)/sigma(Q/p) electron',50,-5.,5.,0.)
         call hbook1(116,' delta(1/p)/sigma(Q/p) electron',50,-5.,5.,0.)
         call hbook1(117,' ch2mc el',100,0.,20.,0.)
         call hbook1(118,' ch2mcprob el',50,0.,1.,0.)

         call hbook1(121,' delta(xf) mip',50,-0.04,0.04,0.)
         call hbook1(122,' delta(yf)  mip',50,-0.4,0.4,0.)
         call hbook1(123,' delta(txf) mip',50,-0.004,0.004,0.)
         call hbook1(124,' delta(tyf) mip',50,-0.02,0.02,0.)

#ifdef SPECIAL
         call hbook1(121,' delta(xf) mip',50,-0.005,0.005,0.)
         call hbook1(122,' delta(yf)  mip',50,-0.005,0.005,0.)
         call hbook1(123,' delta(txf) mip',50,-0.0005,0.0005,0.)
         call hbook1(124,' delta(tyf) mip',50,-0.0005,0.0005,0.)
#endif
         call hbook1(125,' delta(Q/p) mip',50,-0.02,0.02,0.)
         call hbook1(126,' delta(1/p) mip',50,-0.02,0.02,0.)
         call hbook1(127,' ((Q/p)RC-(Q/p)MC) / (Q/p)MC mip',
     +        50,-0.1,0.1,0.)
**         call hbook1(127,' ((Q/p)RC-(Q/p)MC) / (Q/p)MC mip',
**     +        100,-0.04,0.04,0.)
         call hbook2(128,' I(gen),I(rec)',50,-10.,10.,50,-10.,10.,0.)
**         call hbook1(129,' delta(I)   mip (ns)',50,-2.5,2.5,0.)
         call hbook1(129,' delta(I)   mip (ns)',50,-5.,5.,0.)
         call hbook1(131,' delta(xf)/sigma(xf) mip ',50,-5.,5.,0.)
         call hbook1(132,' delta(yf)/sigma(yf)  mip',50,-5.,5.,0.)
         call hbook1(133,' delta(txf)/sigma(txf)  mip',50,-5.,5.,0.)
         call hbook1(134,' delta(tyf)/sigma(tyf)  mip',50,-5.,5.,0.)
         call hbook1(135,' delta(Q/p)/sigma(Q/p)  mip',50,-5.,5.,0.)
         call hbook1(136,' delta(1/p)/sigma(Q/p)  mip',50,-5.,5.,0.)
         call hbook1(137,' ch2mc mip',100,0.,20.,0.)
         call hbook1(138,' ch2mcprob mip',50,0.,1.,0.)
         call hbook1(139,' delta(I)/sigma(I)     mip (ns)',50,-5.,5.,0.)

         call hbook1(730,' zf mip',100,-100.,700.,0.)

         call hbook1(141,' delta(xf) oth',50,-0.04,0.04,0.)
         call hbook1(142,' delta(yf)  oth',50,-0.4,0.4,0.)
         call hbook1(143,' delta(txf) oth',50,-0.004,0.004,0.)
         call hbook1(144,' delta(tyf) oth',50,-0.02,0.02,0.)
         call hbook1(145,' delta(Q/p) oth',50,-0.02,0.02,0.)
         call hbook1(146,' delta(1/p) oth',50,-0.02,0.02,0.)
**         call hbook1(147,' ((Q/p)RC-(Q/p)MC) / (Q/p)MC oth',
**     +        100,-0.04,0.04,0.)
         call hbook1(147,' ((Q/p)RC-(Q/p)MC) / (Q/p)MC oth',
     +        50,-0.1,0.1,0.)
         call hbook1(151,' delta(xf)/sigma(xf) oth ',50,-5.,5.,0.)
         call hbook1(152,' delta(yf)/sigma(yf)  oth',50,-5.,5.,0.)
         call hbook1(153,' delta(txf)/sigma(txf)  oth',50,-5.,5.,0.)
         call hbook1(154,' delta(tyf)/sigma(tyf)  oth',50,-5.,5.,0.)
         call hbook1(155,' delta(Q/p)/sigma(Q/p)  oth',50,-5.,5.,0.)
         call hbook1(156,' delta(1/p)/sigma(Q/p)  oth',50,-5.,5.,0.)
         call hbook1(157,' ch2mc oth',100,0.,20.,0.)
         call hbook1(158,' ch2mcprob oth',50,0.,1.,0.)

         call hbook1(750,' zf oth',100,-100.,700.,0.)




         call hbook1(201,' delta(1/p) mu/pi 1-5 GeV',50,-.01,.01,0.)
         call hbook1(202,' delta(1/p) mu/pi 5-10 GeV',50,-.005,.005,0.)
         call hbook1(203,' delta(1/p) mu/pi 10-20 GeV',50,-.002,.002,0.)
         call hbook1(204,' delta(1/p) mu/pi 20-30 GeV',50,-.002,.002,0.)
         call hbook1(205,' delta(1/p) mu/pi 30-40 GeV',50,-.002,.002,0.)
         call hbook1(206,' delta(1/p) mu/pi 40-50 GeV',50,-.002,.002,0.)
         call hbook1(207,' delta(1/p) mu/pi 50-60 GeV',50,-.002,.002,0.)

         call hbook1(221,' at RICH tx(RC)-tx(MC)',50,-0.01,0.01,0.)
         call hbook1(222,' at RICH ty(RC)-ty(MC)',50,-0.01,0.01,0.)
         call hbook1(223,' at RICH tx(RC)-tx(MC)',50,-0.001,0.001,0.)
         call hbook1(224,' at RICH ty(RC)-ty(MC)',50,-0.001,0.001,0.)

         call hbook1(521,' lg(est resol) x ',200,-10.,0.,0.)
         call hbook1(522,' lg(est resol) y ',200,-10.,0.,0.)
         call hbook1(523,' lg(est resol) tx ',200,-10.,0.,0.)
         call hbook1(524,' lg(est resol) ty ',200,-10.,0.,0.)
         call hbook1(525,' lg(est resol) Q/p ',200,-10.,0.,0.)
         call hbook1(526,' lg(est resol) dp/p ',200,-10.,0.,0.)

         call hbook1(8101,' imtrac prob lt 0.02',30,0.5,30.5,0.)
         call hbook1(8102,' imtrac prob gt 0.02',30,0.5,30.5,0.)
         call hbook1(8103,' ptot   prob lt 0.02',50,0.,50.,0.)
         call hbook1(8104,' ptot   prob gt 0.02',50,0.,50.,0.)

*        **** to be filled by rangerTrack::totalChiSq
         call hbook1(7001,' chi2 contr vs hit number',30,0.,30.,0.)
         call hbook1(7002,' entries contr vs hit number',30,0.,30.,0.)
         init = .true.
      endif

      gcode = itopp_gean(omtra_topp(imc))
      electron = gcode.le.3
      muon     = gcode.eq.5.or.gcode.eq.6
      pion     = gcode.eq.8.or.gcode.eq.9
      kaon     = gcode.eq.11.or.gcode.eq.12
      proton   = gcode.eq.14.or.gcode.eq.15
      other    = .not.(electron.or.muon)

      ptot = sqrt(amax1(fmtra_px(imc)**2+fmtra_py(imc)**2
     +     +fmtra_pz(imc)**2,0.))

      do cmp=1,3                ! count hits for cmp
         hits_cmp(cmp) = 0
      enddo
      hits_all = 0
      hits_mag = 0
      do iso=nmimmh(imc),1,-1
         mimp = imimmh( istamh(imc) + iso )
         call tumimph(mimp,nmx,hit_array,nhits) ! get hits
         do 30 iih=1,nhits      ! loop over associated hits
            ih = hit_array(iih)

            if (fhitb_z(ih).lt.z_min.or.fhitb_z(ih).gt.z_max) ! check z
     +           go to 30
            cmp = igede_cmp(ihitb_gede(ih))
            if (cmp.ge.1.and.cmp.le.3) then
               hits_cmp(cmp) = hits_cmp(cmp) + 1
            endif
            hits_all = hits_all + 1
            if ((fmimp_x(mimp)**2+(ffeld_z(1)-fmimp_z(mimp))**2) ! mag?
     +           .lt.ffeld_r(1)**2) then
               hits_mag = hits_mag + 1
            endif
 30      continue
      enddo

      if (hits_all.le.0) go to 999
      if (hits_mag.lt.hitfm_min) go to 999

*     **** track analysis
      do 20 it=t1,t2
	 nhit = irtra_hsi(it) + irtra_hou(it) + irtra_hin(it)
         if (nhit.ge.hitff_min) then


            if (frtra_zf(it).gt.300.) go to 20

            if (abs(frtra_cvf(15,it)).ge.0.5*cqqrf_zfpar) then
               momentum = .false.
               n_df = 4         ! no momentum on this track
            else
               momentum = .true.
               n_df = 5         !    momentum on this track
            endif

#ifdef FULL
            print *,' tffhist: track',it,' hits=',nhit,
     +           ' npar=',n_df,' nDF=',nhit-n_df,
     +           ' chi2=',frtra_chi(it)
#endif

            chi2 = frtra_chi(it)

            chi2prob = prob(chi2,nhit-n_df)

            if (chi2.le.-1.) then
               print *,' () tffhist: it=',it,' chi2=',chi2
               go to 20
            endif

            if (muon.or.pion) then
               call hfill(1,chi2,0.,1.)
               call hfill(2,chi2prob,0.,1.)
               call hfill(3,chi2/nhit,0.,1.)
               call hfill(4,chi2/(nhit-n_df),0.,1.)
               call hfill(5,prob(chi2,nhit),0.,1.)
            endif

            do cmp=1,3
               if ((float(hits_cmp(cmp))/float(hits_all)).gt.0.5)
     +              then
                  call hfill(10*cmp+1,chi2,0.,1.)
                  call hfill(10*cmp+2,chi2prob,0.,1.)
                  if (cmp.eq.1) then
                     call hfill(51,ptot,chi2prob,1.)
                  elseif (cmp.eq.3) then
                     if (chi2prob.lt.0.02) then
                        iprob = 0
                     else
                        iprob = 1
                     endif
                     call hfill(8101+iprob,float(gcode),0.,1.)
                     call hfill(8103+iprob,ptot,0.,1.)
                  endif
               endif
            enddo

            chi2 = frtra_chi(it)
            chi2prob = prob(chi2,nhit-n_df)
            if (gcode.le.3) then
               call hfill(61,chi2,0.,1.)
               call hfill(62,chi2prob,0.,1.)
            elseif (gcode.eq.5
     +              .or.gcode.eq.6) then
               call hfill(71,chi2,0.,1.)
               call hfill(72,chi2prob,0.,1.)
               do cmp=2,3
                  if ((float(hits_cmp(cmp))/float(hits_all))
     +                 .gt.0.5) then
                     call hfill(81+(cmp-2)*10,chi2,0.,1.)
                     call hfill(82+(cmp-2)*10,chi2prob,0.,1.)
                  endif
               enddo
            endif
         endif
*        **** track parameter analysis
         if (momentum) then
            call tftparm(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)
         else
            call tftpar2(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)
         endif

         if (istat.ne.0) go to 20

**            if (chi2prob.lt.0.02) then
#ifdef DPANORMPRT
         if (dpanorm(3).gt.3.) then
            print *,'*************************************'
            print *,'*     '
            print *,'*     '
            print *,'*     '
            print *,'*   dpanorm(3)=',dpanorm(3), ' for it=',it
            print *,'*     '
            print *,'*     '
            print *,'*     '
            print *,'*     '
            print *,'*************************************'
         endif
#endif


         do ii=1,n_df
            if (gcode.le.3) then
               call hfill(100+ii,dpa(ii),0.,1.)
               call hfill(110+ii,dpanorm(ii),0.,1.)
               call hfill(710,frtra_zf(it),0.,1.)
            elseif (gcode.eq.5
     +              .or.gcode.eq.6) then ! mip part
               call hfill(120+ii,dpa(ii),0.,1.)
               call hfill(130+ii,dpanorm(ii),0.,1.)
               call hfill(730,frtra_zf(it),0.,1.)
            elseif (pion.or.muon) then
               call hfill(140+ii,dpa(ii),0.,1.)
               call hfill(150+ii,dpanorm(ii),0.,1.)
               call hfill(750,frtra_zf(it),0.,1.)
            endif
         enddo

         probmc = prob(ch2mc,n_df)
         if (gcode.le.3) then
            call hfill(117,ch2mc,0.,1.)
            call hfill(118,probmc,0.,1.)
         elseif (gcode.eq.5
     +              .or.gcode.eq.6) then ! mip part
            call hfill(137,ch2mc,0.,1.)
            call hfill(138,probmc,0.,1.)
         elseif (pion.or.muon) then
            call hfill(157,ch2mc,0.,1.)
            call hfill(158,probmc,0.,1.)
         endif

         if (momentum) then
            dpabs = abs(pa(5)) - abs(pamc(5))

*            dpabsnorm = dpabs * dpanorm(5) / dpa(5)

            if (pamc(5).ge.0.) then
               dpabsnorm = dpanorm(5)
            else
               dpabsnorm = -dpanorm(5)
            endif

            if (gcode.le.3) then
               call hfill(100+6,dpabs,0.,1.)
               call hfill(110+6,dpabsnorm,0.,1.)
               if (pamc(5).ne.0.) then
                  call hfill(107,dpabs/abs(pamc(5)),0.,1.)
                  call hfill(108,dpa(5)/pamc(5),0.,1.)
                  call hfill(109,dpabs/abs(pamc(5)),0.,1.)
               endif
            elseif (gcode.eq.5
     +              .or.gcode.eq.6) then ! mip part

                  call hfill(120+6,dpabs,0.,1.)
	          if (dpabsnorm.gt.0..or.dpabsnorm.le.0.) then
                    call hfill(130+6,dpabsnorm,0.,1.)
	          else
                    print *,' tffhist: dpabsnorm=', dpabsnorm
                    go to 20
                  endif
                  if (pamc(5).ne.0.) then
                     call hfill(127,dpa(5)/pamc(5),0.,1.)
#ifdef BIGRESPRT
                     if (dpa(5)/pamc(5).lt.-0.025) then
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' ----->'
                        print *,' tfhist: dpa(5)/pamc(5)=',
     +                       dpa(5)/pamc(5)
                     endif
#endif
                  endif
            else
                  call hfill(140+6,dpabs,0.,1.)
                  call hfill(150+6,dpabsnorm,0.,1.)
                  if (pamc(5).ne.0.) then
                     call hfill(147,dpa(5)/pamc(5),0.,1.)
                  endif
            endif

            if (muon.or.pion) then
               if (pa(5).ne.0.) then
                  ppabs = abs(1./pa(5))
               else
                  ppabs = 0.
               endif

               if (ppabs.gt.1.) then
                  if (ppabs.lt.5.) then
                     call hfill(201,dpabs,0.,1.)
                     
                  else
                     ippabs = ppabs / 10. + 2
                     if (ippabs.le.7) then
                        call hfill(200+ippabs,dpabs,0.,1.)
                     endif
                  endif
               endif
            endif

*           **** parameter erros
            if (frtra_cvf(1,it).gt.0.) call hfill(521,
     +           0.5*alog10(frtra_cvf(1,it)),0.,1.)
            if (frtra_cvf(3,it).gt.0.) call hfill(522,
     +           0.5*alog10(frtra_cvf(3,it)),0.,1.)
            if (frtra_cvf(6,it).gt.0.) call hfill(523,
     +           0.5*alog10(frtra_cvf(6,it)),0.,1.)
            if (frtra_cvf(10,it).gt.0.) call hfill(524,
     +           0.5*alog10(frtra_cvf(10,it)),0.,1.)
            if (frtra_cvf(15,it).gt.0.) call hfill(525,
     +           0.5*alog10(frtra_cvf(15,it)),0.,1.)
            if (frtra_cvf(15,it).gt.0..and.frtra_pf(it).ne.0.) 
     +           call hfill(526,
     +           0.5*alog10(frtra_cvf(15,it)/frtra_pf(it)**2),0.,1.)

         endif ! momentum

 20   continue

 999  end
