*-- Author :    Rainer Mankel   04/12/94

      subroutine tffily(ih,dlnext,jpl,ift,izf,izfnew)

*     **** absorb the next hit (vertical tracking)
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zdomain.fi"

#include "pris/hgmagnhelp.fi"


      logical lgrafy
      parameter (lgrafy=.false.)
      integer ih, jpl, izf, izfnew, xsig_min, xsig_max, del_xsig, xsig,
     +        jzf, ift, jft, ii, jj, imc, tumchit, 
     +        dlnext,dom
      integer message_id_1
      double precision dz, du, cs_thetu, dnoise, xm_p, xr_p,
     +                 cr_p, hch, kalman(dimp,dimm), ihk, m_u
      real wc(3), xxx(2), yyy(2), pnoise, tfxseg, xyfac, pinv
      parameter (xyfac=1.)
      character*1 tfcsig

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"

      save    message_id_1
      data    message_id_1 /1/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"

      if (.not.l_2dy) then
       print *,' () tffily: 2dy only!'
       stop 'tffily'
      endif

      if (diag_level.ge.5)
     +  print *,' tffily: absorb ih, jpl, imc=', ih, jpl, tumchit(ih)

      dom = laydom_dl(dlnext)

      izfnew = 0

      if (igede_cmp(jpl).eq.2) then
       xsig_min = -1
       xsig_max = +1
       del_xsig = +2
      else
       xsig_min = 0
       xsig_max = 0
       del_xsig = +2
      endif

      dz = fhitb_z(ih) - z_zf(izf)

*     **** loop over L/R signs
      do 10 xsig=xsig_min,xsig_max,del_xsig
       if (n_zf.ge.nzfmx) then
        call mepric(message_id_1,3,
     +       'tffily: ranger buffer at limit, branch aborted')
        go to 999
       endif
       if (nca_ft.ge.ncamx) then
        call mepric(message_id_1,3,
     +       'tffily: ranger buffer at limit, branch aborted')
        go to 999
       endif
       jzf = n_zf + 1

*      **** Kalman filter prediction
       xp_zf(2,jzf) = xx_zf(2,izf) + dz * xx_zf(4,izf)
       xp_zf(4,jzf) = xx_zf(4,izf)

       imc = tumchit(ih)
*      **** real life: use momentum estimate
       pinv = abs( xx_zf(5,izf) )
       pinv = amin1(pinv,1.)    ! truncate to 1 GeV
*      **** fudge factors for moliere tails & slope & 0-deg planes
       dnoise = 3.3d0 * fgede_ms(jpl) * pinv**2
       if (diag_level.ge.5)
     +           print *,' fgede_ms(jpl), pinv, dnoise=',
     +           fgede_ms(jpl), pinv, dnoise

       cp_zf(2,2,jzf) = cx_zf(2,2,izf) + 2.d0 * cx_zf(2,4,izf) * dz
     +                                 + cx_zf(4,4,izf) * dz**2
       cp_zf(2,4,jzf) = cx_zf(2,4,izf) + cx_zf(4,4,izf) * dz
       cp_zf(4,2,jzf) = cp_zf(2,4,jzf)
       cp_zf(4,4,jzf) = cx_zf(4,4,izf) + dnoise

       if (diag_level.ge.5) then
        print *,' tffily: pred=', xp_zf(2,jzf),
     +         ' error ', dsqrt( cp_zf(2,2,jzf) ), 'dz=', dz
        print *,' cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)=',
     +           cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
       endif

*      **** projection
       if (igede_cmp(jpl).eq.2) then
        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
*       **** tan(track angle) in uz-plane
        m_u = tx_dlx(dlx1_dlx)
     +       * fgede_cos(jpl) - xp_zf(4,jzf) * fgede_sin(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
        du = tfxseg(fhitb_z(ih),dom) * fgede_cos(jpl)  - fhitb_x(ih)
     +                      - xp_zf(2,jzf) * fgede_sin(jpl)
**        du = tfxint(fhitb_z(ih)) * fgede_cos(jpl)  - fhitb_x(ih)
**     +                      - xp_zf(2,jzf) * fgede_sin(jpl)
        xm_p      = du * cs_thetu
*       **** difference to signed drift distance
        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        h_zf(1,2,jzf) = - fgede_sin(jpl) * cs_thetu
        h_zf(1,4,jzf) = - du * m_u * cs_thetu**3 * (-fgede_sin(jpl))
        hch = h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +      + 2.d0 * h_zf(1,2,jzf) * h_zf(1,4,jzf) * cp_zf(2,4,jzf)
     +      + h_zf(1,4,jzf)**2 * cp_zf(4,4,jzf)

        cr_p = xyfac * fhitb_r(ih)**2 + hch
       elseif (igede_cmp(jpl).eq.3) then
*       **** warning: must care better for local coordinates!
        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
        xm_p = tfxseg(fhitb_z(ih),dom) * fgede_rot(1,jpl)
     +              - xp_zf(2,jzf) * fgede_rot(2,jpl)
**        xm_p = tfxint(fhitb_z(ih)) * fgede_rot(1,jpl)
**     +              - xp_zf(2,jzf) * fgede_rot(2,jpl)
        xr_p = fhitb_x(ih) - xm_p


        h_zf(1,2,jzf) = - fgede_rot(2,jpl)
        h_zf(1,4,jzf) = 0.
        hch = cp_zf(2,2,jzf) * fgede_rot(2,jpl)**2
        cr_p = cm_zf(1,1,jzf) + hch
       else
        print *,' tffily: non-supported type for jpl=', jpl
       endif

       if (diag_level.ge.5) then
               print *,' tffily: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif

*      **** decision
       if (dabs(xr_p).gt.dsqrt(16.d0*cr_p)) then
        if (diag_level.ge.5) then
         print *,' tffily: hit dropped due to nsigma,',
     +       ' dabs(xr_p), dsqrt(8.d0*cr_p)=',
     +       dabs(xr_p), dsqrt(8.d0*cr_p)
        endif
        go to 10
       endif

*      **** filter point
       do ii=2,4,2
        kalman(ii,1) = ( cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                 + cp_zf(ii,4,jzf) * h_zf(1,4,jzf) ) / cr_p
       enddo

*      **** updated x value
       do ii=2,4,2
        xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo
       xx_zf(1,jzf) = tfxseg(fhitb_z(ih),dom)
**       xx_zf(1,jzf) = tfxint(fhitb_z(ih))
       xx_zf(3,jzf) = 0.
       xx_zf(5,jzf) = xx_zf(5,izf)  ! relay momentum estimate

*      **** updated cov matrix
       do ii=1,5
        do jj=1,5
         cx_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       if (diag_level.ge.5) then
        print *,' cp_zf(2,2,jzf)...cp_zf(4,4,jzf)=',
     +     cp_zf(2,2,jzf), cp_zf(4,2,jzf), cp_zf(2,4,jzf),
     +     cp_zf(4,4,jzf)

        print *,' kalman(2,1), kalman(4,1)=',
     +            kalman(2,1), kalman(4,1)

        print *,' xr_p=', xr_p
       endif

       cx_zf(2,2,jzf) = (1. - kalman(2,1) * h_zf(1,2,jzf))
     +                  * cp_zf(2,2,jzf)
     +                + (- kalman(2,1) * h_zf(1,4,jzf))
     +                  * cp_zf(4,2,jzf)
       cx_zf(4,2,jzf) = (- kalman(4,1) * h_zf(1,2,jzf) )
     +                * cp_zf(2,2,jzf)
     +                + (1. - kalman(4,1) * h_zf(1,4,jzf))
     +                * cp_zf(4,2,jzf)
       cx_zf(2,4,jzf) = cx_zf(4,2,jzf)
       cx_zf(4,4,jzf) = (- kalman(4,1) * h_zf(1,2,jzf))
     +                * cp_zf(2,4,jzf)
     +                + (1. - kalman(4,1) * h_zf(1,4,jzf))
     +                * cp_zf(4,4,jzf)

       if (diag_level.ge.5) then
        print *,' cx_zf(2,2,jzf)...cx_zf(4,4,jzf)=',
     +     cx_zf(2,2,jzf), cx_zf(4,2,jzf), cx_zf(2,4,jzf),
     +     cx_zf(4,4,jzf)
       endif

*      **** updated residual
       ihk = 1. - h_zf(1,2,jzf) * kalman(2,1)
     +          - h_zf(1,4,jzf) * kalman(4,1)

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*      **** updated chi2 contribution
       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

       if (diag_level.ge.5) then
        print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +            ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
        print *,' h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)=',
     +            h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)
       endif

*      **** cut
       if (ch_zf(jzf).gt.chmax_y_zfpar) then
          go to 10
       endif

*      **** accept hit
       hit_zf(jzf)   = ih
       nhit_zf(jzf) = nhit_zf(izf) + 1
       domlay_zf(jzf) = dlnext
       plane_zf(jzf) = ihitb_gede(ih)
       z_zf(jzf) = fhitb_z(ih)
       cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
       sign_zf(jzf) = xsig
       prev_zf(jzf) = izf
       fault_zf(jzf) = 0
       pfault_zf(jzf) = fault_zf(izf)
       dim_zf(jzf) = 1
       shadow_zf(jzf) = 0
       n_zf = n_zf + 1

       izfnew = jzf

*      **** fill candidate info
       if (nca_ft.ge.ncamx) then
        print *,' () tffily: candidate overflow, nca_ft=', nca_ft
        stop 'tffily'
       endif
       nca_ft = nca_ft + 1
       jft = nca_ft
       first_ft(jft) = first_ft(ift)
       if (diag_level.ge.5) print *,' clone candidate, jft=', jft
       nhit_ft(jft)     = nhit_zf(jzf)
       last_ft(jft)     = jzf
       prev_ft(jft)     = prev_ft(ift)
       gen_ft(jft)      = gen_ft(ift) + 1
       nfault_ft(jft)   = nfault_ft(ift)
       quality_ft(jft)  = quality_ft(ift)
     +                    + 1.               ! bonus for new hit
     +                    - wchi_y_zfpar * ch_zf(jzf) ! malus for chi2

       alive_ft(jft)    = .true.
       mature_ft(jft)   = .false.
       stat_ft(jft) = stat_ft(ift)

#ifdef RGRAF
*      **** draw
       if (l_graf.and.lgrafy) then
*       **** draw markers
        call igset('LWID',1.)
        call ismk(2)
        wc(1) = tfxseg(z_zf(izf),dom)
**        wc(1) = tfxint(z_zf(izf))
        wc(2) = xx_zf(2,izf)
        wc(3) = z_zf(izf)
        call dipro(wc,xxx(1),yyy(1))
**      call ipm(1,xxx,yyy)
        wc(1) = tfxseg(z_zf(jzf),dom)
**        wc(1) = tfxint(z_zf(jzf))
        wc(2) = xx_zf(2,jzf)
        wc(3) = z_zf(jzf)
        call dipro(wc,xxx(2),yyy(2))
        call ipl(2,xxx,yyy)
        call ipm(2,xxx,yyy)
        call iuwk(0,1)
       endif
#endif

 10   continue

 999  end







