*-- Author :    Rainer Mankel   10/05/96

      subroutine tfkdigi()

*     **** monitor digitization
*     **** interactive version of tfdigi
*     **** called by KUIP
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"

      integer nmx
      parameter (nmx=500)
      integer ih, imc, iso, nso, iih, mimp, mimp2, hit_array(nmx),
     +        nhits, jmc, nnmimp, ipl, cmp, icm, istereo, nprint,
     +        gcode, nch_tot
      real dz, xr, yr, u, t_u, dtx, dty, de, ems, ede, resid, zmin,
     +     zmax, xp, yp, ch_tot, prob, sin_tot

      logical init, electron, tfcharg
      character*4 c(3), ccmp

      data init /.false./
      data c /'Si', 'HDC', 'MSGC'/

      save init, c

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"

      call kugeti(imc)
      call kugetr(zmin)
      call kugetr(zmax)

      if (l_diag) then
         print *,' tfkdigi starting for imc=', imc
         call tfwait()
      endif

      if (imc.eq.0) go to 999

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** check id
      if (.not.( tfcharg(imc) ) ) go to 999
      gcode = itopp_gean(omtra_topp(imc))

      electron = (gcode.eq.2)  .or. (gcode.eq.3)

*     **** loop over hits in sorted order
      nso = nmimmh(imc)
      nprint = 0
      ch_tot = 0.
      nch_tot = 0
      do 30 iso=nso,1,-1
         mimp = imimmh( istamh(imc) + iso )
*        **** get hits associated with mimp
         call tumimph(mimp,nmx,hit_array,nhits)
*        **** loop over associated hits
         do iih=1,nhits
            ih = hit_array(iih)
            if (ih.le.0.or.ih.gt.iq(jhitb+2)) then
               print *,' () tfkdigi: invalid ih=',ih,
     +              ' at iih,mimp=',iih,mimp
               stop 'tfkdigi'
            endif

*           **** no merged points
            call tuhmimp(ih,jmc,mimp,nnmimp)
            if (nnmimp.gt.1) go to 29

*           **** check z
            if (fhitb_z(ih).lt.zmin.or.fhitb_z(ih).gt.zmax) go to 30

*           **** simulate digitization
            ipl = ihitb_gede(ih)
            cmp = igede_cmp(ipl)
            if (cmp.le.3) then
               ccmp = c(cmp)
            else
               ccmp = ' '
            endif

            if (cmp.eq.1) then  ! Si strips
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
               resid = fhitb_x(ih) - u
            elseif (cmp.eq.2) then ! honeycombs
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
     +              - fhitb_x(ih)
               t_u = fmimp_tx(mimp) * fgede_cos(ipl)
     +              - fmimp_ty(mimp) * fgede_sin(ipl)
               resid = fhitb_q(ih) - u / sqrt(1. + t_u**2)
            elseif (cmp.eq.3) then ! MSGCs
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
               resid = fhitb_x(ih) - u
            endif
            if (cmp.ge.1.and.cmp.le.3) then
               call hfill(6000+cmp,resid,0.,1.)
               call hfill(6003+cmp,resid/fhitb_r(ih),0.,1.)
            endif



            if (cmp.eq.1) then
               if (fgede_cos(ipl).gt.0.7) then
                  if (fgede_sin(ipl).gt.0.) then
                     istereo = 1
                  else
                     istereo = 2
                  endif
               else
                  if (fgede_cos(ipl).gt.0.) then
                     istereo = 3
                  else
                     istereo = 4
                  endif
               endif
               call hfill(6100+istereo,resid,0.,1.)
            else
               sin_tot = fgede_sin(ipl) * fgede_rot(1,ipl)
     +              + fgede_cos(ipl) * fgede_rot(2,ipl)
               if (sin_tot.gt.0.05) then
                  istereo = +1
               elseif (sin_tot.lt.-0.05) then
                  istereo = -1
               else
                  istereo = 0
               endif
            endif
         enddo

*        **** multiple scattering control
         if (iso.lt.nso) then
            ems = sqrt(fgede_ms(ipl)) / abs(fmimp_p(mimp))
            ede = fgede_ms(ipl) / 0.0136**2
            mimp2 = imimmh( istamh(imc) + iso + 1)
            if (min(fmimp_z(mimp),fmimp_z(mimp2)).gt.610.
     +           .or.max(fmimp_z(mimp),fmimp_z(mimp2)).lt.290.) then
               dtx = fmimp_tx(mimp2) - fmimp_tx(mimp)
               dty = fmimp_ty(mimp2) - fmimp_ty(mimp)
               de = (abs(fmimp_p(mimp2)) - abs(fmimp_p(mimp)))
     +              / abs(fmimp_p(mimp))
               if (cmp.ge.1.and.cmp.le.3) then
                  call hfill(6006+cmp,dtx,0.,1.)
                  call hfill(6009+cmp,dty,0.,1.)
                  if (electron) then
                     call hfill(6012+cmp,de,0.,1.)
                  else
                     call hfill(6015+cmp,de,0.,1.)
                  endif
                  if (ems.ne.0.) then
                     call hfill(6018+cmp,dtx/ems,0.,1.)
                     call hfill(6021+cmp,dty/ems,0.,1.)
                     if (electron) then
                        call hfill(6024+cmp,de/ede,0.,1.)
                     else
                        call hfill(6027+cmp,de/ede,0.,1.)
                     endif
                  endif
               endif
            endif
         endif

 29      continue
         nprint = nprint + 1
         if (mod(nprint,10).eq.1)
     +        print '(a4,1x,a7,a10,a7,a4,a10,a10)',
     +        'cmp','mimp','zmimp','hit','ste','res','res/acc'
         if (nnmimp.gt.1) then
            print '(a4,1x,i7,f10.3,(a))',
     +           ccmp,mimp,fmimp_z(mimp),' --- merged hits --- '
         elseif (nhits.eq.0) then
            print '(a4,1x,i7,f10.3,(a))',
     +           ccmp,mimp,fmimp_z(mimp),' ---   no   hits --- '
         else
            print '(a4,1x,i7,f10.3,i7,i4,f10.3,f10.3)',
     +        ccmp,mimp,fmimp_z(mimp),ih,istereo,resid,resid/fhitb_r(ih)
            nch_tot = nch_tot + 1
            ch_tot  = ch_tot  + (resid/fhitb_r(ih))**2
         endif

 30   continue

      if (nch_tot.ge.1) then
         print '(//(a),f10.3,(a),f10.4/)',
     +        '     Total Chi**2 =',ch_tot,
     +        '     Probability=',prob(ch_tot,nch_tot)
      endif

      if (l_diag) call tfwait()

 999  end

