*-- Author :    Rainer Mankel   08/02/95

      subroutine tfparm(izf)

*     **** check reconstructed track parameters against MC
      implicit none
      double precision covi(5,5)
      real tfmitoqpt, pamc(5), dpamc(5), ch2mc, ex(5)
      integer i, j, ndf, izf, ifail, mimp, tfmc, tfmimp
#include "arte/Arte.fi"

#include "rang/zf.fi"


#include "auto/HITB.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"

      ndf = 5
      mimp = tfmimp(izf)

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
       if (mimp.eq.0) then
        print *,' tfparm: mimp=', mimp  ! mimp ambiguous (allowed)
        go to 999
       else
        print *,' () tfparm: mimp=', mimp  ! mimp invalid
        stop 'tfparm'
       endif
      endif

      pamc(1) = fmimp_x(mimp)
     +        + fmimp_tx(mimp) * (z_zf(izf) - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + fmimp_ty(mimp) * (z_zf(izf) - fmimp_z(mimp))
      pamc(3) = fmimp_tx(mimp)
      pamc(4) = fmimp_ty(mimp)
      pamc(5) = tfmitoqpt(mimp)
      do i=1,5
       dpamc(i) = xx_zf(i,izf) - pamc(i)
       ex(i)  = dsqrt(cx_zf(i,i,izf))
      enddo

*     **** chi2
      ch2mc = 0.
      do i=1,ndf
       do j=1,ndf
        covi(i,j) = cx_zf(i,j,izf)
       enddo
      enddo

*     **** blank remaining elements
      do i=ndf+1,5
       do j=ndf+1,5
        covi(i,j) = 0.d0
       enddo
      enddo

**      write(*,'((a),5(/5e11.3))') 'before inv:',covi
      call dsinv(ndf,covi,5,ifail)
**      write(*,'((a),5(/5e11.3))') 'after  inv:',covi
      do i=1,ndf
       do j=1,ndf
        ch2mc = ch2mc + dpamc(i) * dpamc(j) * covi(i,j)
**          print *,' chi2 contr, i,j,contr=',
**     +            i,j,dpamc(i) * dpamc(j) * covi(i,j)
       enddo
      enddo
      if (ifail.ne.0) print *,' =====> ifail,chi2=',ifail,ch2mc

*     **** printout
      print 101, izf, hit_zf(izf), tfmc(izf), z_zf(izf),
     + (pamc(i), xx_zf(i,izf), ex(i), dpamc(i), dpamc(i)/ex(i),i=1,4),
     + (pamc(i), xx_zf(i,izf), ex(i), dpamc(i),
     +                                          dpamc(i)/ex(i),i=5,5),
     + ch2mc, cht_zf(izf), nhit_zf(izf)

 101  format(//
     +  '--------------------------------------------------------'/
     +  '| tfparm analysis izf=',i4,
     +     ' ih=', i5, '  mc=', i5,'  z=', f6.0, '|'/
     +  '|------------------------------------------------------|'/
     +  '|         MC        RC       e(RC)    MC-RC   (MC-RC)/e|'/
     +  '|  x=', 5f10.5, '|'/
     +  '|  y=', 5f10.5, '|'/
     +  '| mx=', 5f10.5, '|'/
     +  '| my=', 5f10.5, '|'/
     +  '| ka=', 5f10.5, '|'/
     +  '|------------------------------------------------------|'/
     +  '| ch2mc=', f10.2, '    ch_zf=', f10.2,
     +                                    '  #hits=', i3,'      |'/
     +  '--------------------------------------------------------'
     +    )

#ifdef PPHISTS
*     **** histograms
      if (nhit_zf(izf).gt.5.and.abs(ex(5)).lt.0.05) then
       call tfphis(pamc(5),sngl(xx_zf(5,izf)),ex(5),ch2mc,
     +                                      cht_zf(izf),nhit_zf(izf))
      endif
#endif

 999  end


