*-- Author :    Rainer Mankel   08/05/96

      subroutine tfpropcx(clus,direction)

*     **** propagate cluster clus in /ztripl/
*     **** direction=-1 means backwards
      implicit none
#include "rang/ztripl.fi"
#include "arte/Arte.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer maxhit
      parameter (maxhit=1000)
      integer clus,nhit,itrip,trip,ii,ind_hs(maxhit),n_unique,set,izf,
     +     lasthit,ift,nca_x,direction,nstring,way
      integer message_id_1
      real w,wtot,sx,sy,sxx,sxy,zref,x,tx,d,tfqptest
      character*500 cstring
#include "auto/GEO.fi"
#include "auto/HITB.fi"
      
      data message_id_1/1/
      save message_id_1

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      nhit = 0
      do 20 itrip=1,999         ! collect triplets
         if (itrip.eq.1) then
            trip = trip1_clus(clus)
         else
            trip = nx_trip(trip)
         endif
         if (trip.eq.0) go to 21
         if (nhit.eq.100) print *,' () tfpropcx: nhit exceeding',
     +        ' 100, clus=', clus,' mult=', mult_clus(clus)
         if (nhit.gt.(maxhit-3)) then
            print *,' () tfpropcx: overflowing nhit=', nhit
            print *,'    discard cluster ', clus,
     +           ' mult=', mult_clus(clus)
            go to 999
         endif
         do ii=1,3
            nhit = nhit + 1
            ind_hs(nhit) = s_trip(ii,trip)
         enddo
 20   continue
 21   continue

      if (direction.eq.1) then
         way = 0
      elseif (direction.eq.-1) then
         way = 1
      else
         print *,' () tfpropcx: invalid direction=', direction
      endif
      call sortzv(z_set,ind_hs,nhit,+1,way,1) ! sort decr z

      lasthit = 0
      n_unique = 0
      do ii=1,nhit              ! clean up the duplicates
         set = ind_hs(ii)
         if (hit_set(set).ne.lasthit) then
            n_unique = n_unique + 1
            ind_hs(n_unique) = set
            lasthit = hit_set(set)
         endif
      enddo
      nhit = n_unique
      if (n_unique.gt.100) then
         print *,' () tfpropcx: n_unique=', n_unique,
     +        ' skip cluster ', clus
         go to 999
      endif

      zref = z_set(ind_hs(nhit))
      wtot = 0.
      sx = 0.
      sy = 0.
      sxy = 0.
      sxx = 0.
      n_zf = 0
      nca_ft = 0

      if ((n_zf + nhit).gt.nzfmx) then
         call mepric(message_id_1,3,
     +        'tfpropcx: ranger buffer at limit, clusters aborted')
         go to 999
      endif

      do ii=1,nhit              ! linear regression
         set = ind_hs(ii)
         w = 1. / fhitb_r( hit_set(set) )**2
         if (fhitb_r( hit_set(set) ).le.0.)
     +        print *,' () tfpropcx: r=', fhitb_r( hit_set(set) )
         wtot = wtot + w
         sx = sx + w * (z_set(set)-zref)
         sy = sy + w * x_set(set)
         sxy = sxy + w * (z_set(set)-zref) * x_set(set)
         sxx = sxx + w * (z_set(set)-zref)**2
**            print *,' ii,x,z,zref,w=',ii,x_set(set),z_set(set),zref,w

         n_zf = n_zf + 1
         hit_zf(n_zf)   = hit_set(set)
         nhit_zf(n_zf)  = ii
         whit_zf(n_zf)  = ii
         plane_zf(n_zf) = ihitb_gede(hit_set(set))
         z_zf(n_zf) = fhitb_z(hit_set(set))
         ch_zf(n_zf) = 0.
         cht_zf(n_zf) = 0.
         sign_zf(n_zf) = sig_set(set)
         domlay_zf(n_zf) = dl_set(set)
         if (ii.eq.1) then
            prev_zf(n_zf) = 0
         else
            prev_zf(n_zf) = n_zf - 1
         endif
         fault_zf(n_zf) = 0
         pfault_zf(n_zf) = 0
         dim_zf(n_zf) = 1
         shadow_zf(n_zf) = 0
      enddo

      d = wtot * sxx - sx**2
      if (d.eq.0.) print *,' () tfpropcx: discr=0'

      x  = (sxx * sy - sx * sxy) / d
      tx = (wtot * sxy - sx * sy) / d

      do izf=1,n_zf
         xx_zf(1,izf) = x + (z_zf(izf)-zref) * tx
         xx_zf(2,izf) = 0.
         xx_zf(3,izf) = tx
         xx_zf(4,izf) = 0.
         xx_zf(5,izf) = 0.
      enddo

      xx_zf(5,n_zf) = tfqptest(fhitb_z(hit_set(ind_hs(nhit))),x,tx)
      cx_zf(1,1,n_zf) = sxx / d
      cx_zf(3,3,n_zf) = wtot / d
      cx_zf(1,3,n_zf) = -sx / d
      cx_zf(3,1,n_zf) = -sx / d

      if (diag_level.ge.4) then
         print *,' track parameters:'
         print '(a6,f10.3,a6,f10.3)',
     +        ' x=',xx_zf(1,n_zf),' +- ', dsqrt( cx_zf(1,1,n_zf) )
         print '(a6,f10.3,a6,f10.3)',
     +        ' tx=',xx_zf(3,n_zf),' +- ', dsqrt(cx_zf(3,3,n_zf))
      endif

*     **** fill candidate info
      nca_ft          = nca_ft + 1
      ift             = nca_ft
      first_ft(ift)   = 1
      last_ft(ift)    = n_zf
      prev_ft(ift)    = 0
      gen_ft(ift)     = nhit
      nhit_ft(ift)    = nhit
      nfault_ft(ift)  = 0
      quality_ft(ift) = nhit
      alive_ft(ift)   = .true.
      mature_ft(ift)  = .false.
      stat_ft(ift)    = 0

      if (diag_level.ge.4) then
         print *,' tfpropcx: cluster', clus, ' stored',
     +        ' n_zf,nca_ft=',n_zf,nca_ft
      endif
*     **** track all seeds simultaneously
      begin_ft = 1
      l_2dx = .true.
      l_2dy = .false.
      if (diag_level.ge.3) then
         cstring = ' '
         call tfstrg(1,cstring,nstring)
         print *,' tfpropcx: propagate ', cstring(1:nstring)
      endif

      call tfpropx(direction)

*     **** final killings
      call tfbest()
      nca_x = nca_ft


 999  end











