*-- Author :    Rainer Mankel   18/05/95
*-- changed:    A. Spiridonov   20/02/98

      subroutine tfref()

*     **** find the reference tracks & fill /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"
#include "rang/zseed.fi"
#include "pris/zpstat.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zpstat_tc.fi"

      integer ii, n_prmimp, n_magmimp, n_propmimp, imc, nso, imim, ipl,
     +        isl, iso, cmp, gold, igold, jgold, moth_vx, moth_mc,
     +        code_photon, jaux, jauxh, hit, n_clean, maxpl_patt,
     +        npl_patt_zero, npl_patt_stereo, tpname
      parameter (maxpl_patt=200)
      integer pl_patt_zero(maxpl_patt), pl_patt_stereo(maxpl_patt),
     +        seedx, seedy, iplseed1, iplseed2
      logical init
      real z, r, p, zmag_mimp, zmin_mimp
      logical found_1, found_2, l_seedx, l_seedy
      integer event

      integer nmag_sl,ntrig_sl
      parameter (nmag_sl=6)
      logical trig_sl(nmag_sl)
      real z1_sl(nmag_sl), z2_sl(nmag_sl)
      data z1_sl/300., 350., 400., 450., 500., 550./
      data z2_sl/350., 400., 450., 500., 550., 600./

#include "pris/hgmagnhelp.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

      save event, init
      data event /0/
      data init /.false./

      integer muon1,muon2,pion1,pion2
      real z_mag_mimp(100),zmag_max,pmag_min,pmag_max

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )
    
      integer n_TC1mimp,n_TC2mimp
      integer n_VDmimp
      integer mc,id
      real e_mc,a_mc,pseudorap

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      call rginit()  ! initialize ranger if necessary

      if (.not.init) then
         code_photon  = tpname('gamma')
         init = .true.
      endif

      event = event + 1

*     **** reset /zpstat/
      pstat_nrefpat = 0
      pstat_nrefmag = 0
      pstat_nrefTC = 0
      pstat_ngold = 0

      pion1_PC = .false.
      pion2_PC = .false.

*     **** prepare mh
      call tusomh()

*     **** loop over MC particles

      do 10 imc=1,iq(jmtra+2)

      zmag_mimp = 1.e10
      zmag_max = -1.e10  
      zmin_mimp = 1.e10
      pmag_min =  1.e10
      pmag_max =  0.

      do ii=1,nmag_sl 
        trig_sl(ii) = .false.
      end do
      
       if (diag_level.ge.5) print *,' tfref: imc=', imc
       p = sqrt(fmtra_px(imc)**2 +fmtra_py(imc)**2 +fmtra_pz(imc)**2)
       if (p.lt.1.) go to 10   ! check momentum
       moth_vx = omtra_bver(imc)
       if (diag_level.ge.5) print *,' tfref: moth_vx=', moth_vx
       if (moth_vx.gt.0) then
        moth_mc = omver_btra(moth_vx)
        if (moth_mc.gt.0) then
         if (omtra_topp(moth_mc).eq.code_photon) go to 10
        endif
       endif
*      **** loop over mimps in sorted order
       nso = nmimmh(imc)
       n_prmimp = 0     ! reset mimp counters for current particle
       n_magmimp = 0    !
       n_TC1mimp = 0    !
       n_TC2mimp = 0    !
       n_VDmimp = 0     !
       n_propmimp = 0   !

       npl_patt_zero   = 0 ! reset seeding plane monitoring
       npl_patt_stereo = 0 !

       do 30 iso=1,nso
        if (diag_level.ge.5) print *,' tfref: iso=', iso
        imim = imimmh( istamh(imc) + iso )
        if (diag_level.ge.5) print *,' tfref: imim=', imim
        ipl = imimp_gede(imim)
*       **** avoid packed IPLs in ECAL
        if (ipl.gt.iq(jgede+2)) go to 30
        isl = ogede_gesl(ipl)
        cmp = igede_cmp(ipl)
        if (cmp.lt.1.or.cmp.gt.3) go to 30     ! only Si,Straw,MSGC
*       **** locate hit(s)
        n_clean = 0
        do 40 ii=1,99
         if (ii.eq.1) then
          jaux = pmimp_hitb(imim)
         else
          jaux = xmimp_hitb(jaux)
         endif
         if (jaux.eq.0) go to 41
         hit = mmimp_hitb(jaux)
*        **** check if hit is clean
         jauxh = phitb_mimp(hit)
         if (jauxh.eq.0) go to 40            ! cannot happen
         if (xhitb_mimp(jauxh).ne.0) go to 40 ! more than 1 mimp
         n_clean = n_clean + 1
 40     continue
 41     continue
**        if (n_clean.le.0) go to 30 ! no clean hit associated with mimp       

        z = fmimp_z(imim)
        p = 0.
        if(imim.gt.0) p = fmimp_p(imim) 
        if(imim.gt.0.and.z.lt.zmin_mimp) zmin_mimp = z

        if (z.gt.1330.) then
*        **** beyond-ECAL area: ignore

        else if (z.gt.1150.and.z.lt.1240) then
*        **** TC1-area
        n_TC1mimp = n_TC1mimp + 1

        else if (z.gt.1250.and.z.lt.1330) then
*        **** TC2-area
        n_TC2mimp = n_TC2mimp + 1

        elseif (z.lt.200.) then
*        **** Si vertex area: ignore
        n_VDmimp = n_VDmimp + 1

        else if (z.gt.200..and.z.lt.1000.) then
*        **** main tracker
         if (igesl_mfl(isl).eq.0) then
*         **** pattern recognition area
          n_prmimp = n_prmimp + 1
*         **** account for seeding planes
          if (abs(fgede_sin(ipl)).lt.0.001.and.
     +        abs(fgede_rot(2,ipl)).lt.0.001) then
           if (npl_patt_zero.ge.maxpl_patt) then
            print *,' () tfref: overflowing npl_patt_zero '
            stop 'tfref'
           endif
           npl_patt_zero = npl_patt_zero + 1
           pl_patt_zero(npl_patt_zero) = ipl
          else
           if (npl_patt_stereo.ge.maxpl_patt) then
            print *,' () tfref: overflowing npl_patt_stereo '
            stop 'tfref'
           endif
           npl_patt_stereo = npl_patt_stereo + 1
           pl_patt_stereo(npl_patt_stereo) = ipl
          endif

         else
*         **** magnet area
          n_magmimp = n_magmimp + 1
          if ((z.gt.200.).and.(p.ge.pmag_max).and.(p.ne.0.)) 
     +                                               pmag_max=p !smallest p 
          r = sqrt( (z - zposmg)**2 + fmimp_x(imim)**2 )
          if (r.lt.rmag) then
*          **** magnet proper
           n_propmimp = n_propmimp + 1
           z_mag_mimp(n_propmimp) = z
           if (z.lt.zmag_mimp) zmag_mimp = z ! smallest z in mag proper
           if (z.gt.zmag_max) zmag_max = z   ! largest z in mag proper
           if (p.lt.pmag_min.and.p.ne.0.) pmag_min = p   ! smallest p 
*           if (p.gt.pmag_max) pmag_max = p               ! largest p

           do ii=1,nmag_sl           
             if(z.ge.z1_sl(ii).and.z.le.z2_sl(ii)) then
              trig_sl(ii) = .true.
              go to 50
             end if
           end do
 50        continue
          endif
         endif
        endif
 30    continue ! loop over mimps

*      **** p.r. reference track ?
       if (n_prmimp.ge.minmimp_pref_zfpar) then

*       **** check if imc is a golden track
        jgold = 0
        do 20 gold=1,pstat_ngold
         do igold=1,4
          if (pstat_gold(igold,gold).eq.imc) then
           jgold = igold
           go to 21
          endif
         enddo
 20     continue
 21     continue

        jgold = 1                           ! for single particle generator
*       
        if (pstat_nrefpat.lt.maxref) then
         pstat_nrefpat = pstat_nrefpat + 1  ! accept
         pstat_refpat(pstat_nrefpat) = imc
         pstat_jgoldpat(pstat_nrefpat) = jgold
         ref_mh(imc) = .true.
         if (diag_level.ge.6) print *,' tfref: accept imc=', imc

*        **** hitted superlayers at magnet
         if(zmin_mimp.lt.z1_sl(1)) then
           ntrig_sl = 0
           do ii=1,nmag_sl
             if(trig_sl(ii)) ntrig_sl = ntrig_sl + 1 
           end do  
         else
           ntrig_sl = 100
         end if
         jgold = 0
         mc = imc
         if(mc.eq.muon1) jgold=1
         if(mc.eq.muon2) jgold=2
         if(mc.eq.pion1) jgold=3
         if(imc.eq.pion2) jgold=4


#ifdef FILL_TC_HISTS
*         if(.true..and.(jgold.gt.0).and.(zmag_mimp.lt.450.)) then
         if(.true..and.(jgold.gt.0)) then
           e_mc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
           a_mc = sqrt( fmtra_px(mc)**2/fmtra_pz(mc)**2
     +        +         fmtra_py(mc)**2/fmtra_pz(mc)**2 )
*           pseudorap = - alog(0.5*a_mc)
           pseudorap = - alog(tan(0.5*atan(a_mc)))
           if(jgold.eq.1.or.jgold.eq.2) id = 200
           if(jgold.eq.3.or.jgold.eq.4) id = 300
*           print *,'a,ps,n',a_mc,pseudorap,n_propmimp
           call hf2(id+32,pseudorap,float(n_propmimp),1.)
           if(id.eq.200) then
             call hf2(id+33,pseudorap,float(n_TC1mimp),1.)
             call hf2(id+34,pseudorap,float(n_TC2mimp),1.)
           end if
           call hf2(id+37,pseudorap,float(n_VDmimp),1.)
         end if  
#endif

*        **** magnet reference track ?
         if ((n_propmimp.gt.4).and.(zmag_mimp.lt.450.).and.
     +      (zmag_max.gt.515.).and.(pmag_max/pmag_min.lt.1.3).and.
     +      (ntrig_sl.ge.3) ) then

#ifdef RT_TEST
            if ((imc.eq.muon1).or.(imc.eq.muon2)) then
              print '("ref mc,pmin,max,mi/max ",i4,20(f6.1))'
     +          ,imc,pmag_min,pmag_max,(pmag_min/pmag_max)
            end if
#endif

          if (pstat_nrefmag.lt.maxref) then
           pstat_nrefmag = pstat_nrefmag + 1  ! accept
           pstat_refmag(pstat_nrefmag) = imc
           pstat_jgoldmag(pstat_nrefmag) = jgold
          if (diag_level.ge.6) print *,' tfref: mag-accept imc=', imc
          else
           print *,' () tfref: overflowing pstat_nrefmag=',
     +                                                 pstat_nrefmag
          endif

*         **** TC reference track          

          if(jgold.eq.3) pion1_PC = .true.
          if(jgold.eq.4) pion2_PC = .true.
         
          if(n_TC1mimp.ge.3.and.n_TC2mimp.ge.3) then     ! TC ref tracks   

            if(pstat_nrefTC.lt.maxref) then   
              pstat_nrefTC = pstat_nrefTC + 1  ! accept
              pstat_refTC(pstat_nrefTC) = imc
              pstat_jgoldTC(pstat_nrefTC) = jgold
              if (diag_level.ge.6) print *,' tfref: TC-accept imc=', imc
            else
              print *,' () tfref: overflowing pstat_nrefTC='
     +                                        ,pstat_nrefTC
            endif
          end if                    ! end of TC ref tracks

         endif                      !  end of magnet ref track
        else
         print *,' () tfref: overflowing pstat_nrefpat=',
     +                                                 pstat_nrefpat
        endif
       endif

 10   continue ! loop over imc

      end

*             if(jgold.gt.0.and.jgold.lt.3) then
*                print '("tfref : TC-ref jgold,imc,nmimp ",4i4)'
*     +              ,jgold,imc,n_TC1mimp,n_TC2mimp
*             end if





