*-- Author :    Rainer Mankel   19/05/95
*--changed :    A.Spiridonov    22/04/98

      subroutine tfstam1()

*     **** pattern recognition efficiencies etc (here: magnet)

      implicit none
      
#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfout.fi"
#include "rang/FLAGHist.hh"
#include "rang/descend.fi"
#include "pris/zpstat.fi"
#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "arte/RSEG_cmp.fi"

      integer ncounter, code_eplus, code_eminus, code_muplus,
     +        code_muminus, max_t, tpname
      parameter (ncounter=10)
                 ! counter=1  for e+-
                 !         2  for mu+-
                 !         3  for l+-
                 !         4  for pi+-
                 !         5  for J/Psi
                 !         6  for K0S
                 !         7  for B0
                 !         8  for charged tracks
                 !         9  for charged non-e+-
                 !        10  for ghosts

      parameter (max_t=300)

      integer counter_mc_evt(ncounter), ! reference mc objects per evt
     +        counter_mc_all(ncounter), !           ||        (all evts)
     +        counter_rc_evt(ncounter), ! reference rc objects per evts
     +        counter_rc_all(ncounter), !           ||        (all evts)
     +        counter_ef_all(ncounter), ! defined efficiency evts
     +        counter_cl_evt(ncounter), ! clones per evt
     +        counter_cl_all(ncounter)  !           ||        (all evts)
      real    counter_evtef (ncounter), ! current evt efficiencies
     +        counter_allef (ncounter), ! current run efficiencies
     +        accumul_ef_all(ncounter)  ! summed efficiency   (all evts)
      integer counter, ii, mc, ind_rt, rc, nrc, iirt, it, gold, jgold,
     +        mcgold, counter_lep, lepton, imc, n_events, OK
      integer magref_nrc(maxref)
      character*20 cname
      real mass, charge, pmc, fracmc
      character*20 counter_name(ncounter) ! name of counter
      logical lrefpat(7,maxgold), lrc(7,maxgold), lrec_t(max_t)
      integer numrc(7,maxgold) 

      data n_events /0/

      data counter_name / 'golden e+-', 'golden mu+-', 'golden l+-',
     +      'golden pi+-', 'golden J/Psi', 'golden K0S', 'golden B0',
     +      'charged tracks', 'charged non-e+-', 'ghosts' /

      data counter_mc_evt /ncounter*0/,
     +     counter_mc_all /ncounter*0/,
     +     counter_rc_evt /ncounter*0/,
     +     counter_rc_all /ncounter*0/,
     +     counter_ef_all /ncounter*0/,
     +     counter_cl_all /ncounter*0/,
     +     accumul_ef_all /ncounter*0./

      save n_events, counter_mc_evt, counter_mc_all, counter_rc_evt,
     +     counter_rc_all, counter_ef_all, counter_cl_all, 
     +     accumul_ef_all, counter_name

      integer if_hist ! 2 pr&hist, 1 hist, 0 
      data if_hist/1/
      save if_hist
      character*3 name_r(4)            ! name of golden part
      data name_r/'mu+','mu-','pi+','pi-'/
      integer muon1,muon2,pion1,pion2  ! mc golden mu+,mu-,pi+,pi-
      integer n_r(7),rc_r(7)           ! num of rec ref golden
      integer jj,ij
      real p_r(5,7),p_mc(5,7),d_p(5,7),d_norm(5,7),ch2_r(7),frac_r(7) 
      real p_r1(5),p_mc1(5),d_p1(5),d_norm1(5),ch2_r1
      integer n_e,n_a

*      parameter (n_e=6)
      parameter (n_e=8)
      parameter (n_a=7)

      integer ne_rc(n_e,7),ne_re(n_e,7),mc_r(7)
      integer na_rc(n_a,7),na_re(n_a,7)
      real eff_e(n_e,7),eff_a(n_a,7),err_e(n_e,7),err_a(n_a,7)
      real bin_e(n_e),bin_a(n_a)

      data bin_e/5., 10., 15., 25., 35., 50., 80., 300./
      data bin_a/.01, .03, .05, .07, .1, .15, .3/

      integer ind_e,ind_a,istat,if_store,id
      real e_mc,a_mc
      logical if_rec(7)

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )


#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"

      call rginit()

      if (n_events.eq.0) then
         code_eplus  = tpname('e+')
         code_eminus = tpname('e-')
         code_muplus = tpname('mu+')
         code_muminus = tpname('mu-')
         do ii=1,n_e
           do jj=1,7
             ne_rc(ii,jj) = 0
             ne_re(ii,jj) = 0
           end do
         end do
         do ii=1,n_a
           do jj=1,7
             na_rc(ii,jj) = 0
             na_re(ii,jj) = 0
           end do
         end do
      endif

      do jj=1,7
        if_rec(jj)= .false.
      end do

      n_events = n_events + 1

      do counter=1,ncounter     ! reset event scope counters
         counter_mc_evt(counter) = 0
         counter_rc_evt(counter) = 0
         counter_cl_evt(counter) = 0
      enddo

      do it=1,max_t
         lrec_t(it) = .false.
      enddo

      do jgold=1,7
         n_r(jgold) = 0
      end do

      if (lref_zfout) then
         print *,' '
         print *,' R e f e r e n c e     T r a c k s  (M) :'
         print *,' '
         print '(3a5,a6,a20)',  ! headline
     +        'mc','rc','nrc','pmc','name'
      endif

      do ii=1,pstat_nrefmag     ! loop over reference tracks
         mc = pstat_refmag(ii)

         jgold = 0
         if(mc.eq.muon1) jgold=1
         if(mc.eq.muon2) jgold=2
         if(mc.eq.pion1) jgold=3
         if(mc.eq.pion2) jgold=4
         if(jgold.gt.0) then
            e_mc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
            a_mc = sqrt( fmtra_px(mc)**2/fmtra_pz(mc)**2
     +           +       fmtra_py(mc)**2/fmtra_pz(mc)**2 )

            if(if_hist.gt.0) then
               if(jgold.eq.1.or.jgold.eq.2) id = 200
               if(jgold.eq.3.or.jgold.eq.4) id = 300
               call hf2(id+31,a_mc*1000.,e_mc,1.)
            end if  

            do jj=1,n_e
               if(e_mc.le.bin_e( n_e - jj + 1)) ind_e = n_e - jj + 1
            end do
            do jj=1,n_a
               if(a_mc.le.bin_a( n_a - jj + 1)) ind_a = n_a - jj + 1
            end do
*           print *,'e,a ie,ia',e_mc,a_mc,ind_e,ind_a
            ne_re(ind_e,jgold) = ne_re(ind_e,jgold) + 1
            na_re(ind_a,jgold) = na_re(ind_a,jgold) + 1
         end if

*        **** check if reconstructed
         nrc = 0
         rc = 0

         if (jrseg.le.0) go to 11

         do 10 iirt=1,20        ! locate segmentss
            if (iirt.eq.1) then
               ind_rt = pmtra_rseg(mc)
            else
               ind_rt = xmtra_rseg(ind_rt)
            endif
            if (ind_rt.eq.0) go to 11
            rc = mmtra_rseg(ind_rt)

            if(( IAND(irseg_cmp(rc),rsegc_magt).eq.0 )  
     +      .or.( IAND(irseg_cmp(rc),rsegc_bitsign ).ne.0)) go to 10 ! magnet

            call tfremcse(rc,imc,fracmc) ! locate MC particle again
            call tfmtchs(rc,mc,OK) ! check if low z reached

            if (fracmc.ge.0.7
***     +           .and.abs(frtra_cvf(15,rc)).lt.0.5*cqqrf_zfpar
***     +           .and.frtra_zf(rc).lt.190.
***     +           .and.mc.eq.imc
     +           .and.OK.eq.1) then

*              print '("tfstam1 : z,cvf(15),cqq ",3e10.3)'
*     +            ,frtra_zf(rc),frtra_cvf(15,rc),cqqrf_zfpar

               nrc = nrc + 1

*               print '("tfstam1 : rc,imc,OK,fracmc,z ",3i5,2f7.2)'
*     +             ,rc,imc,OK,fracmc,frtra_zf(rc)
*               if(nrc.gt.1) print'("tfstam1 : ********** CLONE")'

               if(imc.ne.mc) then
                  print *,'tfstam1 : / / /  mc,imc', mc,imc
                  go to 10
               end if
               if(jgold.eq.0) go to 10   
               n_r(jgold) = n_r(jgold) + 1
               call tftcpars(rc,1,imc,p_r1,p_mc1,d_p1,d_norm1,ch2_r1,
     +              istat)
               
               if(n_r(jgold).eq.1) then
                  ne_rc(ind_e,jgold) = ne_rc(ind_e,jgold) + 1
                  na_rc(ind_a,jgold) = na_rc(ind_a,jgold) + 1
               end if

               if_store = 0
               if(n_r(jgold).eq.1.or.ch2_r1.lt.ch2_r(jgold)) if_store=1 

               if(if_store.ne.0) then
                  do jj=1,5     ! store residuals
                     rc_r  (   jgold) = rc
                     p_r   (jj,jgold) = p_r1(jj)
                     p_mc  (jj,jgold) = p_mc1(jj)
                     d_p   (jj,jgold) = d_p1(jj)
                     d_norm(jj,jgold) = d_norm1(jj)
                     ch2_r (   jgold) = ch2_r1
                     frac_r(   jgold) = fracmc
                     mc_r  (   jgold) = mc
                     if_rec(   jgold) = .true.
                  end do
               end if

            endif               ! end of OK rec track
 10      continue
 11      continue

         magref_nrc(ii) = nrc

         if (lref_zfout) then
**            if (mc.eq.muon1.or.mc.eq.muon2.or.
**     +           mc.eq.pion1.or.mc.eq.pion2) then
               call tupaty(omtra_topp(mc),cname,charge,mass,'G')
               pmc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2
     +              +fmtra_pz(mc)**2)
               print '(3i5,f6.2,1x,a19)',
     +              mc,rc,nrc,pmc,cname
**            endif
         end if

         counter = 8            ! charged particles
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (nrc.gt.0) then
            counter_rc_evt(counter) = counter_rc_evt(counter) + 1
            if (nrc.gt.1) then
               counter_cl_evt(counter) = 
     +              counter_cl_evt(counter) + nrc - 1
            endif
         endif

         counter = 9            ! charged non-e+-
         if (omtra_topp(mc).ne.code_eplus
     +        .and.omtra_topp(mc).ne.code_eminus) then
            counter_mc_evt(counter) = counter_mc_evt(counter) + 1
            if (nrc.gt.0) then
               counter_rc_evt(counter) = counter_rc_evt(counter) + 1
               if (nrc.gt.1) then
                  counter_cl_evt(counter) = 
     +                 counter_cl_evt(counter) + nrc - 1
               endif
            endif
         endif

      enddo                     ! reference tracks

      counter = 10              ! ghosts
      if (jrtra.ne.0) then
         do it=1,iq(jrtra+2)    ! loop over reconstructed tracks
            if (prtra_mtra(it).eq.0) then ! check if no corresponding MC
               counter_rc_evt(counter) = counter_rc_evt(counter) + 1
            endif
         enddo                  ! RC tracks
      endif
      counter_mc_evt(counter) = counter_mc_evt(8) ! normalize to ref tr

*     **** loop over golden Bs
      do gold=1,pstat_ngold
         do jgold=1,4           ! loop over stable golden particles
            mcgold = pstat_gold(jgold,gold)
            lrefpat(jgold,gold) = .false. ! initialize ref track flag
            lrc    (jgold,gold) = .false. ! initialize reco flag
            numrc(jgold,gold)   = 0 
            do 20 ii=1,pstat_nrefmag ! gold part occurs in ref tracks ?
               mc = pstat_refmag(ii)
               if (mc.eq.mcgold) then
                  lrefpat(jgold,gold) = .true.
                  if (magref_nrc(ii).gt.0) then
                     lrc(jgold,gold) = .true.
                     numrc(jgold,gold) = 
     +                    numrc(jgold,gold) + magref_nrc(ii)
                  endif
***                  go to 21
               endif
 20         continue            ! mc ref loop
 21         continue
*     **** check if reconstructed
******* lrc(jgold,gold) = pmtra_rtra(mcgold).gt.0
         enddo
         lrefpat(5,gold) = lrefpat(1,gold).and.lrefpat(2,gold) ! J/Psi
         lrefpat(6,gold) = lrefpat(3,gold).and.lrefpat(4,gold) ! K0S
         lrefpat(7,gold) = lrefpat(5,gold).and.lrefpat(6,gold) ! B0
         lrc(5,gold) = lrc(1,gold).and.lrc(2,gold) ! J/Psi
         lrc(6,gold) = lrc(3,gold).and.lrc(4,gold) ! K0S
         lrc(7,gold) = lrc(5,gold).and.lrc(6,gold) ! J/Psi
      enddo


      counter = 3               ! l+-
      do gold=1,pstat_ngold
         do jgold=1,2
            if (lrefpat(jgold,gold)) then
               counter = 3      ! l+-
               lepton = omtra_topp(pstat_gold(jgold,gold))
               if (lepton.eq.code_eplus.or.lepton.eq.code_eminus) then
                  counter_lep = 1
               elseif (lepton.eq.code_muplus
     +                 .or.lepton.eq.code_muminus) then
                  counter_lep = 2
               else
                  print *,' () tfstam: invalid lepton: ', lepton
                  counter_lep = 2
               endif
               counter_mc_evt(counter) = counter_mc_evt(counter) + 1
               counter_mc_evt(counter_lep) = 
     +              counter_mc_evt(counter_lep) + 1
               if (lrc(jgold,gold)) then
                  counter_rc_evt(counter) = counter_rc_evt(counter) + 1
                  counter_rc_evt(counter_lep) = 
     +                 counter_rc_evt(counter_lep) + 1
                  if (numrc(jgold,gold).gt.1) then
                     counter_cl_evt(counter_lep) =
     +                    counter_cl_evt(counter_lep) 
     +                    + numrc(jgold,gold)
                  endif
               endif
            endif
         enddo
      enddo

      counter = 4               ! pi+-
      do gold=1,pstat_ngold
         do jgold=3,4
            if (lrefpat(jgold,gold)) then
               counter_mc_evt(counter) = counter_mc_evt(counter) + 1
               if (lrc(jgold,gold)) then
                  counter_rc_evt(counter) = counter_rc_evt(counter) + 1
               endif
            endif
         enddo
      enddo

      do counter=5,7
         do gold=1,pstat_ngold
            jgold=counter
            if (lrefpat(jgold,gold)) then
               counter_mc_evt(counter) = counter_mc_evt(counter) + 1
               if (lrc(jgold,gold)) then
                  counter_rc_evt(counter) = counter_rc_evt(counter) + 1
               endif
            endif
         enddo
      enddo

      do counter=1,ncounter
*      **** event-based efficiencies
         if (counter_mc_evt(counter).gt.0) then
            counter_ef_all(counter) = counter_ef_all(counter) + 1
            counter_evtef(counter) = float(counter_rc_evt(counter))
     +           / float(counter_mc_evt(counter))
            accumul_ef_all(counter) = accumul_ef_all(counter)
     +           + counter_evtef(counter)
         else
            counter_evtef(counter) = 0.
         endif
*      **** update all counters
         counter_mc_all(counter) = counter_mc_all(counter)
     +        + counter_mc_evt(counter)
         counter_rc_all(counter) = counter_rc_all(counter)
     +        + counter_rc_evt(counter)
         counter_cl_all(counter) = counter_cl_all(counter)
     +        + counter_cl_evt(counter)
         
         if (counter_mc_all(counter).gt.0) then
            counter_allef(counter) = float(counter_rc_all(counter))
     +           / float(counter_mc_all(counter))
         else
            counter_allef(counter) = 0.
         endif
      enddo                     ! updating of counters
     
*     **** fill histograms

#ifdef rangerHIST

      if(if_hist.gt.0) then
         do jj=1,4
            if(if_rec(jj)) then
               if(jj.eq.1.or.jj.eq.2) id = 200
               if(jj.eq.3.or.jj.eq.4) id = 300
               do ii=1,5
                  call hf1(id+10+ii,d_norm(ii,jj),1.)
                  call hf1(id+40+ii,   d_p(ii,jj),1.)
               end do
               
               if(p_r(5,jj).ge.0.) then ! 1/p error
                  call hf1(id+21,d_norm(5,jj),1.)
               else
                  call hf1(id+21,-d_norm(ii,jj),1.)
               end if

               call hf1(id+16,(p_mc(5,jj)/p_r(5,jj)-1.),1.) ! -0.10 0.10
               call hf1(id+22,(p_mc(5,jj)/p_r(5,jj)-1.),1.) ! -0.15 0.15
               call hf1(id+23,(p_r(5,jj)/p_mc(5,jj)-1.),1.) ! -0.10 0.10
               call hf1(id+24,(p_r(5,jj)/p_mc(5,jj)-1.),1.) ! -0.15 0.15
               call hf1(id+25,(p_r(5,jj)-p_mc(5,jj)),1.)      

               call hf1(id+26,frtra_zf(rc_r(jj)),1.)

*            print *,'stam1 : qp,pmc',p_r(5,jj),p_mc(5,jj)

               if(frac_r(jj).lt.0.9999) then
                  call hf1(id+17,(1.-frac_r(jj))*100.,1.) 
               end if

               mc=mc_r(jj)
               e_mc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2
     +              +fmtra_pz(mc)**2)
               a_mc = sqrt( fmtra_px(mc)**2/fmtra_pz(mc)**2
     +              +       fmtra_py(mc)**2/fmtra_pz(mc)**2 )*1000.

               call hf1(id+18,e_mc,1.)
               call hf1(id+19,a_mc,1.)
               if(n_r(jj).gt.1) call hf1(id+20,float(n_r(jj)-1),1.)
               
            end if
         end do
      end if                    ! end of fill histograms
#endif

*     **** print reconstructed tracks
**      if (lrec_zfout.and.if_hist.eq.2) then
      if (lrec_zfout) then
         print *,' '
         print *,' R e c o n s t r u c t e d     Segments    :'
         print *,' '
         print '(a4,a5,a6,2a5,a8)', ! headline
     +        ' trk','mc','frac','nhi','fit','chi'
         if (jrtra.ne.0) then
            do it=1,iq(jrseg+2)
               call tfremcse(it,mc,fracmc)

               if(mc.eq.muon1.or.mc.eq.muon2.or.
     +              mc.eq.pion1.or.mc.eq.pion2    ) then  
                  print '(i4,i5,f6.2,2i5,f8.2)',
     +                 it,mc,fracmc,
     +                 irtra_hsi(it)+irtra_hou(it)+irtra_hin(it),
     +                 irtra_fit(it),
     +                 frtra_chi(it)
               end if
               
            enddo
         endif

         print *,' '
         print *,' T r a c k s       R e s i d u a l s:'
         print *,' '
         
         do jgold=1,4
            if(n_r(jgold).gt.0) then
               print '(2x,a3,"   n_r= ",i2," rc= ",i4," chi2= ",f8.3
     +              ," frac= ",f8.3)'
     +              ,name_r(jgold),n_r(jgold),rc_r(jgold),ch2_r(jgold)
     +              ,frac_r(jgold)
               print '(" p_r    ",6(x,f9.4))',(p_r   (ii,jgold),ii=1,5)
     +              ,(1./p_r(5,jgold))
               print '(" p_mc   ",6(x,f9.4))',(p_mc  (ii,jgold),ii=1,5)
     +              ,(1./p_mc(5,jgold))
               print '(" d_p    ",5(x,f9.4))',(d_p   (ii,jgold),ii=1,5)
               print '(" d_norm ",5(x,f9.4))',(d_norm(ii,jgold),ii=1,5)
            end if
         end do

      endif
 
*     **** printout
      if (leff_zfout) then
         do ii=1,n_e
            eff_e(ii,1) = float(ne_rc(ii,1)+ne_rc(ii,2)) 
     +           /(1.e-10 + float(ne_re(ii,1)+ne_re(ii,2))) * 100. 
            err_e(ii,1) = 
     +           sqrt(float(ne_re(ii,1)+ne_re(ii,2)-ne_rc(ii,1)
     +           -ne_rc(ii,2))
     +           * eff_e(ii,1))/(1.e-10+float(ne_re(ii,1)+ne_re(ii,2)))
     +           *10.

         end do
         do ii=1,n_a
            eff_a(ii,1) = float(na_rc(ii,1)+na_rc(ii,2)) 
     +           /(1.e-10 + float(na_re(ii,1)+na_re(ii,2))) * 100.
            err_a(ii,1) = 
     +           sqrt(float(na_re(ii,1)+na_re(ii,2)-na_rc(ii,1)
     +           -na_rc(ii,2))
     +           * eff_a(ii,1))/(1.e-10+float(na_re(ii,1)+na_re(ii,2)))
     +           *10.
         end do

         do ii=1,n_e
            eff_e(ii,3) = float(ne_rc(ii,3)+ne_rc(ii,4)) 
     +           /(1.e-10 + float(ne_re(ii,3)+ne_re(ii,4))) * 100. 
            err_e(ii,3) = 
     +           sqrt(float(ne_re(ii,3)+ne_re(ii,4)
     +           -ne_rc(ii,3)-ne_rc(ii,4))
     +           * eff_e(ii,3))/(1.e-10+float(ne_re(ii,3)+ne_re(ii,4)))
     +           *10.
         end do
         do ii=1,n_a
            eff_a(ii,3) = float(na_rc(ii,3)+na_rc(ii,4)) 
     +           /(1.e-10 + float(na_re(ii,3)+na_re(ii,4))) * 100.
            err_a(ii,3) = 
     +           sqrt(float(na_re(ii,3)+na_re(ii,4)-na_rc(ii,3)
     +           -na_rc(ii,4))
     +           * eff_a(ii,3))/(1.e-10+float(na_re(ii,3)+na_re(ii,4)))
     +           *10.
         end do

#ifdef UN_TEST
         print '(/)'   
         print '(" p , Gev/c   ",10f6.1)',(bin_e(ii), ii=1,n_e)
         
         print '(" mu rc vs p  ",10i6)'
     +        ,( (ne_rc(ii,1)+ne_rc(ii,2)), ii=1,n_e )
         print '(" mu re vs p  ",10i6)'
     +        ,( (ne_re(ii,1)+ne_re(ii,2)), ii=1,n_e )
         print '(" mu eff vs p ",10f6.1)'
     +        ,( eff_e(ii,1), ii=1,n_e )
         print '("    error    ",10f6.1)'
     +        ,( err_e(ii,1), ii=1,n_e )
         
         print '(" pi rc vs p  ",10i6)'
     +        ,( (ne_rc(ii,3)+ne_rc(ii,4)), ii=1,n_e )
         print '(" pi re vs p  ",10i6)'
     +        ,( (ne_re(ii,3)+ne_re(ii,4)), ii=1,n_e )
         print '(" pi eff vs p ",10f6.1)'
     +        ,( eff_e(ii,3), ii=1,n_e )
         print '("    error    ",10f6.1)'
     +        ,( err_e(ii,3), ii=1,n_e )

         print '(/)'   
         print '(" angle , mlrd",10f6.1)',((bin_a(ii)*1000.), ii=1,n_a)
         print '(" mu rc vs a  ",10i6)'
     +        ,( (na_rc(ii,1)+na_rc(ii,2)), ii=1,n_a )
         print '(" mu re vs a  ",10i6)'
     +        ,( (na_re(ii,1)+na_re(ii,2)), ii=1,n_a )
         print '(" mu eff vs a ",10f6.1)'
     +        ,( eff_a(ii,1), ii=1,n_a )
         print '("    error    ",10f6.1)'
     +        ,( err_a(ii,1), ii=1,n_a )

         print '(" pi rc vs a  ",10i6)'
     +        ,( (na_rc(ii,3)+na_rc(ii,4)), ii=1,n_a )
         print '(" pi re vs a  ",10i6)'
     +        ,( (na_re(ii,3)+na_re(ii,4)), ii=1,n_a )
         print '(" pi eff vs a ",10f6.1)'
     +        ,( eff_a(ii,3), ii=1,n_a )
         print '("    error    ",10f6.1)'
     +        ,( err_a(ii,3), ii=1,n_a )
#endif

         print *,' '
         print *,' G o l d e n     T r a c k s :'
         print *,' '

         do gold=1,pstat_ngold
            print '(''---'',4(i5,1x,a4,1x,l1,''---''))',
     +           (pstat_gold(jgold,gold),
     +           htopp_name(1,omtra_topp(pstat_gold(jgold,gold))),
     +           lrefpat(jgold,gold),jgold=1,4)
         enddo
        
         print 101, n_events,
     +        (counter_name(counter),counter_mc_evt(counter),
     +        counter_rc_evt(counter),counter_cl_evt(counter),
     +        100.*counter_evtef(counter),
     +        counter_mc_all(counter),
     +        counter_rc_all(counter),counter_cl_all(counter),
     +        100.*counter_allef(counter),
     +        counter=1,ncounter)

 101     format(//
     +        ' |===================',
     +        '=====================================================| '/
     +        ' |       statis',
     +        'tics from tfstam1     nevents=',i6,
     +                               '                       |'/
     +        ' |===================',
     +        '=====================================================|'/
     +        ' | Counter   ',
     +        '    MC(ev) RC(ev) CL(ev) ef(evt)  ',
     +        'MC(rn) RC(rn) CL(rn) ef(rn)|'/
     +        10(' | ',a13,3i6,f7.2,5x,3i6,f7.2,'   |'/),
     +        ' |===================',
     +        '=====================================================| ')
      endif

 999  end
