*-- Author :    A.Spiridonov    10/07/98

      subroutine tftcpro(ift1,direction,istat)
*
*     3D track-follow in TC chambers of all alive seeds in /zf/  
*
      implicit none

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zdomain.fi"
#include "rang/zplx.fi"
#include "arte/Arte.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax),n_target,tumchit,domlay,dlnext
      integer ift1,ift,izf,ipl,icycle,method,ncan,ii,jj,
     +        zone,iplnext,imust,izfnew,nhl,nhlmx,ihl,dw,dom
      real x_pred,y_pred,dx_window,dy_window,dz,diff_x,window_size
      parameter (nhlmx=100)
      integer hl(nhlmx),nca_now,to_be_grown,direction,istat
      logical continued

      integer key_buf

#include "rang/descend.fi"
       
      logical electron

      integer mcout
      real fracout

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

      key_buf = 0

*     **** loop over growth cycles
      istat = 0

      do ii=ift1,ncamx
        descend(ii)=0
      end do
*
      do 10 icycle=1,99

*      **** loop over present number of track candidates

        nca_now = nca_ft
        begin_ft = nca_ft + 1
        to_be_grown = 0
        do 20 ift=ift1,nca_now
          if (.not.alive_ft(ift)) go to 20
          if (mature_ft(ift))     go to 20
  
          if(descend(ift).ne.0) then     
            ift_descend = descend(ift)
          else
          ift_descend = ift
          end if

          to_be_grown = to_be_grown + 1

          if (diag_level.ge.5) then
            print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
            print *,' << track candidate ', ift, '             <<'
            print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
          endif

*         **** loop over planes in zone

          izf = last_ft(ift)
          ipl = plane_zf(izf)
          domlay = domlay_zf(izf)
          zone = fault_zf(izf) + 1
          ncan = 0
          continued = .false.
          method = 1  ! 3D    tracking

          if (diag_level.ge.6) then
            print *,' tftcpro: call tfdzone for domlay=', domlay,
     +           '  zone=', zone
          endif

          call tfdzone2(domlay,method,zone,direction,nmax,
     +                               target_vec,n_target)
*
          if (diag_level.ge.5) then
            print *,' zone=', zone
            print '(6((a),i5))',
     +     'tftcpro: for ipl=',ipl,' dl=',domlay,' meth=',method,
     +     ' zone=',zone,
     +     ' nmax=',nmax,' we get n_target=', n_target
          endif
*
          do dom=1,maxdom_dm      ! reset prediction buffer
            filled_db(dom) = .false.
          enddo
*
          do 30 ii=1,n_target
            dlnext = target_vec(ii)
            if (diag_level.ge.5) print *,' tftcpro: next target='
     +                                                    , dlnext
*           **** check if plane is within scope
*           **** check if window is intersected

            dz = fgede_zmin(gede_dp(layplane1_dl(dlnext))) - z_zf(izf)
            dom = laydom_dl(dlnext) ! prediction for target domain

**          if (.not.filled_db(dom)) call tfdbfill(dom,izf,istat)

****        check electron identification
         
            electron = electron_id(ift_descend)   
            electron = .false.
            if (.not.filled_db(dom)) then
              x_pred = xx_zf(1,izf)+xx_zf(3,izf)*(z_dm(dom)-z_zf(izf))
              y_pred = xx_zf(2,izf)+xx_zf(4,izf)*(z_dm(dom)-z_zf(izf))
 
*              print '("tftcpro : dom,izf,x,y ",2i4,2(x,f8.3))'
*     +                                ,dom,izf,x_pred,y_pred

              filled_db(dom) = .true.
            end if
*
            dx_window = 5.
            dy_window = 20.0
            dw = win_dl(dlnext)

*            print '("tftcpro : start test dl,dw=",2i4)',dlnext,dw
*            print '("tftcpro : xy ",4(x,f8.3))'
*     +          ,(xmin_dw(dw)-dx_window),(xmax_dw(dw)+dx_window)
*     +          ,(ymin_dw(dw)-dy_window),(ymax_dw(dw)+dy_window)

            if (x_pred.lt.(xmin_dw(dw)-dx_window).or.
     +        x_pred.gt.(xmax_dw(dw)+dx_window)) go to 30
            if (y_pred.lt.(ymin_dw(dw)-dy_window).or.
     +        y_pred.gt.(ymax_dw(dw)+dy_window)) go to 30

*            print '("tftcpro :    test OK, filled",i2)',filled_db(dom)
**          if (.not.filled_db(dom)) call tftctrand(izf,dom,electron,istat)

*           **** can/must plane found

            ncan = ncan + 1

*           **** loop over hits

            if(dlnext*1000+ift_preced(ift).ne.key_buf) then
              call tfdhlcr(izf,dlnext,nhlmx,hl,nhl)
              key_buf = dlnext*1000+ift_preced(ift)
#ifdef RT_TEST
              print '("tftcpro : nhl ",i4)',nhl
              print '(15(x,i4)/)',(hl(jj),jj=1,nhl)
              print '(15(x,i4)/)',(ihitb_gede(hl(jj)),jj=1,nhl)
              print '(15(x,i4)/)',(igede_cmp(ihitb_gede(hl(jj)))
     +                                                ,jj=1,nhl)
              print '(15(f5.1)/)',(fhitb_x(hl(jj)),jj=1,nhl)
#endif

            end if

            if (diag_level.ge.6) print *,' tftcpro: hitlist nhl= ', nhl
            do 40 ihl=1,nhl

              if (diag_level.ge.5) then
                print *,' tftcpro: hitlist ihl=', ihl, ' hit=', hl(ihl),
     +                                     ' imc=', tumchit(hl(ihl))
              endif
              iplnext = ihitb_gede(hl(ihl))

              diff_x = fhitb_x(hl(ihl))
     +         - (  cstot_plx(iplnext)
     +              * (xx_zf(1,izf)
     +                 + xx_zf(3,izf) * (fhitb_z(hl(ihl)) - z_zf(izf)))
     +            - sntot_plx(iplnext)
     +              * (xx_zf(2,izf)
     +                 + xx_zf(4,izf) * (fhitb_z(hl(ihl)) - z_zf(izf))))

              window_size = 2.
*
              if (diag_level.ge.6) then
                print *,' tftcpro: diff_x=',diff_x,
     +            ' window_size=',window_size
                endif

                izfnew = 0
                if (abs(diff_x).lt.window_size) then

                istat = 0

                call tftcfil(hl(ihl),dlnext,iplnext,ift,izf,izfnew
     +                                                     ,istat)
                if (istat.le.-100) go to 999
                if (istat.le.-1) go to 40
                if (izfnew.gt.0) continued = .true.
              endif

 40         continue  ! hits in hitlist
*
 30       continue  ! planes in zone
*
*         **** allow fault on old candidate
          if (fault_zf(izf).lt.maxflt_tc_zfpar) then
            fault_zf(izf) = fault_zf(izf) + 1
            nfault_ft(ift) = nfault_ft(ift) + 1
          else
*         **** kill or freeze old candidate
            if (whit_zf(izf).lt.whitmin_tc_zfpar) then
              alive_ft(ift) = .false.
            else
              mature_ft(ift) = .true.
              stat_ft(ift) = 6
            endif
          endif
          if (diag_level.ge.5) call tfl()
*
 20     continue
*
*       print * ,'                                      call tfeed'

        call tftcweed
*
        if (diag_level.ge.4) then
          print *,' **********************************************'
          print *,' *                                            *'
          print *,' *                                            *'
          print *,' *           E  N  D     O  F                 *'
          print *,' *                                            *'
          print *,' *           G  R  O  W  T  H                 *'
          print *,' *                                            *'
          print *,' *            C  Y  C  L  E                   *'
          print *,' *                                            *'
          print *,' *                                            *'
          print *,' **********************************************'
          call tfl()
          if (l_diag) call tfwait()
        endif

        if (to_be_grown.le.0) go to 11
*
 10   continue
*
      print *,' () tftcpro: loop ends ii=99'
      stop 'tftcpro'

 11   if (diag_level.ge.4) then
        call tfl()
        print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

 999  end

