// ********************************************************************
//
//  Routine:      rc99ARICH
//  Author:       T.Oest/D.Samtleben
//
//  Description:  rich stand alone reconstruction
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "rich/rich.h"
#include "rise/RingSearchARTE.h"


//*****************************************************************
// function
//*****************************************************************

int rc99ARICH(int level) {

//==================================================================
// 0. get maximum number of RICH photons
//==================================================================
  int maxhits = 1500;

  char cCut[20];
  cCut[0]=0;
  char *RICHcut=getenv("RISE_OCCUPCUT");
  if (RICHcut) {
    strcat(cCut,RICHcut);
    maxhits = atoi(cCut);
  };


//==================================================================
// 1. create hits
//           dric2hitb_(): fills HITB table with RICH hits
//==================================================================


     if (level == 1 || level == 3) {
      int nrhits = ArteTable<HITB>::size();

      dric2hitb_();

      nrhits = ArteTable<HITB>::size() - nrhits;
      if (nrhits > maxhits) return -1;
     }

//==================================================================
// 2. reconstruct rich rings
//           rcrings_(Ch_angle_min,Ch_angle_max,Ch_angle_step,threshold)
//
//    example:
//           rcrings_(40,53,-1,5) ring search for freon
//           ( hint: rcrings_() = rcrings_(40,53,-1,5) )
//           rcrings_(10,25,-1,3) ring search for air
//==================================================================

     if (level > 1){
     if (ArtePointer<EVHD>(1)->date <  990000 &&
         ArteTable<MIMP>::size()    == 0){
      rcrings_(10,25,-1,3);
     } else {
      rcrings_(40,53,-1,5);
     };
     };

     return 0;
}
