// 
//  Author:  Rainer Mankel                     Created:  17-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rcZevnt.C
// reconstruction main program for full detector setup
// (in statu nascendi)


#include "arte/arte.hh"
#include "rang/zfpar.hh"
#include "rang/rgideal.hh"

// Prototypes
extern "C" {
  void careinit_();
  void marpleinit_();
  void rgmaintr_();
  void tfunidm_();
  void careevnt1_();
  void careevnt2_();
  void mtchrscr_();
  void tfbuild_();
  void rcelid_();
  void rcvert_();
}
int SvdInit();


extern "C" {
  void rcZevnt_() {

    // initialization
    static int init = 0;
    if (! init) {
      careinit_();
      marpleinit_();
      init = 1;
    }

    zfpar_.fit = 0;
    rgmaintr_();   // main tracker reconstruction

    zfpar_.segstor = 1;
    rgideal_(1.,8,0.,190.,0);  // ideal SVD reco

    cout << " call tfunidm" << endl;
    tfunidm_();    // ideal match SVD-main tracker

    cout << " call careevnt1" << endl;
    careevnt1_();  // ECAL cluster reconstruction

    cout << " call mtchrscr" << endl;
    mtchrscr_();

    cout << " call careevnt2" << endl;
    careevnt2_();  // set relations

    zfpar_.fit = 2;
    cout << " call tfbuild" << endl;
    tfbuild_();    // refit and book RTRA    

    cout << " call tfelid" << endl;
    rcelid_();     // electron identification

#ifdef VERTX
    rcvert_();     // reconstruct vertices
#endif

  //           call rcrings()

  }
}
