
// ********************************************************************
//
//  Routine:      RICHrec
//
//  Description:  rich reconstruction based on tracks
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "rich/RICHDAQ.h"
#include "rise/RingSearchARTE.h"

#include "rire/richreco.hh"

extern "C" void dric2hitb_();


//*****************************************************************
// function
//*****************************************************************

int RICHrec(int level) {

//==================================================================
// 1. create hits
//           hidric_(): fills HITB table with RICH hits
//==================================================================

  //  if (level == 1 || level == 3) hidric_();
  if (level == 1 || level == 3) dric2hitb_();
  
  //create vector of RICH hits
  RichHits *richhits=new RichHits();
  
//=================================================================
//2.loop over reconstructed tracks and find likelihoods for each 
//  mass hypothesis
//==================================================================
  
  for(ArteTable<RTRA>::iterator rtrait=ArteTable<RTRA>::begin();
      rtrait!=ArteTable<RTRA>::end();rtrait++)
    {

      RichTrack rtrack(*rtrait);    //initialise RichTrack
      (*rtrait)->lre=rtrack.FindLikelihood(1,richhits);
      (*rtrait)->lrmu=rtrack.FindLikelihood(2,richhits);
      (*rtrait)->lrpi=rtrack.FindLikelihood(3,richhits);
      (*rtrait)->lrk=rtrack.FindLikelihood(4,richhits);
      (*rtrait)->lrp=rtrack.FindLikelihood(5,richhits);
    }
  delete richhits;

  return 0;
}




