#include <iostream.h>
#include <stdlib.h>

#include <stdio.h>
#include <math.h>

#include <arte/arte.hh>
#include "arte/RSEG_cmp.hh"

#include "CLHEP/Hist/HBookTuple.h"
#include "CLHEP/Vector/ThreeVector.h"

#include "rire/richreco.hh"

extern HBookTuple ImassNt;

float invmass(RichTrack *track1,RichTrack *track2)
{
  Hep3Vector d=track1->Mom()*track1->Dir()
    +track2->Mom()*track2->Dir();
  float imas=pow(track1->Mom()+track2->Mom(),2)-d.mag2();
  if (imas>0){
    imas=sqrt(imas);
    return imas;
  }
  else return 0;
}


float invmass(float tx1,float ty1,float p1,float tx2,float ty2,float p2)
{
  Hep3Vector dir1(tx1,ty1,1-sqrt(tx1*tx1+ty1*ty2));
  Hep3Vector dir2(tx2,ty2,1-sqrt(tx2*tx2+ty2*ty2));
  Hep3Vector d=p1*dir1+p2*dir2;
  float imas=pow(p1+p2,2)-d.mag2();
  if (imas>0){
    imas=sqrt(imas);
    return imas;
  }
  else return 0;
}


void invariantmass()
{
  
  RichHits *richhits=new RichHits();
  
  vector<RichTrack*> vecrtrack;

  //Target information.
//    for(ArteTable<GTAR>::iterator targetit=ArteTable<GTAR>::begin();
//        targetit!=ArteTable<GTAR>::end();targetit++)
//      {
//        printf("target x,y,z %f %f %f \n",(*targetit)->x,(*targetit)->y,
//  	     (*targetit)->z);
//      }
  
   float targetx=0.63; //provisional run 2337
   float targety=0;
   float targetz=-4.7;
   
   //   float targetx=0.2; //MC
   //   float targety=0;
   //   float targetz=-0.6;
  

  for(ArteTable<RCCL>::iterator rcclit=ArteTable<RCCL>::begin();
      rcclit!=ArteTable<RCCL>::end();rcclit++){

    float tx=((*rcclit)->x-targetx)/((*rcclit)->z-targetz);
    float ty=((*rcclit)->y-targety)/((*rcclit)->z-targetz);
          
    Hep3Vector point((*rcclit)->x,(*rcclit)->y,(*rcclit)->z);
    Hep3Vector direction(tx,ty,sqrt(1-tx*tx-ty*ty));
    float pt=(*rcclit)->esum*sqrt(tx*tx+ty*ty);
    
    if(pt<0.5) continue;

    RichTrack * rtrack=new RichTrack(point,direction,(*rcclit)->esum);
    double eleclike=rtrack->FindLikelihood(1,richhits);
    
    vecrtrack.push_back(rtrack);
  }

  for(vector<RichTrack*>::iterator rtit1=vecrtrack.begin();
      rtit1!=vecrtrack.end();rtit1++)
    {
      float mind1=10;
      ArtePointer<RSEG> minrseg1;
      for(ArteTable<RSEG>::iterator rsegit1=ArteTable<RSEG>::begin();
	  rsegit1!=ArteTable<RSEG>::end();rsegit1++){
	if((*rsegit1)->cmp!=Rsegc::vxd) continue;
	//if(!((*rsegit1)->cmp==Rsegc::vxd ||(*rsegit1)->cmp==Rsegc::patt)) continue;
	
	float dist=sqrt(pow((*rtit1)->Track()->tx()-(*rsegit1)->txf,2)+
			pow((*rtit1)->Track()->ty()-(*rsegit1)->tyf,2));
	if(mind1>dist) {
	  mind1=dist;
	  minrseg1=*rsegit1;
	}
      }
      ArtePointer<RSEG> minrseg2;
      for(vector<RichTrack*>::iterator rtit2=rtit1;
	  rtit2!=vecrtrack.end();rtit2++)
	{
	  if(rtit2==rtit1) continue;

	  float mind2=10;
	  for(ArteTable<RSEG>::iterator rsegit2=ArteTable<RSEG>::begin();
	      rsegit2!=ArteTable<RSEG>::end();rsegit2++){
	    if((*rsegit2)->cmp!=Rsegc::vxd) continue;
	    //if(!((*rsegit1)->cmp==Rsegc::vxd ||(*rsegit1)->cmp==Rsegc::patt)) continue;
	    float dist=sqrt(pow((*rtit2)->Track()->tx()-(*rsegit2)->txf,2)+
			    pow((*rtit2)->Track()->ty()-(*rsegit2)->tyf,2));
	    if(mind2>dist){
	      mind2=dist;
	      minrseg2=*rsegit2;
	    }
	  }

	  float imass=invmass((*rtit1),(*rtit2));

	  float imass2=invmass(minrseg1->txf,minrseg1->tyf,
			       1/(*rtit1)->Track()->pe(),
			       minrseg2->txf,minrseg2->tyf,
			       (*rtit2)->Track()->pe());

	  float pt1=sqrt(pow((*rtit1)->Track()->tx(),2)+
			 pow((*rtit1)->Track()->ty(),2))/
	    (*rtit1)->Track()->pe();
	  float pt2=sqrt(pow((*rtit2)->Track()->tx(),2)+
			 pow((*rtit2)->Track()->ty(),2))/
	    (*rtit2)->Track()->pe();

	  ImassNt.column("imass",imass);
	  ImassNt.column("imass2",imass2);
	  ImassNt.column("pt1",pt1);
	  ImassNt.column("pt2",pt2);
	  ImassNt.column("mind1",mind1);
	  ImassNt.column("mind2",mind2);
	  ImassNt.column("elike1",(*rtit1)->Likelihood(1));
	  ImassNt.column("elike2",(*rtit2)->Likelihood(1));
	  //      ImassNt.column("flag1",flag1);
	  //      ImassNt.column("flag2",flag2);

	  if(imass>2.4) 
	    ImassNt.dumpData();
	  else
	    ImassNt.clearData();
	  
	}
    }

  delete richhits;

  for(vector<RichTrack*>::iterator rtit=vecrtrack.begin();
      rtit!=vecrtrack.end();rtit++)
    {
      delete (*rtit);
    }
  vecrtrack.erase(vecrtrack.begin(),vecrtrack.end());

}

