//**********************************************************************/
//   RICH reconstruction (rire), version 2.00
//
// Created: 08.03.99, by Ignacio Ari\~no. 
//        
//  Implementation of RichHits class.
//
//
//**********************************************************************/

#include "rire/richhits.hh"
#include "rich/PhotonDetection.h"

#include <arte/arte.hh>


RichHits::RichHits()
{

  for(ArteTable<HITB>::iterator hbit=ArteTable<HITB>::begin();
      hbit!=ArteTable<HITB>::end();hbit++)
    {
      if((*hbit)->gede->cmp!=5) continue;
      int up=((*hbit)->y > 0) ? 1:0;

      int chanid=0;
      for(ArteRelationIterator<DIGB> dbit=(*hbit)->digb.begin();
	  dbit!=(*hbit)->digb.end();dbit++){
	chanid=(*dbit)->id;
      }
      int s=smFromChannelID(chanid);
      int r=rowFromChannelID(chanid);
      int c=colFromChannelID(chanid);
      int numchan=RICH_Detector->SuperModule(s).Cell(r,c)->pm().numchannel();
      float cellsize=3.6/sqrt(numchan);


      RHit* hit=new RHit((*hbit)->q,(*hbit)->r,cellsize,up,0);
//       ArteRelationIterator<MIMP> hbmimp = (*hbit)->mimp;
//       ArtePointer<MTRA>imtra((*hbmimp)->mtra);
//       hit.mctrack=imtra.index();

      VecRichHits.push_back(hit);
    }
}



RichHits::~RichHits()
{
  int nhits=0;
 for(vector<RHit*>::iterator vrhit=VecRichHits.begin();
      vrhit!=VecRichHits.end();vrhit++)
    {
      nhits++;
      delete *vrhit;
    }
  VecRichHits.erase(VecRichHits.begin(),VecRichHits.end());

}

