*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_CROS(N_MR1,I1,N_TR1,NB1,N_MR2,I2,N_TR2,NB2)

**********************************************************************
*
* Description: the track is calculated like a line from two plane 
*              intersection. Transform TRD tracks into Arte RSEG Table.
*
* Called from: TRD_REC
*
*          in: N_MR1    - Matrix number                |
*              I1       - Seed number for matrix N_MR  | first TRD
*              N_TR1    - track candidate number       | superlayer
*              NN_BLOK1 - TRD blok                     |
*              N_MR2    - Matrix number                |
*              I2       - Seed number for matrix N_MR  | second TRD
*              N_TR2    - track candidate number       | superlayer
*              NN_BLOK2 - TRD blok                     |
*
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"
#include "auto/RSEG.fi"
#include "auto/RTRA.fi"
#include "auto/RPNT.fi"
#include "auto/RHIT.fi"

c#include "susi/zsimtrx44.fi"
      
      REAL X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, AA1, BB1, CC1, 
     +     DD1, AA2, BB2, CC2, DD2, Z_CR, X_CR, Y_CR,
     +     LAYER_A, LAYER_B, LAYER_C, LAYER_D, SIGMA,Y_RIGHT,
     +     X_0_N, Y_0_N, X_BL_RT, X_RIGHT
      REAL X0, Y0, X_LEFT, Y_LEFT, X_NEW_LEFT, Y_NEW_LEFT, ANGL,
     +     X_NEW, Y_NEW, TAN_YZ, TAN_XZ
      INTEGER N_BLOK, N_MR1, I1, N_TR1, N_MR2, I2, N_TR2, NB1, NB2,
     +        N_MAX, LAYER_N, N_STRAW, K, K1, K2, ROW, N_RS,
     +        N_RP, N_RH, N_MCTR, I_MCTR, I_MC, N_HB, J_F, J_E,
     +        N_MR, I, N_TR, NB, II, J_LAY, TRD_VIEW, ROAD, 
     +        FLAG, N_STR_HIT, TRD_HITB, J1, J2, TRACK

      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      COMMON /TRD_LAYER/ LAYER_A, LAYER_B, LAYER_C, LAYER_D,
     +                   LAYER_N, SIGMA
      COMMON /TRD_ROAD/ ROAD, FLAG, N_STR_HIT, TRACK
      COMMON /REC_MC/ I_MCTR
      COMMON /TRD_ALL/ TRD_VIEW, TRD_HITB

      integer MATRIX_PACK(5,5)
      data MATRIX_PACK
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /

      PARAMETER (N_MAX = 1000)

      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)
      DIMENSION LAYER_A(N_MAX,15,100), LAYER_B(N_MAX,15,100)
      DIMENSION LAYER_C(N_MAX,15,100), LAYER_D(N_MAX,15,100)
      DIMENSION SIGMA(N_MAX,15,100), TRACK(N_MAX,15,100)
      DIMENSION LAYER_N(N_MAX,15)
      DIMENSION X_CR(4), Y_CR(4), Z_CR(4)
      DIMENSION ROAD(N_MAX,15,16,3), N_STR_HIT(3)
      DIMENSION FLAG(N_MAX,15,16)
      DIMENSION I_MCTR(50)
      DIMENSION TRD_VIEW(12,16,78), TRD_HITB(12,16,78)
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
#include "auto/RSEG.ff"
#include "auto/RTRA.ff"
#include "auto/RPNT.ff"
#include "auto/RHIT.ff"

C
C TRD CROSS Event Analysis.
C
*      PRINT *,'START CROSS analysis for TRD'
C
      CALL VZERO(X_CR, 4)
      CALL VZERO(Y_CR, 4)
      CALL VZERO(Z_CR, 4)
C
      AA1 = LAYER_A(N_MR1, I1, N_TR1)
      BB1 = LAYER_B(N_MR1, I1, N_TR1)
      CC1 = LAYER_C(N_MR1, I1, N_TR1)
      DD1 = LAYER_D(N_MR1, I1, N_TR1)
C
      AA2 = LAYER_A(N_MR2, I2, N_TR2)
      BB2 = LAYER_B(N_MR2, I2, N_TR2)
      CC2 = LAYER_C(N_MR2, I2, N_TR2)
      DD2 = LAYER_D(N_MR2, I2, N_TR2)
C
      Z_CR(1) = Z_BL_ST(NB1,1)
      Z_CR(2) = Z_BL_ST(NB1,16)
      Z_CR(3) = Z_BL_ST(NB2,1)
      Z_CR(4) = Z_BL_ST(NB2,16)
C
      DO I = 1, 4
         Y_CR(I) = (AA2*(CC1*Z_CR(I) + DD1) - AA1*(CC2*Z_CR(I) + DD2))/
     +              (BB2*AA1 - BB1*AA2)
         X_CR(I) = (BB1*(CC2*Z_CR(I) + DD2) - BB2*(CC1*Z_CR(I) + DD1))/
     +              (AA1*BB2 - BB1*AA2)
c              WRITE
c     +  (*,'(''CROSS_TRD_1==>'',2(1X,I4), 3(1X,F9.3))')
c     +    NB1, NB2, X_CR(I), Y_CR(I), Z_CR(I)  
      END DO
C
      TAN_XZ = (X_CR(4) - X_CR(1))/(Z_CR(4) - Z_CR(1))
      TAN_YZ = (Y_CR(4) - Y_CR(1))/(Z_CR(4) - Z_CR(1))
C
           DO I = 1, 4
              X0     = X_CR(I)
              Y0     = Y_CR(I)
             IF(I.EQ.1) THEN
              X_LEFT = X_BL_LEFT(NB1,1)
              Y_LEFT = Y_BL_LT(NB1,1)
              Y_RIGHT= Y_BL_RT(NB1,1)
              X_RIGHT= X_BL_RT(NB1,1)
              ANGL = 1.*3.14159/3.
             END IF
             IF(I.EQ.2) THEN
              X_LEFT = X_BL_LEFT(NB1,16)
              Y_LEFT = Y_BL_LT(NB1,16)
              Y_RIGHT= Y_BL_RT(NB1,16)
              X_RIGHT= X_BL_RT(NB1,16)
              ANGL = 1.*3.14159/3.
             END IF
             IF(I.EQ.3) THEN
              X_LEFT = X_BL_LEFT(NB2,1)
              Y_LEFT = Y_BL_LT(NB2,1)
              Y_RIGHT= Y_BL_RT(NB2,1)
              X_RIGHT= X_BL_RT(NB2,1)
              ANGL = -1.*3.14159/3.
             END IF
             IF(I.EQ.4) THEN
              X_LEFT = X_BL_LEFT(NB2,16)
              Y_LEFT = Y_BL_LT(NB2,16)
              Y_RIGHT= Y_BL_RT(NB2,16)
              X_RIGHT= X_BL_RT(NB2,16)
              ANGL = -1.*3.14159/3.
             END IF
C
              X_0_N =   X0*COS(ANGL) + Y0*SIN(ANGL)
              Y_0_N = - X0*SIN(ANGL) + Y0*COS(ANGL)
C
              IF(Y_0_N.GE.Y_LEFT.AND.Y_0_N.LE.Y_RIGHT) THEN
                IF(X_0_N.GE.X_LEFT.AND.X_0_N.LE.X_RIGHT) THEN
                   GO TO 15
                END IF
              END IF
C
              GO TO 900
C
 15           CONTINUE
C
      END DO
C
      DO J_LAY = 1, 2
C
        IF(J_LAY.EQ.1) THEN
           J_F    = 2*J_LAY
           J_E    = 2*J_LAY - 1
           NB     = NB1
           N_MR   = N_MR1
           II     = I1
           N_TR   = N_TR1
        ELSE
           J_F    = 2*J_LAY
           J_E    = 2*J_LAY - 1
           NB     = NB2
           N_MR   = N_MR2
           II     = I2
           N_TR   = N_TR2
        END IF
C
        CALL MMBOOK(JRSEG,1)
C
        N_RS = NRSEG()
C
        IQ(IQRSEG_CMP_L ()) = LGESL_TRD
C*
         Q( QRSEG_PF_L  ()) = 0.0 ! arbitrary value , not defined yet 
         Q( QRSEG_ZF_L  ()) = Z_CR(J_F) 
         Q( QRSEG_XF_L  ()) = X_CR(J_F) 
         Q( QRSEG_YF_L  ()) = Y_CR(J_F) 
         Q( QRSEG_TXF_L ()) = TAN_XZ 
         Q( QRSEG_TYF_L ()) = TAN_YZ
C
         DO J1 = 1 , 4
            DO J2 = J1 , 4 
               Q( QRSEG_CVF_L(MATRIX_PACK(J1,J2))) =  0.0
            ENDDO 
         ENDDO 
C
         Q( QRSEG_CVF_L(MATRIX_PACK(5,5))) = 1.0E-6 * FLARGEST
         Q( QRSEG_CVF_L(MATRIX_PACK(1,1))) = 0.838
         Q( QRSEG_CVF_L(MATRIX_PACK(2,2))) = 0.485
         Q( QRSEG_CVF_L(MATRIX_PACK(3,3))) = 0.023
         Q( QRSEG_CVF_L(MATRIX_PACK(4,4))) = 0.013
C
         Q( QRSEG_ZE_L  ()) = Z_CR(J_E) 
         Q( QRSEG_XE_L  ()) = X_CR(J_E) 
         Q( QRSEG_YE_L  ()) = Y_CR(J_E) 
         Q( QRSEG_TXE_L ()) = TAN_XZ 
         Q( QRSEG_TYE_L ()) = TAN_YZ
C
         IQ(IQRSEG_FIT_L ()) = NB    
C
         DO J1 = 1 , 4
            DO J2 = i1 , 4 
               Q( QRSEG_CVE_L(MATRIX_PACK(J1,J2))) =  0.0
            ENDDO 
         ENDDO 
C
         Q( QRSEG_CVE_L(MATRIX_PACK(5,5))) = 1.0E-6 * FLARGEST
         Q( QRSEG_CVE_L(MATRIX_PACK(1,1))) = 0.838
         Q( QRSEG_CVE_L(MATRIX_PACK(2,2))) = 0.485
         Q( QRSEG_CVE_L(MATRIX_PACK(3,3))) = 0.023
         Q( QRSEG_CVE_L(MATRIX_PACK(4,4))) = 0.013
C
         CALL TRD_MCTR(X_CR(J_F),Y_CR(J_F),Z_CR(J_F))
C
         DO I_MC = 1, 50
C
            IF(I_MCTR(I_MC).NE.0) THEN
               CALL MMBREL(JRSMT,N_RS,I_MCTR(I_MC))  ! RSEG<-->MTRA
            END IF
C
         END DO
C
         DO ROW = 16, 1, -1
            IF(ROAD(N_MR,II,ROW,N_TR).NE.0) THEN
C
               CALL MMBOOK(JRPNT,1)
C
               N_RP = NRPNT() 
C
               Q( QRPNT_PF_L  ()) = 0.0 ! not defined yet 
               Q( QRPNT_ZF_L  ()) = Z_BL_ST(NB,ROW)
               Q( QRPNT_XF_L  ()) = (BB1*(CC2*Z_BL_ST(NB,ROW) + DD2) 
     +      - BB2*(CC1*Z_BL_ST(NB,ROW) + DD1))/ (AA1*BB2 - BB1*AA2)
               Q( QRPNT_YF_L  ()) = (AA2*(CC1*Z_BL_ST(NB,ROW) + DD1) 
     +      - AA1*(CC2*Z_BL_ST(NB,ROW) + DD2))/(BB2*AA1 - BB1*AA2)
               Q( QRPNT_TXF_L ()) = TAN_XZ 
               Q( QRPNT_TYF_L ()) = TAN_YZ 
C
               DO J1 = 1 , 4
                  DO J2 = J1 , 4 
                     Q( QRPNT_CVF_L(MATRIX_PACK(J1,J2))) =  0.0
                  ENDDO 
               ENDDO 
C
               Q( QRPNT_CVF_L(MATRIX_PACK(5,5))) = 1.0E-6 * FLARGEST
               Q( QRPNT_CVF_L(MATRIX_PACK(1,1))) = 0.838
               Q( QRPNT_CVF_L(MATRIX_PACK(2,2))) = 0.485
               Q( QRPNT_CVF_L(MATRIX_PACK(3,3))) = 0.013
               Q( QRPNT_CVF_L(MATRIX_PACK(4,4))) = 0.023    
C
               CALL MMBREL(JRSRP,N_RS,N_RP)
C 
            IF(TRD_HITB(NB,ROW,ROAD(N_MR,II,ROW,N_TR)).NE.0) THEN
               CALL MMBOOK(JRHIT,1)
C
               N_RH = NRHIT() 
C
               Q( QRHIT_P_L  ()) = 0.0 ! not defined yet
               Q( QRHIT_X_L  ()) = (BB1*(CC2*Z_BL_ST(NB,ROW) + DD2) 
     +      - BB2*(CC1*Z_BL_ST(NB,ROW) + DD1))/ (AA1*BB2 - BB1*AA2)
               Q( QRHIT_Y_L  ()) = (AA2*(CC1*Z_BL_ST(NB,ROW) + DD1) 
     +      - AA1*(CC2*Z_BL_ST(NB,ROW) + DD2))/(BB2*AA1 - BB1*AA2)
               Q( QRHIT_TX_L ()) = TAN_XZ 
               Q( QRHIT_TY_L ()) = TAN_YZ 
              IQ(IQRHIT_RTRA_L()) = 0

C
c              CALL TRD_RTHI(NB,ROW,N_HB)
C
              N_HB = TRD_HITB(NB,ROW,ROAD(N_MR,II,ROW,N_TR))
C
               CALL MMBREL(JRSRH,N_RS,N_RH)
               CALL MMBREL(JHIRH,N_HB,N_RH)
C
             END IF
C
            END IF
         END DO
C
        END DO
C

c      DO I = 1, 4
c              WRITE
c     +  (*,'(''CROSS_TRD==>'',2(1X,I4), 3(1X,F9.3))')
c     +    NB1, NB2, X_CR(I), Y_CR(I), Z_CR(I)  
c      END DO
C
           DO I = 1, 4
              X0     = X_CR(I)
              Y0     = Y_CR(I)
             IF(I.EQ.1) THEN
              X_LEFT = X_BL_LEFT(NB1,1)
              Y_LEFT = Y_BL_LT(NB1,1)
              Y_RIGHT= Y_BL_RT(NB1,1)
              ANGL = -1.*3.14159/3.
             END IF
             IF(I.EQ.2) THEN
              X_LEFT = X_BL_LEFT(NB1,16)
              Y_LEFT = Y_BL_LT(NB1,16)
              Y_RIGHT= Y_BL_RT(NB1,16)
              ANGL = -1.*3.14159/3.
             END IF
             IF(I.EQ.3) THEN
              X_LEFT = X_BL_LEFT(NB2,1)
              Y_LEFT = Y_BL_LT(NB2,1)
              Y_RIGHT= Y_BL_RT(NB2,1)
              ANGL = 1.*3.14159/3.
             END IF
             IF(I.EQ.4) THEN
              X_LEFT = X_BL_LEFT(NB2,16)
              Y_LEFT = Y_BL_LT(NB2,16)
              Y_RIGHT= Y_BL_RT(NB2,16)
              ANGL = 1.*3.14159/3.
             END IF
C...
*              ANGL = 1.*3.14159/3.
C
C NUMBER OF STRAW CALC.
C

              X_NEW_LEFT =   X_LEFT*COS(ANGL) + Y_LEFT*SIN(ANGL)
              Y_NEW_LEFT = - X_LEFT*SIN(ANGL) + Y_LEFT*COS(ANGL)
C
              ANGL = - ANGL
C
              X_NEW = (X0 - X_NEW_LEFT)*COS(ANGL) + 
     +             (Y0 - Y_NEW_LEFT)*SIN(ANGL)
              Y_NEW = -1.*(X0 - X_NEW_LEFT)*SIN(ANGL) + 
     +             (Y0 - Y_NEW_LEFT)*COS(ANGL)
C
              X_0_N =   X0*COS(ANGL) + Y0*SIN(ANGL)
              Y_0_N = - X0*SIN(ANGL) + Y0*COS(ANGL) 
C
              N_STRAW = INT(X_NEW/0.61) + 1
C
c            PRINT *,'CHECK',X0,Y0,N_STRAW,X_0_N,Y_0_N
C
      END DO
c      PRINT *,'---------------------------------'
c            print *,'sigma',SIGMA(N_MR1, I1, N_TR1),
c     +                                 SIGMA(N_MR2, I2, N_TR2)              
C
*      PRINT *,'STOP CROSS analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_CROS
************************************************************************
