*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTKILL(iv,k,flag)
c
c       input:    iv       =  vertex index      Int
c                 k        =  track  index      Int
c
c       output:   flag   Int  < 0 if fail
c
c       action:   takes track it off vertex iv
c
c------------------------------------------------------------
c
      subroutine  VTKILL( iv, k, flag )

      implicit none

      integer iv, k, it, momflg
      integer flag, flag1

      integer n, m, mm, i, j, jj, imax, jmax

      double precision 
     1  AGB(5,3), WBG(3,5), pc(5), pcAx(5), dch2
      double precision 
     1  a33, a34, b13

#include "vt/vtdat.fi"


      flag = -1
      if (iv.gt.nvtmax)         goto 999
      if ( .not. vtset(iv) )    goto 999

      n = ntr(iv)
      if ( k .gt. n )           goto 999

      if ( fit(iv) .eq. 0 ) then
        call VTFIT(iv,0,flag1)
        if ( flag1.ne.0 ) goto 999
      endif
      momflg = 0
      if ( fit(iv) .eq. 2 )  momflg = 1

      if ( dist(iv) .eq. 0 ) then
        call VTDIS(iv,flag1)
        if (flag1.lt.0)           goto 999
      endif

      if (momflg.eq.0) then
        imax = 4
        jmax = 2
      else
        imax = 5
        jmax = 3
      endif

      it = ktr(iv,k)
      m  = nv(it)
      mm = jv(iv,it)
      nv(it) = nv(it) - 1
      jv(iv,it) = 0
      do  i = mm+1, m
        jv(kv(it,i),it) = jv(kv(it,i),it) - 1
        kv(it,i-1) = kv(it,i)
      enddo
      kv(it,m) = 0

      dch2 = chi2(iv,n) - chi2s(iv,k)

      xvs(1,iv) = xnk(1,iv,k)
      xvs(2,iv) = xnk(2,iv,k)
      xvs(3,iv) = xnk(3,iv,k)

      b13 = Bk13(iv)

      jj = 0

      do  j = 1, n

        if ( j .eq. k ) goto 100

        jj = jj + 1

        a33 = Ak33(iv,j)
        a34 = Ak34(iv,j)

        it = ktr(iv,j)

        do  i = 1, imax
          AGB(i,1) = G(1,i,it)+b13*G(3,i,it)
          AGB(i,2) = G(2,i,it)+b13*G(4,i,it)
        enddo
        if (momflg.ne.0) then
          do  i = 1, 5
            AGB(i,3) = G(i,5,it)
          enddo
        endif
        do  i = 1, jmax
          do  mm = 1, imax
            WBG(i,mm) = 0.
            do  m = 1, jmax
              WBG(i,mm) = WBG(i,mm) + W(i,m,iv,j)*AGB(mm,m)
            enddo
          enddo
        enddo

        pc(1) = p(1,it)
        pc(2) = p(2,it)
        pc(3) = p(3,it) - b13*a33
        pc(4) = p(4,it) - b13*a34
        if (momflg.ne.0) pc(5) = p(5,it)

        pcAx(1) = pc(1)
        pcAx(2) = pc(2)
        pcAx(3) = pc(3) - xvs(1,iv) - a33*xvs(3,iv)
        pcAx(4) = pc(4) - xvs(2,iv) - a34*xvs(3,iv)
        if (momflg.ne.0) pcAx(5) = pc(5)

        do  i = 1, jmax
          qvs(i,iv,jj) = 0.
          do  m = 1, imax
            qvs(i,iv,jj) = qvs(i,iv,jj) + WBG(i,m)*pcAx(m)
          enddo
        enddo

  100   continue

      enddo

      ntr(iv) = ntr(iv) - 1
      do  i = k+1, n
        ktr(iv,i-1) = ktr(iv,i)
      enddo
      n = n-1
      chi2(iv,n) = dch2

      call vtfit(iv,momflg,flag1)
      if (flag1.lt.0) goto 999

      flag = 0

  999 continue

      return
      end
