/*-------------------------------------------------------------------------
 *
 *  OTrDecode header file
 *                             UU Oct 1998
 *                             DV Nov 1998 
 *                             UU Dec 1998        
 * 
 *-----------------------------------------------------------------------*/
#ifndef __OTrDecode_h
#define __OTrDecode_h
 
#include "online/component.h"
#include "online/grr.h"
#include "online/etb.h"
 
#define MAXDAQ     10
#define MAXFED    100
#define NCHANNEL  128
#define COMPID 0x400
 
#define INFO_FLT_STATUS 1
#define INFO_FLT_EVENT  2
#define INFO_SLT_STATUS 3
#define INFO_BX_LONG    4
#define INFO_PHYS_BX    5
#define INFO_FLT_BX     6
#define INFO_SLT_EVENT  7
#define INFO_RUN_NUMBER 8





unsigned char *OTr_decode_TDC_init(const char *Tables_filename,
                                   const char *TDC_table_filename);

int OTr_decode_TDC_to_ModW(unsigned char *buf,int FED,int ch,int *SL,
                           int *Layer,int *Module,int *Sector,int *Wire);

int OTr_decode_TDC_to_Wire(unsigned char *buf,int FED,int ch,int *SL,
                            int *Layer,int *Sector,int *ASD,int *Wire);

int OTr_decode_Wire_to_TDC(unsigned char *buf,int SL,int Layer,int Sector,
                            int ASD,int *Side,int *Crate,int *Slot,int *Conn,
			   int *FED);
int OTrGetConnector(unsigned char *buf,int SL,int Layer,int Sector,
                            int ASD,int *FED,int *Conn);

int convert_str(unsigned char *buf,int FROM,int TO,char *str);

int convert(unsigned char *,int ,int ,int *);

void OTr_decode_TDC_quit(unsigned char *Table);


/*--------------------------------------------------------------------------*/ 

int OTrGetEvent(FILE *, EVENT_HDR *, int, int);

int OTrGetTDC(EVENT_HDR *,int,unsigned char *tdc[MAXFED], int); 

int OTrGetASD8(unsigned char *,unsigned char *tdc[MAXFED], 
	       unsigned char asd8[16],char, char, char, char);

int OTrGetMask(char *, const int, const int);

int OTrGetEvtInfo(int, EVENT_HDR *, int, short);

#endif /*  __OTrDecode_h */
