#ifndef __OTR_RTCALIB_HH__
#define __OTR_RTCALIB_HH__

#ifdef USE_ROOT
 #ifndef ROOT_Rtypes
 #include <Rtypes.h>
 #endif
#endif

class TCanvas;
class TProfile;
class TH1F;
class OTrRTProjection ;
class OTrTrackCandidate ;
class OTrReconstructedTrackInterface;

class OTrRTCalib
{
public:
  OTrRTCalib() ;
  //bool Next(vector<OTrTrackCandidate*>& trackSample, bool) ;
  void Reset() ;
  static void SetUpdateFrequency(int nTracks) { fgUpdateFrequency=nTracks; }
  bool Fit(bool fitT=true, bool fitSigma=true, 
	   bool fit05mm=true, bool fit10mm=true) ;
  void Add(const OTrTrackCandidate* ) ;
  void Add(const OTrReconstructedTrackInterface*) ;
  void UpdateCanvas() ;
#ifdef USE_ROOT
  ClassDef(OTrRTCalib,0)
#endif
private:
  //Rootstuff
  TH1F* fChi2ProbH1 ;
  TCanvas* fCanvas ;
  OTrRTProjection** fRTProjection ;
  int fNTrackCandidates ;
  int fNTracks  ;
  int fNHitsTotal  ;
  int fNHitsTrack  ;
  int fNReconstructedHits ;
  int fNDofs ;
  double fChiSquare ;
  int fCycle ;
  static int fgUpdateFrequency ; // no tracks per update
};

#endif



