#ifndef __OTR_RTPROJECTION_HH__
#define __OTR_RTPROJECTION_HH__

class HepVector ;
class HepSymMatrix ;
class MyProfile ;
class TProfile ;
class TH1F ;
class OTrParameterizedRTRelation ;
class OTrReconstructedTrackInterface ;
class OTrHit ;
class TCanvas ;

class OTrRTProjection
{
public:
  OTrRTProjection(OTrParameterizedRTRelation*,bool=true,bool=true) ;
  bool Add(const OTrReconstructedTrackInterface&, const OTrHit*) ;
  bool FitT() ;
  bool FitSigma2() ;
  void Reset() ;
  void UpdateCanvas() ;
  void Draw() ;
  inline int GetNTParameters() const { return fNTParameters ; } ;
  inline int GetNSParameters() const { return fNSParameters ; } ;
  //inline TProfile* GetTResidualProf() { return fTResidualVsR ; } ;
  //inline TProfile* GetNormalizedResidual2Prof() { return fNormalizedResidual2VsR ; } ;
  //inline TH1F* GetRecDistanceH1() { return fReconstructedDistanceH1 ; } ;
  //inline TH1F* GetNonRecDistanceH1() { return fNonReconstructedDistanceH1 ; } ;
  //OTrParameterizedRTRelation* GetRTRelation() const { return fRTRelation ; } ;
private:
  OTrParameterizedRTRelation* fRTRelation ;
  int fNTParameters ;
  int fNSParameters ;
  HepVector* fDChi2DP_T ;
  HepVector* fDChi2DP_S ;
  HepSymMatrix* fD2Chi2DP2_T ;
  HepSymMatrix* fD2Chi2DP2_S ;
  MyProfile* fTResidualProfile ;
  MyProfile* fTSigma2ResidualProfile ;
  // Rootstuff
  TProfile* fTResidualVsR ;
  TProfile* fNormalizedResidual2VsR ; 
  TH1F* fRecDistanceH1 ;
  TH1F* fNonRecDistanceH1 ;
  TH1F* fRecTimeH1 ;
  TH1F* fNonRecTimeH1 ;
  TH1F* fRResidualH1 ;
  TH1F* fRCorrectedResidualH1 ;
  TH1F* fTResidualH1 ;
  TH1F* fChi2ProbH1  ;
  TH1F* fResCorrectionH1 ;
  TH1F* fTempH1 ;
  TCanvas* fCanvas ;
  int fColor ;
  //double* fRecCutSigmaCorFacVec ;
  //double* fNonrecCutSigmaCorFacVec ;
  static float fgMaxNormalizedResidualForT  ;
  static float fgMaxNormalizedResidualForSigma2  ;
} ;

#endif
