#ifndef __OTR_SPLINERTRELATION_HH__
#define __OTR_SPLINERTRELATION_HH__

#ifndef __OTR_PARAMETERIZEDRTRELATION_HH__
#include "OTrParameterizedRTRelation.hh"
#endif
class EventSample ;
class istream ;
class TH1 ;

/** The SPlineRTRelation is another implementation of the ParameterizedRTRelation class. **/

class OTrSplineRTRelation : public OTrParameterizedRTRelation
{
public:
  /// Empty destructor
  virtual ~OTrSplineRTRelation() ;
#ifdef USE_ROOT
  /// Calculates initial parameters using integrated time spectrum
  OTrSplineRTRelation(int, int, TH1*, HepDouble, HepDouble, 
		      HepDouble, HepDouble, HepDouble,int tdegree=3, int s2degree=3) ;
#endif
  /// Initializes parameters from file
  OTrSplineRTRelation(istream&);
private:
  ///
  int fTDegree ;
  int fSigma2Degree ;
  ///
  HepVector fTKnots ;
  ///
  HepVector fSigma2Knots ;
  ///
  double EvaluateBSpline(const HepVector&,
                         const int, const int, const double) const ;
  ///
  double EvaluateBSplineDerivative(const HepVector&,
                         const int, const int, const double) const ;
  ///
  double EvaluateBSplineSecondDerivative(const HepVector&,
			 const int, const int, const double) const ;
  // Declared by mother class
private:
  ///
  void CalcEquidistantKnots() ;
  ///
  virtual void CorrectT0() ;
  ///
  virtual void RepairTParameters() ;
  ///
  virtual void RepairSigma2Parameters() ;
public:
  ///
  virtual vector<OTrFunctionValue> CalcBasisFuncVector(HepDouble,int) const ;
  ///
  virtual void SetUniformSigma(HepDouble) ;
  ///
  virtual void Write(ostream&) const ;
};

#endif







