#ifndef __OTR_SUPERLAYER_HH__
#define __OTR_SUPERLAYER_HH__

#ifndef __OTR_LAYER_HH__
#include "OTrLayer.hh"
#endif
#ifndef __OTR_COMPONENT_HH__
#include "OTrComponent.hh"
#endif
#ifndef __OTR_COMPONENTMOTHER_HH__
#include "OTrComponentMother.hh"
#endif

class TCanvas ;
class OTrEvent ;

class OTrSuperLayer : public OTrDetectorComponent, 
		      public OTrComponentMother<OTrLayer>
{
public:
  // typedefs, enumerates
  typedef Iterator LayerIterator ;
  typedef ChildContainer LayerContainer ;

  // constructors, destructor, assigment
  OTrSuperLayer();
  OTrSuperLayer( ComponentId_t );
  virtual ~OTrSuperLayer() ;

  // setters and getters
  int GetNLayers() const { return GetNChildren() ; } ;
  const LayerContainer& GetLayers() const { return GetChildren() ; } ;
  LayerContainer& GetLayers() { return GetChildren() ; } ;
  OTrLayer* GetLayer(LayerId_t id) { return GetChild(id) ; } ;
  const OTrLayer* GetLayer(LayerId_t id) const { return GetConstChild(id) ; } ;
  OTrLayer* FindLayer(LayerId_t id) { return FindChild(id) ; } ;
  const OTrLayer* FindLayer(LayerId_t id) const { return FindConstChild(id) ; } ;
  virtual ItemId_t GetItemId() const { return GetSuperLayerId() ; } ;

  // other public methods
  OTrLayer* AddLayer(LayerId_t id) ;
  void Connect() ;
  void Translate( const ThreeVector& p ) ;

#ifdef USE_ROOT
  ClassDef(OTrSuperLayer,0) // The superlayer class
  virtual TString GetName() const ;
  void Plot(TCanvas* canvas, const int choice, const OTrEvent* event, const bool use_mask ) ;
#endif
private:
} ;


#endif
