#ifndef __OTR_SUPERLAYEREVENT_HH__
#define __OTR_SUPERLAYEREVENT_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
#ifndef __OTR_SECTIONCLUSTER_HH__
#include "OTrSectionCluster.hh"
#endif
#ifdef USE_ROOT
 class TPad ;
 class TBuffer ;
 #ifndef ROOT_Rtypes
 #include <Rtypes.h>
 #endif
#endif
class OTrHit ;
class OTrSuperCluster ;

class OTrSuperLayerEvent
{
public:
  // typedefs
  typedef vector< OTrHit* > HitContainer ;
  //typedef list<OTrHit*> HitContainer ;
  typedef vector<OTrSuperCluster*> ClusterContainer ;
  typedef vector<OTrSectionCluster> SectionClusterContainer ;
  ///
  OTrSuperLayerEvent() ;
  ///
  virtual ~OTrSuperLayerEvent() ;
  ///
  OTrHit* Add( OTrHit* ) ;
  ///
  int SearchClusters() ;
  ///
  void DumpHits(ostream& os=cout) const ;
  ///
  void DumpClusters(ostream& os=cout) const ;
  ///
  const ClusterContainer& GetClusters() const { return fClusters ; } ;
  ///
  const HitContainer& GetHits() const { return fHits ; } ;
  ///
  void PerformHistogramming() ;
  ///
  int GetNHits() const { return fHits.size() ; } ;

  /// sort the hits per superlayer according to GEDE index and x
  void SortHits();
#ifdef USE_ROOT
  ///
  ClassDef(OTrSuperLayerEvent,0) // The Outer Tracker superlayer event 
  //void Streamer(TBuffer&) ;
  /// draw all the hits in the event display
  void DrawHits() ;
  /// draw the clusters in the event display
  void DrawClusters() ;
#endif
  
#ifdef USE_ARTE
  void AppendHITB() ;  // append hits to the HITB bank
  void AppendRSEG() ;  // append clusters to the RSEG bank
#endif
private:
  void SearchSectionClusters() ;
  void SearchSuperClusters() ;
  ///
  HitContainer fHits ;
  ///
  ClusterContainer fClusters ; // Reconstructed clusters 
  SectionClusterContainer fZeroClusters ;  // Clusters in zero stereo layer
  SectionClusterContainer fPlusClusters ;  // Clusters in plus stereo layer
  SectionClusterContainer fMinusClusters ; // Clusters in minus stereo layer
};

#endif
