#ifndef __OTR_TDC_HISTOGRAM_HH__
#define __OTR_TDC_HISTOGRAM_HH__

#ifdef USE_ROOT

#include <TH1.h>
#include "OTrObservable.hh"
class OTrChannel;
class OTrSector;


class OTrTdcHistogram: public TH1D
{
public:
  /// default constructor
  OTrTdcHistogram();

  /// constructor
  OTrTdcHistogram( OTrChannel* c );

  /// constructor
  OTrTdcHistogram( OTrSector* s );

  /// return the bin number with the maximum content
  int MaximumBin();

  /// x with maximum number of entries
  inline double MaximumX() { return GetBinCenter( MaximumBin() ); } 

  ///
  OTrFObservable GetPeakValue( bool withGaussianFit = false );

  /// fit to an asymmetric Gaussian
  OTrFObservable FitAsymmetricGaussian( OTrFObservable& width );

  /// fit to the sum of two error functions
  OTrFObservable FitTwoErrorFunctions();

};

#endif
#endif
